# pdf(file="CNVR151_2_BC_T1D_vs_58C_NBS2.pdf", width=12, height=9);  plotd(best_fit, pcolls = c("58C", "NBS", "T1D", "BC"), no_bars=50); dev.off();
# plotd(new=T, col="lightgrey", objects=objects, plot_fit=T)
plotd=function(objects =NULL, data    =NULL, new   =FALSE, col   ="lightgrey", plot_fit=T, advanced=T, main=NULL, 
               new_plot=TRUE, no_bars =50  , layout=NULL , 
               all_cl  =TRUE, indiv_cl=TRUE, pcolls=NULL , breaks=NULL, ung_dat=NULL, dens_vals=NULL, model_fits=NULL, 
               plot_combined=TRUE, cnv_index  =NULL, 
               cnv_name     =NULL, master_list=NULL, dverdict=NULL, pipeline="Standard", clean=F, cleanMar=c(2, 2, 2, 1), 
               layoutWidths =NULL, cex.main   =2.1)
{
  noco = objects$opars$noco
  if(is.null(pcolls)) 
    coll_indices = 1:noco else 
    coll_indices = match(pcolls, colnames(objects$dat))
  nplotcols = ceiling(sqrt(length(coll_indices)+plot_combined)); 
  nplotrows = ceiling(    (length(coll_indices)+plot_combined)/nplotcols)
  if(new_plot) 
    par(mfrow=c(nplotrows,nplotcols))
  if(is.null(data)) 
    data = objects$dat
  if(is.null(objects))
    advanced=F 
  if(advanced) {
    v = as.numeric(rownames(data))
    if(is.null(ung_dat)) ung_dat = ungrid_dat(objects$dat)
    look_at_calls(objects=objects, new=new, ung_dat=ung_dat, in_main=main, new_plot=F, png=F, no_bars=no_bars, 
                  all_cl=all_cl, indiv_cl=indiv_cl, pcolls=pcolls, breaks=breaks, dens_vals=dens_vals, model_fits=model_fits, 
                  plot_combined=plot_combined, layout=layout, cnv_index=cnv_index, cnv_name=cnv_name, master_list=master_list,
                  dverdict=dverdict, pipeline=pipeline, clean=clean, cleanMar=cleanMar, layoutWidths=layoutWidths, cex.main=cex.main)
    return(0)
  }
  if(is.null(data)) {
    if(!is.null(objects)) 
      data = objects$dat else {
      cat("In plotd. Can't find anything to plot.\n"); 
      browser();
    }
  }
  if(!is.null(dim(data))) {
    grid_vals = as.numeric(rownames(data))
    if(dim(data)[2]>1) {
      cat("Warning, this fn only plots one collection. Only plotting first collection.\n")
      data = data[,1]
    }
  } else               {
    grid_vals = as.numeric(   names(data))
  }
  if(new==F) lines(grid_vals, data, col=col)
  if(new==T) plot( grid_vals, data, col=col, typ="l")
  if(!is.null(objects) & plot_fit) add_model_fit_to_plot(objects)
}




look_at_calls=function(objects, new=F, new_plot=T, in_main=NULL, png=F, ung_dat, tr_nocl=-1, no_bars=50, breaks=NULL, plot_combined=T, show_diagnostics=T,
              cnv_index=NULL, cnv_name=NULL, plot_fn = NULL, aic_best_nocl=NA, all_cl=F, indiv_cl=T, pcolls=NULL, clean=F,
              dens_vals=NULL, model_fits=NULL, cex.main=2.1, cex.axis=1.0, cex.lab=1.3, layout=NULL, master_list=NULL, dverdict=NULL,
              pipeline = "Standard", ml_allbest=F, cleanMar=c(2, 2, 2, 1), layoutWidths=NULL, lwd=1.5, combineOnlySupplied=FALSE,
              useFullCollNames=TRUE, ylab="")
{
 #if(!ml_allbest) { if(pipeline!="Standard") pipeline2 = "Best" else pipeline2="Standard"} else  {pipeline2=pipeline} 
  if(!is.null(objects$flags$DEBUG)) DEBUG = objects$flags$DEBUG else DEBUG = 1
  nocl          = objects$opars$nocl
  noco          = objects$opars$noco
  if(!clean & is.null(layout)) {
    cex.main=cex.main *      sqrt(noco/10 )
    cex.lab =cex.lab  *      sqrt(noco/10 )
    cex.axis=cex.axis * sqrt(sqrt(noco/10))
  }
  collections   = colnames(objects$dat)
  if(is.null(pcolls)) 
    coll_indices = 1:noco 
  else 
  {
    if(is.numeric(pcolls)) 
      coll_indices = pcolls 
    else
      coll_indices = match(pcolls, collections)
  }
  if(is.null(cnv_name) & !is.null(objects$flags$cnv_name)) cnv_name = objects$flags$cnv_name
  if(!is.null(master_list))
    mlRow   = which(master_list[,"CNV"]==cnv_name)

  plotd_dim = (7/2)*ceiling(sqrt(length(coll_indices)))
  font=2; tcl=-0.2
  if(png) {
  if(is.null(plot_fn)) {if(is.null(cnv_name)) cnv_name=cnv_index; plot_fn = get_coutput_fns(cnv_name = cnv_name)$plot_fn}    
    pdf(file=plot_fn, width=1.3*plotd_dim, height=plotd_dim)
  }
  if( new) pars = objects$npars
  if(!new) pars = objects$opars
  clm           = make_clm(smcs=pars$smc, clds=pars$cld, noco=noco, nocl=nocl) 
  if(!is.null(cnv_index)) cnv_num = paste(" (no. ", cnv_index, ")", sep="") else cnv_num = NULL

  if(!clean) xlab = "1-d probe summary" else 
             xlab = ""
  if( clean) par(mar=cleanMar)
  if( clean) axis_numbering = F else 
             axis_numbering = T
  # First processing of plot-titles, there's another step once we loop over collections (call to processTitles).
  if(is.null(in_main)) {
    if(clean) {
      in_main = "only coll"
    } else {
      if(tr_nocl!=-1) # tr_nocl is set to -1 if the true number of classes isn't known (so for most real data, but not simulated)
        main = paste(cnv_name, cnv_num, " true #cl=", tr_nocl, ", fit # cl=", nocl, sep="") else
        main = "notReadyYet"
      in_main ="not_passed"
    }
  }
  if(tr_nocl!=-1 | is.null(master_list)) show_diagnostics = F ## tr_nocl!=-1 being used as a proxy for 'simulated data' here.

  if(is.null(layout)) {
    extra_plots = plot_combined+show_diagnostics
    gr_sz       = ceiling(sqrt(length(coll_indices)+extra_plots)); #grid size is for the grid of plots showing the model fit.
    smaller_gr  = gr_sz*(1:gr_sz)
    if(gr_sz^2>(length(coll_indices)+extra_plots)) height = which(smaller_gr>=(length(coll_indices)+extra_plots))[1] else height = gr_sz
    height_check = gr_sz*height >= length(coll_indices)+extra_plots; if(!height_check) {cat("  Warning, don't think all plots will fit.\n")}
    if(new_plot) {
      par(cex.axis=cex.axis); par(cex.lab=cex.lab); 
    }
  } else {
    if(is.null(layoutWidths))
      layout(layout) else
    layout(mat=layout, widths=layoutWidths)
  }
  if(new_plot) par(mfrow=c(height, gr_sz))
  par(cex.main=cex.main);
  if(!plot_combined | combineOnlySupplied)
    xlim = range(ung_dat[coll_indices]) else
    xlim = range(unlist(ung_dat))
  if(is.null(breaks)) breaks = (((-1):(no_bars+1))/no_bars)*(max(xlim)-min(xlim)) + min(xlim)
  collhists = as.list(coll_indices); max_densities = rep(-1, length(coll_indices))
  for(coll in 1:length(coll_indices)) {
    collhists[[coll]]   = hist(ung_dat[[coll_indices[coll]]], breaks=breaks, plot=F)
    max_densities[coll] = max(collhists[[coll]]$density)
  }
  ylim = c(0    , max(max_densities)*1.15)
  for(coll in coll_indices) {
    main = processTitles(main=main, inMain=in_main, clean=clean,
                         cnvName=cnv_name, cnvNum=cnv_num,
                         collections=collections, coll=coll,
                         useFullCollNames=useFullCollNames)
   #hist(ung_dat[[coll]], n=no_bars, col="lightgrey", main=main, xlab=xlab, probability=T, ylim=ylim, xlim=xlim)
    hist(ung_dat[[coll]], breaks=breaks, col="lightgrey", main=main, xlab=xlab, ylab=ylab, probability=T, ylim=ylim, xlim=xlim, xaxt="n", yaxt="n")
    axis(1, labels=axis_numbering, tcl=tcl); axis(2, labels=axis_numbering, tcl=tcl); 
    add_model_fit_to_plot(objects = objects, pars=pars, no_inds_vec = colSums(objects$dat), coll=coll, 
                          all_cl=all_cl, indiv_cl=indiv_cl, new=new, lwd=lwd,
                          dens_vals=dens_vals[[coll]], model_fits=model_fits[[coll]])
    if(!is.null(master_list)) {
      collName = collections[coll]
      if(collName %in% get_diseases()) {
        coll_plots_cex = 2.1
        MAFcol   = paste("MAF." , collName             , sep="")
        BFcol    = paste("BF_"  , collName             , sep="")
        BFercol  = paste("BF_"  , collName, "_expanded", sep="")
        B1col    = paste("Beta_", collName             , sep="")
        B1ercol  = paste("Beta_", collName, "_expanded", sep="")
        BF       = master_list[mlRow, c(BFcol  )]
        BFer     = master_list[mlRow, c(BFercol)]
        B1       = exp(master_list[mlRow, c(B1col  )])
        B1er     = exp(master_list[mlRow, c(B1ercol)])
        collMAF  = master_list[mlRow, c(MAFcol )]
        theight  = 0.95 * max(ylim); 
        theight2 = 0.85 * max(ylim); 
        t1xpos  = xlim[1] + 0.1*(xlim[2]-xlim[1])
        t2xpos  = xlim[1] + 0.9*(xlim[2]-xlim[1])
        midxpos = xlim[1] + 0.5*(xlim[2]-xlim[1])
        text(t1xpos , theight , format(round(BF,      digits=1), nsmall=1), font=2, cex=coll_plots_cex    , col="purple")
        text(t2xpos , theight , format(round(BFer,    digits=1), nsmall=1), font=2, cex=coll_plots_cex    , col="purple")
        text(midxpos, theight , format(round(collMAF, digits=3), nsmall=3), font=1, cex=coll_plots_cex    , col="black" )
        text(t1xpos , theight2, format(round(B1     , digits=2), nsmall=2), font=3, cex=coll_plots_cex-0.2, col="black" )
        text(t2xpos , theight2, format(round(B1er   , digits=2), nsmall=2), font=3, cex=coll_plots_cex-0.2, col="black" )
        if(is.na(BF) |  is.na(BFer)) {
          BF = -9; BFer = -9;
          box(col="lightgrey", lwd=2)
        } else {
          if(max(c(BF, BFer)) > 2.5) box(col="red", lwd=3)
        }
      } else {
        coll_plots_cex = 2.1
        MAFcol   = paste("MAF", ".", collName             , sep="")
        collMAF  = master_list[mlRow, c(MAFcol )]
        theight  = 0.95 * max(ylim); 
        theight2 = 0.85 * max(ylim); 
        t1xpos  = xlim[1] + 0.1*(xlim[2]-xlim[1]); t2xpos = xlim[1] + 0.9*(xlim[2]-xlim[1])
        midxpos = xlim[1] + 0.5*(xlim[2]-xlim[1]); 
        text(midxpos, theight, round(collMAF, digits=3), font=1, cex=coll_plots_cex, col="black")
      }
    }
  }

  if(show_diagnostics){   
    empty.plot()
    if(!is.null(master_list)) {
      check = length(mlRow)==1; if(!check) {cat("  Warning - don't have exactly one match for this CNV name!\n"); if(DEBUG > 1) browser();}
      start = master_list[mlRow,"StartCoord"]; end = master_list[mlRow,"EndCoord"];

      adj = c(0.0, 0.5); text_cex = 2
      box(col="grey", lwd=2)
      xposes = c(0.05, 0.05, 0.05, 0.52, 0.05, 0.52, 0.05, 0.05, 0.05)
      yposes = c(0.92, 0.81, 0.66, 0.66, 0.51, 0.51, 0.36, 0.21, 0.06)
      text(xposes[1], yposes[1], cnv_name, font=font, cex=1.2*text_cex, adj=adj, col="magenta")
      text(xposes[2], yposes[2], paste("Chr "  , master_list[mlRow,"Chr"], ",  ", prettyNum(start, big.mark=","), " (", round((end-start)/1e3, digits=1), " kb)", sep=""), font=font, cex=text_cex-0.2, adj=adj)
      text(xposes[3], yposes[3], paste("CDC = ", round( master_list[mlRow, "designedDupConditionalConcordance"], digits=3), sep=""), font=font, cex=text_cex, adj=adj)
      text(xposes[4], yposes[4], paste("Con = ", round( master_list[mlRow, paste("posteriorsNonLDFmerged", sep="")], digits=4), sep=""), font=font, cex=text_cex, adj=adj)
      text(xposes[5], yposes[5], paste("MAF = ", round( master_list[mlRow, paste("MAF", sep="")], digits=3), sep=""), font=font, cex=text_cex, adj=adj)
      text(xposes[6], yposes[6], paste("HWE = ", signif(master_list[mlRow, paste("HWE", sep="")], digits=3), sep=""), font=font, cex=text_cex, adj=adj)
      text(xposes[7], yposes[7], paste("R2 HapMap = ",
                                                 round(master_list[mlRow,"bestLocalHapmapTagR2" ], digits=3), " (",
                                                 round(master_list[mlRow,"bestGlobalHapmapTagR2"], digits=3), ")", sep=""), font=font, cex=text_cex, adj=adj)
      text(xposes[8], yposes[8], paste("R2 Affy6  = ",
                                                 round(master_list[mlRow,"bestLocalAffy6TagR2" ], digits=3), " (",
                                                 round(master_list[mlRow,"bestGlobalAffy6TagR2"], digits=3), ")", sep=""), font=font, cex=text_cex, adj=adj)
      if(is.null(dverdict)) {
        verdict = "none"
        col = "lightgrey"
      } else {
        verdict = dverdict
        col = "black"
      }
      text(xposes[9], yposes[9], paste("Ver = ", verdict , sep=""), font=font, cex=text_cex, adj=adj, col=col);
      # Give VNTR overlap, SNPs in probe info, multiple probe_mapping info, evidence for polymorphism info, 'Complex' flag, 

    } else {
      # cat("  Warning - no master list passed to look_at_calls."); #browser();
    }
  }
  if(plot_combined){   
    if(combineOnlySupplied)   
      hist(unlist(ung_dat[coll_indices]), breaks=breaks, col="lightgrey", main="Combined Data", 
                  xlab=xlab, ylab=ylab, probability=T, ylim=ylim, xlim=xlim) else
      hist(unlist(ung_dat),               breaks=breaks, col="lightgrey", main="Combined Data", 
                  xlab=xlab, ylab=ylab, probability=T, ylim=ylim, xlim=xlim)
    if(!is.null(master_list)) {
      text(t1xpos,  theight,  "BF"     , font=font, cex=coll_plots_cex, col="purple")
      text(t2xpos,  theight,  "BF (ER)", font=font, cex=coll_plots_cex, col="purple")
      text(midxpos, theight , "MAF",     font=1,    cex=coll_plots_cex)
      text(t1xpos , theight2, "RR"     , font=3,    cex=coll_plots_cex-0.2)
      text(t2xpos , theight2, "RR (ER)", font=3,    cex=coll_plots_cex-0.2)
    }
    if(!objects$flags$use_hier_mchoice) {
      if(objects$flags$model!="simple") pars = objects$ninferred$simple_pars
      if(objects$flags$model=="simple") pars = pars
      add_model_fit_to_plot(objects = objects, pars=pars, no_inds_vec = colSums(objects$dat), 
                            coll=NA, combined=T, all_cl=all_cl, indiv_cl=indiv_cl, new=new, lwd=lwd) #, dens_vals=dens_vals, model_fits=model_fits[[coll]])
    }
  }
  if(png) dev.off();
 #if(cnv_name=="CNVR5.1") browser();
}

#new flag not implemented yet. SO if try to plot 'new' model fits this will give the wrong answers (and a warning).
add_model_fit_to_plot=function(objects, pars=NULL, no_inds_vec=NULL, modelf_col="grey", combined=F, 
                               coll=NULL, truncate_lines=T, new=F, lwd=1.5, 
                               all_cl=F, indiv_cl=T, dens_res=1000, dens_vals=NULL, model_fits=NULL)
{
  if(is.null(model_fits) | is.null(dens_vals))
  {
    nocl       = pars$nocl
    rv         = make_fit_densities(objects=objects, pars=pars,  combined=combined, coll=coll, new=new, dens_res = dens_res)
    model_fits = rv$model_fits
    dens_vals  = rv$dens_vals
  } else {
    nocl       = nrow(model_fits)  
  }
  if(combined) 
  {
    if(all_cl)   plot_model_fit(truncate_lines=truncate_lines, lwd=lwd,
                                dens_vals=dens_vals, model_fit=colSums(model_fits), col="orange")    
    if(indiv_cl) plot_model_fit(truncate_lines=truncate_lines, lwd=lwd,
                                dens_vals=dens_vals, model_fit=model_fits[cl], mean=clm[cl])
  } else {
    if(all_cl) plot_model_fit(truncate_lines=truncate_lines, lwd=lwd,
                              dens_vals=dens_vals, model_fit=colSums(model_fits), col="orange", cl=NULL)
    for(cl in 1:nocl)
      if(indiv_cl) plot_model_fit(truncate_lines=truncate_lines, lwd=lwd,
                                  dens_vals=dens_vals, model_fit=model_fits[cl,], mean=pars$hkclm[coll,cl], cl=cl)
  }
}

plot_model_fit=function(truncate_lines, dens_vals, model_fit, truncate_cut_off=1e3, 
                        mean=NA, col="red", cl=NULL, lwd=1.5,
             cols=c("red", "blue", "green", "cyan", "magenta", "darkgreen", "darkred", "darkblue", "grey", "black", "darkred", "darkgreen"))
{
  remove = which(model_fit<(max(model_fit/truncate_cut_off)))
  if( truncate_lines & length(remove)>0)  keep = (1:length(dens_vals))[-remove]
  if(!truncate_lines | length(remove)==0) keep = 1:length(dens_vals)
  if(is.null(cl)) this_cl_col = col else this_cl_col = cols[cl]
  lines(dens_vals[keep], model_fit[keep], col=this_cl_col, lwd=lwd)
  if(!is.na(mean)) points(mean, 0, pch="x", col="red")
}

display_attempts=function(DEBUG, move_attempts, func, pars)
{
   if(DEBUG>2) 
   {
      cat("   Attempts =", move_attempts, "\n")
      cat("   In ", func, ":\n", sep="")
      cat("   smallest" , pars$smc, "\n")
      cat("   distances", pars$cld, "\n")
   }
}



display_clm=function(objects, condition=DEBUG>3)
{
  iter = objects$flags$iter
  if(condition) { 
    cat("Iter = ", iter, ".\n", sep=""); 
    dsts = objects$opars$cld
    if(objects$opars$nocl>1  & objects$opars$noco> 1) oclm = cumsum( c(mean(objects$opars$smc), colMeans(dsts)) )
    if(objects$opars$nocl==1                        ) oclm = objects$opars$smc
    if(objects$opars$nocl>1  & objects$opars$noco==1) oclm = cumsum( c(     objects$opars$smc ,       dsts          ) )
    if(objects$opars$nocl> 1) cat("Old clm  = ", oclm, "\n", sep=" ")
    if(objects$opars$nocl==1) cat("Old smcs = ", oclm, "\n", sep=" ")
    dsts = objects$npars$cld
    if(objects$opars$nocl>1  & objects$opars$noco> 1) nclm = cumsum( c(mean(objects$npars$smc), colMeans(dsts)) )
    if(objects$opars$nocl==1                        ) nclm = objects$npars$smc
    if(objects$opars$nocl>1 & objects$opars$noco==1 ) nclm = cumsum( c(     objects$npars$smc ,       dsts          ) )
    if(objects$opars$nocl> 1) cat("New clm  = ", nclm, "\n", sep=" ")
    if(objects$opars$nocl==1) cat("New smcs = ", nclm, "\n", sep=" ")
    grid_vals = as.numeric(rownames(objects$dat))
    cat("Range of data = ", range(grid_vals), "\n");
  }
}


look_at_mclust_calls=function(dat, main=NULL, mclust, cnv_types)
{
  xlab="dat, red=means, green = 2standard deviations, grey=posterior density"
  hist = hist(dat, n=100, plot=F)
  ylim = range(hist$counts)
  plot(hist, ylim=c(0, ylim[2]*1.1), col="lightgrey", main=main, xlab=xlab)
  clm  = mclust$parameters$mean
  clsd = sqrt(mclust$parameters$variance$sigmasq)
  arrows(x0=clm, y0=50, x1 = clm+2*clsd, y1=50, code=2, col="green", length=0.05)
  arrows(x0=clm, y0=50, x1 = clm-2*clsd, y1=50, code=2, col="green", length=0.05)
  abline(v=clm, col="lightgrey")
  add_mclust_fit(mclust, no_inds=nrow(mclust$z))
  cnv_calls  = mclust$z
  hard_calls = apply(cnv_calls, 1, which.max)
  calls_cor = cor(hard_calls, cnv_types)
  cat("Correlation of calls with truth = ", round(calls_cor*100, digits=2), "%\n", sep="")
}

add_mclust_fit=function(mclust, no_inds=9000)
{
  nocl        = length(mclust$parameters$mean)
  clm         = mclust$parameters$mean
  avg_clv     = rep(mclust$parameters$variance$sigmasq, nocl)
  proportions = mclust$parameters$pro
  for(cl in 1:nocl)
  {
    cl_distribution = rnorm(1e4, mean=clm[cl], sd=sqrt(avg_clv[cl]))
    cl_density = density(cl_distribution)
    cl_density$y = cl_density$y/8.5e2*no_inds
    cl_density$y = cl_density$y*proportions[cl]
    lines(cl_density, col="red")
  }
}


# source("cnv_caller.R"); look_at_a_cnv(cnv_name="THRAP3_8", mapping="y_GMM", return_dad=F)
# source("cnv_caller.R"); look_at_a_cnv(cnv_name="THRAP3_8_1", mapping="original")
# source("cnv_caller.R"); look_at_a_cnv(cnv_name="THRAP3_9_1", mapping="original")
# source("cnv_caller.R"); look_at_a_cnv(cnv_name="CNVR151_2", mapping="correlation")
look_at_a_cnv=function(cnv_name=NULL, dat_dir="/data/garganey/cardin/postdoc/CNVs/ccc+_main/data", no_breaks=50, mapping="original",
                         ann_dir = "/data/garganey/cardin/postdoc/CNVs/ccc+_main/", store_sample_names=F, return_dad=F)
{
  source("cnv_caller.R")
  options(error=recover); 
  DEBUG                         = 1.5
  if(mapping=="original"   )     names_fn = paste(ann_dir, "original_cnv_names_mapping_order.txt", sep="")
  if(mapping=="correlation")     names_fn = paste(ann_dir, "correlation_cnv_names_mapping_order.txt", sep="")
  if(mapping=="y_GMM"      )     names_fn = paste(ann_dir, "ygmm_cnv_names_mapping_order.txt", sep="")
  cnv_names = as.matrix(read.table(file=names_fn, as.is=T, header=T)) 

  if(is.null(cnv_name)) {
    cat("Please set 'cnv_name' to the name of the CNV you want to look at (as labelled in the original mappings)\n")
    cat("eg use: ", cnv_names[1], "\n");
    return(0);
  }
  cnv_index          = which(cnv_names==cnv_name)
  if(length(cnv_index)==0) {
    cat("Couldn't find CNV: ", cnv_name, "in file:\n  ", names_fn, "\n");
    browser();
    return(0);
  }
  cat("In this probe->CNV mapping this is the ", cnv_index, "th CNV.\n");
  arguments          = set_arguments(cnvs=cnv_index, write_tag="NA", read_tag="NA", write_results=0)
  if(mapping=="original"   ) arguments$ptcnv_type          = "original"
  if(mapping=="correlation") arguments$ptcnv_type          = "correlation"
  if(mapping=="y_GMM"      ) arguments$ptcnv_type          = "y_GMM"

  extra_args       = set_up_caller(arguments)

  data_and_details = get_data(arguments=arguments, extra_args=extra_args, cnv_index=cnv_index)
  prog_cnvname     = data_and_details$cnv_name

  check = prog_cnvname == cnv_name
  if(!check) {
    cat("Error in script! Have somehow pulled out the wrong CNV?\n Wrong probe mappings file?\n"); 
    cat("Wanted CNV: ", cnv_name, ". However using annotation file this CNV seems to be: ", data_and_details$cnv_name, "\n");
    browser();
  }
  ud    = data_and_details$ung_dat
  nrows = ceiling(sqrt(length(ud)+1))
  ncols = ceiling((length(ud)+1)/nrows)
  par(mfcol=c(nrows, ncols))
  xlim  = range(ud); #No longer: c(-0.0505, 0.0505)
  breaks = ((0:no_breaks)/no_breaks)*(xlim[2]-xlim[1])+xlim[1]
  for(coll in 1:length(ud))
  {
    collname = names(ud)[coll]
    main     = paste("CNV: ", cnv_name, ", collection: ", collname, sep="")
    hist(ud[[coll]], breaks=breaks, col="lightgrey", main=main, xlab = "Signal", xlim=xlim)
  }
  hist(unlist(ud), breaks=breaks, col="lightgrey", main="Combined Data", xlab = "Signal", xlim=xlim)
  
  if(return_dad) return(data_and_details)
  #da = data_and_details$data_array
}

processTitles=function(main, inMain, useFullCollNames, clean,
              cnvName, cnvNum, collections, coll)
{
  if(!is.null(inMain)) {
    if(length(inMain)>1) #This allows the user to supply a complete vector of plot names.
      return(inMain[coll])
    if(inMain=="only coll")  
      main = paste(collections[coll], sep="")
    if(inMain=="none")       
      main = ""
    if(inMain=="not_passed") 
      main = paste(cnvName, cnvNum, " ", collections[coll], sep="")
    if(!inMain %in% c("only coll", "none", "not_passed")) 
      main = inMain
  }
  main = gsub(pattern="NBS", replace="UKBS", main)
  if(useFullCollNames & (main %in% collections)) {
    fullCollNames = get_collections(useFullCollNames=TRUE)
    main = fullCollNames[main]
  }
  return(main)
}

#Code given by Damjan
text_only_plot=function(font=2, cex=1.2)
{
   plot(1, type="n", xaxt="n", yaxt="n", xlab="", ylab="")
    text(1, 1.4, "HWE -log10(p-values)", font=font, cex=cex)
    text(1, 1.2, paste(    "BC =", pval.BC,
                        "\nT1D =", pval.T1D,
                        "\n CD =", pval.CD,
                        "\nNBS =", pval.NBS), cex=1.5)
}

# Sets up the plotting canvas but draws nothing.
# The x- and y-axes both have limits set as c(0,1).
empty.plot <- function()
{
    plot(NULL, type="n", bty="n",
         xlim=c(0,1), ylim=c(0,1),
         xaxs="i",    yaxs="i",
         xaxt="n",    yaxt="n",
         xlab="",     ylab="")
}

get_layout_mat=function(sim=F)
{
  if(sim) {
    mat <- matrix(c(1, 2, 3, 4),          nrow=4, byrow=T)
  } else  {
    mat <- matrix(c(1, 2, 3, 4, 5, 0,6, 0, 7), 3, byrow=T)
  }
  return(mat)
}
