# R CMD INSTALL cnvCall --library=~/cardinRlibraries/
# detach(package:MASS); detach(package:cnvCall); library(cnvCall, lib.loc="~/cardinRlibraries/")
# git remote add wattle ssh://data/wattle/project/wtccc.plus.cnv/cardin/cnvCall.git
# git push wattle master 

get_caller_scripts_dir=function() 
  "caller_scripts/"
get_caller_output_dir=function() 
  "caller_output/"
get_data_freezes_dir=function()
  "data_freeze/"
get_QC_dir=function()
  "QC/"
get_cnvtest_dir=function()
  "cnvtest/"
get_crnt_df_dir=function(dfr=get_dfr())
  paste(get_data_freezes_dir(), "data_freeze_", dfr, "/", sep="")
get_bychrdat_dir=function(dfr=get_dfr(), normalisation="normalised6")                #5
{
  if(dfr %in% 1:10) {
    dir = paste(get_crnt_df_dir(dfr=dfr), "by_chromosome_data/", normalisation, "/", sep="")
  } else { ##This is not implemented!
    dir = paste(get_dir_names()$simdat_dir, dfr, "/", sep="")
  }  
}
get_sang_ann_dir=function(dfr=get_dfr()) #Contains: MASTER_sample_QC.txt
  paste(get_crnt_df_dir(dfr=dfr), "files/annotation_files/", sep="")
get_ptcnv_dir=function(dfr=get_dfr()) #probe_to_CNV_mapping_original_vx.txt
  paste(get_crnt_df_dir(dfr=dfr), "files/probe_to_CNV_mapping/", sep="")
get_ox_inputs_dir=function()
  paste("ox_caller_inputs/data_freeze_", get_dfr(), "/",  sep="")
get_nocl_verdicts_dir=function(dfr=get_dfr()) 
  paste(get_ox_inputs_dir(), sep="")
get_pr2lines_dir=function(dfr=get_dfr()) 
  paste(get_ox_inputs_dir(), sep="")
get_ind_excl_dir=function(dfr=get_dfr())                       
  paste(get_ox_inputs_dir(), sep="")
  #paste(get_sang_ann_dir(), sep="")
get_pr_excl_dir=function(dfr=get_dfr()) 
  paste(get_ox_inputs_dir(), sep="")
get_simdat_dir=function(simdat_tag="test_simdat") 
  paste("simdat/", simdat_tag, "/", sep="")
get_project_root=function(automatic=FALSE, verbose=1) {
  #cat("Original version of 'get_project_root' not found.\n "); 
  project_root = "/data/vault1/cardin/oxDat/calling/"
  if(!automatic) {
    cat("Please supply a project_root, perhaps            \n  ",
        "/data/vault1/cardin/oxDat/calling/  (default), or\n  ", 
        "/home/niall/Desktop/Documents/myPapers/calling_paper/data/ ", sep="")
    x=scan(nmax=1, what = character(0)); 
    if(!length(x)==0) { #!is.null(x)) {
      if(nchar(x)>2) 
        project_root=x
    }
  }
  if(verbose>1)
    cat("\n  project_root set to: \'", project_root, "\', Thanks.\n", sep="")
  return(project_root)
}
get_dfr=function(verbose=1)
{
  if(verbose>1)
    cat("  Obsolete call to get_dfr?\n")
  return(8)
}
# 

get_dir_names=function(project_root=get_project_root(automatic=TRUE), 
   normalisation="normalised6", simdat_tag="test_simdat", real_data=T)
{
  scripts_dir           = paste(project_root, get_caller_scripts_dir(), sep="")      
  output_dir            = paste(project_root, get_caller_output_dir() , sep="")      
  data_freezes_dir      = paste(project_root, get_data_freezes_dir()  , sep="")      
  bychrdat_dir          = "not set" #paste(project_root, get_bychrdat_dir(normalisation=normalisation), sep="") #5   
  simdat_dir            = paste(project_root, get_simdat_dir(simdat_tag=simdat_tag), sep="") #5   
  if(!real_data) bychrdat_dir = simdat_dir        
  sang_ann_dir          = paste(project_root, get_sang_ann_dir()      , sep="")      
  ptcnv_dir             = paste(project_root, get_ptcnv_dir()         , sep="")      
 #QC_dir                = paste(project_root, get_QC_dir()            , sep="")      
  cnvtest_dir           = paste(project_root, get_cnvtest_dir()       , sep="")      
  
  ox_inputs_dir         = paste(project_root, get_ox_inputs_dir()     , sep="")      
  pr2lines_dir          = paste(project_root, get_pr2lines_dir()      , sep="")      
  ind_excl_dir          = paste(project_root, get_ind_excl_dir()      , sep="") #10  
  pr_excl_dir           = paste(project_root, get_pr_excl_dir()       , sep="")      
  nocl_verdicts_dir     = paste(project_root, get_nocl_verdicts_dir() , sep="")      

  #Not passed
  crnt_df_dir           = paste(project_root, get_crnt_df_dir()       , sep="")       # "crnt_df_dir"=crnt_df_dir, 

  rv = list("project_root" = project_root, "scripts_dir"= scripts_dir    , "output_dir"   = output_dir  , "data_freezes_dir" = data_freezes_dir, 
            "bychrdat_dir" = bychrdat_dir, "ptcnv_dir"  = ptcnv_dir      , "pr2lines_dir" = pr2lines_dir, "ind_excl_dir"     = ind_excl_dir,
            "pr_excl_dir"  = pr_excl_dir , "simdat_dir" = simdat_dir     , "sang_ann_dir" = sang_ann_dir,
            "ox_inputs_dir"=ox_inputs_dir , "nocl_verdicts_dir"=nocl_verdicts_dir, 
            "cnvtest_dir"  = cnvtest_dir )
  return(rv)
} 

# simdat_fn=get_input_fns(arguments=arguments, cnv_index=cnv_index)$simdat_fn
get_input_fns=function(arguments=NULL, cnv_index=NULL, tag=NULL, normalisation=NULL, chr=NULL, verbose=1, red_or_green=NULL,
                 exclusion_type=NULL, which_inds_excl="pearson_post_calling", mapping=NULL, agilent_data=T, inc_dir=T)
{
  msqc_fn       = get_msqc_fn()
  simdat_fn     = get_simdat_fn( arguments=arguments, cnv_index=cnv_index)
  simpars_fn    = get_simpars_fn(arguments=arguments, cnv_index=cnv_index)
  sim_hprs_fn   = get_simhprs_fn(arguments=arguments, cnv_index=cnv_index)
  probe_excl_fn = get_probe_excl_fn(chr=chr, exclusion_type=exclusion_type, verbose=verbose)
  ind_excl_fn   = get_excl_fn(which_inds_excl=which_inds_excl, verbose=verbose, inc_dir=inc_dir)
  pt2cnv_fn     = get_pt2cnv_fn(mapping=mapping)
  dat_fn        = get_dat_fn(cnv_index=cnv_index, tag=tag, normalisation=normalisation, chr=chr, verbose=verbose, red_or_green=red_or_green)
  xChromExcludeListFn = getXchromExclFn(sexToExclude=tag, verbose=verbose)
  if(!agilent_data) dat_fn = simdat_fn

  rv = list("msqc_fn"=msqc_fn, "simdat_fn"=simdat_fn, "dat_fn"=dat_fn, "probe_excl_fn"=probe_excl_fn, "ind_excl_fn"=ind_excl_fn,
            "simpars_fn"=simpars_fn, "sim_hprs_fn"=sim_hprs_fn, "pt2cnv_fn"=pt2cnv_fn, "xChromExcludeListFn"=xChromExcludeListFn)
  return(rv)
}

#This function gets the filename for SIMULATED data - not real data
get_simdat_fn=function(arguments, cnv_index)
{
  this_sim_fn = paste(get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir, arguments$simdat_tag, "_seed=", arguments$read_seed, "_sim=", cnv_index, ".RData", sep="");  
  return(this_sim_fn)
}
get_simpars_fn=function(arguments, cnv_index)
{
  if(is.null(cnv_index)) {
    this_sim_fn = paste(get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir, "simpars/sim_pars_", arguments$simdat_tag, "_seed=", arguments$read_seed                    , ".txt", sep="");      
  } else {
    this_sim_fn = paste(get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir, "simpars/sim_pars_", arguments$simdat_tag, "_seed=", arguments$read_seed, "_sim=", cnv_index, ".txt", sep="");  
  }
  return(this_sim_fn)
}
get_simhprs_fn=function(arguments, cnv_index)
{
  if(is.null(cnv_index)) {
    this_sim_fn = paste(get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir, "simpars/sim_hyper_priors_", arguments$simdat_tag, "_seed=", arguments$read_seed                    , ".txt", sep="");  
  } else {
    this_sim_fn = paste(get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir, "simpars/sim_hyper_priors_", arguments$simdat_tag, "_seed=", arguments$read_seed, "_sim=", cnv_index, ".txt", sep="");  
  }
  return(this_sim_fn)
}

get_cnvtest_loc=function()
{
  cnvtestloc = paste("/data/garganey/cardin/postdoc/CNVs/calling/testing/cnvtest/", "snptest", sep="");
  return(cnvtestloc)
}

get_cnvtest_outfn=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                           disease, expanded_reference=NULL, extra=NULL, 
                           ldf=F, merge=F, testType = "additive")
{
  if(!merge) 
    dir = get_coutput_dirs(coutput_root=this_run_loc, er=expanded_reference)$cnvt_results_dir else
    dir = get_coutput_dirs(coutput_root=this_run_loc, er=expanded_reference)$merged_cnvtr_dir
  if(ldf) ldfTag = "ldf_" else ldfTag = NULL
  if(testType=="additive") testTypeTag = NULL else testTypeTag = paste(testType, "_", sep="")
  fname   = paste(dir, testTypeTag, ldfTag, "testing", extra, "_", this_run_name, "_", paste(disease, sep="", collapse="_"),
                   "_expanded_reference=", expanded_reference, ".txt", sep="")  
  return(fname)
}

get_cnvtest_ind_exl_fn=function(this_run_loc = .default.coutput_root, this_run_name=write_tag)
{
  fn  = paste(this_run_loc, "cnvtest_ind_exl", ".txt", sep="")
  return(fn)
}
get_cnvtest_cnv_exl_fn=function(this_run_loc = .default.coutput_root, this_run_name=write_tag)
{
  fn  = paste(this_run_loc, "cnvtest_cnv_exl", ".txt", sep="")
  return(fn)
}

get_mergef_cnvofn=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, disease, expanded_reference=NULL, extra=NULL, ldf=F)
{
  dir = get_coutput_dirs(coutput_root=this_run_loc, er=expanded_reference)$merged_cnvtr_dir
  fn      = paste(dir, "testing", extra, "_", this_run_name, "_", disease, "_expanded_reference=", expanded_reference, ".txt", sep="")
  ldf_fn  = paste(dir, "ldf_testing", extra, "_", this_run_name, "_", disease, "_expanded_reference=", expanded_reference, ".txt", sep="")
  if(ldf) return(ldf_fn) else return(fn)
}

get_coutput_fns=function(coutput_root = .default.coutput_root, this_run_name=write_tag, cnv_name=NULL, cnv_names=NULL, arguments=NULL, signal_model="t8",
                         verbose=1, DEBUG=1, collections=NULL, call_thresh=0.95, er=NULL, disease=NULL, diseases=NULL, extra=NULL, 
                         merge=F, dfr=get_dfr(), hcalls_filetype = "txt", ldf=T, testType="additive")
{
  cout               = get_coutput_dirs(coutput_root=coutput_root)
  dat_with_smpl_fn   = paste(cout$one_ddat_dir, "one_ddat_"      , this_run_name, "_", "full_one_ddat_with_sample_names" , ".RData", sep="")
  data_fn            = paste(cout$one_ddat_dir, "one_ddat_"      , this_run_name, "_", cnv_name , ".RData", sep="")
  fit_fn             = paste(cout$fits_dir    , "fit_smry_"      , this_run_name, "_", cnv_name , ".RData", sep="")
  text_pars_fn       = paste(cout$pars_dir    , "core_pars_smry_", this_run_name, "_", cnv_name , ".txt"  , sep="") #pars
  plot_fn            = paste(cout$plots_dir   , "image_"         , this_run_name, "_", cnv_name , ".pdf"  , sep="")
  stpts_fn           = paste(cout$stpts_dir   , "stpts_"         , this_run_name, "_", cnv_name , ".RData", sep="")
  manyplot_fns       = paste(cout$plots_dir   , "image_"         , this_run_name, "_", cnv_names, ".pdf"  , sep="")
  cnvtest_fn         = paste(cout$cnvtest_dir , "snptest"                                            , sep="")
  details_fn         = make_det_fn(arguments=arguments, det_filetag=this_run_name, this_run_name=this_run_name, signal_model=signal_model)
  probeScale_fn      = paste(cout$probeScale_dir, "probeScale_"  , this_run_name, "_", cnv_name , ".txt"  , sep="")

  all_cnvs_smry_fn   = paste(coutput_root     , "all_cnv_summary_", this_run_name, ".txt", sep="")
  args_input_fn      = paste(coutput_root     , "arguments_input_", this_run_name, ".txt", sep="")
  sample_names_fn    = paste(coutput_root     , "sample_names_"   , this_run_name, ".txt", sep="")
  joined_calls_fns   = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "joinedcalls_"    , collections, ".txt", sep="")
  sorted_calls_fns   = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "sortedcalls_"    , collections, ".txt", sep="")
  summary_calls_fns  = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "summarycalls_"   , collections, ".txt", sep="")
  sorted_smry_cfn    = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "sorted_summarycalls_",          ".txt", sep="")
  cnvtest_sample_fns = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "cnvtest_samples_", collections, ".txt", sep=""); 
  names(cnvtest_sample_fns)=collections;
  hard_calls_fn      = paste(get_coutput_dirs(coutput_root=coutput_root)$hard_calls_dir  , "hardcalls_callthresh=", call_thresh, ".", hcalls_filetype, sep="")
  merged_calls_fns   = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "mergedcalls_", collections, ".txt", sep="")
  merged_hcalls_fn   = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "merged_hard_calls_", call_thresh, ".", hcalls_filetype, sep="")
  merged_smry_cfn    = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "merged_summarycalls.txt", sep="")
  merged_plots_fn    = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_plots_dir, "mergedplots_", cnv_name, ".pdf", sep="")
  merged_fits_fn     = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_fits_dir , "mergedfits_" , cnv_name, ".rda", sep="")
  merged_cnvtest_ofn = get_mergef_cnvofn(this_run_loc = coutput_root, this_run_name=this_run_name, disease=disease, expanded_reference=er, extra=extra, ldf=F)
  merged_qc_stats_fn = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_call_QC_dir, "all_QC_metrics.RData.rda", sep="")
  merged_cnv_qcs_fn  = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_call_QC_dir, "by_cnv_QC_metrics.RData" , sep="")

 #ldf_calls_fn           = paste(get_coutput_dirs(coutput_root=coutput_root)$ldf_calls_dir, "" , sep="")
  ldf_fit_fn             = paste(cout$ldf_fits_dir, "ldf_fit_smry_", this_run_name, "_", cnv_name , ".RData", sep="")
  ldf_joined_calls_fns   = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "ldf_joinedcalls_"    , collections, ".txt", sep="")
  ldf_sorted_calls_fns   = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "ldf_sortedcalls_"    , collections, ".txt", sep="")
  ldf_smry_calls_fns     = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "ldf_summarycalls_"   , collections, ".txt", sep="")
  ldf_srtd_smry_cfn      = paste(get_coutput_dirs(coutput_root=coutput_root)$jd, "ldf_sorted_summarycalls_",          ".txt", sep="")
  ldf_merged_calls_fns   = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "ldf_mergedcalls_", collections, ".txt", sep="")
  ldf_merged_hcalls_fn   = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "ldf_merged_hard_calls_", call_thresh, ".", hcalls_filetype, sep="")
  ldf_merged_smry_cfn    = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "ldf_merged_summarycalls.txt", sep="")
  ldf_merged_plots_fn    = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_plots_dir, "ldf_mergedplots_", cnv_name, ".pdf", sep="")
  ldf_merged_fits_fn     = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_fits_dir , "ldf_mergedfits_" , cnv_name, ".rda", sep="")
  ldf_merged_cnvtest_ofn = get_mergef_cnvofn(this_run_loc = coutput_root, this_run_name=this_run_name, disease=disease, expanded_reference=er, extra=extra, ldf=T)
  ldf_merged_qc_stats_fn = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_call_QC_dir, "ldf_all_QC_metrics.RData.rda", sep="")
  ldf_merged_cnv_qcs_fn  = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_call_QC_dir, "ldf_by_cnv_QC_metrics.RData" , sep="")
  ldf_unm_cnvtest_outfn  = get_cnvtest_outfn(this_run_loc = coutput_root, this_run_name=this_run_name, disease=disease, expanded_reference=er, extra=extra, ldf=T)
  ldf_qc_stats_fn        = paste(get_coutput_dirs(coutput_root=coutput_root)$QC_dir, "ldf_all_QC_metrics.RData.rda", sep="")
  ldf_cnv_qcstats_fn     = paste(get_coutput_dirs(coutput_root=coutput_root)$QC_dir, "ldf_by_cnv_QC_metrics.RData" , sep="")
  ldf_hard_calls_fn      = paste(get_coutput_dirs(coutput_root=coutput_root)$hard_calls_dir  , "ldf_hardcalls_callthresh=", call_thresh, ".", hcalls_filetype, sep="")
  ldf_plot_fn            = paste(cout$ldf_plots_dir   , "ldf_image_"         , this_run_name, "_", cnv_name , ".pdf"  , sep="")
  ldf_dat_with_smpl_fn   = paste(cout$ldf_dat_dir, "ldf_one_ddat_"      , this_run_name, "_", "full_one_ddat_with_sample_names" , ".RData", sep="")
  ldf_data_fn            = paste(cout$ldf_dat_dir, "ldf_one_ddat_"      , this_run_name, "_", cnv_name , ".RData", sep="")


  cnvtest_outfn          = get_cnvtest_outfn(this_run_loc = coutput_root, this_run_name=this_run_name, disease=disease, expanded_reference=er, extra=extra, ldf=F)
  cnvtest_ind_exl_fn     = get_cnvtest_ind_exl_fn(this_run_loc = coutput_root, this_run_name=this_run_name)
  cnvtest_cnv_exl_fn     = get_cnvtest_cnv_exl_fn(this_run_loc = coutput_root, this_run_name=this_run_name)
  qc_stats_fn            = paste(get_coutput_dirs(coutput_root=coutput_root)$QC_dir, "all_QC_metrics.RData.rda", sep="")
  cnv_qcstats_fn         = paste(get_coutput_dirs(coutput_root=coutput_root)$QC_dir, "by_cnv_QC_metrics.RData" , sep="")
  if(ldf) ldfTag = "LDF" else ldfTag = "nonLDF" 
  masterListFname        = paste(coutput_root, ldfTag, "masterCNVlist.", this_run_name, ".rda", sep="")
  masterFname            = paste(coutput_root, "masterCNVlist.", this_run_name, ".rda", sep="")
  if(length(diseases)>1) 
    combinedCNVtestSampleFnames = getCombinedCNVtestSampleFnames(diseases=diseases, collections=collections) else
    combinedCNVtestSampleFnames = cnvtest_sample_fns
  
  CNVtestMultCasesFn     = get_cnvtest_outfn(this_run_loc = coutput_root, this_run_name=this_run_name, 
                              disease=diseases, expanded_reference=er, extra=extra, ldf=ldf, merge=merge, testType=testType)

  verdicts_plots_fn  = paste(get_coutput_dirs(coutput_root=coutput_root)$verdicts_plots_dir, "verdictsplots_", cnv_name, ".pdf", sep="")
  which_classes_merged_fn     = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "which_classes_merged.rda" , sep="")
  ldf_which_classes_merged_fn = paste(get_coutput_dirs(coutput_root=coutput_root)$merged_calls_dir, "ldf_which_classes_merged.rda" , sep="")

  rv               = list("data_fn"=data_fn, "dat_with_smpl_fn"=dat_with_smpl_fn, "fit_fn"=fit_fn, "sorted_calls_fns"=sorted_calls_fns,
                          "plot_fn"=plot_fn, "sample_names_fn"=sample_names_fn, "summary_calls_fns"=summary_calls_fns,
                          "joined_calls_fns"=joined_calls_fns, "merged_calls_fns"=merged_calls_fns, "merged_plots_fn"=merged_plots_fn,
                          "manyplot_fns"    =manyplot_fns    , "hard_calls_fn"   = hard_calls_fn, "cnvtest_sample_fns"=cnvtest_sample_fns,
                          "cnvtest_outfn"=cnvtest_outfn, "qc_stats_fn"=qc_stats_fn, "cnv_qcstats_fn"=cnv_qcstats_fn,
                          "merged_hcalls_fn"=merged_hcalls_fn, "sorted_smry_cfn"=sorted_smry_cfn, "merged_smry_cfn"=merged_smry_cfn,
                          "which_classes_merged_fn"=which_classes_merged_fn, "merged_cnvtest_ofn"=merged_cnvtest_ofn, "cnvtest_fn"=cnvtest_fn,
                          "text_pars_fn"=text_pars_fn, "stpts_fn"=stpts_fn, "args_input_fn"=args_input_fn, "all_cnvs_smry_fn"=all_cnvs_smry_fn,
                          "merged_qc_stats_fn"=merged_qc_stats_fn, "merged_cnv_qcs_fn"=merged_cnv_qcs_fn, "details_fn"=details_fn,
                          "masterListFname"=masterListFname, "verdicts_plots_fn"=verdicts_plots_fn, "merged_fits_fn"=merged_fits_fn,
                          "cnvtest_ind_exl_fn"=cnvtest_ind_exl_fn, "cnvtest_cnv_exl_fn"=cnvtest_cnv_exl_fn, "ldf_fit_fn"=ldf_fit_fn,
                          "ldf_joined_calls_fns"=ldf_joined_calls_fns, "ldf_sorted_calls_fns"=ldf_sorted_calls_fns, "ldf_smry_calls_fns"=ldf_smry_calls_fns,
                          "ldf_srtd_smry_cfn"=ldf_srtd_smry_cfn, "ldf_merged_calls_fns"=ldf_merged_calls_fns, "ldf_merged_hcalls_fn"=ldf_merged_hcalls_fn,
                          "ldf_merged_smry_cfn"=ldf_merged_smry_cfn, "ldf_merged_plots_fn"=ldf_merged_plots_fn, "ldf_merged_fits_fn"=ldf_merged_fits_fn,
                          "ldf_merged_cnvtest_ofn"=ldf_merged_cnvtest_ofn, "ldf_merged_qc_stats_fn"=ldf_merged_qc_stats_fn, 
                          "ldf_merged_cnv_qcs_fn"=ldf_merged_cnv_qcs_fn, "ldf_qc_stats_fn"=ldf_qc_stats_fn, "ldf_cnv_qcstats_fn"=ldf_cnv_qcstats_fn,
                          "ldf_hard_calls_fn"=ldf_hard_calls_fn, "ldf_unm_cnvtest_outfn"=ldf_unm_cnvtest_outfn, "ldf_plot_fn"=ldf_plot_fn,
                          "ldf_which_classes_merged_fn"=ldf_which_classes_merged_fn, "ldf_dat_with_smpl_fn"=ldf_dat_with_smpl_fn, 
                          "ldf_data_fn"=ldf_data_fn, "probeScale_fn"=probeScale_fn, "combinedCNVtestSampleFnames"=combinedCNVtestSampleFnames,
                          "CNVtestMultCasesFn"=CNVtestMultCasesFn)
  return(rv)
}


getCombinedCNVtestSampleFnames=function(collections, diseases)
{
  diseasePart = paste(diseases, collapse="_")
  combinedCNVtestSampleFnames = paste(get_coutput_dirs()$jd, "combinedDiseasesCNVtestSamples_", 
                                                             collections,
                                                             "_combining_", diseasePart, ".txt", sep=""); 
  names(combinedCNVtestSampleFnames)=collections;
  return(combinedCNVtestSampleFnames)
}

make_det_fn=function(arguments, real_data=F, det_filetag, signal_model="t8", seed=1, extra = "det_sim_study", verbose=1, deg_free=8, this_run_name)
{
  if(is.null(arguments)) {
    details_fn = write_tag_to_fn(tag=det_filetag, real_data=real_data, signal_model=signal_model, seed=seed, extra = extra, verbose=verbose, deg_free=deg_free, 
                  results_dir_tag=paste(this_run_name, "/", sep="")) 
  } else {
      details_fn = write_tag_to_fn(tag=arguments$det_filetag, real_data=real_data, signal_model=arguments$signal_model,  
               seed=seed, extra = "det_sim_study", verbose=arguments$verbose, deg_free=arguments$deg_free, results_dir_tag=arguments$results_dir_tag) 
  }
}

get_summary_names=function(withdir=F, jd=getjd(),
                           sample_names= get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
                           collections=names(sample_names))
{
  summary_call_names = paste("summarycalls_", mapping, "_", summary, "_", collections, ".txt", sep="")
  if(withdir) summary_call_names = paste(jd, summary_call_names, sep="")
  return(summary_call_names)
}


get_coutput_dirs=function(coutput_root = .default.coutput_root, cl=NULL, hitcp_details=NULL, er=NULL, merged=F)
{
  coutput_root       = coutput_root
  jd                 = paste(coutput_root, getjd()                     , sep="")
  cd                 = paste(coutput_root, getcd()                     , sep="")
  hard_calls_dir     = paste(coutput_root, get_hard_calls_dir()        , sep="")
  merged_calls_dir   = paste(coutput_root, get_merged_calls_dir()      , sep="")
  merged_hcalls_dir  = paste(coutput_root, get_merged_hcalls_dir()     , sep="")
  merged_plots_dir   = paste(coutput_root, get_merged_plots_dir()      , sep="")
  merged_fits_dir    = paste(coutput_root, get_merged_fits_dir()       , sep="")
  merged_call_QC_dir = paste(coutput_root, get_merged_call_QC_dir()    , sep="")
  merged_cnvtr_dir   = paste(coutput_root, get_merged_cnvtest_res_dir(expanded_reference=er), sep="")
  plots_dir          = paste(coutput_root, get_plots_dir()             , sep="")
  fits_dir           = paste(coutput_root, get_fits_dir()              , sep="")
  pars_dir           = paste(coutput_root, get_pars_dir()              , sep="")
  stpts_dir          = paste(coutput_root, get_stpts_dir()             , sep="")
  one_ddat_dir       = paste(coutput_root, get_one_ddat_dir()          , sep="")
  jplots_dir         = paste(coutput_root, get_joined_plots_dir(cl=cl) , sep="")
  sample_files_dir   = paste(coutput_root, get_sample_files_dir()      , sep="")
  sim_smry_dir       = paste(coutput_root, get_sim_smry_dir()          , sep="")
  probeScale_dir     = paste(coutput_root, get_probeScale_dir()        , sep="")

  ldf_calls_dir      = paste(coutput_root, get_ldf_calls_dir()          , sep="")
  ldf_fits_dir       = paste(coutput_root, get_ldf_fits_dir()           , sep="")
  ldf_dat_dir        = paste(coutput_root, get_ldf_dat_dir()            , sep="")
  ldf_plots_dir      = paste(coutput_root, get_ldf_plots_dir()          , sep="")
  ldf_merged_fits_dir= paste(coutput_root, get_ldf_merged_fits_dir()    , sep="")

  QC_dir             = paste(coutput_root, get_myQC_dir(merged=merged) , sep="")
  cnvtest_dir        = paste(project_root, get_cnvt_dir()              , sep="")
  cnvt_results_dir   = paste(coutput_root, get_cnv_test_results_dir(expanded_reference=er)  , sep="")
  hit_cplots_dir     = paste(coutput_root, get_hit_cplots_dir(hitcp_details=hitcp_details), sep="")
  verdicts_plots_dir = paste(coutput_root, get_verdicts_plots_dir(), sep="")

  rv = list("coutput_root"=coutput_root, "jd"=jd, "cd"=cd, "plots_dir"=plots_dir, "fits_dir"=fits_dir, "one_ddat_dir"=one_ddat_dir, 
         "QC_dir"=QC_dir, "jplots_dir"=jplots_dir, "merged_calls_dir"=merged_calls_dir, "cnvtest_dir"=cnvtest_dir, "pars_dir"=pars_dir,
         "cnvt_results_dir"=cnvt_results_dir, "merged_plots_dir"=merged_plots_dir, "hard_calls_dir"=hard_calls_dir,
         "hit_cplots_dir"=hit_cplots_dir, "merged_call_QC_dir"=merged_call_QC_dir, "merged_cnvtr_dir"=merged_cnvtr_dir,
         "stpts_dir"=stpts_dir, "sim_smry_dir"=sim_smry_dir, "verdicts_plots_dir"=verdicts_plots_dir, "merged_fits_dir"=merged_fits_dir,
         "ldf_fits_dir"=ldf_fits_dir, "ldf_calls_dir"=ldf_calls_dir, "ldf_dat_dir"=ldf_dat_dir, "ldf_plots_dir"=ldf_plots_dir,
         "ldf_merged_fits_dir"=ldf_merged_fits_dir, "probeScale_dir"=probeScale_dir)
  return(rv)
}

get_string_from_hitcp_details=function(hitcp_details)
{
  string = c()
  for(i in 1:length(hitcp_details))
  {
    string = paste(string, names(hitcp_details)[i], "=", hitcp_details[i], sep="")
    if(i < length(hitcp_details)) string = paste(subdir_name, "_", sep="") 
    if(i ==length(hitcp_details)) {}
  }
  return(string)
}
get_hit_cplots_dir=function(hitcp_details)
{
  subdir_name = get_string_from_hitcp_details(hitcp_details)
  return(subdir_name)
}
get_stpts_dir=function()
  return("stpts/")
getjd=function()
  return("joined_calls/")
get_hard_calls_dir=function()
  return("hard_calls/")
get_merged_hcalls_dir=function()
  return("hard_calls/")
get_merged_calls_dir=function()
  return("merged_calls/")
get_merged_call_QC_dir=function()
  return("merged_calls/QC/")
get_merged_plots_dir=function()
  return("merged_plots/")
get_merged_fits_dir=function()
  return("merged_fits/")
get_merged_cnvtest_res_dir=function(expanded_reference=NULL)
  return(paste("merged_testing_", "expanded_reference=", expanded_reference, "/", sep=""))
get_results_dir=function(coutput_root = .default.coutput_root)
  return(coutput_root)
get_sim_smry_dir=function(coutput_root = .default.coutput_root)
  return("sim_smry/")
getcd=function()
  return("calls/")
get_cnvt_dir=function()
  return("cnvtest/")
get_cnv_test_results_dir=function(expanded_reference=NULL)
  return(paste("testing_", "expanded_reference=", expanded_reference, "/", sep=""))
get_verdicts_plots_dir=function()
  return("verdicts_plots/")
get_ldf_fits_dir=function()
  return("ldf_fits/")
get_probeScale_dir=function()
  return("probeScale/")
get_ldf_calls_dir=function()
  return("ldf_calls/")
get_ldf_dat_dir=function()
  return("ldf_dat/")
get_plots_dir=function()
  return("plots/")
get_ldf_merged_fits_dir=function()
  return("ldf_merged_fits/")
get_ldf_plots_dir=function()
  return("ldf_plots/")
get_fits_dir=function()
  return("fits/")
get_pars_dir=function()
  return("pars/")
get_one_ddat_dir=function()
  return("one_ddat/")
get_myQC_dir=function(merged=F)
{
  if(merged) return("merged_calls/QC/") else return("QC/")
}
get_sample_files_dir=function()
  return("")
get_joined_plots_dir=function(cl)
  return(paste("joined_", cl, "cl_plots/", sep=""))

get_tags=function(t1=NULL, t2=NULL)
  return(c("t1"=t1, "t2"=t2))
getctags=function(t1=NULL, t2=NULL)
{
  if(is.null(t1)) tags = get_tags() else tags = get_tags(t1=t1, t2=t2)
  ct1  = paste("calls_", tags["t1"], sep="")  
  ct2  = tags["t2"] 
  return(c("ct1"=ct1, "ct2"=ct2))
}
getplottags=function(t1=NULL, t2=NULL)
{
  if(is.null(t1)) tags = get_tags() else tags = get_tags(t1=t1, t2=t2)
  ct1  = paste("image_", tags["t1"], sep="")  
  ct2  = tags["t2"] 
  return(c("ct1"=ct1, "ct2"=ct2))
}
getfittags=function(t1=NULL, t2=NULL)
{
  if(is.null(t1)) tags = get_tags() else tags = get_tags(t1=t1, t2=t2)
  ct1  = paste("fit_smry_", tags["t1"], sep="")  
  ct2  = tags["t2"] 
  return(c("ct1"=ct1, "ct2"=ct2))
}
getoneddtags=function(t1=NULL, t2=NULL)
{
  if(is.null(t1)) tags = get_tags() else tags = get_tags(t1=t1, t2=t2)
  ct1  = paste("one_ddat_", tags["t1"], sep="")  
  ct2  = tags["t2"] 
  return(c("ct1"=ct1, "ct2"=ct2))
}
join_tags=function(t1=NULL, t2=NULL, types="deprecated", type=1, file_type="calls", set=NULL)
{
  if(is.null(t1) & is.null(file_type))   {cts = get_tags(    ); t1=cts[1]; t2=cts[2]} else {
    if(is.null(t1) & file_type=="calls") {cts = getctags(    ); t1=cts[1]; t2=cts[2]}
    if(is.null(t1) & file_type=="plots") {pts = getplottags( ); t1=pts[1]; t2=pts[2]}
    if(is.null(t1) & file_type=="fits" ) {pts = getfittags(  ); t1=pts[1]; t2=pts[2]}
    if(is.null(t1) & file_type=="onedd") {pts = getoneddtags(); t1=pts[1]; t2=pts[2]}
  }
  if(types=="deprecated") ptcnv_psmry = NULL else ptcnv_psmry = types[type]
  joined_fn_tag = paste(t1, ptcnv_psmry, t2, sep="")
  return(joined_fn_tag)
}


get_sorted_names=function(sample_names= get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), 
                          collections=names(sample_names), withdir=F, jd=getjd())
{
  sorted_call_names = paste("sortedcalls_", mapping, "_", summary, "_", collections, ".txt", sep="")
  if(withdir) sorted_call_names = paste(jd, sorted_call_names, sep="")
  return(sorted_call_names)
}

#get_hcalls_names=function(sample_names= get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), 
#                          collections=names(sample_names), withdir=F, jd=getjd(), thresh)
get_hcalls_names=function(withdir=F, jd=getjd(), thresh)
{
  hcall_names = paste("hard_calls_", mapping, "_", summary, "_thresh=", thresh, ".txt", sep="")
  if(withdir) hcall_names = paste(jd, hcall_names, sep="")
  return(hcall_names)
}

output_ldfCalls=function(arguments, data_and_details, ldf_results)
{
  real_data=arguments$real_data; cnv_index=arguments$cnv_index; cnv_name=data_and_details$cnv_name; 
  StartCoord=data_and_details$StartCoord; sample_names=data_and_details$sample_names; data_array=data_and_details$data_array; 
  ldf_best_fit=ldf_results$best_fit; ung_dat=ldf_results$ung_dat
  coll_names=names(data_array); no_inds_vec=colSums(ldf_best_fit$dat); 

  if(is.null(cnv_name)) fn_cnv_name=cnv_index else fn_cnv_name=cnv_name;
  if(is.na(StartCoord)) fn_StartCoord=cnv_index else fn_StartCoord=StartCoord;

  ########## Create the required filenames ###########
  ldf_fit_fn   = get_coutput_fns(cnv_name = fn_cnv_name)$ldf_fit_fn
  ldf_dat_fn   = get_coutput_fns(cnv_name = fn_cnv_name)$ldf_data_fn
  ldf_dat_ffn  = get_coutput_fns(cnv_name = fn_cnv_name)$ldf_dat_with_smpl_fn
  ind_calls    = get_calls_matrices(objects=ldf_best_fit, ung_dat=ung_dat, collnames = names(data_array))
  ldf_calls_fn = write_tag_to_fn(tag=arguments$ldf_calls_fn_tag, real_data=real_data, signal_model=arguments$signal_model,  
                  seed=arguments$seed, extra = "ldf_calls/ldf_calls", verbose=arguments$verbose, deg_free=arguments$deg_free, 
                  results_dir_tag=arguments$results_dir_tag)
  ########## Create output directories ###########
  if(!file.exists(get_coutput_dirs()$ldf_fits_dir  )) dir.create(get_coutput_dirs()$ldf_fits_dir  )
  if(!file.exists(get_coutput_dirs()$ldf_dat_dir   )) dir.create(get_coutput_dirs()$ldf_dat_dir   )
  if(!file.exists(get_coutput_dirs()$ldf_plots_dir )) dir.create(get_coutput_dirs()$ldf_plots_dir )
  if(!file.exists(get_coutput_dirs()$ldf_calls_dir )) dir.create(get_coutput_dirs()$ldf_calls_dir )
 #if(!file.exists(get_coutput_dirs()$              )) dir.create(get_coutput_dirs()$)
  ########## Write the calls themselves ###########
  if(cnv_index==arguments$cnvs[1]) {
    if(arguments$write_calls & !is.null(sample_names[1])) write_calls(fn=ldf_calls_fn, cnv_index=cnv_index, colnames=T, 
          sample_names=sample_names, colls=coll_names, coll_nums=no_inds_vec, fit=ldf_best_fit, cnv_name=fn_cnv_name, 
          chr=data_and_details$chr, ung_dat=ung_dat, pos=StartCoord, ind_calls=ind_calls, sep_files=arguments$calls_in_sep_files, cnvs=arguments$cnvs)
  }
 if(arguments$write_calls) write_calls(fn=ldf_calls_fn, cnv_index=cnv_index, colnames=F, sample_names=sample_names, colls = coll_names, coll_nums=no_inds_vec, 
                   fit=ldf_best_fit, cnv_name=fn_cnv_name, chr=data_and_details$chr, ung_dat=ung_dat, pos=StartCoord, ind_calls=ind_calls, 
                   sep_files=arguments$calls_in_sep_files, cnvs=arguments$cnvs)
  ########## Save the model fits    ###########
  ldf_fit_smry= make_fit_summary_object(best_fit = ldf_best_fit, stpt_states=ldf_results$stpt_states)
  if(arguments$store_ldffit_smry){save(ldf_fit_smry, file=ldf_fit_fn)}
  ########## Save the used 1-d data ###########
  if(arguments$store_ldf_dat){
   if(!file.exists(ldf_dat_ffn)) save(ung_dat, file=ldf_dat_ffn)
   ud = ung_dat; 
   for(i in 1:length(ud)) {names(ud[[i]])=NULL; ud[[i]] = round(ud[[i]], digits=4)}
   save(ud, file=ldf_dat_fn)
  }
  ########## Generating plot for this cnv ###########
  plot_fn      = get_coutput_fns(cnv_name = fn_cnv_name)$ldf_plot_fn
  if(!arguments$real_data) {
    total_sim    = data_and_details$total_sim
    tr_nocl = 2*(total_sim$sim_pars$no_alleles)-1
  } else 
    tr_nocl = -1
  if(arguments$graphics_slow | arguments$png) 
    look_at_calls(objects=ldf_best_fit, new=F, png=arguments$png, plot_fn=plot_fn, cnv_index=cnv_index, no_bars=arguments$no_bars,
                   cnv_name=cnv_name, ung_dat=ung_dat, tr_nocl=tr_nocl, all_cl=T, indiv_cl=T);
  ########## ldf output complete ###########
  return(ldf_best_fit)
}



output_results=function(arguments, data_and_details, extra_args, results)
{
   if(DEBUG>0 & arguments$verbose>=1 & arguments$write_results!=0) cat(" Summarising and writing results to files.\n", sep="");
   real_data    = arguments$real_data
   otptdirs     = make_output_dirs(real_data=real_data,  verbose=arguments$verbose, results_dir_tag=arguments$results_dir_tag)
   cnv_index    = data_and_details$cnv_index
   cnv_name     = data_and_details$cnv_name
   StartCoord   = data_and_details$StartCoord
   if(is.null(cnv_name)) fn_cnv_name=cnv_index else fn_cnv_name=cnv_name;
   if(is.na(StartCoord)) fn_StartCoord=cnv_index else fn_StartCoord=StartCoord;
   data_array   = data_and_details$data_array
   no_probes    = ncol(data_array[1,1][[1]])
   stpt_states  = results$stpt_states
   best_fit     = results$best_fit
   pagd         = best_fit$oinferred$pagd
   coll_names   = names(data_array) 
   no_inds_vec  = colSums(best_fit$dat)
   ung_dat      = data_and_details$ung_dat
   ind_calls    = get_calls_matrices(objects=best_fit, ung_dat=ung_dat, collnames = names(data_array))
   chr          = data_and_details$chr
   true_d_range = data_and_details$true_d_range
   orig_spread  = true_d_range[2]-true_d_range[1]
   sample_names = data_and_details$sample_names
   confidence   = calc_confidence(pagd=best_fit$oinferred$pagd, grid_dat = best_fit$dat)
   cnvs         = arguments$cnvs
   seed         = arguments$seed
   this_run_smry= make_fit_summary_object(best_fit = best_fit, stpt_states=stpt_states)
   sn_fn = get_coutput_fns(cnv_name = fn_cnv_name)$sample_names_fn
   if(arguments$output_sample_names | !file.exists(sn_fn)) {
     ind_names1 = lapply(data_array, rownames); #check for sangercontrol: "HapMap412943" %in% ind_names1[[1]]
     write.list_to_file(ind_names1, filename=sn_fn)
   }
  best_fit$likelihood$bic_evidence = calc_evidence(fit=best_fit, separate_collections=T) 

   evidences          = apply(X=stpt_states, MARGIN=c(1,2), FUN=calc_evidence, separate_collections=arguments$use_hier_mchoice, set_point = "hier_mchoice", type="bic", new=F) 
   max_evidences      = apply(evidences, MARGIN=1, max, na.rm=T)
  #cat("  Check that I'm getting the maximum evidence correctly.\n"); browser();
   nocl1_row          = which(rownames(evidences)=="cl=1")
   if(length(nocl1_row)==1) {
     nocl1ev            = evidences[,1]
     nocl_gt1ev         = max(evidences[-c(which(rownames(evidences)=="cl=1")),])
     if(0 & DEBUG > 1.7) {cat("Sort out evidence for polymorphism (hier mchoice = ", arguments$use_hier_mchoice, ").\n"); browser();}
   }
   #nocl1ev           = stpt_states[which(rownames(stpt_states)=="cl=1"),1][[1]]$likelihood$bic_evidence
   #stpt_best_noclrow = which(rownames(stpt_states)==paste("cl=", best_fit$opars$nocl, sep=""))
   #nocl_gt1ev        = max(sapply(stpt_states[stpt_best_noclrow,], function(x) return(x$likelihood$bic_evidence)))
   #evidences          = apply(X=stpt_states, MARGIN=c(1,2), FUN=calc_evidence, separate_collections=F, set_point = NULL, type="bic") 
   if(!arguments$real_data) {
     total_sim    = data_and_details$total_sim
          tr_nocl = 2*(total_sim$sim_pars$no_alleles)-1
   } else 
     tr_nocl = -1
   if(!is.null(sample_names)) sample_names = matrix(sample_names, nrow=1)
   #get_coutput_fns()$ get_dir_names()$
   writeProbeScalings(data_and_details=data_and_details, cnv_name=fn_cnv_name)

   calls_fn     = write_tag_to_fn(tag=arguments$calls_fn_tag       , real_data=real_data, signal_model=arguments$signal_model,  seed=seed, extra = "calls/calls", verbose=arguments$verbose, deg_free=arguments$deg_free, results_dir_tag=arguments$results_dir_tag)
   det_fn       = write_tag_to_fn(tag=arguments$det_filetag        , real_data=real_data, signal_model=arguments$signal_model,  seed=seed, extra = "det_sim_study", verbose=arguments$verbose, deg_free=arguments$deg_free, results_dir_tag=arguments$results_dir_tag) 
   all_cnvs_smry_fn = get_coutput_fns(cnv_name = fn_cnv_name)$all_cnvs_smry_fn
   args_fn_tag  = get_coutput_fns(cnv_name = fn_cnv_name)$args_input_fn
   outputfns_fn = paste(arguments$overall_summary_tag, "filenames_of_input_and_output_files", arguments$seed, ".txt", sep="")

   plot_fn      = get_coutput_fns(cnv_name = fn_cnv_name)$plot_fn
   text_pars_fn = get_coutput_fns(cnv_name = fn_cnv_name)$text_pars_fn
   fit_fn       = get_coutput_fns(cnv_name = fn_cnv_name)$fit_fn
   stpts_fn     = get_coutput_fns(cnv_name = fn_cnv_name)$stpts_fn
   one_ddat_fn  = get_coutput_fns(cnv_name = fn_cnv_name)$data_fn
   one_ddat_ffn = get_coutput_fns(cnv_name = fn_cnv_name)$dat_with_smpl_fn
   sim_pars_fn  = get_input_fns(arguments=arguments, cnv_index=cnv_index)$simpars_fn
   simdat_fn    = get_input_fns(arguments=arguments, cnv_index=cnv_index)$simdat_fn
   sim_hprs_fn  = get_input_fns(arguments=arguments, cnv_index=cnv_index)$sim_hprs_fn
   simdat_fn    = data_and_details$total_sim$this_sim_fn
   inout_fns    = c("all_cnvs_smry_fn"  =all_cnvs_smry_fn  , "calls_fn" = calls_fn    , "plot_fn"      = plot_fn      , "det_fn"      = det_fn      , 
                    "simdat_fn"=simdat_fn, "sim_hprs_fn" = sim_hprs_fn , "outputfns_fn"= outputfns_fn, "sim_pars_fn" = sim_pars_fn ,
                    "stpts_fn" =stpts_fn , "text_pars_fn" = text_pars_fn , "args_fn_tag" = args_fn_tag, "simdat_tag" = arguments$simdat_tag)
   if(cnv_index==cnvs[1] & arguments$write_inout_fns) write.table(inout_fns, file = outputfns_fn, quote=F, append=F, col.names=F)
   hard_calls   = check_calls(ob=best_fit, data_array=data_array, ung_dat=ung_dat)
   hard_calls   = lapply(hard_calls, make_nullcalls_na, nocl=best_fit$opars$nocl)
  #calls4write  = matrix(unlist(hard_calls), nrow=ncol(data_array), byrow=F)

   # Need to write crucial info about each CNV (add to summary file?):
   #  - Breakdown of bic_evidence: Likelihood, components of prior, P(phen|genotypes)
   write_args = prep_arguments(arguments)
  #summary   = paste("cnv_id", "Estimated_no_classes:", "assoc_evidence", "beta1", "bic_evidence", paste("max_ev_", names(max_evidences),sep=""), "signal_model", "no_inds", "no_probes")
   summary   =     c("cnv_id", "Estimated_no_classes:", "assoc_evidence", "beta1", "bic_evidence", paste("max_ev_", names(max_evidences),sep=""), "orig_spread", "confidence", "signal_model", "deg_free", "no_inds", "no_probes")
   if(cnv_index==cnvs[1]) {
     if(arguments$write_nocl_summary) write.table(t(summary), file=all_cnvs_smry_fn , quote=F, row.names=F, col.names=F, append=T)
     #cat("in output results1.\n"); browser()
     if(arguments$write_calls & !is.null(sample_names[1])) write_calls(fn=calls_fn, cnv_index=cnv_index, colnames=T, sample_names=sample_names, colls=coll_names, coll_nums=no_inds_vec, fit=best_fit, cnv_name=fn_cnv_name, chr=chr, ung_dat=ung_dat, pos=StartCoord, ind_calls=ind_calls, sep_files=arguments$calls_in_sep_files, cnvs=arguments$cnvs)
     if(!real_data) sim_par_names = matrix(c(names(data_and_details$total_sim$sim_pars), names(data_and_details$total_sim$sim_pars$intens_pars)), nrow=1)
     if(!real_data) sim_hprior_names = matrix(c(names(data_and_details$total_sim$sim_hprior), names(data_and_details$total_sim$sim_pars$intens_pars)), nrow=1)
     if(arguments$write_arguments) write.list_to_file(write_args, filename=args_fn_tag)
     if(!real_data & arguments$write_arguments) write.table(sim_par_names   , file = sim_pars_fn, quote=F, row.names=F, col.names=F, append=F)
     if(!real_data & arguments$write_arguments) write.table(sim_hprior_names, file = sim_hprs_fn, quote=F, row.names=F, col.names=F, append=F)
   }
    # if(!arguments$real_data & arguments$write_details) 
   if(is.null(cnv_name)) cnv_id = cnv_index else cnv_id = cnv_name
   #cat("in output results1.\n"); browser()
   if(arguments$write_calls) write_calls(fn=calls_fn, cnv_index=cnv_index, colnames=F, sample_names=sample_names, colls = coll_names, coll_nums=no_inds_vec, 
                     fit=best_fit, cnv_name=fn_cnv_name, chr=chr, ung_dat=ung_dat, pos=StartCoord, ind_calls=ind_calls, sep_files=arguments$calls_in_sep_files, cnvs=arguments$cnvs)
   numbers = round(c(best_fit$opars$nocl, best_fit$likelihood$lassoc_bf, best_fit$opars$betas[2], best_fit$likelihood$bic_evidence, max_evidences, orig_spread, confidence), digits=2)
   smry_line = t(as.matrix(c(cnv_id, numbers, best_fit$flags$signal_model, best_fit$flags$deg_free, sum(best_fit$dat), no_probes)))
   colnames(smry_line) = summary
   if(arguments$write_nocl_summary) write.table(smry_line, file=all_cnvs_smry_fn , quote=F, row.names=F, col.names=F, append=T)
   if(arguments$write_summary) quick_fit_summary(fit=best_fit, write=arguments$write_summary, text_pars_fn=text_pars_fn, seed=seed, cnv_name=cnv_name, cnv_index=cnv_index, verbose=arguments$verbose, smry_line=smry_line, stpt_states=stpt_states)
   if(0 & !real_data & arguments$write_details) unused_det_fn = detailed_sim_output(objects=best_fit, sim_pars=total_sim$sim_pars, simdat=total_sim$simdat, 
                    sim_index=cnv_index, filename=det_fn, h_calls=hard_calls, tr_nocl=tr_nocl, ung_dat=ung_dat)
   if(!real_data) sim_par_output    = matrix(unlist(data_and_details$total_sim$sim_pars)  , nrow=1)
   if(!real_data) sim_hprior_output = matrix(unlist(data_and_details$total_sim$sim_hprior), nrow=1)
   if(!real_data & arguments$write_arguments) write.table(sim_par_output   , file = sim_pars_fn, quote=F, row.names=F, col.names=F, append=T)
   if(!real_data & arguments$write_arguments) write.table(sim_hprior_output, file = sim_hprs_fn, quote=F, row.names=F, col.names=F, append=T)
   if(arguments$store_ung_dat){
     if(!file.exists(one_ddat_ffn)) save(ung_dat, file=one_ddat_ffn)
    #browser()
     ud = ung_dat; 
     for(i in 1:length(ud)) {names(ud[[i]])=NULL; ud[[i]] = round(ud[[i]], digits=4)}
     save(ud, file=one_ddat_fn)
   }
   if(arguments$store_thisfit_smry){save(this_run_smry, file=fit_fn)}

  #if(!real_data  & arguments$write_details & cnv_index >cnvs[1]) det_filetag  = det_summary_fn
   if(arguments$graphics_slow | arguments$png) 
     look_at_calls(objects=best_fit, new=F, png=arguments$png, plot_fn=plot_fn, cnv_index=cnv_index, no_bars=arguments$no_bars,
                    cnv_name=cnv_name, ung_dat=ung_dat, tr_nocl=tr_nocl, all_cl=T, indiv_cl=T);
   if(cnv_index==arguments$cnvs[length(arguments$cnvs)] & DEBUG>1.7 | arguments$write_results==0) {
     f = best_fit; 
     if(names(dev.cur())!= "null device") plotd(f); cat("betas = ", f$opars$betas, "\n"); cat("BF = ", f$likelihood$lassoc_bf, "\n")
     browser();
   }
   if(length(grep("garganey", project_root))>0) return(best_fit) else return(NULL)
}

writeProbeScalings=function(data_and_details=data_and_details, cnv_name)
{
  if(!file.exists(get_coutput_dirs()$probeScale_dir)) dir.create(get_coutput_dirs()$probeScale_dir)
  cnv_name=data_and_details$cnv_name
  probeScale_fn = get_coutput_fns(cnv_name=cnv_name)$probeScale_fn
  write.table(data_and_details$probe_scale, file=probeScale_fn, quote=F, row.names=T, col.names=F, append=F)
}


#Dan wrote me this function!
write.list_to_file=function(x, filename, append=F) {
  connxn <- file(filename, "w")
  if(is.null(names(x))) {  #This variant for no-names written by Niall
    names(x) = 1:length(x) 
    lapply(names(x), function(cnv) {cat(x[[cnv]], file=connxn); cat("\n", file=connxn, sep="")} )
  } else {
   #lapply(names(x), function(cnv) {cat(cnv, x[[cnv]], file=connxn); cat("\n", file=connxn, sep="")} )
    lapply(names(x), function(cnv) cat(cnv, x[[cnv]], "\n", file=connxn)) #Original line by dan
  }
  close(connxn) # added by me so possibly daft
  invisible()
}

#write_calls(fn=calls_fn, cnv_index=cnv_index, colnames=F, sample_names=sample_names, colls = colls, coll_nums=no_inds_vec)
write_calls=function(fn, cnv_index=NULL, cnv_name=NULL, chr, pos, colnames=F, sample_names, colls, coll_nums, 
                     forJM=T, fit, ung_dat, ind_calls=NULL, sep_files=T, cnvs=NULL, DEBUG=1.1)
{
  ending = substr(fn, nchar(fn)-3, nchar(fn))
  nocl   = fit$opars$nocl
  if(ending==".txt") fn = substr(fn, 1, nchar(fn)-4)
  if(is.null(ind_calls)) ind_calls  = get_calls_matrices(objects=fit, ung_dat=ung_dat)
  write_header = (!forJM & colnames & !is.null(sample_names[1]) & !sep_files)

  if(length(colls)<=0) {
    cat("  Warning! No Collection names passed!.\n"); 
    if(DEBUG>1.1) browser(); 
    colls = makeDefaultCollnames(noco=length(ind_calls))
  }  
  if(length(colls)!=length(ind_calls)) {cat("  Warning! Unclear how many collections there are in write_calls.\n"); if(DEBUG>1.1) browser();}  

  for(coll in 1:length(colls))
  {
    if(!sep_files) coll_fn = paste(fn, "_", colls[coll], ".txt", sep="")
    if( sep_files) {
      if(length(cnvs)==1) {
        if( is.null(cnv_name)) coll_fn = paste(fn, "_", cnv_index, "_", colls[coll], ".txt", sep="")
        if(!is.null(cnv_name)) coll_fn = paste(fn, "_", cnv_name , "_", colls[coll], ".txt", sep="")
      } else {
        coll_fn = paste(fn, "_firstcnv=", cnvs[1], "_", colls[coll], ".txt", sep="")
      }
    }
    if(write_header) write.table(sample_names, file=coll_fn, quote=F, row.names=F, col.names=F, append=F)
    write_line = matrix(c(chr, cnv_name, pos, nocl, round(ind_calls[[coll]], digits=3)), nrow=1)
    if(!sep_files) {
      write.table(write_line, file=coll_fn, quote=F, row.names=F, col.names=F, append=T)
    }
    if( sep_files)  {
     if(!colnames){
       if(cnv_index==cnvs[1]){
          write.table(write_line, file=coll_fn, quote=F, row.names=F, col.names=F, append=F)
        } else {
          write.table(write_line, file=coll_fn, quote=F, row.names=F, col.names=F, append=T)
        }
      }
    }
  }
  #cat("in write_calls.\n"); browser()
}

#This function simply processes the object 'arguments' so that it can be more easily written to file.
prep_arguments=function(arguments)
{
  ar2     = arguments
  lengths = sapply(arguments, length)
  for(i in which(lengths>1)) {
    ar2[[i]]        = max(arguments[[i]])
    names(ar2)[[i]] = paste("max", names(arguments)[[i]], sep="")
  }
  ar2[sapply(ar2, is.null)] = "NULL"
  return(ar2)
}

#This function creates a list of the most important features of the model fit to enable plotting of model fits and calculation of likelihoods etc.
make_fit_summary_object=function(best_fit, stpt_states)
{
  best_nocl     = best_fit$opars$nocl
  nocls         = as.numeric(sapply(strsplit(rownames(stpt_states), split="="), '[', 2))
  evidences     = apply(X=stpt_states, MARGIN=c(1,2), FUN=calc_evidence, separate_collections=best_fit$flags$use_hier_mchoice, set_point = "hier_mchoice", type="bic", new=F) 
  max_evidences = apply(evidences, MARGIN=1, max, na.rm=T)
 #max_e_indices1 = which(evidences==max_evidences, arr.ind=T) #, na.rm=T)
  all_fit_pars_smrys = as.list(rep(NA, length(nocls)))
  max_e_indices = rep(NA, nrow(evidences))
  for(nocl_ind in 1:length(nocls)) max_e_indices[nocl_ind] = which(evidences[nocl_ind,]==max_evidences[nocl_ind])[1] #[1] is normally redundant but sometimes there are ties
  for(nocl_ind in 1:length(nocls))
  {
    nocl  = nocls[nocl_ind]
    if(nocl!=best_nocl) spfit = stpt_states[[nocl_ind,max_e_indices[nocl_ind]]] else spfit = best_fit
    all_fit_pars_smrys[[nocl_ind]] = specific_fit_summary(fit=spfit)
  }
  best_fit_pars_smry = specific_fit_summary(fit=best_fit)
  smry = list("cnv_name"=best_fit$flags$cnv_name, "cnv_index"=best_fit$flags$cnv_index, "gdat" = best_fit$dat, 
              "grid_lklihds"=best_fit$oinferred$lpdga, "full_lklihd"=best_fit$likelihood$o_liklihd, 
              "intensity_lklihd"=best_fit$likelihood$o_intsty, 
              "evidences"=evidences, "bestf_pars"=best_fit_pars_smry, "use_null" = best_fit$flags$use_null, 
              "null_prop"=best_fit$opars$null_prop, "signal_model"=best_fit$flags$signal_model, 
              "deg_free"=best_fit$flags$deg_free)
 #if(DEBUG==1.71) {cat("Design model fit summary.\n"); browser();}
  return(smry)
}
# Plotting Code! Also now want to be able to add the posterior on class assignment, like Vincent does.
#   - Chris Holmes wanted to plot the quantiles of the data against the quantiles of the model fit. What do I need for that?


#  source("cnv_caller.R"); likelihood_summary(write_tag="test_3")
#  source("cnv_caller.R"); likelihood_summary(which_cnvs=1:150, write_tag="test_3")
likelihood_summary=function(machine="garganey", which_cnvs="all", write_tag="test_of_new_summary", cnv_identifier="CNV", 
                            sig_model = "t8", seed=1, verbose=1)
{
  ptcnv         = read_ptcnv( mapping=mapping)  
  mapped_cnvs   = ptcnv[,cnv_identifier]; 
 #if(which_cnvs[1]=="all") cnvs = ptcnv[which(ptcnv[,"Chr"]%in%(1:22)),cnv_identifier] else cnvs = ptcnv[which_cnvs,cnv_identifier];
  if(which_cnvs[1]=="all") cnvs = ptcnv[which(ptcnv[,"Chr"]!=23),cnv_identifier] else cnvs = ptcnv[which_cnvs,cnv_identifier];
  likelihoods   = as.list(rep(NA, length(cnvs))); names(likelihoods) = cnvs
  for(cnv_index in 1:length(cnvs))
  {
    cnv_name     = cnvs[cnv_index]
    full_data_fn = get_coutput_fns(cnv_name = cnv_name)$dat_with_smpl_fn
    simple_fn    = get_coutput_fns(cnv_name = cnv_name)$data_fn
    fit_fn       = get_coutput_fns(cnv_name = cnv_name)$fit_fn

    likelihoods[[cnv_index]] = likelihood_from_fits(smpl_fn=simple_fn, data_fn=full_data_fn, fit_fn=fit_fn, signal_model=sig_model)
  }
  browser();
  return(likelihoods)
}


myload=function(fn=NULL)
{
  if (is.null(fn))
    return(NULL)

  name = load(fn)
  return(get(name))
}

