Initialise=function(dat=NULL, gridding=T, noco = 3, nocl, stpt_ind=1, stpt=NULL, case_colls=NULL, DEBUG=NULL, iter=0, no_iters=NULL, null_prior=NULL, extra_args, 
                    no_inds=NULL, grid_breaks=NULL, grid_density=NULL, no_inds_vec=NULL, graphics_slow=NULL, use_null_class=NULL, null_prop=NULL, data_and_details=NULL,
                    artificial_stop=NULL, png_fn_tag=NULL, cnv_index, signal_model=NULL, start_hierarchy=NULL, seed=NULL, probe_summary=NULL, arguments=NULL, model=NULL)
{
  dat            = data_and_details$gdat ;              noco = data_and_details$noco  ;     null_prior       = arguments$use_pr_on_nl_classp ;
  DEBUG          = arguments$DEBUG       ;        case_colls = arguments$case_colls   ;     use_null_class   = arguments$use_null_class      ;
  null_prop      = arguments$null_prop   ;       no_inds_vec = colSums(dat)           ;       no_inds        = sum(no_inds_vec)              ;
  grid_density   = arguments$grid_density;     graphics_slow = arguments$graphics_slow;       grid_breaks    = data_and_details$grid_breaks  ;
  png_fn_tag     = arguments$png_fn_tag  ;      signal_model = arguments$signal_model ;      artificial_stop = arguments$artificial_stop     ;
  seed           = arguments$seed        ;     probe_summary = arguments$probe_summary;      start_hierarchy = arguments$start_hierarchy     ;
  min_extra_cld  = arguments$min_extra_cld ;  use_hierarchy  = arguments$use_hierarchy; 
  sum_calls_nocl = arguments$sum_calls_nocl;  sum_calls_assoc= arguments$sum_calls_assoc;    sum_calls       = sum_calls_nocl                ;
  simple_model_iters   = arguments$simple_model_iters  ;                             ;              min_var  = arguments$min_var             ;
  hier_mchoice_iters   = arguments$hier_mchoice_iters  ;                             ;      use_hier_mchoice = arguments$use_hier_mchoice    ;
  no_assoc_model_iters = arguments$no_assoc_model_iters;                             ;            cnv_name   = data_and_details$cnv_name     ;
  full_model_iters     = arguments$full_model_iters    ;wdat = arguments$wdat        ;
  no_iters             = arguments$no_iters            ;                             ;            use_priors = arguments$use_priors          ;
  stpt                 = extra_args$stpts[[stpt_ind]]  ;                             ;              deg_free = arguments$deg_free            ;
  gnf_theta            = arguments$gnf_theta           ;                             ;

  # nocl  = no of classes/clusters. The number of distinct possible genotype classes
  # anocl = This is the number of classes that individuals can actually be assigned to (so it includes NULL)
  # cld   = The _global_ distances between each of the classes (the collections are perturbations of this)
  # smc   = The locations of the smallest logratio class in each of the collections
  # clv   = The variances of each the classes in each of the collections
  # of each individual in each collection to a class
  # pda   = prob_dat_given_assignments: These  is the probability of the individuals data given the assignments 
  # pda   = matrix(list(), nrow=1, ncol = noco) 
  # pdga  = prob_dat_given_assignments - lpdga[cl,col] = Prob of measurement given in class cl and mean, centres of cl.
  # lpdga[cl,col] = P(Xi | mu_cl, sg^2_cl, pi_cl) #This is wha'ts actually used)
  # pagd  = prob_assignment_given_dat: This is the probability of the various possible assignments for each ind.
  # pdgs  = The probability of the data given the centers of the smallest classes for each collection
  # pdgs  = matrix(-1, nrow = 1, ncol = noco)
  # prgnf = The prior on the genotype frequencies in each cohort.
  # gnf   = The genotype frequency vector in each cohort.
  # gnf_apar - This parameterises the prior on the *allele* frequency.
      #('alpha' in the model). for the genotype frequency vector. Currently NOT cohort specific (reflecting no population structure)
  # gnf_ws This parameterises the prior on the *population genotype* frequency (gnf_lambda - gnf_controls and gnf_cases deal with the obvious frequencies)

    grid_size = nrow(dat)
    anocl     = nocl + as.integer(use_null_class)

   #gnf = matrix(-1, nocl, noco)
   #for(col in 1:noco)
   #  gnf[,col] = 1.0/nocl   #gnf[,col] = sum(dat[,col])/nocl
    ## Need to think what these values should be! Alpha essentially controls the range of possible allele frequency distributions
    ## Also need to reparameterise these values in terms of a mean and variance!
    #a = M(M(1-M)/V -1)
    #b = (a/M)-a
    gnf_a_m = 0.5
    gnf_a_v = 0.035
    gnf_hp_shape1 = gnf_a_m*(gnf_a_m*(1-gnf_a_m)/gnf_a_v -1); # mean = a/(a+b), var = (a*b)/((a+b)^2*(a+b+1))
    gnf_hp_shape2 = (gnf_hp_shape1/gnf_a_m)-gnf_hp_shape1; #'alpha_var' in the model - the variance of the parameter 'gnf_apar' (alpha in the model), describes gnf_ws (w in the model)3
    gnf_theta     = gnf_theta; #'theta' in the model - control how close to HWE we are
    #(alpha in the model) This is a draw from the prior on the distribution of the tightness of the dirichlet in the gnf model:
    gnf_apar      = rbeta(1, shape1=gnf_hp_shape1, shape2=gnf_hp_shape2)

    #The w's are distributed in a 1,4,6,4,1 kindof way.
    # When there are two alleles there are three genotype classes and these are labelled: 0,1,2 (so the last one is labelled nocl-1).
    gnf_ws      = make_ws_from_alpha(gnf_apar=gnf_apar, nocl=nocl, gnf_theta=gnf_theta)
    dparams     = (gnf_theta*gnf_ws)
    if(sum(gnf_ws<1)>0 & DEBUG>1.6 & arguments$verbose>1) 
      cat(" Warning, some prior genotype frequencies are extremely low (In function: Initialise), \n Raising frequency in minimum classes.\n");
    gnf_lambda  = my_rdirichlet(1, (dparams)) + 5e-5      #This line is to ensure at least a 1/20,000 prior probability of allocation
    gnf_lambda  = normalise(gnf_lambda, sum=(1-null_prop))
    gnf_controls = NA
    gnf_cases    = NA
    check = sum(abs(gnf_lambda)<1e-8)
    if(check>0 & DEBUG>0.9) {cat(" Warning - have an extremely low prior on the genotype frequency in", check, "of the classes.\n"); browser();}
    # This records the current `inference' on the frequency of null individuals in the POPULATION
    # Note that this is distinct to the *class proportions* where the null CP is fixed at null_prop
    if( use_null_class) nullf        = rep(NA, noco)
    if(!use_null_class) nullf        = rep(NA, noco)
    names(nullf) = paste(rep("coll=", noco), 1:noco, sep="")
    gnfp = list(     nullf ,  gnf_hp_shape1 ,  gnf_hp_shape2  , gnf_theta  , gnf_apar  , gnf_ws  , gnf_lambda ,  gnf_controls ,  gnf_cases )
    names(gnfp) = c("nullf", "gnf_hp_shape1", "gnf_hp_shape2", "gnf_theta", "gnf_apar", "gnf_ws", "gnf_lambda", "gnf_controls", "gnf_cases")
    ok_to_be_na = which(names(gnfp) %in% c("nullf", "gnf_controls", "gnf_cases"))
    if(is.na(range(gnfp[-c(ok_to_be_na)])[1])) {cat(" Warning, NAs detected in genotype_frequency priors.\n"); browser();}
    lpdga = array(-1,  c(grid_size, anocl, noco)) #Remember, this NO LONGER has the counts in each grid included in it
    pagd  =  array(-1, c(grid_size, anocl, noco)) #Remember, this NO LONGER has the counts in each grid included in it
    lpagd =  array(-1, c(grid_size, anocl, noco)) #Remember, this NO LONGER has the counts in each grid included in it
    names(lpdga)     = names(dat);
    lpdga_rownames   = paste("gridval", 1:dim(lpdga)[1], sep="")
    lpdga_colnames   = paste("cl" , 1:dim(lpdga)[2], sep="")
    if(use_null_class) 
      lpdga_colnames[length(lpdga_colnames)] = c("NULL")
    if(!arguments$real_data) lpdga_3rdnames   = makeDefaultCollnames(noco=dim(lpdga)[3])
    if( arguments$real_data) lpdga_3rdnames   = colnames(dat)
    dimn_lpdga       = list(lpdga_rownames,lpdga_colnames,lpdga_3rdnames)
    dimnames(pagd ) = dimn_lpdga
    dimnames(lpagd) = dimn_lpdga
    dimnames(lpdga) = dimn_lpdga

  new_assignments = matrix(list(), nrow=noco, ncol=no_inds)
  for(collection in 1:noco)  
    new_assignments[1,collection] = list(matrix(-1, nrow=no_inds_vec[collection], ncol=anocl))

   betas = rep(-1, 2) #beta[1] = baseline risk, beta[2] = additive effect.
   prbeta0 = list("normal", 0, 1)          #Given by Jonathan!
   prbeta1 = list("normal", 0, (0.2)^2)    #Given by Jonathan!
   names(prbeta0)  = c("distribution", "mean", "var");
   names(prbeta1)  = c("distribution", "mean", "var");


   ## prsmc = pr_classes_small  = the prior on the position of the smallest class.

   prsmc_mean_mean   = -0.02
   prsmc_mean_var    = (0.005)^2
   prsmc_var_mean    = 0.0002
   prsmc_var_var     = (0.0002)^2
   ss                = mean_var_to_standard_pars(distribution="inverse_gamma", mean=0.0002, var=(0.0002)^2, verbose=F)
   prsmc_var_scale   = ss["iscale"]
   prsmc_var_shape   = ss["ishape"]
  #prsmc_var_scale   = 5e-3
  #prsmc_var_shape   = 3
   prsmc_mean        = list("normal"       , prsmc_mean_mean, prsmc_mean_var )
   names(prsmc_mean) = c("distribution"    , "mean"         , "var"     )
   prsmc_var         = list("Inverse Gamma", prsmc_var_scale, prsmc_var_shape)
   names(prsmc_var)  = c("distribution"    , "scale"        , "shape"        )

   prsmc_mean1       = rnorm(1, prsmc_mean_mean, sqrt(prsmc_mean_var))
   prsmc_var1        = rinvgamma(1, scale = prsmc_var_scale, shape = prsmc_var_scale)

   hprsmc            = list(prsmc_mean ,  prsmc_var)
   names(hprsmc)     = list("mean", "var")
   prsmc             = list("normal", prsmc_mean1, prsmc_var1)
   names(prsmc)      = c("distribution", "mean", "var")

   ##prcld = pr_class_distances = the prior on the gaps between different classes
   prcld_mean_mean   =  0.02
   prcld_mean_var    = (0.002)^2
   prcld_var_mean    =  0.0001     #  0.002
   prcld_var_var     = (0.0002)^2 # (0.0005)^2
   prcld_mean_scale  = prcld_mean_var /prcld_mean_mean
   prcld_mean_shape  = prcld_mean_mean/prcld_mean_scale
   prcld_var_scale   = prcld_var_var  /prcld_var_mean
   prcld_var_shape   = prcld_var_mean /prcld_var_scale
  #prcld_shape       = prcld_mean/prcld_scale
   prcld_mean        = list("gamma", prcld_mean_scale, prcld_mean_shape);
   prcld_var         = list("gamma", prcld_var_scale , prcld_var_shape );
   names(prcld_mean) = c("distribution", "scale", "shape")
   names(prcld_var)  = c("distribution", "scale", "shape")
   prcld_mean1       = rgamma(1, scale=prcld_mean_scale, shape=prcld_mean_shape)
   prcld_var1        = rgamma(1, scale=prcld_var_scale , shape=prcld_var_shape )
   prcld_scale       = prcld_var1/prcld_mean1
   prcld_shape       = prcld_mean1/prcld_scale
   prcld             = list("gamma", prcld_scale, prcld_shape); 
   names(prcld)      = c("distribution", "scale", "shape")
   hprcld            = list(prcld_mean ,  prcld_var)
   names(hprcld)     = list("mean", "var")


  smc   = rep(0,noco);
  names(smc) = colnames(dat)
  cld   = matrix(-1, nrow=noco, ncol=(nocl-1)) 
  if(ncol(cld)>0) colnames(cld) = paste(rep("c_dist_", ncol(cld)), 1:(ncol(cld)), sep="")

  if(nrow(cld)>0) {
    if(arguments$real_data) {
      rownames(cld) = colnames(dat) #(!) CAREFUL, I haven't checked that these names are all in the right order.
    } else {
      rownames(cld) = makeDefaultCollnames(noco=nrow(cld)) 
    }
  }

 #gsmc   = 0;
 #gcld   = rep(-1, (nocl-1)) 
 #gclv   = rep(-1,  nocl   )
 #if(length(gcld)>0) names(gcld) = paste(rep("c_dist_", length(gcld)), 1:(length(gcld)), sep="")
 #names(gclv) = paste(rep("cl_", length(gclv)), 1:(length(gclv)), sep="")

   ## Normal data, how should I express uncertainty in the variances of the classes? To do with probesno_probes
   ##prclv = pr_class_vars = the prior on the variances in the different classes
   # The model for cluster variances is: log(var_{cj, zj}) = base{cj, 0} + increment_cj * z_j (cj = cohort of ind j, zj=copynumber of ind j)
   # Prior on the base variance is normal(a,b) where a is N(s1, s2^2) and b is inverse_gamma(t1, t2)
   # Prior on the increment variance is gamma(phi_m, phi_var) where phi_m is Gamma(u1, u2) and phi_var gamma(v1, v2)
   #base variance = 0.0000454 = 4.54 * 10-5
   prlclv_base_mean_mean   =  -10; #(this is the LOG of the variance that I think a normal cluster might have!)
   prlclv_base_mean_var    = (0.05)^2
  #prlclv_base_var_mean    =  0.02
  #prlclv_base_var_var     = (0.01)^2
  #prlclv_base_var_scale   = prlclv_var_mean/prlclv_var_var
  #prlclv_base_var_shape   = prlclv_var_mean/prlclv_var_scale
   prlclv_base_var_mean    = 2e-2
   prlclv_base_var_var     = (0.7)^2
   isc_ish                 = mean_var_to_standard_pars(distribution="inverse_gamma", mean=prlclv_base_var_mean, var=prlclv_base_var_var, verbose=F)
   prlclv_base_var_scale   = isc_ish["iscale"]
   prlclv_base_var_shape   = isc_ish["ishape"]
   prlclv_base_mean        = list("normal"       , prlclv_base_mean_mean, prlclv_base_mean_var);
   prlclv_base_var         = list("inverse_gamma", prlclv_base_var_scale, prlclv_base_var_shape );
   names(prlclv_base_mean) = c("distribution", "mean" , "var");
   names(prlclv_base_var)  = c("distribution", "scale", "shape");
   prlclv_base_mean1       = rnorm(    1, prlclv_base_mean_mean, sqrt(prlclv_base_mean_var) )
   prlclv_base_var1        = rinvgamma(1, scale = prlclv_base_var_scale, shape = prlclv_base_var_shape)
   prlclv_base             = list("normal", prlclv_base_mean1, prlclv_base_var1); 
   names(prlclv_base)      = c("distribution", "mean", "var")

   #inc = increment (ie. how much the variance changes for different copy number classes)
   prlclv_inc_mean_mean   =  0.02
   prlclv_inc_mean_var    = (0.003)^2
   prlclv_inc_var_mean    =  0.002
   prlclv_inc_var_var     = (0.0003)^2
   prlclv_inc_mean_scale  = prlclv_inc_mean_var/prlclv_inc_mean_mean
   prlclv_inc_mean_shape  = prlclv_inc_mean_mean/prlclv_inc_mean_scale
   prlclv_inc_var_scale   = prlclv_inc_var_var  /prlclv_inc_var_mean
   prlclv_inc_var_shape   = prlclv_inc_var_mean /prlclv_inc_var_scale
   prlclv_inc_mean        = list("gamma", prlclv_inc_mean_scale, prlclv_inc_mean_shape);
   prlclv_inc_var         = list("gamma", prlclv_inc_var_scale, prlclv_inc_var_shape );
   names(prlclv_inc_mean) = c("distribution", "scale" , "shape");
   names(prlclv_inc_var)  = c("distribution", "scale" , "shape");
   prlclv_inc_mean1       = rgamma(1, scale=prlclv_inc_mean_scale, shape=prlclv_inc_mean_shape)
   prlclv_inc_var1        = rgamma(1, scale=prlclv_inc_var_scale , shape=prlclv_inc_var_shape )
  #prlclv_inc_scale1      = prlclv_inc_var1 /prlclv_inc_mean1
  #prlclv_inc_shape1      = prlclv_inc_mean1/prlclv_inc_scale1

   prlclv_base            = list("normal", prlclv_base_mean1, prlclv_base_var1 );  
  #prlclv_inc             = list("gamma" , prlclv_inc_scale1, prlclv_inc_shape1);  
   prlclv_inc             = list("normal" , prlclv_inc_mean1, prlclv_inc_var1 );  
   names(prlclv_base)     = c("distribution", "mean", "var"  )
   names(prlclv_inc )     = c("distribution", "mean", "var")

   #list( prlclv_base_mean_mean ,  prlclv_base_mean_var ,  prlclv_base_var_scale ,  prlclv_base_var_shape ,  prlclv_base,
   hprclv        = list( prlclv_base_mean,  prlclv_base_var ,  prlclv_inc_mean ,  prlclv_inc_var)# ,  prlclv_base ,  prlclv_inc )
   names(hprclv) = list("base_mean", "base_var", "inc_mean", "inc_var")#, "base", "inc")

  clv   = matrix(-1, nrow=noco, ncol = nocl)
  colnames(clv) = paste(rep("c_vars_", ncol(clv)), 1:(ncol(clv)), sep="")
  rownames(clv) = rownames(cld)

   hkclm = make_clm(smcs=smc, clds=cld, nocl=nocl, noco=noco);
   hkclv = clv
   study_pdisease = NULL
   model_pdisease = NULL
  #hkgnf = gnfp$gnf
   npars    = list(  nocl,  smc ,  cld ,  clv ,  noco ,  gnfp,   betas ,  grid_breaks ,  anocl ,  null_prop ,  hkclm ,  hkclv ,  study_pdisease ,  model_pdisease )
   names(npars)= c("nocl", "smc", "cld", "clv", "noco", "gnfp", "betas", "grid_breaks", "anocl", "null_prop", "hkclm", "hkclv", "study_pdisease", "model_pdisease")
   opars = npars

   init_pr    = 1E-10 # Degenerate Initial value for priors (set properly before program starts)
   o_prior    = log(init_pr)

   npriors = list(     prsmc,   hprsmc ,  prcld ,  hprcld ,  prlclv_base ,  prlclv_inc ,   hprclv ,  prbeta0 ,  prbeta1 )
   names(npriors) = c("prsmc", "hprsmc", "prcld", "hprcld", "prlclv_base", "prlclv_inc",  "hprclv", "prbeta0", "prbeta1")
   opriors = npriors

   olkld   = -1E200;
   nlkld   = -1E200;
   assoc   =    list(case_colls ,  olkld ,  nlkld )
   names(assoc) = c("case_colls", "olkld", "nlkld")
   

   simple_pars        = npars
   noassoc_pars       = npars
   hier_mchce_pars    = npars
   start_pars         = NA
   start_priors       = NA
   ninferred          = list(lpdga ,  pagd ,  lpagd ,  simple_pars ,  hier_mchce_pars ,  noassoc_pars ,  start_pars ,  start_priors )
   names(ninferred)   =   c("lpdga", "pagd", "lpagd", "simple_pars", "hier_mchce_pars", "noassoc_pars", "start_pars", "start_priors")
   oinferred          = ninferred

   mv             = NULL
   if(nocl==3) {stpt$bot_q = stpt$cl3qs[1]; stpt$top_q = stpt$cl3qs[3]}
   no_null_moves = 0
   inherit_stpt  = F
   grid_vals = as.numeric(rownames(dat))
   dmax  = max(grid_vals)
   dmin  = min(grid_vals)
   flags         = list(DEBUG, iter,   no_iters ,  stpt_ind ,  mv ,  stpt ,  no_null_moves , grid_density  , inherit_stpt ,  min_var ,  
                     graphics_slow ,  artificial_stop ,  cnv_index ,  signal_model ,  start_hierarchy ,  use_hier_mchoice ,  dmax ,  dmin ,
                     seed ,  probe_summary ,  simple_model_iters ,  hier_mchoice_iters ,  no_assoc_model_iters ,  full_model_iters ,  cnv_name , 
                     arguments$use_mpar_additions,  arguments$hack_add_var, arguments$hack_add_cld ,  use_null_class ,  null_prior ,  
                     arguments$hack_add_gnf_lambda, arguments$verbose,  model ,  min_extra_cld ,  use_hierarchy , arguments$models,
                     sum_calls_nocl ,  sum_calls_assoc ,  sum_calls ,  wdat ,  deg_free ,  use_priors )
   names(flags)  = c("DEBUG", "iter", "no_iters", "stpt_ind", "mv", "stpt", "no_null_moves", "grid_density", "inherit_stpt", "min_var",
                    "graphics_slow", "artificial_stop", "cnv_index", "signal_model", "start_hierarchy", "use_hier_mchoice", "dmax", "dmin" , 
                    "seed", "probe_summary", "simple_model_iters", "hier_mchoice_iters", "no_assoc_model_iters", "full_model_iters", "cnv_name", 
                    "use_mpar_additions",                   "hack_add_var",          "hack_add_cld", "use_null_class", "null_prior", 
                             "hack_add_gnf_lambda",         "verbose", "model", "min_extra_cld", "use_hierarchy", "models",
                    "sum_calls_nocl", "sum_calls_assoc", "sum_calls", "wdat", "deg_free", "use_priors")
   nlposterior       = NA; #This records the (log) posterior                               [Proposed but not yet accepted move]
   lposterior        = NA; #This records the (log) posterior                               ['current (newest accepted) state' ]
   n_intsty          = NA; #This records the (log) likelihood - intensity component only.  [Proposed but not yet accepted move]
   o_intsty          = NA; #This records the (log) likelihood - intensity component only.  ['current (newest accepted) state' ]
   coll_spec_liklihds= NA; #This records the intensity likelihood for each collection separately
   n_asolkhd         = NA; #This records the (log) likelihood - intensity & association.   [Proposed but not yet accepted move]
   o_asolkhd         = NA; #This records the (log) likelihood - intensity & association.   ['current (newest accepted) state' ]
   n_liklihd         = NA; #This records the (log) likelihood - intensity & association.   [Proposed but not yet accepted move]
   o_liklihd         = NA; #This records the (log) likelihood - intensity & association.   ['current (newest accepted) state' ]
   n_prior           = NA; #This records the (log) product of the priors of all parameters [Proposed but not yet accepted move]
   o_prior           = NA; #This records the (log) product of the priors of all parameters ['current (newest accepted) state' ]
   lassoc_bf         = NA; #This records the (log) Bayes Factor comparing the no-association to additive-association models
   bic_evidence      = NA; #This records the (log) model evidence of the model as estimated by bic.
   aic_evidence      = NA; #This records the (log) model evidence of the model as estimated by bic.
   n_prior_brkdwn    = list("")
   o_prior_brkdwn    = list("")
   #objects$assoc$nlkld/olkld Stores the new/current (log) likelihood of the association part of the model ONLY (respectively)

   likelihood     = list( lposterior ,  nlposterior ,  n_intsty ,  o_intsty ,  n_asolkhd ,  o_asolkhd ,  lassoc_bf ,  aic_evidence ,   bic_evidence ,  n_prior_brkdwn ,  o_prior_brkdwn )
   names(likelihood) = c("lposterior", "nlposterior", "n_intsty", "o_intsty", "n_asolkhd", "o_asolkhd", "lassoc_bf", "aic_evidence",  "bic_evidence", "n_prior_brkdwn", "o_prior_brkdwn")
   simple_mchoice    = NA; # These three record the full likelihood spectrum at various points 
   hier_mchoice      = NA; # To record what wasa going on at various points of model choice
   no_assoc          = NA; # 
   full_model        = NA; #This records what the (log) likelihood of the intensity + association was after inference on betas[2] had finished
   lstore      = list(simple_mchoice ,  hier_mchoice ,  no_assoc ,  full_model )
   names(lstore) = c("simple_mchoice", "hier_mchoice", "no_assoc", "full_model") 
   accepted_last = NULL;

   objects         = list(dat ,  opars ,  npars ,  ninferred ,  oinferred ,  assoc ,  likelihood ,  lstore ,  opriors ,  npriors ,  accepted_last ,  flags )
   names(objects)    = c("dat", "opars", "npars", "ninferred", "oinferred", "assoc", "likelihood", "lstore", "opriors", "npriors", "accepted_last", "flags")

   objects           = initialise_params(objects=objects, nocl=nocl); if(sum(is.na(unlist(objects$opars$gnfp[-(1)])))>0) {cat("In Initialise. Part of gnf is NA.\n"); browser();}
   objects$npars     = objects$opars;
     if(DEBUG>3) {cat("About to set start point (look at npars and npriors).\n"); browser()}
     if(objects$flags$stpt$type=="naive" ) objects = set_start_pt_1(objects, st_details=stpt)
     if(objects$flags$stpt$type=="clever") objects = set_start_pt_2(objects, heights=3:max(objects$dat))
     if(objects$flags$stpt$type=="user"  ) objects = user_defined_fit(objects=objects, in_nocl=nocl, maxL_vars=T, maxL_means=F, maxL_gnf=T, no_em_like_steps = 1)
     check_cols_same(objects=objects, initialise=T)
     bad  = check_clm(objects=objects, smcs=objects$npars$smc, dsts=objects$npars$cld, move="initialise", cur=T)
    #bad  = check_clm(objects=objects, smcs=objects$opars$smc, dsts=objects$opars$cld, move="initialise", cur=T)
     objects                        = update_hk_pars(objects, new=T)
     objects                        = update_lpdga(objects)
    #objects$ninferred$lpagd        = make_lpagd(ob=objects, direct_lpdga=NULL, new=T, combined=F)
     objects$ninferred$lpagd        = NA
     objects$ninferred$pagd         = make_pagd(ob=objects, direct_lpdga=NULL, new=T, combined=F)
     if(DEBUG>0.5 & (min(objects$ninferred$pagd)<0 | max(objects$ninferred$pagd)>1)) {cat("In Initialise. Error, impossible pagd.\n"); browser();}
     objects$likelihood$n_intsty    = calc_intens_lkld(dat = objects$dat, lpdga = NULL, log=T, best_call=!objects$flags$sum_calls, objects=objects, new=T)
     objects$likelihood$n_prior_brkdwn = calc_newprior(npars = objects$npars, npriors = objects$npriors, log=T, flags=objects$flags);
     objects$likelihood$o_prior_brkdwn = objects$likelihood$n_prior_brkdwn
     objects$likelihood$n_prior     = objects$likelihood$n_prior_brkdwn$ltotal_prior
     objects$likelihood$o_prior     = objects$likelihood$n_prior
     objects$opriors                = objects$npriors
     objects                        = calc_phen_g_gen(objects, hard_calls=!objects$flags$sum_calls)
     objects$assoc$olkld            = objects$assoc$nlkld
     objects$likelihood$o_intsty    = objects$likelihood$n_intsty
     objects$likelihood$lposterior  = objects$likelihood$n_intsty + objects$assoc$nlkld + objects$likelihood$o_prior
     objects$likelihood$n_liklihd   = objects$likelihood$n_intsty + objects$assoc$nlkld
     objects$likelihood$o_liklihd   = objects$likelihood$n_liklihd
   if(is.na(objects$likelihood$lposterior)){cat("In Initialise. Likelihood is NA.\n"); browser();}
     objects$opars                  = objects$npars;
   objects$npars                    = objects$opars 
   objects$oinferred                = objects$ninferred
  if(objects$flags$use_null_class) gnf_sum = (1-objects$opars$null_prop) else gnf_sum=1
   if(check_dat(data=objects$opars$gnfp$gnf_lambda, precision=1e-8, sum=gnf_sum)) {
      cat("set_start_pt_2. Problem with genotype frequencies.\n"); browser();
    }
  #if(!is.matrix(objects$opars$gnfp$gnf)|!is.matrix(objects$npars$gnfp$gnf)) {cat("In initialise1. gnf has lost a dimension.\n"); browser();}
   return(objects) 
}







initialise_params=function(objects, co_sp_sd=0.0002, nocl=3)
{
  if(!is.null(objects$opars$pnc)) objects$opars$nocl = objects$opars$pnc else objects$opars$nocl = nocl;
  #cluster variances (actually standard deviations!) are tightened by the parameter cvt = cluster_variance_tightness
  objects = make_clm_pr(objects)
  objects = make_clv_pr(objects)
  objects = make_gnf_pr(objects)
 #objects$opars$betas[1] = rnorm(1, objects$npriors$prbeta0$mean, sqrt(objects$npriors$prbeta0$var))
 #objects$opars$betas[2] = rnorm(1, objects$npriors$prbeta1$mean, sqrt(objects$npriors$prbeta1$var))
  objects$opars$betas[1] = -7 #The priors on the betas are fixed, so they don't need to be initialised.
  objects$opars$betas[2] = 0
  objects$opars$model_pdisease    = get_model_pdisease(objects=objects, from_controls=F)  # from_controls=F means use pop_freqs = gnf_lambda
  objects$opars$gnfp$gnf_controls = make_control_freqs(objects=objects, pop_freqs =objects$opars$gnfp$gnf_lambda, new=F)
  objects$opars$gnfp$gnf_cases    = make_case_freqs(   objects=objects, pop_freqs =objects$opars$gnfp$gnf_lambda, new=F)
  if(sum(is.na(unlist(objects$opars$gnfp[-(1)])))>0) {cat("In initialise_params. Part of gnf is NA.\n"); browser();}
  if(objects$flags$use_null_class) gnf_sum = (1-objects$opars$null_prop) else gnf_sum=1
   if(check_dat(data=objects$opars$gnfp$gnf_lambda, precision=1e-8, sum=gnf_sum)) {
      cat("initialise_params. Problem with genotype frequencies.\n"); browser();
    }
  return(objects)
}

make_gnf_pr=function(objects)
{
  nocl = objects$opars$nocl
  noco = objects$opars$noco
  null_prop = objects$opars$null_prop
  #gnf_apar = rbeta(1, shape1=gnf_hp_shape1, shape2=gnf_hp_shape2)
  mv       = st_pars_to_mean_var(distribution="beta", shape1=objects$opars$gnfp$gnf_hp_shape1, shape2= objects$opars$gnfp$gnf_hp_shape2, verbose=F)
  gnf_apar = mv["mean"]
  gnf_ws   = make_ws_from_alpha(gnf_apar=gnf_apar, nocl=nocl, gnf_theta = objects$opars$gnfp$gnf_theta)
  objects$opars$gnfp$gnf_ws     = gnf_ws
  objects$opars$gnfp$gnf_apar   = gnf_apar
  if(objects$flags$use_null_class) gnf_sum = (1-objects$opars$null_prop) else gnf_sum=1
  objects$opars$gnfp$gnf_lambda   = normalise(gnf_ws, sum=gnf_sum)
 #objects$opars$gnfp$gnf_controls = make_control_freqs(objects=objects, pop_freqs=objects$npars$gnfp$gnf_lambda      , new=F)
 #objects$opars$gnfp$gnf_cases    = make_case_freqs(   objects=objects, pop_freqs=objects$npars$gnfp$gnf_lambda      , new=F)
  return(objects)
}

#This generates prior values of the hyper parameters required for and then actual values for the cluster variances
make_clv_pr=function(objects)
{
  #These are the hyper_parameters of the means and variances of the clusters - inference can be done on these!
  nocl = objects$opars$nocl
  noco = objects$opars$noco
 #objects$npriors$hprclv$base$mean = rnorm(    1, objects$npriors$hprclv$base_mean$mean        , sqrt(objects$npriors$hprclv$base_mean$var)   )
  objects$npriors$hprclv$base$mean = objects$npriors$hprclv$base_mean$mean
 #objects$npriors$hprclv$base$var  = rinvgamma(1, scale = objects$npriors$hprclv$base_var$scale, shape = objects$npriors$hprclv$base_var$shape)
  mv = st_pars_to_mean_var(distribution="inverse_gamma", iscale=objects$npriors$hprclv$base_var$scale, ishape= objects$npriors$hprclv$base_var$shape, verbose=F)
  objects$npriors$hprclv$base$var  = mv["mean"]

 #base_classes              = rnorm(1   , objects$npriors$hprclv$base$mean        , sqrt(objects$npriors$hprclv$base$var))
  base_classes              = objects$npriors$hprclv$base$mean
  base_classes              = rep(base_classes, noco)
 #inc_mean                  = rgamma(1, scale=objects$npriors$hprclv$inc_mean$scale, shape=objects$npriors$hprclv$inc_mean$shape)
  mv = st_pars_to_mean_var(distribution="gamma", scale=objects$npriors$hprclv$inc_mean$scale, shape= objects$npriors$hprclv$inc_mean$shape, verbose=F)
  inc_mean                  = mv["mean"]

  inc_var                   = rgamma(1, scale=objects$npriors$hprclv$inc_var$scale , shape=objects$npriors$hprclv$inc_var$shape)
  mv = st_pars_to_mean_var(distribution="gamma", scale=objects$npriors$hprclv$inc_var$scale, shape=objects$npriors$hprclv$inc_var$shape, verbose=F)
  inc_var                   = mv["mean"]

  objects$npriors$hprclv$inc$scale = inc_var /inc_mean
  objects$npriors$hprclv$inc$shape = inc_mean/objects$npriors$hprclv$inc$scale
  objects$opars$clv[,1]     = exp(base_classes)
 #increment = rgamma((1   )*(nocl-1), scale=objects$npriors$hprclv$inc$scale , shape=objects$npriors$hprclv$inc$shape)
  mv = st_pars_to_mean_var(distribution="gamma", scale=objects$npriors$hprclv$inc$scale, shape=objects$npriors$hprclv$inc$shape, verbose=F)
  increment = rep(mv["mean"], (nocl-1))
  increment = matrix(rep(increment, noco), noco, (nocl-1), byrow=T)
  increment = t(t(increment)*(1:(nocl-1)))
  objects$opars$clv[,-c(1)] = exp(base_classes + increment)
  return(objects)
}

#This generates prior values of the hyper parameters required for and then actual values of the cluster means
make_clm_pr=function(objects)
{
  #These are the hyper_parameters of the means and variances of the clusters - inference can be done on these!
  nocl = objects$opars$nocl
  noco = objects$opars$noco
 #objects$npriors$prsmc$mean = rnorm(    1, objects$npriors$hprsmc$mean$mean        , sqrt(objects$npriors$hprsmc$mean$var)   )
  objects$npriors$prsmc$mean = objects$npriors$hprsmc$mean$mean

 #objects$npriors$prsmc$var  = rinvgamma(1, scale = objects$npriors$hprsmc$var$scale, shape = objects$npriors$hprsmc$var$shape)
  mv = st_pars_to_mean_var(distribution="inverse_gamma", iscale=objects$npriors$hprsmc$var$scale, ishape= objects$npriors$hprsmc$var$shape, verbose=F)
  objects$npriors$prsmc$var  = mv["mean"]
 #objects$opars$smc         = rep(rnorm(1, objects$npriors$prsmc$mean, sqrt(objects$npriors$prsmc$var)), noco)
  objects$opars$smc         = rep(objects$npriors$prsmc$mean, noco)

 #cld_mean                  = rgamma(1, scale=objects$npriors$hprcld$mean$scale, shape=objects$npriors$hprcld$mean$shape)
  mv = st_pars_to_mean_var(distribution="gamma", scale=objects$npriors$hprcld$mean$scale, shape=objects$npriors$hprcld$mean$shape, verbose=F)
  cld_mean                  = mv["mean"]

 #cld_var                   = rgamma(1, scale=objects$npriors$hprcld$var$scale , shape=objects$npriors$hprcld$var$shape)
  mv = st_pars_to_mean_var(distribution="gamma", scale=objects$npriors$hprcld$var$scale, shape=objects$npriors$hprcld$var$shape, verbose=F)
  cld_var                   = mv["mean"]

  objects$npriors$hprcld$scale = cld_var /cld_mean
  objects$npriors$hprcld$shape = cld_mean/objects$npriors$hprcld$scale
 #cld               = rep(rgamma((nocl-1), scale=objects$npriors$hprcld$scale , shape=objects$npriors$hprcld$shape), noco)
  mv = st_pars_to_mean_var(distribution="gamma", scale=objects$npriors$hprcld$scale, shape=objects$npriors$hprcld$shape, verbose=F)
  cld               = mv["mean"]
  objects$opars$cld = matrix(cld, noco, (nocl-1), byrow=T)
  dimnames(objects$opars$cld) = dimnames(objects$npars$cld) 
  objects$opars$cld = mypmax(inmat = objects$opars$cld, objects$flags$min_extra_cld) #This is to avoid the infinite (or zero) gamma densities as cld -> 0
  return(objects)
}



#This sets the start points by looking for the right number of clusters and then finding their maxima.
#Could be used as a move - but is currently deterministic
set_start_pt_2=function(objects, also_set_variance=F, heights=(3:max(objects$dat)))
{
   nocl          = objects$opars$nocl
   noco          = objects$opars$noco
   #max_height    = max(objects$dat)
   #heights       = 3:max_height
   dat2          = rowSums(objects$dat)
   grid_vals     = as.numeric(names(dat2))
   no_inds       = sum(dat2)
   peak_set      = apply(t(t(heights)), 1, guess_peaks, dat=dat2, just_indices=F)
   p_nocl        = unlist(lapply(peak_set, length))
   good_heights  = which(p_nocl==nocl)
   problems = length(good_heights)==0   
   if(problems)
   {
      rdat        = range(as.numeric(names(dat2)))
      length      = rdat[2]-rdat[1]
      class_means = (1:(nocl))/(nocl+1)*length + rdat[1]
   } else
   {
     h_check = diff(good_heights)
     h_breaks = c(which(h_check>1), length(good_heights))
     if(length(h_breaks)>1){
       if(objects$flags$DEBUG>2) cat("Warning, height based starting point guess is tricky.\n");
       best_reg = which.max(diff(h_breaks))
       best_point = (h_breaks[best_reg+1]+h_breaks[best_reg])/2
     } else
     {
       best_point    = ceiling(length(good_heights)/2)
     }
     chosen_height = good_heights[best_point]
     class_means   = as.numeric(     (peak_set[[chosen_height]]))
   }
   class_means  = myas.matrix(invec=class_means, rdim=c(1,nocl), dimnames=list(c("comb_colls"), paste(rep("cl", nocl), 1:nocl)))
   class_means2 = rev_hk2(mom_type="mean", moments=class_means, nocl=nocl, vals=grid_vals, flags=objects$flags)
   # get_hack_diff_mean(cl=2, wdat=objects$flags$wdat, add_cld=objects$flags$hack_add_cld)
   extreme_gvs  = calc_high_low_grid_vals(objects=objects)

   class_means2[1]    = max( class_means2[1], as.numeric(rownames(objects$dat))[extreme_gvs["low_gv" ]])
   class_means2       = pmin(class_means2   , as.numeric(rownames(objects$dat))[extreme_gvs["high_gv"]])
   avcld              = diff(class_means2)
   avcld              = mypmax(inmat = avcld, objects$flags$min_extra_cld) #This is to avoid the infinite (or zero) gamma densities as cld -> 0
   avsmc              = min(class_means2)
  #avsmc = min(-1e-3, avsmc)

   objects$npars$smc           = rep(avsmc, noco)
   objects$npars$cld           = matrix(rep(avcld, noco), nrow=noco, ncol = (nocl-1), byrow=T)
   dimnames(objects$npars$cld) = dimnames(objects$opars$cld)
   check_clm(objects=objects, smcs=objects$npars$smc, dsts=objects$npars$cld, move="\"Clever\" Initialisation Routine", cur=T, average=F, extra_added=F)
   objects                     = update_hk_pars(objects, new=T)

  #objects$npriors$prlclv_base$mean = -13
  #objects$npriors$prlclv_base$var  = 0.06;
  #objects$npriors$prlclv_inc$scale = 0.02
  #objects$npriors$prlclv_inc$shape = 0.15;

   if(objects$flags$DEBUG>1 & 0) cat("height = ", chosen_height, "and peaks = ", peak_set[[chosen_height]], "\n");
   objects                 = update_hk_pars(objects, new=T)
   objects                 = update_lpdga(objects)
  #objects$ninferred$lpagd = make_lpagd(ob=objects, direct_lpdga=NULL, new=T, combined=F)
   objects$ninferred$lpagd = NA
   objects$ninferred$pagd  = make_pagd( ob=objects, direct_lpdga=NULL, new=T, combined=F)
   objects$oinferred       = objects$ninferred
   if(!problems) objects   = combined_maxgnf(objects=objects, new=T)
   objects                 = maxL_variances( objects=objects, new=T, combined=T)
   objects$opars           = objects$npars
   objects                 = change_gnf_hpars(objects=objects, maximise=T)
   objects$opars           = objects$npars

  if(objects$flags$use_null_class) gnf_sum = (1-objects$opars$null_prop) else gnf_sum=1
   if(check_dat(data=objects$opars$gnfp$gnf_lambda, precision=1e-8, sum=gnf_sum)) {
      cat("set_start_pt_2. Problem with genotype frequencies.\n"); browser();
    }
   return(objects)
}

#Naive starting point based on pre-defined quantiles.
set_start_pt_1=function(objects, also_set_variance=F, st_details=NULL)
{
   nocl          = objects$opars$nocl
   noco          = objects$opars$noco
   #if(objects$flags$DEBUG>2.5 & !is.null(st_details$3clqs) & nocl!=3) {cat("Warning, non-standard quantiles are irrelevant when nocl =", nocl, "\n");}
   grid_vals     = as.numeric(rownames(objects$dat))
   rdat = range(grid_vals)
   wdat = rdat[2] - rdat[1]
   dat2          = rowSums(objects$dat)
   if(nocl==3) {
     q1 = cumsum(dat2)  
     no_inds = q1[length(q1)]
     if(is.null(st_details)) {
       lowest_pt  = which(q1 >    no_inds/20)[1]
       middle_pt  = which(q1 >    no_inds/2 )[1]
       highest_pt = which(q1 > 19*no_inds/20)[1]
     } else
     {
       quantiles  = st_details$cl3qs
       lowest_pt  = which(q1 > no_inds*quantiles[1])[1]
       middle_pt  = which(q1 > no_inds*quantiles[2])[1]
       highest_pt = which(q1 > no_inds*quantiles[3])[1]
     }
     if(lowest_pt==middle_pt ) middle_pt  = middle_pt+1
     if(middle_pt==highest_pt) highest_pt = highest_pt+1
     if(highest_pt>length(q1)) {highest_pt = highest_pt-1; middle_pt  = middle_pt-1;}
     if(lowest_pt==middle_pt ) lowest_pt  = lowest_pt-1

     clm = c(grid_vals[lowest_pt], grid_vals[middle_pt], grid_vals[highest_pt])
   } else {
     # Dealing with nocl!= 3 here.
     clm = initialise_clm(objects=objects, bot_q=st_details$bot_q, top_q=st_details$top_q, equal=T, nocl=nocl, style=st_details$genqs)
   }
  #objects$npriors$prlclv_base$var  = 0.1;
   clm   = myas.matrix(invec=clm , rdim=c(1,nocl), dimnames=list(c("comb_colls"), paste(rep("cl", nocl), 1:nocl)))
   clm2  = rev_hk2(mom_type="mean", moments=clm, nocl=nocl, vals=grid_vals, flags=objects$flags)
   clm2  = myas.matrix(invec=clm2, rdim=c(1,nocl), dimnames=list(c("comb_colls"), paste(rep("cl", nocl), 1:nocl)))
   avsmc = clm2[1]
   avcld = apply(clm2, 1, diff)
   avcld             = mypmax(inmat = avcld, objects$flags$min_extra_cld) #This is to avoid the infinite (or zero) gamma densities as cld -> 0
   objects$npars$smc = rep(avsmc, noco)
   objects$npars$cld = matrix(rep(avcld, noco), nrow=noco, ncol = (nocl-1), byrow=T)
   dimnames(objects$npars$cld) = dimnames(objects$opars$cld)
   if(sum(!(objects$npars$cld>=0))>0) {cat("Error, cannot have negative distances between clusters.\n"); browser();}
   if(sum( (objects$npars$cld==0))>0) {cat("Error, should not have zero distances between clusters.\n"); browser();}

   #Note: the following line won't necessarily get you back to clm if the class_distances in clm were so small that rev_hk2 applied the minimum_distance to them
   # TO check you can get one part of this minimum from:    # get_hack_diff_mean(cl=, add_cld=objects$flags$hack_add_cld)
   objects             = update_hk_pars(objects, new=T)
  #check2              = max(objects$npars$hkclm)<=objects$flags$dmax; 
  #if(!check2) objects = undo_min_extra_problem(objects)
   objects             = update_hk_pars(objects, new=T)
   check_clm(objects=objects, move="set_start_pt_1", cur=F, average=F, smc_min_val=0.0505, stop=T)
  if(objects$flags$use_null_class) gnf_sum = (1-objects$opars$null_prop) else gnf_sum=1
   if(check_dat(data=objects$opars$gnfp$gnf_lambda, precision=1e-8, sum=gnf_sum)) {
      cat("set_start_pt_1. Problem with genotype frequencies.\n"); browser();
    }
   return(objects)
}




set_up_caller=function(arguments)
{
  stpts       = set_start_points(to_use =arguments$stpts_to_use) 
  sim_args    = set_up_sim(arguments)
  real_d_args = set_up_reald(arguments)
  extra_args  = list("sim_args"=sim_args, "real_d_args"=real_d_args, "stpts"=stpts)
  return(extra_args)
}

set_up_reald=function(arguments)
{
  if( is.null(arguments$remove_colls)) real_d_args = list("remove_colls"= c("Unknown"))
  if(!is.null(arguments$remove_colls)) real_d_args = list("remove_colls"= arguments$remove_colls)
  return(real_d_args)
}


set_up_sim=function(arguments)
{
  cnvs = arguments$cnvs
  if(!arguments$real_data)
  {
     no_sims     = length(cnvs)
     sim_alleles = c(rep(2, 160), rep(1, 10), rep(3, 30))
     sim_alleles = sim_alleles[1:length(cnvs)]
     sim_noco    = arguments$sim_noco
    #sim_alleles = ceiling(rgamma(no_sims, scale=1/3, shape=8)+0.3)
    #sim_alleles[2*(1:12)] = c(1:3, 1:3, 1:3, 1:3)
    #sim_alleles[1] = 2    
    sim_args = list( "no_sims"             = no_sims             ,
                     "sim_alleles"         = sim_alleles         ,
                     "sim_no_inds"         = rep(arguments$sim_inds_p_coll, sim_noco),
                     "sim_case_colls"       = c(rep(0,(sim_noco)))  ,
                     "tr_nocls"            = (2*sim_alleles)-1           ,
                     "read_sim_from_file"  = arguments$read_sim_from_file,
                     "allelicModel"        = TRUE,
                     "numGenotypes"        = "usingAlleles", #This is normally set through the number of alleles
                     "haveBadProbes"       = TRUE
                   )
    if(arguments$sim_association) 
      sim_args$sim_case_colls[length(sim_args$sim_case_colls)] = 1
    names(sim_args$sim_case_colls) = makeDefaultCollnames(noco=sim_noco)
  } else {
    sim_args = list("no_sims"=NULL,"sim_alleles"=NULL,"sim_no_inds"=NULL,
                    "sim_case_colls"=NULL,"tr_nocl"=-1, 
                    "read_sim_from_file"=NULL, "allelicModel"=NULL,
                    "numGenotypes"=NULL, "haveBadProbes"=NULL)
  }
  return(sim_args)
}



set_arguments=function(write_results = -1,
                       pca           = FALSE,                       cnvs          = NULL ,
                       cnv_names     = NULL,                        cnv_names_fn  = NULL ,
                       write_tag     = NULL,                        read_tag      = NULL ,
                       read_seed     = 1,                           DEBUG         = 1.5  ,
                       mapping       = "allCNVsAllMappings",        quick         = FALSE,
                       vquick        = FALSE,                       nocls         = NULL ,
                       collections   = NULL,                        diseaseColls  = NULL ,
                       sim           = FALSE                                             )
{
  artificial_stop_i   = -1;
  artificial_stop_cl  = -1;
  artificial_stop_cn  = -1;
  artificial_stop_st  = -1;
  artificial_stop     = c(artificial_stop_i, artificial_stop_cl, artificial_stop_cn, artificial_stop_st)
  if(is.null(collections)) collections=get_collections(sim=sim)
  if(pca) probe_summary = "pca" else probe_summary = "mean"
  no_cnv_specifiers   = (!is.null(cnvs))+(!is.null(cnv_names))+(!is.null(cnv_names_fn))
  if(!no_cnv_specifiers==1) {cat("  Warning, don't have exactly one method of specifying CNV(s) to analyse.\n"); 
                             cat("  Just using cnv_index = 1 (if appropriate)\n"); cnvs = 1; if(DEBUG>1.5) browser()
  }    
  if(is.null(nocls)) nocls = 10:1
  if(!is.null(cnv_names_fn)) {
    # names_dir    = "/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling/interesting_cnvs/"
    # cnv_names_fn = paste(names_dir, "test_cnv_names.txt", sep="")
    cnv_names = unlist(read.table(cnv_names_fn, as.is=T, header=T))
   #if(verbose>1) cat("Looking at CNVs:", cnv_names, "\n");
  }
  if(!is.null(cnv_names)) {
    rv          = get_cnv_indices_from_names(cnv_names=cnv_names, mapping=mapping)
    cnvs        = rv$cnv_indices
    exact_match = rv$exact_match
    if(!exact_match & DEBUG>1.5) {cat("Uncertain whether to proceed with ambiguity in CNV names.\n"); browser();}
    cat("cnv indices =", cnvs, "\n")
  } 
  if(!is.null(cnvs)) {} #Do Nothing, this is already in the most useful format.
  ## Note about normalisations file: Must have CNV indices in the SAME ORDER as the Probe->CNV Mapping file being used at present
  ##      ust have columns called: 'cnv_index', 'cnv_id' and 'normalisation' holding the obvious things.

  arguments =list( "DEBUG"               = DEBUG         ,
                   "signal_model"        = "t8"          ,
                   "deg_free"            = 8             ,
                   "models"              = c("simple"="simple", "hier_nocl_choice"="hier_nocl_choice", "no_assoc"="no_assoc", 
                                             "full_no_hierarchy"="full_no_hierarchy", "full_model"="full_model") ,
                   "graphics_slow"       = F             ,       
                   "nocls"               = nocls         ,
                   "use_supplied_nocl"   = "none"        , # Give filename (eg: "master.list.csv") Use "none" if you want the program to choose nocl for itself
                   "supplied_nocl_col"   = "verdict.damjan", #This is the column I want from Damjan's 'verdicts' file to get his number of classes
                   "normalisation"       = "normalised6" , 
                   "normalisation_file"  = "none"        , #Give the FULL PATH of a normalisations file if one is wanted - otherwise give 'none'
                   "add_half_to_ratio"   = T             , # If Red Green read in separately, then setting this to 'T' means that log(R/G + 0.5) used.
                   "remove_colls"        = c("Unknown", "YRI", "JPT_CHB", "CEU")     , 
                   "remove_scontrol"     = T             ,
                   "rem_hapmap"          = F             ,
                   "rem_agilent_repeats" = F             ,
                   "output_sample_names" = F             , #Normally false as on GC it would be wasteful to write it hundreds of times
                   "ptcnv_type"          = mapping       ,
                   "probe_exclusion_type"= "probes_with_snps",
                   "stpts_to_use"        = c(3,1,3,4,5,3:7,3,3,4), # c(3,1,3:7)
                   "inherit_stps"        = T             ,
                   "which_inds_excl"     = "/data/garganey/cardin/postdoc/CNVs/calling/data_freeze/data_freeze_8/files/annotation_files/precalling_exclusion_list_data_freeze_8_v6.txt",
                   "supply_ind_excl_dir" = T             ,
                   "excl_probes"         = F             ,
                   "use_priors"          = T             ,
                   "formal_as_test"      = T             ,
                   "use_hierarchy"       = T             ,
                   "use_hier_mchoice"    = T             ,
                   "infer_kernel"        = T             ,
                   "possible_kernels"    = c("normal"=NA, "t"=3, "t"=8),
                   "sum_calls_nocl"      = T             ,
                   "sum_calls_assoc"     = T             ,
                   "use_null_class"      = T             ,
                   "use_pr_on_nl_classp" = F             ,
                   "simple_model_iters"  = 1:20          ,
                   "hier_mchoice_iters"  = 1:250         ,
                   "kernel_choice_iters" = 1:50          ,
                   "no_assoc_model_iters"= 1:2000        ,
                   "full_model_iters"    = 1:2000        ,
                   "set_sa_limit"        = 0             , # 1/2 is what I would use, but it's quite ad-hoc
                   "use_mpar_additions"  = T             ,
                   "min_var"             = 4e-9          ,
                   "hack_add_var"        = (1/110)^2     ,# These three params will be added on when the likelihood is calculated. 
                   "hack_add_cld"        = 0.06          ,# Means, vars are a *proportion of the total range*. Gnf is a straight genotype frequency minimum.
                   "min_extra_cld"       = 1/100*0.1     ,# This is the bit that there's a prior on. May wish to renormalise these values from the prior? (Integrate a gamma)
                   "hack_add_gnf_lambda" = 0             ,# Variances (to avoid a data point having its own class), class_dsts&gnfs (some local peaks have them tiny)
                   "artificial_stop"     = artificial_stop,
                   "heated"              = F             ,
                   "gridding"            = T             ,
                   "wdat"                = 0.1           , #This is the width that the 1-d summary of the data will be scaled to (before gridding) 
                   "return_ungridded"    = T             ,
                  #"machine"             = machine       ,
                   "pilot"               = F             ,              
                   "real_data"           = T     ,      
                   "duplicates_fn"       = NULL,  # filename of Richard's duplicates list, needed for PVS scaling
                   "probe_scaling"       = "none",
                   "probe_summary"       = probe_summary ,  
                   "make_ldf_calls"      = T     ,
                   "cnv_index"           = 1     ,
                   "combine_colls"       = F     ,
                   "grid_density"        = 1             ,
                   "visualise"           = F     ,
                   "gnf_theta"           = 300   ,
                   "null_prop"           = 3/1000,
                   "case_colls"          = makeCaseColls(collections=collections, diseaseColls=diseaseColls),
                   "seed"                = 1     ,
                   "read_seed"           = read_seed,
                   "store_stpts"         = F     ,
                   "no_sims"             = 100                   ,
                   "sim_association"     = 1                     ,
                   "inf_association"     = 1                     ,
                   "sim_no_probes"       = 10                    ,
                   "sim_noco"            = 3     ,
                   "sim_inds_p_coll"     = 3000  ,
                   "sim_difficulty"      = 10,
                   "sim_maf"             = "from_model",
                   "sim_signal_kernel"   = "normal",
                   "signal"              = 2.5, 
                   "noise"               = 0.5, 
                   "beta0"               = -8,
                   "beta1"               = 0.2,
                   "write_sim_to_file"   = F     , 
                   "read_sim_from_file"  = T     , 
                   "cnvs"                = cnvs  ,
                  #"no_cnvs"             = 3885  , 
                  #"overwrite_files"     = T    , 
                   "write_results"       = -1    , 
                   "write_details"       = F     , 
                   "verbose"             = 1     , 
                   "write_summary"       = F     , 
                   "write_calls"         = F     , 
                   "write_inout_fns"     = F     ,
                   "calls_in_sep_files"  = T     , 
                   "store_stpts"         = F     ,
                   "store_ung_dat"       = T     ,
                   "store_ldf_dat"       = T     ,
                   "store_thisfit_smry"  = T     ,
                   "store_ldffit_smry"   = T     ,
                   "write_nocl_summary"  = F     , 
                   "write_arguments"     = F     , 
                   "no_bars"             = 50    ,
                   "png"                 = T     ,
                   "results_dir_tag"     = paste("test_", Sys.Date(), sep=""),
                   "png_fn_tag"          = paste("test_3",sep =""), 
                   "overall_summary_tag" = paste("test_3",sep =""),  
                   "calls_fn_tag"        = paste("test_3",sep =""), 
                   "ldf_calls_fn_tag"    = paste("test_3",sep =""), 
                   "summ_fn_tag"         = paste("test_3",sep =""), 
                   "fitsum_fn_tag"       = paste("test_3",sep =""), 
                   "one_ddat_fn_tag"     = paste("test_3",sep =""), 
                   "extreme_inds_ftag"   = paste("test_3",sep =""), 
                   "arguments_fn_tag"    = paste("test_3",sep =""),
                   "stpts_filetag"       = paste("test_3",sep =""), 
                   "det_filetag"         = paste("test_3",sep =""), 
                   "simdat_tag"        = paste("test_3",sep ="") #The data to be READ IN (usually after simulation)
                 )
  if(quick) {
    cat("  Dividing number of iterations by 4 for this (presumably) test run.\n");
    arguments$simple_model_iters   = ceiling(arguments$simple_model_iters  /4); arguments$hier_mchoice_iters = ceiling(arguments$hier_mchoice_iters/4)
    arguments$no_assoc_model_iters = ceiling(arguments$no_assoc_model_iters/4); arguments$full_model_iters   = ceiling(arguments$full_model_iters  /4)
    arguments$kernel_choice_iters  = ceiling(arguments$kernel_choice_iters /4);
  }
  if(vquick) {
    cat("  Using very few runs - useful for examining output formats etc..\n");
    arguments$simple_model_iters   = 4; arguments$hier_mchoice_iters = 8
    arguments$no_assoc_model_iters = 28; arguments$full_model_iters  = 8
    arguments$kernel_choice_iters  = 8;
  }
  arguments$no_iters = max(arguments$simple_model_iters) + max(arguments$hier_mchoice_iters) + max(arguments$no_assoc_model_iters) + max(arguments$no_assoc_model_iters)
  if(write_results==1) {
    arguments$write_details       = T; arguments$write_summary       = T;  arguments$write_calls = T;
    arguments$store_stpts         = T; arguments$write_nocl_summary  = T;  arguments$png         = T;  
    arguments$write_arguments     = T;
  }
  if(write_results==0) {
    arguments$write_details       = F; arguments$write_summary       = F;  arguments$write_calls = F;
    arguments$store_stpts         = F; arguments$write_nocl_summary  = F;  arguments$png         = F;  
    arguments$write_arguments     = F;
  }
  if(!is.null(write_tag)) {
    arguments$png_fn_tag        = write_tag; arguments$overall_summary_tag = write_tag ; arguments$calls_fn_tag  = write_tag; arguments$summ_fn_tag      = write_tag;
    arguments$arguments_fn_tag  = write_tag; arguments$det_filetag         = write_tag ; arguments$stpts_filetag = write_tag; arguments$one_ddat_fn_tag  = write_tag;
    arguments$extreme_inds_ftag = write_tag; arguments$fitsum_fn_tag       = write_tag ; arguments$ldf_calls_fn_tag = write_tag;
  }
    if(!is.null(read_tag)) {arguments$simdat_tag = read_tag;}
  return(arguments)
}

#  This function creates the vector 'case_colls' which supplies the case/control status of the collections (0=control, 1=case)
#  These order that the collectionsa are specified in here should correspond to that in 'data_array' (unless no association analysis is done in which case it's irrelevant)
makeCaseColls=function(collections=NULL, noco=NULL, diseaseColls=NULL, ccc=NULL, DEBUG=1, sim=F)
{
  # If the data comes from the ccc+ experiment then these automatically sets that up.
  #if(testVal(ccc)) {
  #  if(ccc) case_colls = c("T2D"=0, "BC"=0, "58C"=0, "NBS"=0, "T1D"=0, "CAD"=0, "BD"=0 ,"HT"=0, "RA"=0, "CD"=0)
  # }

  # If a vector of collections has been supplied make case_colls from these
  if(!is.null(collections))
  {
    case_colls        = rep(0, length(collections))
    names(case_colls) = collections
  } else {
    # If merely a number of collections has been specified then use this 
    # This then means that diseaseColls need to be *numbered* (as there are no names!)
    if(!is.null(noco))
    {
      case_colls = rep(0, noco)
      names(case_colls) = makeDefaultCollnames(noco=noco)
    } else {
      #warning("  Cannot set case_colls with no information!\n")
      cat(     "  Cannot set case_colls with no information!\n")
      cat("  Automatically generating collections.\n")
      collections=get_collections(sim=sim)
      case_colls = makeCaseColls(collections=collections,  diseaseColls=diseaseColls, DEBUG=DEBUG)
    }
  }
  if(is.null(noco)) 
    noco = length(collections)
  # If any disease collections have been passed (often this will just be one collection) then they are set to 1 here
  case_colls[names(case_colls)%in%diseaseColls] = 1                  

  # Check consistency between case_colls and the number of collections
  checkLen(vec=case_colls, len=noco, DEBUG=DEBUG)

  return(case_colls)
}

get_collections=function(disease=NULL, non_metab=NULL, 
                         non_auto_immune=NULL, sim=F, in_noco=3,
                         useFullCollNames=FALSE)
{
  collections = c("58C", "NBS", "T2D", "RA", "CD", "BD", "CAD", "HT", "BC", "T1D")
  auto_immune = c("RA" , "CD" , "T1D")
  metabolic   = c("CAD", "HT" , "T2D")
  if(!is.null(non_metab)) {
    cat("  WARNING! Currently no effort is made to retain the ORDER of the collections here which call_rates fns etc. rely on.\n")
    if(is.null(disease)) cat("Warning - if removing metabolic collections should input a disease surely?\n")
    collections = union(setdiff(collections, metabolic), disease) #Note, this will remove the order on the collections.
  }
  if(!is.null(non_auto_immune)) {
    cat("  WARNING! Currently no effort is made to retain the ORDER of the collections here which call_rates fns etc. rely on.\n")
    if(is.null(disease)) cat("Warning - if removing auto_immune collections should input a disease surely?\n")
    collections = union(setdiff(collections, auto_immune), disease) #Note, this will remove the order on the collections.
  }
  real_colls = T; if(exists(".nocollnames")) if(.nocollnames) real_colls=F
  if(!real_colls | sim) collections = makeDefaultCollnames(noco=in_noco)
  
  fullCollNames = c("58C"="1958 birth cohort",
                    "NBS"="United Kingdom blood service",
                    "T2D"="type 2 diabetes",
                    "RA" ="rheumatoid arthritis",
                    "CD" ="Crohn's disease",
                    "BD" ="bipolar disorder",
                    "CAD"="coronary artery disease",
                    "HT" ="hypertension",
                    "BC" ="breast cancer",
                    "T1D"="type 1 diabetes")
  if(useFullCollNames & sum(collections %in% names(fullCollNames))==length(collections))
  {
    collections = fullCollNames[collections]
  }
  return(collections)
}


# This function is a helper function for checking consistency (or a vector and a length that is hould have)
checkLen=function(vec=NULL, len=NULL, DEBUG=1)
{
  lenCheck = length(vec)==len
  if(!lenCheck) {
    cat("  Warning, inconsistent vector length not equal to value for checking.\n")
    if(DEBUG>1) browser()
  }
}

makeDefaultCollnames=function(noco)
{
  defCollNames = paste("coll_", 1:noco, sep="")
  return(defCollNames)
}


set_args_clusters=function(cnvs=NULL, cnv_names=NULL, write_tag, read_tag, write_results, mapping)
{
  arguments                      = set_arguments(cnvs=cnvs, cnv_names=cnv_names, write_tag=write_tag, read_tag=read_tag, write_results=write_results, mapping=mapping)
  arguments$which_inds_excl      = "precalling_exclusion_list_data_freeze_8_v6.txt"
  arguments$probe_exclusion_type = "SNPs" # Set to T to exclude whatever probes are passed in the excl list - eg multiply mapping or probes with SNPs in
  arguments$excl_probes          = F
  arguments$results_dir_tag      = write_tag
  arguments$real_data            = T
  arguments$remove_scontrol      = T; #T normal, but can set to F for analysing SangerControl/ #"HapMap412943" = SangerControl
  arguments$output_sample_names  = T;
  arguments$normalisation        = "normalised6"; #"QNR_and_QNG", "normalised5", "normalised6" 
  arguments$add_half_to_ratio    = T;
  arguments$remove_colls         = c("Unknown", "YRI", "JPT_CHB", "CEU");       
  arguments$use_hierarchy        = T
  arguments$use_hier_mchoice     = T
  arguments$probe_summary        = "PCA" # "mean" or "pca"
 
  arguments$simple_model_iters   = 1:30
  arguments$hier_mchoice_iters   = 1:225
  arguments$no_assoc_model_iters = 1:2000
  arguments$full_model_iters     = 0
  arguments$no_iters             = max(arguments$simple_model_iters)+max(arguments$no_assoc_model_iters)+max(arguments$full_model_iters);

  arguments$png                  = T
  arguments$calls_in_sep_files   = T     
  arguments$write_summary        = T
  arguments$store_thisfit_smry   = T     
  arguments$ung_dat              = T
  arguments$store_stpts          = !arguments$real_data #So NO, don't store start_points
  arguments$graphics_slow        = F
  arguments$stpts_to_use         = c(3,1,3,4,5,3:7,3,3,4)
  arguments$null_prop            = 3/1000
  arguments$signal_model         = "t8"
  arguments$nocls                = 10:1
  return(arguments)
}


get_no_inds=function(in_dat){
  if(ncol(in_dat[[1]])>nrow(in_dat[[1]])) {cat("Looks like data has been transposed.\n"); browser();}
  return(nrow(in_dat[[1]]))
}


