

set_violence=function(iter)
{
  if(iter< 25            ) violence   = rgamma(1, shape=10, scale=3E-3) ;    #This is how big the moves try to be.
  if(iter>=25 & iter < 80) violence   = rgamma(1, shape=10, scale=6E-4) ;    #This is how big the moves try to be.
  if(iter>=80            ) violence   = rgamma(1, shape=10, scale=2E-4) ;    #This is how big the moves try to be.
  return(violence)
}

get_poss_models=function()
  return(c("simple", "full_model", "full_no_hierarchy", "no_assoc", "hier_nocl_choice"))

choose_move=function(objects, sa, forcemv, start_hierarchy=1000, model=NULL, last_iter)
{
  nocl      = objects$opars$nocl
  iter      = objects$flags$iter
  condition = FALSE
  if(objects$flags$DEBUG>1) if(!(model %in% objects$flags$models)) {cat("Problem: model type not part of standard naming scheme.\n"); browser();}
  display_clm(objects=objects, condition=condition)
  # "hier_nocl_choice
  ####MCMC-like move suggestions
  if(is.null(forcemv)) 
  {
    combine_colls      = objects$flags$model=="simple" | !objects$flags$use_hierarchy
    uprand        = runif(1,0,1) 
    ###### Towards the end certain key moves are FORCED (This is like EM but it the acceptances are Bayesian) #######
    #"Move Breakpoits" - When uprand lies between these the corresponding move is chosen.
    mvbp                         = c(0.04, 0.08, 0.18, 0.28, 0.30, 0.45, 0.50 , 0.65, 0.70, 0.85, 0.93, 0.98, 1 )
    if(model=="full_model") mvbp = c(0.04, 0.06, 0.08, 0.10, 0.15, 0.20, 0.45 , 0.48, 0.70, 0.85, 0.93, 0.98, 1 )
    names(mvbp)                  = c(  1 ,   2 ,   3 , 4   ,   5 ,   6 ,   7  ,   8 ,   9 ,  10 ,  11 ,  12 , 13)
    #"hierarchy Move Breakpoits" as mvbp, but these moves only happen when iter>start_hierarchy (!comb)
    hmvbp                         = c(0.70, 0.83, 0.84, 0.87, 0.90, 0.93, 0.965, 1.00)
    if(model=="full_model") hmvbp = c(0.70, 0.78, 0.88, 0.96, 0.97, 0.98, 0.990, 1.00)
    uprand        = last_moves(model=model, last_iter=last_iter, iter=iter, mvbp=mvbp, hmvbp=hmvbp, uprand=uprand)
   #if(iter == last_iter-1) browser();
    violence      = set_violence(iter)
    beta_violence = rgamma(1, shape=10, scale=2E-2)
    col_sp_var    = 0.0001; #This controls how different the cohorts will be after this move. 

    if(                  uprand<mvbp[1] )  {mv = "vars"         ; objects$npars = c_clust_vars(    objects=objects, pars=objects$opars, violence = violence/3, col_sp_var = col_sp_var, combined=combine_colls) }
    if(uprand>=mvbp[1] & uprand<mvbp[2] )  {
      #mean3 doesn't need to know about the model as it _retains_ differences (or absence of) between collections
      if(objects$flags$model=="simple") {mv = "mean3"        ; objects$npars = c_clust_mean3(objects=objects, objects$opars, violence = violence, iter=iter)}
      if(objects$flags$model!="simple") {
        if(nocl> 1) {
          mv = "ch_gnf_alpha" ; objects = change_gnf_hpars(objects=objects, mid_move=F, maximise=TRUE, violence = 0.03^2)
        }
        if(nocl==1) {
          change  = c_h_pars(objects=objects, violence = 0.001); mv= change$mv; objects = change$objects;
        }
      }
    }
    #Probably want to use hcalls = T when the data is fitting well. (Although haven't debugged code for handling classes of size 0)
    if(uprand>=mvbp[2] & uprand<mvbp[3] )  {mv = "maxL_vars"    ; objects       = maxL_variances(objects=objects, use_hcalls=F, combined = combine_colls)}
    if(uprand>=mvbp[3] & uprand<mvbp[4] )  {mv = "maxL_means"   ; objects       = maxL_means(    objects=objects, use_hcalls=F, combined = combine_colls)}
    if(uprand>=mvbp[4] & uprand<mvbp[5] )  {mv = "mean1"        ; objects$npars = c_clust_mean    (objects=objects, objects$opars, violence = violence )}
    if(uprand>=mvbp[5] & uprand<mvbp[6] )  {mv = "mean3"        ; objects$npars = c_clust_mean3(objects=objects, objects$opars, violence = violence, iter=iter)}
    #New moves can be inserted here in the place of the second 'mean3'. They'll be tried 1/20 moves at present.
    if(uprand>=mvbp[6] & uprand<mvbp[7] )  {
     #if(model %in% c("full_model", "full_no_hierarchy")) { #### This line is wrong as it's important to change BETA0!! However c_betas and max_beta check before changing beta1
      if(model %in% c("full_model", "full_no_hierarchy", "no_assoc", "hier_nocl_choice") && nocl>1) {
        beta_rand = runif(1,0,1)
        if(beta_rand > 0.5) {mv = "max_beta"  ; objects$npars$betas = maximise_beta(objects=objects, model=model)                          }
        if(beta_rand <=0.5) {mv = "c_betas"   ; objects$npars = c_betas(objects=objects, pars=objects$opars, violence = beta_violence, model=model)}
        objects$npars$gnfp$gnf_controls = make_control_freqs(objects=objects, pop_freqs =objects$npars$gnfp$gnf_lambda, new=T)
        objects$npars$gnfp$gnf_cases    = make_case_freqs(   objects=objects, pop_freqs =objects$npars$gnfp$gnf_lambda, new=T)
      } else {
                             mv = "mean3"     ; objects$npars = c_clust_mean3(objects=objects, objects$opars, violence = violence, iter=iter)
      }
    } 
    if(uprand>=mvbp[7] & uprand<mvbp[8] )  {
      change = c_h_pars(objects=objects, violence = 0.001); mv = change$mv; objects = change$objects;
    }
    if(uprand>=mvbp[8] & uprand<mvbp[9]) {
      if(model %in% c("full_model", "full_no_hierarchy", "no_assoc", "hier_nocl_choice") && nocl>1) {
        mv = "c_betas"  ; objects$npars = c_betas(pars=objects$opars, violence = beta_violence, model=model) 
        objects$npars$gnfp$gnf_controls = make_control_freqs(objects=objects, pop_freqs    =objects$npars$gnfp$gnf_lambda  , new=T)
        objects$npars$gnfp$gnf_cases    = make_case_freqs(   objects=objects, pop_freqs=objects$npars$gnfp$gnf_lambda, new=T)
      } else {  
          mv = "mean3"    ; objects$npars = c_clust_mean3(objects=objects, objects$opars, violence = violence, iter=iter)
        if(nocl>1 && objects$flags$DEBUG>1 & !(model %in% c("simple"))) {cat("Problem: model type not part of standard naming scheme (2nd point).\n"); browser();}
      }
    }

    if(uprand>=mvbp[9])                
    {
      if(!(model=="simple")) #if model==hier_nocl_choice then can still change these hyper-params (but not betas[2]).
      {
        bp_check = (hmvbp[1]==mvbp[9]); if(!bp_check) {cat("Warning, mismatch of move choice breakpoints.\n"); browser();}
        if(uprand>=hmvbp[1] & uprand<hmvbp[2]) {
          change  = c_h_pars(objects=objects, violence = 0.001); mv = change$mv; objects = change$objects;
        }
        if(model %in% c("full_model", "full_no_hierarchy", "no_assoc", "hier_nocl_choice") && nocl>1) {
          if(uprand>=hmvbp[2] & uprand<hmvbp[3]) {mv = "c_betas"   ; objects$npars = c_betas(objects=objects, pars=objects$opars, violence = beta_violence, model=model)}
          if(uprand>=hmvbp[3] & uprand<hmvbp[4]) {mv = "max_beta"  ; objects$npars$betas = maximise_beta(objects=objects, model=model)                          }
          objects$npars$gnfp$gnf_controls = make_control_freqs(objects=objects, pop_freqs =objects$npars$gnfp$gnf_lambda, new=T)
          objects$npars$gnfp$gnf_cases    = make_case_freqs(   objects=objects, pop_freqs =objects$npars$gnfp$gnf_lambda, new=T)
        } else                  {
          if(uprand>=hmvbp[2] & uprand<hmvbp[4]) {mv = "mean3"     ; objects$npars = c_clust_mean3(objects=objects, objects$opars, violence = violence, iter=iter)}
        }
        if(objects$flags$use_hierarchy) {
          if(uprand>=hmvbp[4] & uprand<hmvbp[5]) {mv = "col_mean1" ; objects$npars = c_clust_mean_cspec(objects=objects, objects$opars, col_sp_var = col_sp_var)}
          if(uprand>=hmvbp[5] & uprand<hmvbp[6]) {mv = "col_mean2" ; objects$npars = c_clust_mean_cspec2(objects=objects, objects$opars, col_sp_var = col_sp_var)}
         #if(uprand>=hmvbp[6] & uprand<hmvbp[7]) {mv = "spec_max_gnf"; objects     = max_gnf(        objects=objects, min_1=T)}
        } else                          {
          if(uprand>=hmvbp[4] & uprand<hmvbp[5]) {mv = "mean1"        ; objects$npars = c_clust_mean    (objects=objects, objects$opars, violence = violence )}
          if(uprand>=hmvbp[5] & uprand<hmvbp[6]) {mv = "mean3"        ; objects$npars = c_clust_mean3(objects=objects, objects$opars, violence = violence, iter=iter)}
        }
        if(uprand>=hmvbp[6] & uprand<hmvbp[7]) {mv = "comb_max_gnf"; objects     = combined_maxgnf(objects=objects)}
        if(uprand>=hmvbp[7]                  ) {mv = "mean2"     ; objects$npars = c_clust_mean2(objects=objects, objects$opars, violence = violence, combined=combine_colls)}
      } else
      {
        if(uprand>=mvbp[9]  & uprand<mvbp[10]) {mv = "mean3"; objects$npars  = c_clust_mean3(objects=objects, pars=objects$opars, violence = violence, iter=iter)}
        if(nocl>1) {
          if(uprand>=mvbp[10] & uprand<mvbp[11]) {mv = "comb_max_gnf"; objects = combined_maxgnf(objects=objects)              }
          if(uprand>=mvbp[11] & uprand<mvbp[12]) {mv = "change_gnf"  ; objects = change_gnf(     objects=objects, gnf_sd=0.02) }
        } else {
          if(uprand>=mvbp[10] & uprand<mvbp[11]) {change  = c_h_pars(objects=objects, violence = 0.001); mv= change$mv; objects = change$objects;}
          if(uprand>=mvbp[11] & uprand<mvbp[12]) {change  = c_h_pars(objects=objects, violence = 0.001); mv= change$mv; objects = change$objects;}
        }
        if(uprand>=mvbp[12] & uprand<mvbp[13]) {mv = "mean2"; objects$npars  = c_clust_mean2(objects=objects, pars=objects$opars, violence = violence, combined=combine_colls)}
      }
    }
  } else {
      objects = do_forced_mv(objects=objects, forcemv=forcemv); mv = forcemv$mvtype;
  }
  display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=1, func="updater (showing new values)", pars=objects$npars)
  if(objects$flags$DEBUG>0.5) ##checks!
  {
    if(sum(!(objects$npars$cld> 0))>0) {cat("  Error, cannot have negative distances between clusters.\n"); browser();}  
    if(sum(!(objects$npars$clv>=0))>0) {cat("  Error, cannot have negative variances of clusters.\n"     ); browser();}  
  }
  objects$flags$mv = mv
  if(nrow(objects$npars$cld)!=objects$opars$noco) {cat("in choose_move. dim of npars$cld wrong.\n"); browser();}
  check_beta1 = (objects$flags$DEBUG==0 | model=="full_model" | model=="full_no_hierarchy"| (objects$opars$betas[2]==0 & objects$npars$betas[2]==0))
  if(!check_beta1) {cat("Warning, In choose move. beta1!=0 yet haven't started full_model yet.\n"); browser();}

  return(objects)
}

do_forced_mv=function(objects, gridding=T, forcemv)
{
    mv = forcemv$mvtype
    ## This code is used ONLY for debugging the Maximiser. Inside are deterministic moves, to see how they affect likelihood etc.
    if(objects$flags$DEBUG<2) {cat("Warning!! Using forced moves with a low DEBUG value, mistake? (if not set DEBUG=2?)\n"); browser();}
    if(mv=="c_mean_forced")      objects$npars = c_clust_mean_force(forcemv=forcemv, pars=objects$opars, violence = 0.001)
    if(mv=="spec_c_mean_forced") objects$npars = c_clust_mean_cspec_force(forcemv=forcemv, pars=objects$opars, col_sp_var = 0.001)
    if(mv=="c_var_forced" )      objects$npars = c_clust_vars_force(forcemv=forcemv, pars=objects$opars, violence = 0.001)
}

# nda = combineCollsInDataArray(data_array=da)
combineCollsInDataArray=function(data_array)
{
  noco=1
  newDataArray = matrix(list(""), nrow=1, ncol=1)
  datMat = matrix(NA, nrow=0, ncol=ncol(data_array[[1,1]]))
  for(i in 1:length(data_array)) datMat = rbind(datMat, data_array[[1,i]])
  newDataArray[[1,1]] = datMat
  names(newDataArray) = "coll1"; colnames(newDataArray) = names(newDataArray)
  return(newDataArray)
}

## Sometimes the interplay of the fixed class distances and the minimum_extra class distance lead to means outside the range of the data.
## check_clm picks these up and pauses the program as they're a worrying sign
## The following function tries to undo this effect.
undo_min_extra_problem=function(objects, precision=1e-10)
{
   cat("Why has this function been called (have decided to stop checking for means outside range of data!)?\n"); browser();
  #wdat = objects$flags$dmax - objects$flags$dmin 
   wdat = objects$flags$wdat
   nocl = objects$opars$nocl
   ##Check that the data really goes outside the range:
   check0 = min(objects$npars$hkclm)>=objects$flags$dmin; if(objects$flags$DEBUG>0.5 & !check0) {cat("Shouldn't have class means below min of data.\n"); browser()}
   check1 = max(make_clm(smcs=objects$npars$smc, clds=objects$npars$cld, noco=objects$opars$noco, nocl=objects$opars$nocl))<=objects$flags$dmax
   if(objects$flags$DEBUG>0.5 & !check1) {cat("Shouldn't have class means above max of data.\n"); browser()}
   check2 = max(objects$npars$hkclm)<=objects$flags$dmax; 
   if(!check2)
   {
      #browser()
      new_clm        = objects$npars$hkclm
      new_clm[which(new_clm>objects$flags$dmax)] = objects$flags$dmax
      extra_clds     = rev_hk4(hkclm=new_clm, flags=objects$flags, increase_sm_dsts=F, neg_cldok=T)$clds
      sm_clds        = which((extra_clds - objects$flags$min_extra_cld)< -precision, arr.ind=T)
      too_close      = length(sm_clds)>0
      cli = 1  #This is a counter for how many attempts to fix the clds have been made and shouldn't go over nocl
      while(too_close) {
       #sm_clms      = sm_clds
       #sm_clms[,2]  = sm_clms[,2]+1
        next_cls     = sm_clds[nrow(sm_clds),]
        next_cls[2]  = next_cls[2]+1
        min_diff     = get_hack_diff_mean(cl=sm_clds[nrow(sm_clds),2], wdat=wdat, add_cld=objects$flags$hack_add_cld)
        new_clm[sm_clds[nrow(sm_clds),]] = new_clm[next_cls] - objects$flags$min_extra_cld - min_diff
        extra_clds       = rev_hk4(hkclm=new_clm, flags=objects$flags, increase_sm_dsts=F, neg_cldok=T)$clds 
        sm_clds          = which(extra_clds < objects$flags$min_extra_cld, arr.ind=T)
       #cat("Check that I'm indexing the classes properly!\n"); browser();
        too_close        = length(sm_clds)>0
        if(objects$flags$DEBUG > 0.3 & cli > nocl) {cat("problem in min dist implementation.\n"); browser()}
        cli = cli+1; 
      }
   }
   objects$npars$hkclm = new_clm
   extras_decomp       = rev_hk4(hkclm=new_clm, flags=objects$flags)
   objects$npars$smc   = extras_decomp$smc
   objects$npars$cld   = extras_decomp$clds
   return(objects)
}





#May wish to update this to have a DEBUG argument to output the commented messages when exceptional cases occur
calc_dat_moments=function(data, in_clv)
{
  if(!is.null(dim(data)))
  {
    vals = as.numeric(rownames(data))
    if(ncol(data)>1) cat("data matrix sent, not vector.\n");
    if(ncol(data)>1) data = rowSums(data, 1, sum)
  }
  if( is.null(dim(data))) vals = as.numeric(   names(data))
  empty_clust = F
  counts = data
  if(sum(counts)<1e-4) {
    #if(objects$flags$DEBUG>2) {
    #  cat("In calc_dat_moments. Less than 0.0001 data points expected in this class. Returning previous value.\n");
    #}
    empty_clust    = T
    moments        = list( NULL , NULL ,  empty_clust )
    names(moments) = c("mean", "var", "empty_clust")
    return(moments)
  }
  max_val  = which.max(counts          )
  residual = sum(      counts[-max_val])
  if(sum(residual)<1e-10) {
    #if(objects$flags$DEBUG>2) {
    #  cat("In calc_dat_moments. Hard to estimate variance of cluster when data so concentrated. Returning previous value.\n");
    #}
    empty_clust    = F; #empty_clust=F and var=NULL means that mean is ok, but variance is not.
    moments        = list(  0   ,   NULL  ,  empty_clust )
    names(moments) = c("mean",  "var"  , "empty_clust")
    return(moments)
  }

  mean     = sum(vals*counts  )/sum(counts)
  ssq      = sum(vals^2*counts)/sum(counts)
  if(length(which(counts>0))>1 & sum(counts)>1) {
    var    = ssq-mean^2 
    bias_corrected_var = var * sum(counts)/(sum(counts)-1)
  } else             {
    if(sum(counts)<=1) {
      #bias_corrected_var    = 1
       bias_corrected_var    = in_clv
      #empty_clust = T
    }
    # This is very tricky! What's a good estimate of the variance of these data points when they're all in the same grid_val?
    if(sum(counts)>1) {
      if(is.null(in_clv)) {cat("Warning, data seems to be a single point!\n"); browser(); bias_corrected_var=1;}
      bias_corrected_var = in_clv
    }
  }
  if(sum(bias_corrected_var<0 )>0) {cat("In calc_dat_moments. Error, cannot have negative variances.\n"); browser();}
  if(sum(bias_corrected_var==0)>0) {cat("In calc_dat_moments. Zero variances will cause problems later.\n"); browser();}

  moments = list(mean, bias_corrected_var, empty_clust )
  names(moments) = c("mean", "var"    ,"empty_clust")
  return(moments)
}



##This is a rather unfortunate duplication of the code in Initialise() in 'initialise.R'. Decided not to spend time objectifying it all.
## Need to maintain the ability to have different priors/parameters for simulation and inference.
# gnf_theta ('theta' in JMs written model) - controls how close to HWE we are
set_sim_hpriors=function(sim_pars, gnf_theta=30)
{
    noco = sim_pars$noco
    nocl = 2*(sim_pars$no_alleles)-1
    #################### CLASS PROPORTIONS ####################
    ##(denoted gnf, short for allele_frequencies)
    #a = M(M(1-M)/V -1)
    #b = (a/M)-a
    gnf_a_m = 0.5
    gnf_a_v = 0.035
    gnf_hp_shape1 = gnf_a_m*(gnf_a_m*(1-gnf_a_m)/gnf_a_v -1); # mean = a/(a+b), var = (a*b)/((a+b)^2*(a+b+1))
    gnf_hp_shape2 = (gnf_hp_shape1/gnf_a_m)-gnf_hp_shape1; #'alpha_var' in the model - the variance of the parameter 'gnf_apar' (alpha in the model), describes gnf_ws (w in the model)3
    #(alpha in the model) This is a draw from the prior on the distribution of the tightness of the dirichlet in the gnf model:
    gnfp =      list(gnf_hp_shape1 ,  gnf_hp_shape2 ,  gnf_theta)
    names(gnfp) = c("gnf_hp_shape1", "gnf_hp_shape2", "gnf_theta")
    if(is.na(range(gnfp)[1])) {cat("Warning, NAs detected in allele_frequency priors.\n"); browser();}

    #################### Association Parameters ####################
    prbeta0 = list("normal", 0, 1)          #Given by Jonathan!
    prbeta1 = list("normal", 0, (0.2)^2)    #Given by Jonathan!
    names(prbeta0)  = c("distribution", "mean", "var")
    names(prbeta1)  = c("distribution", "mean", "var")

   #################### Cluster Centres ####################
   ## prsmc = the prior on the position of the smallest class.
   prsmc_mean_mean   = -0.02
   prsmc_mean_var    = (0.005)^2
  #prsmc_var_mean    = 0.02
  #prsmc_var_var     = (0.01)^2
   prsmc_var_scale   = 5e-3
   prsmc_var_shape   = 3
   prsmc_mean        = list("normal"       , prsmc_mean_mean, prsmc_mean_var )
   names(prsmc_mean) = c("distribution"    , "mean"         , "var"     )
   prsmc_var         = list("Inverse Gamma", prsmc_var_scale, prsmc_var_shape)
   names(prsmc_var)  = c("distribution"    , "scale"        , "shape"        )

   prsmc_mean1       = rnorm(1, prsmc_mean_mean, sqrt(prsmc_mean_var))
   prsmc_var1        = rinvgamma(1, scale = prsmc_var_scale, shape = prsmc_var_shape)

   #\/ \/ \/ \/ \/ \/ 
   prsmc             = list("normal", prsmc_mean1, prsmc_var1)
   hprsmc            = list(prsmc_mean ,  prsmc_var)
   #/\ /\ /\ /\ /\ /\
   names(prsmc)      = c("distribution", "mean", "var")
   names(hprsmc)     = list("mean", "var")
 
   ##prcld = pr_class_distances = the prior on the gaps between different classes
   prcld_mean_mean   =  0.02
   prcld_mean_var    = (0.002)^2
   prcld_var_mean    =  0.002
   prcld_var_var     = (0.0005)^2
   prcld_mean_scale  = prcld_mean_var /prcld_mean_mean
   prcld_mean_shape  = prcld_mean_mean/prcld_mean_scale
   prcld_var_scale   = prcld_var_var  /prcld_var_mean
   prcld_var_shape   = prcld_var_mean /prcld_var_scale
  #prcld_shape       = prcld_mean/prcld_scale
   prcld_mean        = list("gamma", prcld_mean_scale, prcld_mean_shape);
   prcld_var         = list("gamma", prcld_var_scale , prcld_var_shape );
   names(prcld_mean) = c("distribution", "scale", "shape")
   names(prcld_var)  = c("distribution", "scale", "shape")
   prcld_mean1       = rgamma(1, scale=prcld_mean_scale, shape=prcld_mean_shape)
   prcld_var1        = rgamma(1, scale=prcld_var_scale , shape=prcld_var_shape )
   prcld_scale       = prcld_var1/prcld_mean1
   prcld_shape       = prcld_mean1/prcld_scale
   #\/ \/ \/ \/ \/ \/ 
   prcld             = list("gamma", prcld_scale, prcld_shape); 
   hprcld            = list(prcld_mean ,  prcld_var)
   #/\ /\ /\ /\ /\ /\
   names(prcld)      = c("distribution", "scale", "shape")
   names(hprcld)     = list("mean", "var")

   #################### Cluster Variances ####################
   ##prclv = pr_class_vars = the prior on the variances in the different classes
   # The model for cluster variances is: log(var_{cj, zj}) = base{cj, 0} + increment_cj * z_j (cj = cohort of ind j, zj=copynumber of ind j)
   # Prior on the base variance is normal(a,b) where a is N(s1, s2^2) and b is inverse_gamma(t1, t2)
   # Prior on the increment variance is gamma(phi_m, phi_var) where phi_m is Gamma(u1, u2) and phi_var gamma(v1, v2)
   prlclv_base_mean_mean   =  -10; #(this is the LOG of the variance that I think a normal cluster might have!)
   prlclv_base_mean_var    = (0.05)^2
   prlclv_base_var_scale   = 5
   prlclv_base_var_shape   = 500
   prlclv_base_mean        = list("normal"       , prlclv_base_mean_mean, prlclv_base_mean_var);
   prlclv_base_var         = list("inverse_gamma", prlclv_base_var_scale, prlclv_base_var_shape );
   names(prlclv_base_mean) = c("distribution", "mean" , "var");
   names(prlclv_base_var)  = c("distribution", "scale", "shape");
   prlclv_base_mean1       = rnorm(    1, prlclv_base_mean_mean, sqrt(prlclv_base_mean_var) )
   prlclv_base_var1        = rinvgamma(1, scale = prlclv_base_var_scale, shape = prlclv_base_var_shape)

   #\/ \/ \/ \/ \/ \/ 
   prlclv_base             = list("normal", prlclv_base_mean1, prlclv_base_var1); 
   #/\ /\ /\ /\ /\ /\
   names(prlclv_base)      = c("distribution", "mean", "var")

   #inc = increment (ie. how much the variance changes for different copy number classes)
   prlclv_inc_mean_mean   =  0.02
   prlclv_inc_mean_var    = (0.003)^2
   prlclv_inc_var_mean    =  0.002
   prlclv_inc_var_var     = (0.0003)^2
   prlclv_inc_mean_scale  = prlclv_inc_mean_var/prlclv_inc_mean_mean
   prlclv_inc_mean_shape  = prlclv_inc_mean_mean/prlclv_inc_mean_scale
   prlclv_inc_var_scale   = prlclv_inc_var_var  /prlclv_inc_var_mean
   prlclv_inc_var_shape   = prlclv_inc_var_mean /prlclv_inc_var_scale
   prlclv_inc_mean        = list("gamma", prlclv_inc_mean_scale, prlclv_inc_mean_shape);
   prlclv_inc_var         = list("gamma", prlclv_inc_var_scale, prlclv_inc_var_shape );
   names(prlclv_inc_mean) = c("distribution", "scale" , "shape");
   names(prlclv_inc_var)  = c("distribution", "scale" , "shape");
   prlclv_inc_mean1       = rgamma(1, scale=prlclv_inc_mean_scale, shape=prlclv_inc_mean_shape)
   prlclv_inc_var1        = rgamma(1, scale=prlclv_inc_var_scale , shape=prlclv_inc_var_shape )
   prlclv_inc_scale1      = prlclv_inc_var1 /prlclv_inc_mean1
   prlclv_inc_shape1      = prlclv_inc_mean1/prlclv_inc_scale1

   #\/ \/ \/ \/ \/ \/ 
   prlclv_base            = list("normal", prlclv_base_mean1, prlclv_base_var1 );  
   prlclv_inc             = list("gamma" , prlclv_inc_scale1, prlclv_inc_shape1);  
   #/\ /\ /\ /\ /\ /\
   names(prlclv_base)     = c("distribution", "mean" , "var"  )
   names(prlclv_inc )     = c("distribution", "scale", "shape")

   #list( prlclv_base_mean_mean ,  prlclv_base_mean_var ,  prlclv_base_var_scale ,  prlclv_base_var_shape ,  prlclv_base,
   #\/ \/ \/ \/ \/ \/ 
   hprclv        = list( prlclv_base_mean,  prlclv_base_var ,  prlclv_inc_mean ,  prlclv_inc_var)# ,  prlclv_base ,  prlclv_inc )
   #/\ /\ /\ /\ /\ /\
   names(hprclv) = list("base_mean", "base_var", "inc_mean", "inc_var")#, "base", "inc")

   priors = list(     prsmc,   hprsmc ,  prcld ,  hprcld ,  prlclv_base ,  prlclv_inc ,   hprclv ,  prbeta0 ,  prbeta1,   gnfp )
   names(priors) = c("prsmc", "hprsmc", "prcld", "hprcld", "prlclv_base", "prlclv_inc",  "hprclv", "prbeta0", "prbeta1", "gnfp")
   return(priors)
}

sim_pars_names=function()
{
  names=c("noco", "no_inds", "no_probes","no_alleles", 
          "case_colls", "signal", "noise", "association", "intens_pars", 
          "difficulty", "maf", "betas", "allelicModel", "numGenotypes",
          "haveBadProbes") # length 14
}
make_sim_pars=function(arguments, extra_args, cnv_index)
{
  sim_pars     = list("noco"          = arguments$sim_noco, 
                      "no_inds"       = extra_args$sim_args$sim_no_inds, 
                      "no_probes"     = arguments$sim_no_probes, 
                      "no_alleles"    = extra_args$sim_args$sim_alleles[cnv_index], 
                      "case_colls"    = extra_args$sim_args$sim_case_colls, # arguments$case_colls,
                      "signal"        = arguments$signal, 
                      "noise"         = arguments$noise, 
                      "association"   = arguments$sim_association, 
                      "intens_pars"   = set_probe_measurement_pars(arguments=arguments,
                                        difficulty = arguments$sim_difficulty), 
                      "difficulty"    = arguments$sim_difficulty, 
                      "maf"           = arguments$sim_maf, #"from_model"
                      "betas"         = c("beta0"=arguments$beta0, "beta1"=arguments$beta1),
                      "allelicModel"  = extra_args$sim_args$allelicModel, #TRUE
                      "numGenotypes"  = extra_args$sim_args$numGenotypes[cnv_index],
                      "haveBadProbes" = extra_args$sim_args$haveBadProbes
                      )
  check = sum(names(sim_pars)==sim_pars_names())==length(sim_pars); 
  if(!check) cat("  Warning!! discrepency in simulation parameter names.\n")
  return(sim_pars)
}

# gnf_lambda = simGenFreqs(hpriors=hpriors, sim_pars=sim_pars, DEBUG=DEBUG)
simGenFreqs=function(hpriors, sim_pars, DEBUG=1.1, 
                     nocl  = 2*sim_pars$no_alleles-1)
{
  noco  = sim_pars$noco
  index = 1:nocl 
  if(sim_pars$maf=="from_model")
  {
    ##Generate Allele frequencies, hence genotype frequencies in each of the collections
    gnf_hp_shape1 = hpriors$gnfp$gnf_hp_shape1
    gnf_hp_shape2 = hpriors$gnfp$gnf_hp_shape2
    gnf_theta     = hpriors$gnfp$gnf_theta
    gnf_apar      = rbeta(1, shape1=gnf_hp_shape1, shape2=gnf_hp_shape2) # These are the ALLELE frequencies
    #The w's are distributed in a 1,4,6,4,1 kindof way.
    #gnf_ws control gnf_lambda (lambda in the model)
    # These are the population GENOTYPE frequencies
    gnf_ws      = (choose((nocl-1), 0:(nocl-1)) * gnf_apar^index * (1-gnf_apar)^(nocl-index-1)) 
    dparams     = (gnf_theta*gnf_ws)
    if(sum(dparams<1)>0 & 0) {
      cat("Warning, some prior allele frequencies are extremely low, \nRaising frequency in minimum classes.\n");
    }
    dparams      = pmax(dparams, rep(1, length(dparams))) 
    gnf_lambda   = my_rdirichlet(1, (dparams)) #This has bene checked - the prior is on the POPULATION gnfs. cnv types simulated from case/control gnfs though.
  } else {
    maf  = sim_pars$maf
   #gfs  = c(m^2, 2*m*(1-m), (1-m)^2) #Standard HWE calculation for two allele systems
    if(nocl==3) m = maf else m = (maf^2)^(1/(nocl-1)) # This is to achieve the same proportion in the smallest class for each nocl
    gnf_lambda = choose(nocl-1, index-1   ) * m^(nocl-index) * (1-m)^(index-1) # Creating HWE frequencies that mimic the 2-allele system
    gnf_apar = "used_fixed_lambdas"
  }
  rv = list("gnf_apar"=gnf_apar, "gnf_lambda"=gnf_lambda)
  return(rv)
}

#genFreqsFromNumClasses=function(hpriors, sim_pars, DEBUG=1.1, 
#                             nocl  = 2*sim_pars$no_alleles-1)
#{
#  
#}


sim_from_model=function(hpriors, sim_pars, DEBUG=1.1,
                        pause = FALSE,
                        signal=NULL)
{
  noco  = sim_pars$noco
  if(sim_pars$allelicModel) {
    nocl       = 2*sim_pars$no_alleles-1
    genRv      = simGenFreqs(hpriors=hpriors, sim_pars=sim_pars, DEBUG=DEBUG, nocl=nocl)
  } else {
    nocl       = sim_pars$numGenotypes
    genRv      = simGenFreqs(hpriors=hpriors, sim_pars=sim_pars, DEBUG=DEBUG, nocl=nocl)
  }
  gnf_lambda = genRv$gnf_lambda
  gnf_apar   = genRv$gnf_apar
  index = 1:nocl 
  gnf_controls = make_control_freqs(objects=NULL, pop_freqs=gnf_lambda, betas = sim_pars$betas)
  gnf_cases    = make_case_freqs(   objects=NULL, pop_freqs=gnf_lambda, betas = sim_pars$betas)
  check = sum(abs(gnf_lambda)<1e-8)
  if(0 & check>0 & DEBUG>0.9) {
    cat("Warning - have an extremely low prior on the allele frequency in", check, "of the classes.\n"); browser();
  }

  #Generating diseame model parameters from the prior
 #beta0 = rnorm(1, 0, 1)  
 #beta1 = rnorm(1, 0, 0.2^2)
  # beta0 is set to a very low value so that relative risk=odds ratio which means that
  # Retrospective inference can be done using a prospective model
  beta0 = sim_pars$betas[1] 
  #Forcing an association:
  if(sim_pars$association) beta1 = sim_pars$betas[2] else beta1 = 0
  cnv_types = sim_cnv_types(beta0, beta1, hpriors, sim_pars, nocl=nocl, noco=noco, gnf_controls=gnf_controls, gnf_cases=gnf_cases)
  if(DEBUG>=2) {
    min_cnvt = range(cnv_types)[1]; max_cnvt = range(cnv_types)[2]; breaks = (min_cnvt-0.5):(max_cnvt+0.5); 
    cat("Genotype Frequencies in controls and cases respectively:\n");
    cat(hist(cnv_types[[1]], plot=F, breaks=breaks)$counts, "\n"); cat(hist(cnv_types[[3]], plot=F, breaks=breaks)$counts, "\n");   
  }
 #intens_pars = set_probe_measurement_pars(arguments=arguments)
  if(is.null(signal))
    signal = sim_pars$signal / (sim_pars$difficulty/10)
  noise  = sim_pars$noise  * (sim_pars$difficulty/10)
  data_array         = sim_intensities(cnv_types=cnv_types, intens_pars=sim_pars$intens_pars, 
                                       signal=signal, noise=noise, 
                                       no_gtypes=nocl, numProbes=sim_pars$no_probes,
                                       haveBadProbes=sim_pars$haveBadProbes)
  if(sim_pars$difficulty>=10) 
    data_array       = complicate_intensities(data_array=data_array, 
                                              difficulty=sim_pars$difficulty, 
                                              numBatchEffects=2, 
                                              numTimeEffects=2)                                              
  priors_used        = list( beta0 ,  beta1 ,  gnf_apar ,  gnf_lambda )
  names(priors_used) = c(   "beta0", "beta1", "gnf_apar", "gnf_lambda")
  return_val         = list( data_array ,  cnv_types ,  priors_used )
  names(return_val)  = list("data_array", "cnv_types", "priors_used")
  if(pause) browser()
  return(return_val)
  ## I need to record everything, perhaps in an object called sim_pars (which might include another list sim_hpars, and even sim_hpriors)
}

complicate_intensities=function(data_array, difficulty=10, 
                        numBatchEffects= 0+2*(difficulty>=10), 
                        numTimeEffects = 0+2*(difficulty>=10), 
                        simExtremeInds = FALSE ,
                        batch_prop     = 1/40  , 
                        simNullInds    = TRUE  ,
                        fixedNumNulls  = TRUE  ,
                        nullProp       = 4/1000,
                        batch_effect_strength=0.03*(difficulty/10), batch_effect_deviation=0.07, 
                        time_effect_strength=0 , time_effect_deviation=0.01 , time_effect_len=0.05*(difficulty/10),
                        null_class_mean = 0.002*(difficulty/10) , null_class_sd = 0.0012,
                        extreme_inds_mean = 0.0003*(difficulty/10), extreme_inds_sd = 0.0007, how_extreme=2.5*(difficulty/10))
{
  noco           = ncol(data_array)
  no_probes      = ncol(data_array[[1,1]])
  dat_extremes   = quantile(unlist(data_array), probs=c(0.01, 0.99))
  robust_data_range = diff(dat_extremes)
  batch_effect_mean = batch_effect_strength * robust_data_range
  batch_effect_var  = (batch_effect_deviation * robust_data_range)^2
  time_effect_mean  = time_effect_strength * robust_data_range
  time_effect_var   = (time_effect_deviation * robust_data_range)^2
  dodgy_batches     = 0 #These are just counters (count up to batch_effects)
  dodgy_periods     = 0
  tot_no_inds = sum(sapply(data_array, nrow))
  ## Simluate Batch Effects
  while(dodgy_batches < numBatchEffects) {
    colls   = sample(x=noco, size=1)
    for(coll in colls) {
      coll_no_inds     = nrow(data_array[[1,coll]])           # The number of individuals in each collection (assumed to be the same)
      batch_size       = batch_prop * coll_no_inds            # The number of individuals in each batch (whos measurements are altered in the same way)
      numBatchesInColl = floor(coll_no_inds)/batch_size       # The TOTAL number of batches the data for the collection
      block            = sample(x=numBatchesInColl, size=1)   # The specific block of individuals to be affected.
      batch_inds       = (((block-1)*batch_size)+1         ):   
                         (((block-1)*batch_size)+batch_size)  # The actual individuals that are affected by this specific batch effect.
      if(0) {
        ss = mean_var_to_standard_pars(distribution="gamma", mean=batch_effect_mean, var=batch_effect_var)
        batch_scale = ss["scale"]
        batch_shape = ss["shape"]
        data_array[[1,coll]][batch_inds,] = data_array[[1,coll]][batch_inds,] + rgamma(length(batch_inds)*no_probes, scale=batch_scale, shape=batch_shape )
      }
      if(1) {
        data_array[[1,coll]][batch_inds,] = data_array[[1,coll]][batch_inds,] + rnorm(1, mean=batch_effect_mean, sd=sqrt(batch_effect_var))
      }
    }
    dodgy_batches = dodgy_batches + 1
  }
  ## Simluate Time Effects
  while(dodgy_periods < numTimeEffects) {
    beg_dfrnt_patch = runif(1, 0, 1-time_effect_len)
    period          =  c(beg_dfrnt_patch,  beg_dfrnt_patch+time_effect_len)
    for(coll in 1:noco)
    {
      no_inds = nrow(data_array[[1,coll]])
      period_affected_inds = c(floor(period[1]*no_inds), floor(period[2]*no_inds))
      data_array[[1,coll]][period_affected_inds,] = data_array[[1,coll]][period_affected_inds,] + rnorm(1, mean=time_effect_mean, sd=sqrt(time_effect_var))
    }
    dodgy_periods = dodgy_periods + 1
  }
  ## Simluate Null Individuals
  if(simNullInds>0) {
    if(!fixedNumNulls) {
      ss = mean_var_to_standard_pars(distribution="beta", mean=null_class_mean, var=(null_class_sd)^2)
      null_shape1 = ss["shape1"]
      null_shape2 = ss["shape2"]
      num_null_inds = rbeta(1, shape1=null_shape1, shape2=null_shape2) * tot_no_inds
    } else {
      num_null_inds = nullProp*tot_no_inds
    }
    nni_per_coll  = round(num_null_inds/noco, digits=0)
    for(coll in 1:noco)
    {
      no_inds = nrow(data_array[[1,coll]])
      null_inds = sample(no_inds, nni_per_coll)
      data_array[[1,coll]][null_inds,] = runif(nni_per_coll, dat_extremes[1], dat_extremes[2])
    }
  }
  ## Simluate Extreme Individuals
  if(simExtremeInds>0) {
    ss = mean_var_to_standard_pars(distribution="beta", mean=extreme_inds_mean, var=(extreme_inds_sd)^2)
    extreme_shape1 = ss["shape1"]
    extreme_shape2 = ss["shape2"]
    num_extreme_inds = rbeta(1, shape1=extreme_shape1, shape2=extreme_shape2) * tot_no_inds
    nei_per_coll  = round(num_extreme_inds/noco, digits=0)
    for(coll in 1:noco)
    {
      no_inds = nrow(data_array[[1,coll]])
      extreme_inds = sample(no_inds, nei_per_coll)
      data_array[[1,coll]][extreme_inds,] = runif(nei_per_coll, how_extreme*dat_extremes[1], how_extreme*dat_extremes[2])
    }
  }
  return(data_array)
}


sim_intensities=function(cnv_types, intens_pars, signal=2.5, 
                         noise=0.5, no_gtypes, numProbes=10, DEBUG=1.1,
                         haveBadProbes = TRUE,
                         propBadProbes = 7/10,
                         pause=FALSE
                        )
{
  #Probe behaviour
  #  - Some probes have no response (perhaps the first 2 or the last 2 or something)
  #  - Want to model variation in DNA quality between collections - both changes in mean and variance of measurements.
  noco = length(cnv_types)
  data_array = matrix(list(), nrow=1, ncol=noco) ## Just for now. no_ind rows, no_probe cols
  colnames(data_array) = 1:(ncol(data_array))
  signal_kernel = intens_pars$signal_kernel
  deg_free      = intens_pars$deg_free
  collNames     = makeDefaultCollnames(noco=noco)
  if(haveBadProbes) {
    badProbes = sort(sample(1:numProbes, floor(propBadProbes*numProbes)))
  }
  for(coll in 1:noco)
  {
    no_inds = length(cnv_types[[coll]])
    if(DEBUG>2 & no_inds>5000) {cat("Simulating intensities. On collection", coll, "\n");}
    data_array[coll] = list(matrix(-1, nrow=no_inds, ncol = numProbes))
    colnames(data_array)[coll] = collNames[coll]
    #co_bias = rnorm( 1, (intens_pars$co_bias_dst$mean*(coll-1)), sqrt(intens_pars$co_bias_dst$variance))
    co_bias = rnorm( 1, (intens_pars$co_bias_dst$mean         ), sqrt(intens_pars$co_bias_dst$variance))
    co_sd   = rgamma(1, scale=intens_pars$co_sd_dst$scale,   shape = intens_pars$co_sd_dst$shape   )
    for(cl in 1:no_gtypes)
    {
      no_this      = sum(  cnv_types[[coll]]==cl)
      these_types  = which(cnv_types[[coll]]==cl)
      for(k in 1:numProbes)
      {
        if(k %in% badProbes) 
          thisProbeSignal = signal/10 else
          thisProbeSignal = signal 
        pr_bias = rnorm( 1, intens_pars$pr_bias_dst$mean     , sqrt(intens_pars$pr_bias_dst$variance))
        pr_sd   = rgamma(1, scale=intens_pars$pr_sd_dst$scale, shape = intens_pars$pr_sd_dst$shape   )
        if(signal_kernel=="normal") data_array[coll][[1]][these_types,k] = 
          rnorm(n = no_this    , mean=(co_bias+pr_bias+(thisProbeSignal*cl)), sd=(noise+co_sd+pr_sd))            
        if(signal_kernel=="t")      data_array[coll][[1]][these_types,k] = 
          my_rt(nsamp = no_this, mean=(co_bias+pr_bias+(thisProbeSignal*cl)), sd=(noise+co_sd+pr_sd), df=deg_free)            
       }
    }
    if(pause) 
      browser()
    rownames(data_array[[1,coll]]) = paste(collNames[coll], "_ind", 1:nrow(data_array[[1,coll]]), sep="")
  }
  return(data_array)
}


set_probe_measurement_pars=function(difficulty = 10, arguments) 
{
  #difficulty: Low levels lead to tight, well separated clusters and collections having very similar properties
  col_bias_mean   = 0 *(difficulty/10); #0.10 ; #This is combined with the collection index   
  col_bias_sd     = 0.01 *(difficulty/10);
  col_sd_param1   = 100  /(difficulty/10); #The larger this number the tighter the distribution.
  col_sd_param2   = 40                   ; #The larger this number the smaller the values produced.
  pr_bias_sd      = 0.75*(difficulty/10)
  pr_bias_dst     = list("distribution"="normal", "mean" = 0   , "variance"= pr_bias_sd^2)
  pr_sd_dst       = list("distribution"="gamma" , "scale"= 1/16, "shape"   = 20              )
  co_bias_dst     = list("distribution"="normal", "mean" = col_bias_mean   , "variance"= col_bias_sd^2)
  co_sd_dst       = list("distribution"="gamma" , "scale"= 1/(col_sd_param2*col_sd_param1), "shape" = col_sd_param1)
  signal_kernel   = arguments$sim_signal_kernel

  intens_pars     = list( col_bias_mean ,  col_bias_sd ,  col_sd_param1 ,  col_sd_param1 ,  
                          pr_bias_dst ,  pr_sd_dst ,  co_bias_dst ,  co_sd_dst ,  signal_kernel )
  names(intens_pars) = c("col_bias_mean", "col_bias_sd", "col_sd_param1", "col_sd_param1", 
                         "pr_bias_dst", "pr_sd_dst", "co_bias_dst", "co_sd_dst", "signal_kernel")
  return(intens_pars)
}

recordSimStudies=function(simDats=1:6)
{
  setups(2); 
  options(error=recover); options(warn=2); 
  
  tags   = c("varbeta_smallcoll2_", "varbeta_smallmgf2_", "varbeta2_", "noassoc2_", "easy_varbeta_", "easy_noassoc_")
  assocs = c(T, T, T, F, T, F)
  betaMeanEasy = 0.15
  betaMeanHard = 0.12
  #For May simulations used: list(dist="gamma", "mean"=0.1, "sd"=0.03) whenver didn't use 0.
  addEffects = list(list(dist="gamma", "mean"=betaMeanHard, "sd"=0.03),
                    list(dist="gamma", "mean"=betaMeanHard, "sd"=0.03),
                    list(dist="gamma", "mean"=betaMeanHard, "sd"=0.03),
                    0,
                    list(dist="gamma", "mean"=betaMeanEasy, "sd"=0.03),
                    0)
  collSizes = c(200, 2000, 2000, 2000, 2000, 2000)
  simNocos  = c(10, 10, 3, 3, 3, 3)
  mafs      = list(NULL, 0.1, NULL, NULL, NULL, NULL)
  difficulties = c(10, 10, 10, 10, 8, 8)
  simKernels   = c("normal", "normal", "normal", "normal", "t", "t")
  numSimDats   = length(tags)

  for(sim in 1:simDats)
  {
    make_many_simdats(data_ftag = paste(tags[sim], Sys.Date(), sep=""), association=assocs[sim], add_effect=addEffects[[sim]], 
                      coll_sizes=collSizes[sim], sim_noco=simNocos[sim], maf=mafs[[sim]])
  }
}


simpleNumClassesStudy=function(nameTag    = "simpleStudyThreeClass",
                               numClasses = 3, 
                               difficulty = 10,
                               signal=NULL)
{
  datTag = paste(nameTag, "_", Sys.Date(), sep="")  
  make_many_simdats(data_ftag      = datTag, 
                    association    = FALSE, 
                    add_effect     = 0, 
                    coll_sizes     = 2000, 
                    sim_noco       = 3, 
                    maf            = NULL,
                    genotypicModel = TRUE,
                    numGenotypes   = numClasses,
                    difficulty     = difficulty,
                    signal         = signal)
}

make_many_simdats=function(arguments  = NULL, debug_get_data    = F       , association = F , 
                           add_effect = 0.1 , sim_signal_kernel = "normal", difficulty  = 10,                          
                           maf        = NULL, coll_sizes        = 2000    , sim_noco    = 3 , 
                           data_ftag  = paste("simtest2_", Sys.Date(), sep=""),
                           genotypicModel = FALSE, numGenotypes = 3,
                           signal=NULL
                          )
{
  require(cccpCallNJC)
  if(debug_get_data) debug(get_data)
  options(error=recover); 
  DEBUG                           = 1.71                  
  if(is.null(arguments)) {
    arguments                     = set_arguments(cnvs=1:200, write_tag="irrelevant", read_tag=data_ftag, DEBUG=DEBUG)
    arguments$signal_model        = "normal"
    arguments$sim_signal_kernel   = "normal"
    arguments$sim_association     = association
    if(!is.null(maf)) 
      arguments$sim_maf           = maf
    if(!is.null(coll_sizes)) 
      arguments$sim_inds_p_coll   = coll_sizes
    arguments$sim_noco            = sim_noco
  }
  if(association) 
    arguments$case_colls = c(rep(0, arguments$sim_noco-1), 1) else 
    arguments$case_colls =   rep(0, arguments$sim_noco)
  names(arguments$case_colls) = makeDefaultCollnames(noco=sim_noco)

  arguments$real_data           = F
  arguments$write_sim_to_file   = T
  arguments$read_sim_from_file  = F
  arguments$sim_difficulty      = difficulty
  # chisq_noncentral (expected test_stat, ets = eBF+2) = R^2 * 2no_controls*no_cases*(p'-p)^2 / (no_controls + no_cases)p^(1-p^)
  # p^ = (no_controls*p + no_cases*p')/(no_controls+no_cases)
  # p  = allele frequency in controls
  # p' = theta*p/(1-p+theta*p) - the allele frequency in cases   (theta = relative risk)
  # R^2 = 1 as we're typing the causal locus

  arguments$cnvs                = 1:200
  if(is.list(add_effect))
    ss = mean_var_to_standard_pars(distribution=add_effect[["dist"]], mean=add_effect[["mean"]], var=add_effect[["sd"]]^2, verbose=F)
  for(cnv_index in arguments$cnvs) {
    if(is.list(add_effect)) {
      if(add_effect[["dist"]]=="gamma") {
        beta1 = rgamma(1, shape=ss["shape"], scale=ss["scale"])
      }
    } else beta1 = add_effect
    arguments$beta1               = beta1
    extra_args                    = set_up_caller(arguments)
    if(genotypicModel)
    {
      extra_args$sim_args$numGenotypes = rep(numGenotypes, length(arguments$cnvs))
      extra_args$sim_args$allelicModel = FALSE
    }
    
    # The function: get_data (project package) calls "make_simdat" which then writes the data to file directly! 
    # So 'total_sim' is only usefully returned for debugging purposes.
    total_sim = get_data(arguments=arguments, extra_args=extra_args, 
                         cnv_index=cnv_index, no_inference=T, simSignal=signal)
  }
}

getSimData=function(arguments, extra_args, cnv_index, 
                    no_inference=NULL, DEBUG,
                    signal=NULL)
{
  if(arguments$sim_noco>1 & length(arguments$case_colls)==1) {
    arguments$case_colls = makeCaseColls(noco=arguments$sim_noco)
  }
  if(extra_args$sim_args$read_sim_from_file) {
    this_sim_fn   = get_input_fns(arguments=arguments, cnv_index=cnv_index)$simdat_fn
    cat("  Reading in simulated data from file:", this_sim_fn, "...", sep="")
    total_sim     = myload(this_sim_fn)
    cat("Done.\n")
    sim_pars      = total_sim$sim_pars; 
    sim_hpriors   = total_sim$sim_hpriors;  
    simdat        = total_sim$simdat  
    if(!is.null(total_sim$this_sim_fn)) {check_fn= total_sim$this_sim_fn==this_sim_fn} else check_fn=T
    if(DEBUG>3.5 & !check_fn) {cat("Inconsistency with filenames of simulated data.\n"); browser();}
  } else      {
    total_sim = make_simdat(arguments=arguments, extra_args=extra_args, 
                            cnv_index=cnv_index, DEBUG=DEBUG,
                            signal=signal)

    if(no_inference) return(total_sim)

    sim_pars = total_sim$sim_pars; sim_hpriors = total_sim$sim_hpriors; simdat = total_sim$simdat; 
  }
  data_array        = simdat$data_array; if(is.null(names(data_array))) 
  names(data_array) = colnames(data_array)
  if(arguments$combine_colls) 
    data_array = combineCollsInDataArray(data_array=data_array)
  used_ogt_sample_names        = as.list(rep(NA, ncol(data_array))); 
  names(used_ogt_sample_names) = colnames(data_array)
  for(coll in 1:ncol(data_array)) {
    given_names = rownames(data_array[[1,coll]])
    if(!is.null(given_names)) {
      used_ogt_sample_names[[coll]] = given_names 
    } else  {
      used_ogt_sample_names[[coll]]  = makeDefaultCollnames(noco=arguments$sim_noco)
      rownames(data_array[[1,coll]]) = used_ogt_sample_names[[coll]]
    }
  }  
  rv = list("simdat"   =simdat   , "sim_pars"   = sim_pars,
            "arguments"=arguments, "data_array" = data_array,
            "total_sim"=total_sim, 
            "used_ogt_sample_names" = used_ogt_sample_names
           )
  return(rv)
}


## make_simdat writes the simulated data to file (it is often called by 'get_data', currently in the project package.
make_simdat=function(arguments, extra_args, cnv_index, 
                     no_inference=NULL, DEBUG,
                     haveBadProbes=TRUE,
                     intensityPause = FALSE,
                     signal = NULL) #signal has a default value defined by set_arguments (in intiialise_core.R)
{
  ########## set up simulation ##########
  tr_nocl      = extra_args$sim_args$tr_nocls[cnv_index]
  sim_pars     = make_sim_pars(arguments=arguments, extra_args=extra_args, 
                               cnv_index=cnv_index)
  sim_hpriors  = set_sim_hpriors(sim_pars)
  if(arguments$verbose) {
      cat("Simulating data..."); ptm = proc.time();
    if(extra_args$sim_args$allelicModel) {
      cat("Simulating ", extra_args$sim_args$sim_alleles[cnv_index], 
                                     " alleles (therefore ", tr_nocl, " genotypes)...", sep="")
    } else {
      cat("Simulating ", extra_args$sim_args$numGenotypes[cnv_index], " genotypes ...", sep="")
    }
  }
  simdat       = sim_from_model(hprior = sim_hpriors, sim_pars=sim_pars, 
                                DEBUG  = DEBUG, pause=intensityPause,
                                signal = signal
                                )
  if(1 & DEBUG>1.5) {
    tr_betas1        = c(simdat$priors_used$beta0, simdat$priors_used$beta1)
    tr_betas2        = c(sim_pars$betas["beta0"], sim_pars$betas["beta1"])
    check_trbetas    = sum(abs(tr_betas1-tr_betas2)<1e-7)==length(tr_betas1)
    if(!check_trbetas) {cat("Warning - disagreement in what betas used in the sim study!\n"); browser()}
  }
  if(DEBUG>1 & arguments$verbose) {cat("done, (took", proc.time()-ptm, "seconds)\n")}
  total_sim =      list(sim_pars ,  sim_hpriors ,  simdat )
  names(total_sim) = c("sim_pars", "sim_hpriors", "simdat")
  ########## write-data-to-file ##########
  if(arguments$write_sim_to_file) {
    this_sim_dir          = get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir
    if(!file.exists(this_sim_dir)) 
      dir.create(this_sim_dir, showWarnings = FALSE)
    this_sim_fn           = get_input_fns(arguments=arguments, cnv_index=cnv_index)$simdat_fn
    total_sim[[4]]        = this_sim_fn
    names(total_sim)[4]   = "this_sim_fn"
    sim_par_names     = matrix(c(names(total_sim$sim_pars), names(total_sim$sim_pars$intens_pars)), nrow=1)
    sim_hprior_names  = matrix(c(names(total_sim$sim_hprior), names(total_sim$sim_pars$intens_pars)), nrow=1)
    sim_par_output    = matrix(unlist(total_sim$sim_pars)  , nrow=1)
    sim_hprior_output = matrix(unlist(total_sim$sim_hprior), nrow=1)
    sim_pars_dir      = paste(get_dir_names(simdat_tag=arguments$simdat_tag)$simdat_dir, "simpars/", sep="")
    if(!file.exists(sim_pars_dir)) dir.create(sim_pars_dir, showWarnings=F)
    sim_pars_fn       = get_input_fns(arguments=arguments)$simpars_fn
    sim_hprs_fn       = get_input_fns(arguments=arguments)$sim_hprs_fn
    save(total_sim, file=this_sim_fn)
    if(cnv_index==arguments$cnvs[1]) {
      write.table(sim_par_names   , file = sim_pars_fn, quote=F, row.names=F, col.names=F, append=F)
      write.table(sim_hprior_names, file = sim_hprs_fn, quote=F, row.names=F, col.names=F, append=F)
    }
    write.table(sim_par_output   , file = sim_pars_fn, quote=F, row.names=F, col.names=F, append=T)
    write.table(sim_hprior_output, file = sim_hprs_fn, quote=F, row.names=F, col.names=F, append=T)
  }
  return(total_sim)
}

## Proto code! This is not the right formula at all
RR_to_OR=function(RR)
{
  OR = RR-1
  return(OR)
}
## Proto code! This is not the right formula at all
OR_to_RR=function(OR)
{
  RR = OR+1
  return(RR)
}

# expected_bf(beta1=0.2, theta=NULL, alf=0.5, gnf=NULL, no_controls=6000, no_cases=3000)
expected_bf=function(beta1=NULL, theta=NULL, alf=NULL, gnf, no_controls, no_cases)
{
  if(is.null(theta)) theta = OR_to_RR(beta1)
  if(is.null(alf  )) alf   = sqrt(   gnf[1]) # Assuming 2 allele model, hoping that will extend ok to 3-allele...
  p       = alf                              # This is just a number, so implicitly assuming only two alleles
  p_prime = theta*p/(1-p+theta*p) 
  p_bar   = (no_controls*p + no_cases*p_prime)/(no_controls+no_cases) 
  CS_ncp  = 2*no_controls*no_cases*(p_prime-p)^2 / ((no_controls + no_cases)*p_bar*(1-p_bar))
  BF      = CS_ncp - 2
  return(BF)
}

# plot_bfs_for_ORs()
plot_bfs_for_ORs=function(range = c(0, 0.15), no_vals = 1001, alf = 0.2)
{
  beta1s = (0:1000)*((range[2]-range[1])/1000) + range[1]
  bfs    = sapply(beta1s, expected_bf, theta=NULL, alf=alf, gnf=NULL, no_controls=6000, no_cases=3000)
  plot(beta1s, bfs, main="Expected BF for a range of Odds ratios", xlab = "Odds Ratio", type="l")
  invisible(0)
}

runInitialArgChecks=function(data_matrix, data_array, data_and_details, arguments)
{
  numDatSpecifications = (!is.null(data_matrix))+(!is.null(data_array))+(!is.null(data_and_details))
  if(numDatSpecifications!=1) {
    cat("  Warning, exactly one of data_matrix, data_array, and data_and_details should be specified.\n")
    cat("  Currently", numDatSpecifications, "of them are specified. Pausing here, so that you can look around.\n")
    browser()    
  }
  if(!is.null(data_matrix)) #Run quick checks on the matrix of measurements (if specified)
  {
    datNoco    = 1
    datNumInds = nrow(data_matrix)
    datOK      = TRUE
    indsNamed  = length(rownames(data_matrix)==nrow(data_matrix))
    SNPsNamed  = length(colnames(data_matrix)==ncol(data_matrix))
    if(!(indsNamed & SNPsNamed)) {
      cat("  Warning, CNVCALL requires that both individuals and SNPs are named in data_matrix.\n")
      cat("  Pausing here for you to examine data_matrix.\n")
      browser()
    }
    datOK = datOK & is.matrix(data_matrix) & indsNamed & SNPsNamed
    if(!datOK) {
      cat("  Warning, problems found with data_matrix. Pausing here, for you to look at the data.\n")
      browser()
    }
  }
  if(!is.null(data_array)) #Run quick checks on 'data_array' (if specified)
  {
    datNoco    = ncol(data_array)
    collNames  = colnames(data_array)
    collNames2 = names(data_array)
    if(length(collNames)!=datNoco) {
      cat("  Warning, data_array should have column names, the names of the collections.\n")
      if(length(collNames)==datNoco) 
        cat("  You have specified 'names' for data_array, but it should be column names (however this may be fine).\n")
      cat("  Pausing here for you to examine data_array.\n")
      browser()
    }
    checkIndsNamed = function(mat) length(rownames(mat))==nrow(mat)
    checkSNPsNamed = function(mat) length(colnames(mat))==ncol(mat)
    indsNamed      = sum(sapply(data_array, FUN=checkIndsNamed))==datNoco
    SNPsNamed      = sum(sapply(data_array, FUN=checkSNPsNamed))==datNoco
    if(!(indsNamed & SNPsNamed)) {
      cat("  Warning, CNVCALL requires that both individuals and SNPs are named in data_array.\n")
      cat("  Pausing here for you to examine data_array.\n")
      browser()
    }
    datNumInds = sum(sapply(data_array, FUN=nrow))
    datOK      = TRUE
    datOK      = datOK & is.matrix(data_array) & sum(sapply(data_array, FUN=is.matrix))==datNoco & length(unique(sapply(data_array, FUN=ncol)))==1
    if(!datOK) {
      cat("  Warning, problems found with data_array. Pausing here, for you to look at the data.\n")
      browser()
    }
  }
  if(!is.null(data_and_details))
  {
    cat("  Currently no inbuilt checks run on data_and_details.\n")
  }
  
  # Check for obvious inconsistencies between the data and the arguments given.
  if(length(arguments$case_colls) != datNoco) {
    cat("  Warning, \"collections\" argument to \"set_arguments\" \n",
        "  should be a vector of length=(the number of collections being examined).\n", sep="")
    cat("  This warning being given as \"case_colls\" has been found to have the wrong length.\n")
    cat("  Pausing here for you to examine.\n")
    browser()
  }
}


#This function removes the probe giving the biggest and the probe giving the lowest measurements
remove_extremes=function(data_array, no_probes_to_remove=20, noco=1, remove_two=F, rinds=T, rprobes=F)
{
   for(coll in 1:noco)
   {
     dm           = data_array[1,coll][[1]]
     top_few      = sort(dm, decreasing=T)[1:no_probes_to_remove]
     bottom_few   = sort(dm, decreasing=F)[1:no_probes_to_remove]
     #Of course sometimes the most extreme measurements come from the BEST probes
     worst_probe1 = which(dm ==   top_few[1], arr.ind=T)[1]
     worst_probe2 = which(dm ==bottom_few[1], arr.ind=T)[1]
     worst_probe3 = which(dm ==   top_few[2], arr.ind=T)[1]
     worst_probe4 = which(dm ==bottom_few[2], arr.ind=T)[1]
     worst_ind1   = which(dm ==   top_few[1], arr.ind=T)[2]
     worst_ind2   = which(dm ==bottom_few[1], arr.ind=T)[2]
     worst_ind3   = which(dm ==   top_few[2], arr.ind=T)[2]
     worst_ind4   = which(dm ==bottom_few[2], arr.ind=T)[2]
     if(!remove_two) rem_rows = unique(c(worst_probe1,worst_probe2))
     if( remove_two) rem_rows = unique(c(worst_probe1,worst_probe2,worst_probe3,worst_probe4))
     if(!remove_two) rem_cols = unique(c(worst_ind1,worst_ind2))
     if( remove_two) rem_cols = unique(c(worst_ind1,worst_ind2,worst_ind3,worst_ind4))
     if(rinds)   data_array[1,coll][[1]] = dm[         , -rem_cols]
     if(rprobes) data_array[1,coll][[1]] = dm[-rem_rows,          ] 
   }
  return(data_array)
}

pool_data=function(data_array)
{
  no_probes = nrow(data_array[1,1][[1]])
  if(is.null(no_probes)) return(NA)
  datmat    = matrix(-1, nrow=no_probes, ncol=0)
  for(coll in 1:ncol(data_array))
    datmat= cbind(datmat, data_array[,coll][[1]])
}
look_at_data_array=function(data_array, noco=1, cnv_name, cnv_index=cnv_index, pool_data=T, col="lightgrey", hist=T, density=T)
{
   datmat = pool_data(data_array=data_array)
   if(is.na(sum(datmat))) return(NA)
   par(mfcol=c(2,2))
  #for(coll in 1:noco)
  #{
     dm           = datmat #data_array[1,coll][[1]]
     dmeans       = colMeans(dm, 2, mean)
     pca_weights  = svd(t(dm))$u[,1]
     broad_probe  = which.max(apply(dm, 1, sd)) #Can probably make this faster using sapply?
     xlab         = paste("1d-measurement summary, ", cnv_index, sep="")
     if(hist) {
       hist(dm              , n=100, main=paste(" All probes:"              , cnv_name),xlab=xlab, col=col)
       hist(dmeans          , n=100, main=paste(" Probe Means"              , cnv_name),xlab=xlab, col=col)
       hist(pca_weights     , n=100, main=paste(" PCA weights"              , cnv_name),xlab=xlab, col=col)
       hist(dm[broad_probe,], n=100, main=paste(" Single most varying Probe", cnv_name),xlab=xlab, col=col)
     }
     browser();
     if(density) {
     adjust=0.1
     plot(density(dm              , adjust=adjust), main=paste(" All probes:"              , cnv_name),xlab=xlab)
     plot(density(dmeans          , adjust=adjust), main=paste(" Probe Means"              , cnv_name),xlab=xlab)
     plot(density(pca_weights     , adjust=adjust), main=paste(" PCA weights"              , cnv_name),xlab=xlab)
     plot(density(dm[broad_probe,], adjust=adjust), main=paste(" Single most varying Probe", cnv_name),xlab=xlab)
     }
     browser();
  #}
}

# Creates the 1-dimensional probe summaries.
# Optionally does probe scaling.
get_oned_pr_summary=function(probe_scaling = c("none", "all", "PVS"),
                             probe_summary = c("pca", "PCA", "mean", "median"),
                             data_array,
                             split_data    = FALSE,
                             duplicates    = NULL)
{
  # Check that probe_scaling and probe_summary are allowed values.
  probe_scaling = match.arg(probe_scaling)
  probe_summary = match.arg(probe_summary)

  # Check that duplicates are provided if PVS scaling is requested.
  if (probe_scaling == "PVS" && is.null(duplicates))
    stop('PVS scaling requested but duplicates not provided.')

  # Convert data to big matrix.
  data_matrix = data_array_to_matrix(data_array=data_array)

  # Calculate probe standard deviations if PVS scaling is requested.
  if (probe_scaling == "PVS") {
    # Get the WTCCC name corresponing to each row of the data matrix.
    real_wtccc_names = dissect_sample_names(rownames(data_matrix))$orig_names

    # Find which rows correspond to duplicates.
    dup1 = match(duplicates$name1, real_wtccc_names)
    dup2 = match(duplicates$name2, real_wtccc_names)

    # Check if any of these individuals are missing and give a warning message.
    missing_duplicates = is.na(dup1) & is.na(dup2)
    if (any(missing_duplicates)) {
        # Find which individuals are missing.
        num_missing = sum(missing_duplicates)

        # Print a warning message.
        cat(" ", num_missing, "duplicates missing from probe intensity matrix,",
            "omitting them from PVS calculations.\n")

        # Omit missing individuals (which are NAs these variables).
        dup1 = dup1[!missing_duplicates]
        dup2 = dup2[!missing_duplicates]
    }

    # Pull out the probe intensities for the duplicates.
    imat_dup1 = data_matrix[dup1, , drop=FALSE]
    imat_dup2 = data_matrix[dup2, , drop=FALSE]

    # Calculate within-individual probe standard deviations using the
    # duplicates.  This is like doing an ANOVA with n groups of 2 observations
    # each and calculating the within-groups standard deviation.
    degf = (2 - 1) * length(dup1)  # n groups of 2 observations
    sum_of_squares = colSums((imat_dup1 - imat_dup2)^2 / 2, na.rm=TRUE)
    probe_stdevs   = sqrt(sum_of_squares / degf)
  } else
    probe_stdevs   = NULL

  # Convert probe_scaling to an argument to pass to scale().
  scaling_mapping = list(none = FALSE,
                         all  = TRUE,
                         PVS  = probe_stdevs)
  scale. = scaling_mapping[[probe_scaling]]

  # Do the requested scaling.
  data_matrix_scaled = scale(data_matrix, center=TRUE, scale=scale.)

  # Convert back to the crazy data array.
  data_array_scaled = data_matrix_to_array(data_matrix_scaled)

  # Do the appropriate probe summary.
  if (probe_summary %in% c("pca", "PCA"))
    one_ddat = run_PCA(     data_array_scaled, split_data=split_data)
  else if (probe_summary=="mean")
    one_ddat = calc_means(  data_array_scaled)  # d_means = apply(data_array[1,1][[1]], 1, mean)
  else if (probe_summary=="median")
    one_ddat = calc_medians(data_array_scaled)
  else
    stop("Unknown probe summary method.")

  # Return the 1-dimensional summary and the scale. argument used.
  return(list(one_ddat = one_ddat,
              scale.   = scale.))
}

calc_medians=function()
{
  cat("Not Implemented yet, sorry!.\n");
  browser()
}

# Extracts names of good quality duplicates, using Richard's recommended
# settings as default.
get_good_duplicates=function(duplicates               = NULL,
                             good_Duplicate_Source    = "designed_duplicate",
                             good_CNVcallsCorrelation = 0.8)
{
  if (is.null(duplicates))
    return(NULL)

  # Identify the good quality duplicates.
  good.duplicates = subset(duplicates,
                           Duplicate_Source %in% good_Duplicate_Source &
                           CNVcallsCorrelation > good_CNVcallsCorrelation)

  # Pull out the WTCCC names for the good duplicate pairs.
  dupl.name1 = as.character(good.duplicates[,"WTCCC_name_1"])
  dupl.name2 = as.character(good.duplicates[,"WTCCC_name_2"])

  # Return the WTCCC names.
  return(list(name1 = dupl.name1,
              name2 = dupl.name2))
}

process_data=function(data_array,
                      gridding         = TRUE,
                      grid_res         = 0.0005,
                      start_range      = c(-0.002, 0.002),
                      no_inds,
                      keep_range       = FALSE,
                      split_data       = FALSE,
                      wdat             = 0.1,
                      return_ungridded = FALSE,
                      grid_density,
                      duplicates       = NULL,  # data frame from Richard's duplicate file, to use for PVS scaling
                      probe_scaling    = c("none", "all", "PVS"),
                      probe_summary    = c("pca", "PCA", "mean", "median"),
                      verbose          = TRUE,
                      DEBUG,
                      scale_quantiles  = TRUE,
                      qs_to_scale_to   = c(0.001, 0.999))
{
   # Check that probe_scaling and probe_summary are allowed values.
   probe_scaling = match.arg(probe_scaling)
   probe_summary = match.arg(probe_summary)

   # Check that duplicates are provided if PVS scaling is requested.
   if (probe_scaling == "PVS" && is.null(duplicates))
     stop('PVS scaling requested but duplicates not provided.')

   if(!exists("DEBUG")) {cat("Warning - no instance of DEBUG passed (procdat)\n"); DEBUG=1}
   if(DEBUG>1 & probe_summary=="pca"  & verbose) cat(" Running PCA on data..."); 
   if(DEBUG>1 & probe_summary=="mean" & verbose) cat(" Using probe means as 1-d summary..."); 
   ptm = proc.time();
   dat2 = unlist(data_array)
   full_d_range   = quantile(dat2, probs=c(0, 1))
   true_d_range   = quantile(dat2, probs=c(0.005, 0.995))

   # Extract the names of the _good_ duplicates.
   duplicates = get_good_duplicates(duplicates)
   # Note: if duplicates was not NULL, this is now a 2-element list rather than
   # a data frame.

   # Calculate the 1-dimensional probe summaries.
   oned_probe_summary = get_oned_pr_summary(probe_scaling = probe_scaling,
                                            probe_summary = probe_summary,
                                            data_array    = data_array,
                                            split_data    = split_data,
                                            duplicates    = duplicates)
   dat = oned_probe_summary$one_ddat  # the actual 1-d probe summary
   scl = oned_probe_summary$scale.    # the option used for probe scaling

   noco           = ncol(data_array)
   ind_per_cohort = floor(no_inds/noco)
   #Should rescale the data here (program currently tuned to -0.05 to 0.05, but this is an odd range?)
   rdat    = c(NA, NA)
   if(!scale_quantiles) {
     for(coll in 1:length(dat))
       rdat    = c(min(rdat[1], min(dat[[coll]]), na.rm=T), max(rdat[2], max(dat[[coll]]), na.rm=T))
   }
   if( scale_quantiles) {
     rdat = quantile(unlist(dat), probs = qs_to_scale_to) #Note that rdat isn't the best 'data range' to retain as PCA loses the original range
   }
   for(coll in 1:length(dat))
   {
     dat[[coll]] = dat[[coll]] - rdat[1]
     if(!keep_range) {
       dat[[coll]] = dat[[coll]] / (rdat[2]-rdat[1]) * wdat ##0.1 is the data_range that the priors are optimised for
       dat[[coll]] = dat[[coll]] - (wdat/2)
     }
     if( keep_range) {
       dat[[coll]] = dat[[coll]] / (rdat[2]-rdat[1]) * full_d_range[2]-full_d_range[1] ##0.1 is the data_range that the priors are optimised for
       dat[[coll]] = dat[[coll]] + full_d_range[1]
     }
   }
   if(verbose) {if(DEBUG>1 & (proc.time()-ptm)[1]>10) {cat("done, (took", proc.time()-ptm, "seconds)\n")} else{cat("done.\n")}}

   grid_return = grid_data(dat=dat, start_range=start_range, grid_res=grid_res, grid_density=grid_density, DEBUG=DEBUG)
   new_dat     = grid_return$new_dat
   rownames(new_dat) = round(as.numeric(rownames(new_dat)), digits=7)
   
   #The following line, if used would reduce the size of 'new_dat' which gets passed around a lot and saved at the end.
   if(0) {dimnames   = dimnames(new_dat);  new_dat     = matrix(as.integer(new_dat), nrow=nrow(new_dat)); dimnames(new_dat) = dimnames}
  #colnames(new_dat) = names(data_array)
   grid_breaks = grid_return$grid_breaks
   if(!return_ungridded) {
     fdat        = list(new_dat, grid_breaks,   scl)
     names(fdat) = c("gridded", "grid_breaks", "probe_scale")
   }
   if( return_ungridded) {
     fdat =       list(new_dat,  dat       ,  grid_breaks  ,  true_d_range,   scl )
     names(fdat) = c("gridded", "ungridded", "grid_breaks" , "true_d_range", "probe_scale")
   }
   return(fdat)
}

perform_ldf=function(calls_mat, dat_matrix, verbose = 1)
{
  #Vincent's Code:
  if(0) {
    posterior <- fit$posterior.H0[, grep('^P', names(fit$posterior.H0))] #Here Vincent simply pulls out the soft-calls matrix
    can <- cancor(x = t(num.data), y = as.matrix(posterior))             
    ldf <- as.numeric( t(num.data) %*%  can$xcoef[,1])
  }
  #Vincent's Code (MKII):
  if(0) {
    my.rank <- qr(as.matrix(posterior))$rank
    if (my.rank > 1) {
     can <- cancor(x = num.data, y = as.matrix(posterior))
     data$ldf <- as.numeric( num.data %*%  can$xcoef[,1])
     data$ldf <- (data$ldf - mean(data$ldf))/sd(data$ldf)
     if  ( sign(cor(data$ldf, signal)) == -1) data$ldf <- - data$ldf
    } else data$ldf <- data$pca
  }
  if(ncol(calls_mat)>1)
  {
    # This is an R function for 'canonical correlation' 
    # For two matrices this finds linear combinations ac1 and bc2 of the columns with the highest covariance(ac1, bc2)
    can         <- cancor(x = dat_matrix, y = as.matrix(calls_mat))
    oneDsummary <- as.numeric( dat_matrix %*%  can$xcoef[,1])
    if(cor(rowMeans(dat_matrix), oneDsummary) < 0) 
      oneDsummary = -oneDsummary
    if(verbose>1) {
      par(mfcol=c(1,2)); plot(oneDsummary); 
      plot(rowMeans(dat_matrix))
    }
  } else {
    datWithinCollections =   get_oned_pr_summary(probe_scaling = "none",
                                        probe_summary = "pca",
                                        data_array    = data_matrix_to_array(data_matrix=dat_matrix),
                                        split_data    = FALSE,
                                        duplicates    = NULL)$one_ddat
    # the following is a bit of a hack to get the data into the right shape (a vector, arther than a list with an element per collection):
    oneDsummary = data_array_to_matrix(data_array= lapply(datWithinCollections, as.matrix))                                        
  }
  return(oneDsummary)
}


#This function produces posterior calls using lpdga and gnf
#(!!) Warning, should it be using the lambdas rather than the gnfs here?
#clpagd = make_lpagd(ob=objects, direct_lpdga=NULL, new=F, combined=F)
make_lpagd=function(ob=NULL, direct_lpdga=NULL, new=F, combined=F, use_null_freq=F)
{
  if( is.null(direct_lpdga) & new) lpdga = ob$ninferred$lpdga
  if( is.null(direct_lpdga) &!new) lpdga = ob$oinferred$lpdga
  if(!is.null(direct_lpdga))       lpdga = direct_lpdga
 #if( is.null(direct_gnf  ) & new) gnf   = ob$npars$gnfp$gnf
 #if( is.null(direct_gnf  ) &!new) gnf   = ob$opars$gnfp$gnf
 #if(!is.null(direct_gnf  )) gnf   = direct_gnf
  #The current set-up doesn't allow direct_nullf type usage of this function.
 #if( new) gnf = ob$npars$gnfp$gnf else gnf = ob$opars$gnfp$gnf
 #if(!new) null_freq=ob$opars$gnfp$nullf
 #if( new) null_freq=ob$npars$gnfp$nullf

  if( new) { gnf_lambda = ob$npars$gnfp$gnf_lambda; gnf_cases = ob$npars$gnfp$gnf_cases; gnf_controls = ob$npars$gnfp$gnf_controls; }
  if(!new) { gnf_lambda = ob$opars$gnfp$gnf_lambda; gnf_cases = ob$opars$gnfp$gnf_cases; gnf_controls = ob$opars$gnfp$gnf_controls; }

 #if(is.null(ob) & (is.null(direct_lpdga) | is.null(direct_gnf)) ) {
 #  cat("In make_lpagd. Can't proceed, not enough information.\n"); browser();
 #}
 #if(!is.null(ob) & !is.null(direct_lpdga) & !is.null(direct_gnf)) {
 #  cat("In make_lpagd. Ambiguous source of lpdga and gnf. Using directly given values.\n");
 #}
  anocl       = ob$opars$anocl
  nocl        = ob$opars$nocl
  noco        = ob$opars$noco
  use_null    = ob$flags$use_null_class
  null_prop   = ob$opars$null_prop
  al2apply=function(tobe_logadded, MARGIN, logadd) {apply(X = tobe_logadded, MARGIN=MARGIN, FUN=logadd)}
  al3apply=function(tobe_logadded, MARGIN, logadd) {apply(X = tobe_logadded, MARGIN=MARGIN, FUN=logadd)}

 #aprobs      = make_aprobs(gnf=gnf , use_null=use_null, null_prop=null_prop, null_freq=null_freq, use_null_freq=use_null_freq, noco=noco)
  if(combined==F) {
   #lpagd holds chiamo-like soft_grid_calls: For every grid value the posterior probabilities of that grid value lying in each cluster.
    lpagd     = lpdga
    for(coll in 1:noco) {
      collName=colnames(ob$dat)[coll]
      if(ob$assoc$case_colls[collName]==0) coll_freqs = gnf_controls
      if(ob$assoc$case_colls[collName]==1) coll_freqs = gnf_cases  #coll_freqs = make_case_freqs(objects=ob, pop_freqs=gnf_lambda, sum=1-null_prop, new=new)
      withnull_freqs = make_aprobs(gnf=NULL, use_null=use_null, null_prop=null_prop, null_freq=null_freq, use_null_freq=use_null_freq, noco=noco, gnf_lambda=coll_freqs)
      this_gprops = withnull_freqs
        if(ob$flags$use_mpar_additions) {
           this_gprops[1:nocl] = withnull_freqs[1:nocl] + ob$flags$hack_add_gnf_lambda
        } else {
          this_gprops = withnull_freqs[cl]
        }
      #The transposes here are so that 'this_gprops' is added to each ROW of lpagd[,,collName]
      lpagd[,,collName]  =    t(t(lpdga[,,collName]) + log(this_gprops)) #Adding: mat + vec. This adds mat[1,1]+vec[1], mat[2,1]+vec[2], ... (vec is recycled)
    }
    ## \/ \/ **Slow** \/ \/##
    sums = al2apply(tobe_logadded=lpagd, MARGIN=c(1,3), logadd=add_log2)
    ## /\ /\ **Slow** /\ /\##

   #sums = apply(lpagd, c(1,3), add_log2)
    for(coll in 1:noco) {
      mat_sums = matrix(sums[,coll], nrow=nrow(lpagd), ncol=ncol(lpagd))
      lpagd[,,coll] =  lpagd[,,coll]-mat_sums
    }
  } else { #This is the SOFT CALLS version. This attempts to cope with worse model fits and otherwise empty classes! (for combined collections)
    lpdga           = make_combined_lpdga(objects=ob, vals=as.numeric(rownames(ob$dat)))
    #lpagd = soft_grid_calls: For every grid value the posterior probabilities of that grid value lying in each cluster.
    lpagd = lpdga; #matrix(NA, nrow=dim(lpdga)[1], ncol=nocl)
    for(cl in 1:nocl)   {
      lpagd[,cl]  = lpdga[,cl] + log(gnf_lambda[cl]) #This is ok as the collections have been COMBINED
    }   
    sums  = al3apply(tobe_logadded=lpagd, MARGIN=c(1), logadd=add_log2)
   #sums  = apply(lpagd, 1, add_log2)
    #careful - Using the fact that R applies 1st element of vector to the [1,1], second to [2,1], etc.
    lpagd =  lpagd - sums 
  }
  return(lpagd)
}

#This function produces posterior calls using lpdga and gnf
#(!!) Warning, should it be using the lambdas rather than the gnfs here?
make_pagd=function(ob=NULL, direct_lpdga=NULL, new=F, combined=F, use_null_freq=F)
{
  if( is.null(direct_lpdga) & new) lpdga = ob$ninferred$lpdga
  if( is.null(direct_lpdga) &!new) lpdga = ob$oinferred$lpdga
  if(!is.null(direct_lpdga))       lpdga = direct_lpdga
  if( new) { gnf_lambda = ob$npars$gnfp$gnf_lambda; gnf_cases = ob$npars$gnfp$gnf_cases; gnf_controls = ob$npars$gnfp$gnf_controls; }
  if(!new) { gnf_lambda = ob$opars$gnfp$gnf_lambda; gnf_cases = ob$opars$gnfp$gnf_cases; gnf_controls = ob$opars$gnfp$gnf_controls; }

  anocl       = ob$opars$anocl
  nocl        = ob$opars$nocl
  noco        = ob$opars$noco
  use_null    = ob$flags$use_null_class
  null_prop   = ob$opars$null_prop

  if(combined==F) {
   #pagd holds chiamo-like soft_grid_calls: For every grid value the posterior probabilities of that grid value lying in each cluster.
    pagd     = lpdga #(just to get dimensions right)
    for(coll in 1:noco) {
      collName=colnames(ob$dat)[coll]
      if(ob$assoc$case_colls[collName]==0) coll_freqs = gnf_controls
      if(ob$assoc$case_colls[collName]==1) coll_freqs = gnf_cases  #coll_freqs = make_case_freqs(objects=ob, pop_freqs=gnf_lambda, sum=1-null_prop, new=new)
      withnull_freqs = make_aprobs(gnf=NULL, use_null=use_null, null_prop=null_prop, null_freq=null_freq, use_null_freq=use_null_freq, noco=noco, gnf_lambda=coll_freqs)
      this_gprops = withnull_freqs
        if(ob$flags$use_mpar_additions) {
           this_gprops[1:nocl] = withnull_freqs[1:nocl] + ob$flags$hack_add_gnf_lambda
        } else {
          this_gprops = withnull_freqs[cl]
        }
      #The transposes here are so that 'this_gprops' is added to each ROW of lpagd[,,collName]
      pagd[,,collName]  =    t(t(exp(lpdga[,,collName])) * this_gprops) #Multiplying: mat * vec. This gives [1,1]=mat[1,1]*vec[1], mat[2,1]*vec[2], ... (vec is recycled)
    }
   #sums = apply(X=pagd, MARGIN=c(1,3), FUN=sum)
    # The next four lines deal with a potential underflow issue when observations are very unlikely.
    if(ob$flags$DEBUG>1.51 & min(pagd==0)) {
      cat("  Warning, 0 values (underflow) in probability of assignment\n")
      if(DEBUG>1.71) browser()
    }
    # The following line is a hack to deal with the issue.
    pagd[pagd==0] = 1e-200
    for(coll in 1:noco) {
     #mat_sums = matrix(sums[,coll, drop=F], nrow=nrow(pagd), ncol=ncol(pagd))
     #pagd[,,coll] =  pagd[,,collv]/mat_sums
      pagd[,,coll] =  pagd[,,coll, drop=F]/rowSums(pagd[,,coll, drop=F]) # drop=F only needed when not using null prop as then there's always >= 2 classes!
    }

  } else { #This is the SOFT CALLS version. This attempts to cope with worse model fits and otherwise empty classes! (for combined collections)
    lpdga           = make_combined_lpdga(objects=ob, vals=as.numeric(rownames(ob$dat)))
    #pagd = soft_grid_calls: For every grid value the posterior probabilities of that grid value lying in each cluster.
    pagd = lpdga; #gets dims right, instead of doing: matrix(NA, nrow=dim(lpdga)[1], ncol=nocl) 
    for(cl in 1:nocl)   {
      pagd[,cl]  = exp(lpdga[,cl, drop=F]) * gnf_lambda[cl] #This is ok as the collections have been COMBINED
    }   
   #sums  = al3apply(tobe_logadded=lpagd, MARGIN=c(1), logadd=add_log2)
   #sums  = apply(lpagd, 1, add_log2)
    #careful - Using the fact that R applies 1st element of vector to the [1,1], second to [2,1], etc.
    pagd =  pagd/rowSums(pagd)
  }
  if(ob$flags$DEBUG>0.5 & (min(pagd)<0 | max(pagd)>1)) {cat("  In make_pagd. Error, impossible pagd.\n"); browser();}
  return(pagd)
}



get_calls_matrices=function(objects, ung_dat=NULL, verbose=1, collnames=NULL)
{
  if(is.null(ung_dat)) {
    cat("  Warning, have not been passed the ungridded data. Generating approximate data for calls.\n");
    ung_dat = ungrid_dat(objects$dat)
  }
  noco = objects$opars$noco; 
  nocl = objects$opars$nocl; 
  chiamo_calls = as.list(rep("", noco))
  if(!is.null(collnames)) names(chiamo_calls) = collnames else names(chiamo_calls) = makeDefaultCollnames(noco=noco)
 #grid_hcalls = make_grid_calls(objects=ob, use_null_freq=F)
  if(verbose>=1) cat("Calling in coll: ")
  grid_breaks     = objects$opars$grid_breaks
  for(coll in 1:noco)
  {
    one_dsmry       = ung_dat[[coll]]
    ind_grid_vals   = sapply(X=one_dsmry, FUN=data_boxer, grid_breaks=grid_breaks)
    if(verbose>=1) cat(names(ung_dat)[coll], "")
    ind_calls1      = objects$oinferred$pagd[ind_grid_vals,1:nocl,, drop=F]
    ind_calls       = ind_calls1[,,coll, drop=T]
    chiamo_calls[[coll]] = unlist(t(ind_calls))
    colnames(chiamo_calls[[coll]]) = names(ung_dat[[coll]])
   #h_calls[[coll]] = grid_hcalls[ind_grid_vals]
  }  
  if(verbose>=1) cat("\n")
  return(chiamo_calls)
}


# make_case_freqs(objects=objects, pop_freqs=objects$npars$gnfp$gnf_lambda, new=T)
make_case_freqs=function(objects=NULL, control_freqs=NULL, pop_freqs, new=T, betas=NULL, model_pdisease=NULL)
{
   if(!is.null(objects)) {
     if(new) beta0 = objects$npars$betas[1] else beta0 = objects$opars$betas[1]
     if(new) beta1 = objects$npars$betas[2] else beta1 = objects$opars$betas[2]
  } else {
     beta0 = betas[1]; 
     beta1 = betas[2];
  }
  sum   = sum(   pop_freqs)
  nocl  = length(pop_freqs)
  # P(D|Z,B) = Bin(1, p), p = exp(B0 + B1*Z)/(1+exp(B0 + B1*Z)). (D here stands for case/control_status = Case (D for disease))
  Z = 0:(nocl-1)
  # dm_p = (disease_model) the binomial probability of someone having disease status (with the above model)
  dm_p  = exp(beta0 + beta1*Z)/(1+exp(beta0 + beta1*Z))
  # P(Zi | D, B) (proportional to P(D|Zi,B)*P(Zi))  # BUT P(Z_i) is the POPULATION FREQUENCIES! Not the control frequencies. 
  case_freqs = normalise(pop_freqs * dm_p, sum=sum)
  return(case_freqs)
}

# make_control_freqs(objects=objects, pop_freqs=objects$npars$gnfp$gnf_lambda, new=T, betas=NULL, model_pdisease=NULL)
make_control_freqs=function(objects=NULL, pop_freqs, new=T, precision=1e-5, betas=NULL, model_pdisease=NULL)
{
   # P(Zi=k | Phi=0) = P(Phi=0 | Zi=k)P(Zi=k)/P(Phi=0)
   # P(Phi=0 | Zi=k) = 1/(1+exp(beta0 + beta1*k)) #From the association model
   # P(Zi=k)         = pop_freqs
   # P(Phi=0)        = sum_k(P(Phi=0 | Z=k)P(Z=k))

   nocl = length(pop_freqs) #(Null class is not included in this vector)
   sum  = sum(pop_freqs)
   if(!is.null(objects)) {
     if(new) beta0 = objects$npars$betas[1] else beta0 = objects$opars$betas[1]
     if(new) beta1 = objects$npars$betas[2] else beta1 = objects$opars$betas[2]
    #model_pdisease  = objects$pars$model_pdisease
   } else {
     beta0 = betas[1]; 
     beta1 = betas[2];
    #model_pdisease  = model_pdisease
   }
   genotypes     = 0:(nocl-1)

   # P(Z=k | Phi=0) = P(Phi=0 | Z=k)P(Z=k)/P(Phi=0)
   # P(Phi=0)       = sum_k(P(Phi=0 | Z=k)P(Z=k))
   # P(Phi=0 | Z=k) = (1/(1+exp(beta0 + beta1*genotypes)))
   # P(Z=k)         = pop_freqs
   # So: 
   # control_freqs = P(Z=k | Phi=0) = normalise((1/(1+exp(beta0 + beta1*genotypes)))*pop_freqs, sum=sum)
   control_freqs = normalise((1/(1+exp(beta0 + beta1*genotypes)))*pop_freqs, sum=sum)
  #control_freqs = (1/(1+exp(beta0 + beta1*genotypes))) * (pop_freqs) / (1-model_pdisease) 
  #control_freqs = normalise(control_freqs, sum=sum(pop_freqs))                          
   check = sum(abs(control_freqs - normalise(control_freqs, sum=sum(pop_freqs)))) < precision
   if(!check) {cat("  Warning. New frequencies don't sum to the right amount.\n"); browser();}
   return(control_freqs)
}

# make_pop_freqs(objects=objects, control_freqs=objects$npars$gnfp$gnf_controls, new=T)
make_pop_freqs=function(objects, control_freqs, new=T, precision=1e-5)
{
  if(new) gnf_controls   = objects$npars$gnfp$gnf_controls else gnf_controls   = objects$opars$gnfp$gnf_controls
  if(new) gnf_cases      = objects$npars$gnfp$gnf_cases    else gnf_cases      = objects$opars$gnfp$gnf_cases
  if(new) model_pdisease = objects$npars$model_pdisease    else model_pdisease = objects$opars$model_pdisease

  sum     = sum(control_freqs)
  gnf_pop = (gnf_cases*model_pdisease) + (gnf_controls*(1-model_pdisease))
  check = sum(abs(gnf_pop - normalise(gnf_pop, sum=sum))) < precision
  if(!check) {cat("  Warning. New frequencies don't sum to the right amount.\n"); browser();}
  return(gnf_pop)
}

make_pop_from_control_only=function(objects, control_freqs, new=T, precision=1e-5)
{
  if(new) gnf_controls = objects$npars$gnfp$gnf_controls else gnf_controls = objects$opars$gnfp$gnf_controls
  if(new) beta0 = objects$npars$betas[1] else beta0 = objects$opars$betas[1]
  if(new) beta1 = objects$npars$betas[2] else beta1 = objects$opars$betas[2]
 #if(new) model_pdisease = objects$npars$model_pdisease    else model_pdisease = objects$opars$model_pdisease

  nocl      = length(control_freqs) #(Null class is not included in this vector)
  genotypes = 0:(nocl-1)
  sum       = sum(control_freqs)
  # P(Zi=k) = P(Zi=k,Phi=0) / P(Phi=0 | Zi=k)
  # P(Zi=k) = P(Zi=k | Phi=0) P(Phi=0) / P(Phi=0 | Zi=k)            # - Requires P(Phi=0) (but can just normalise this out)
  #         = control_freqs * 1-model_pdisease / (1/1+exp(b0 + b1k))
  #         = (control_freqs / (1/1+exp(b0 + b1k)) )  / sum_k(control_freqs / (1/1+exp(b0 + b1k)) )
  prob_control = 1/(1+exp(beta0 + beta1*genotypes))
  gnf_pop      = (control_freqs / prob_control) / sum((control_freqs / prob_control))
  gnf_pop      = normalise(gnf_pop, sum=sum)
 #check = sum(abs(gnf_pop - normalise(gnf_pop, sum=sum))) < precision
 #if(!check) {cat("Warning. New frequencies don't sum to the right amount.\n"); browser();}
  return(gnf_pop)
}

# Function to calculate P(Case) for a sample conditional only it being randomly chosen rom individuals in the study
get_study_pdisease=function(objects)
{
  # Find the names of the collections that are cases and controls
  caseNames    = names(which(objects$assoc$case_colls==1))
  controlNames = names(which(objects$assoc$case_colls==0))
  # Calculate the total number of cases (and controls)
  numCases     = colSums(objects$dat[, caseNames])
  numControls  = colSums(objects$dat[, controlNames])
  # Proportion of individuals who are cases is then the ratio of these
  study_pdisease = sum(numCases)/sum(numControls)
  return(study_pdisease)
}

# get_model_pdisease=function(objects=objects, new=new, from_controls=T)
get_model_pdisease=function(objects, new=T, from_controls=T)
{
  nocl = objects$opars$nocl
  if(new) betas     = objects$npars$betas           else betas     = objects$opars$betas
  if(new) pop_freqs     = objects$npars$gnfp$gnf_lambda   else pop_freqs     = objects$opars$gnfp$gnf_lambda
  if(new) control_freqs = objects$npars$gnfp$gnf_controls else control_freqs = objects$opars$gnfp$gnf_controls
  pop_freqs     = normalise(    pop_freqs, sum=1)
  control_freqs = normalise(control_freqs, sum=1)
  exp_term                  = exp(betas[1] + betas[2]*(0:(nocl-1)))   
  prob_CASES_given_class    = exp_term/(1+exp_term) #comes from rearranging: log(p/1-p) = B0 + B1*Z
  prob_controls_given_class =        1/(1+exp_term)
  if(!from_controls) {
    # P(Phi_i = 1)   = sum_k    P(Phi_i = 1 | Z=k)  *  P(Z=k)
    # model_pdisease = sum_k prob_CASES_given_class * pop_freqs
    model_pdisease = sum(prob_CASES_given_class * pop_freqs)
  }
  if(from_controls)
  {
    # P(Phi=1) = 1-P(Phi=0) = 1 - 1/(1/P(Phi=0))
    # 1/P(Phi=0) = sum_k P(Z=k)/P(Phi=0) = sum_k P(Z=k|Phi=0)/P(Phi=0|Z=k)
    #                                    = sum_k control_freqs/prob_controls_given_class
    model_phealthy = 1/sum(control_freqs/prob_controls_given_class)
    model_pdisease = 1-model_phealthy
  }
  check1 = !is.na(model_pdisease); if(objects$flags$DEBUG>1 & !check1) {cat("  NA P(Phi=1)\n"); browser();}
  check2 = (model_pdisease<=1 & model_pdisease>=0); if(objects$flags$DEBUG>1 & !check2) {cat("  P(Phi=1) outside [0,1]\n"); browser();}
  return(model_pdisease)
}

make_ws_from_alpha=function(gnf_apar, nocl, gnf_theta)
{
  index  = 0:(nocl-1)
  gnf_ws = (choose((nocl-1), 0:(nocl-1)) * gnf_apar^index * (1-gnf_apar)^(nocl-index-1)) 
  gnf_ws = pmax(gnf_ws, rep(1/gnf_theta, length(gnf_ws))) 
  gnf_ws = normalise(gnf_ws, sum=1)
  #This process seems to give things in the reverse order - so reversing them on the next line
  return(rev(gnf_ws))
}





# Minimum genotype frequencies (gnf_lambda) not implemented yet
update_hk_pars=function(objects, new=T)
{
  wdat = objects$flags$wdat
  if(new==F) {cat("  Error. In update_hk_pars. Explicitly updating opars not implemented yet.\n"); browser()}
  if(!objects$flags$use_mpar_additions) {
    objects$npars$hkclm= make_clm(smcs=objects$npars$smc, clds=objects$npars$cld, nocl=objects$opars$nocl, noco=objects$opars$noco);  
    objects$npars$hkclv=objects$npars$clv ;
  }
  if( objects$flags$use_mpar_additions){
    vals     = as.numeric(rownames(objects$dat)) 
    new_moms = apply_edge_effects_hack(mean=make_clm(smcs=objects$npars$smc, clds=objects$npars$cld, nocl=objects$opars$nocl, noco=objects$opars$noco), var = objects$npars$clv, cl="all", vals=vals, flags=objects$flags)
    objects$npars$hkclm = new_moms$new_mean
    objects$npars$hkclv = new_moms$new_sd^2
    if(objects$flags$iter==-1) {cat("  Checking that the hacks applied to the means/vars used for the likelihoods are being done correctly.\n"); browser();}
  }
  return(objects)
}


#This function adds a small amount onto the variances but also onto the class distances.
#Note that for the purposes of this function the smallest class starts at _1_ and so (cl-1) is used as the extra distance for each class.
apply_edge_effects_hack=function(mean, var, cl, vals=NULL, flags)
{
 #wdat = range(vals)[2]-range(vals)[1]
 #wdat = flags$dmax-flags$dmin
  wdat = flags$wdat
  noco = nrow(mean)
  if(cl=="all") {
    check_dim   = !is.null(mean); if(!check_dim) {cat("  Error. In fn to add small bits onto means and vars. Haven't passed matrix of means.\n"); browser();}
    nocls       = 1:ncol(mean)
    mean_extras = ((nocls-1)*(wdat*flags$hack_add_cld))
    new_mean    = t(t(mean)  + mean_extras)             #This attempts to add a different value onto each class) but the same for each collection)
    new_sd      = sqrt(var) + get_hack_diff_sd(wdat=wdat, add_var=flags$hack_add_var) #Here I add the same number onto all variances
   #if(noco>1) {cat("Check that new_mean calculated correctly.\n"); browser();}
    new_moms      = list(new_mean ,  new_sd ) 
    names(new_moms) = c("new_mean", "new_sd")
  } else        {
    new_mean =     mean  + get_hack_diff_mean(cl=cl, wdat=wdat, add_cld=flags$hack_add_cld)
    new_sd   = sqrt(var) + get_hack_diff_sd(         wdat=wdat, add_var=flags$hack_add_var)
    new_moms      = list(new_mean ,  new_sd ) 
    names(new_moms) = c("new_mean", "new_sd")
  }
  return(new_moms)
}

# (!) Since changing the treatment of outliers this width is now different for different CNVs. Higher min distance with more outliers
get_hack_diff_mean=function(cl, wdat=0.1, add_cld)
  return( (cl-1)*wdat*add_cld )

# sd = get_hack_diff_sd(wdat=0.1, add_var=objects$flags$hack_add_var)
# (!) Since changing the treatment of outliers this width is now different for different CNVs. Higher min standard deviation with more outliers
get_hack_diff_sd=function(wdat=0.1, add_var)
  return( wdat*sqrt(add_var) )

# get_hack_diff_var(wdat=(max(vals)-min(vals)), add_var=objects$flags$hack_add_var)
get_hack_diff_var=function(wdat, add_var)
  return( wdat^2*add_var )


make_combined_lpdga=function(objects, vals, use_null)
{
  anocl      = objects$opars$anocl
  dat2       = rowSums(objects$dat)        # The counts at each grid value (summed over collections)
 #av_smc     = mean(objects$opars$smc)           # Simplified model for model selection.
 #av_cld     = apply(objects$opars$cld, 2, mean) # ""
 #clm        = cumsum(c(av_smc, av_cld))              # The class means     used for likelihood calculation
  clm        = colMeans(objects$opars$hkclm) 
  av_clv     = colMeans(objects$opars$hkclv) # The class variances used for likelihood calculation (sqrts of)
  names(clm) = sapply(names(av_clv), sub, pattern="_vars", replacement="means")
  if(!use_null) {
    class_names = names(clm)
  }
  if( use_null) 
  {
    class_names = c(names(clm), "NULL")
  }
  ld_gv    = matrix(0, nrow=length(vals), ncol=anocl) #matrix to store various P(grid_vals | cluster parameters)
  colnames(ld_gv) = class_names
 #l_lk     = matrix(0, nrow=length(vals), ncol=objects$opars$nocl) #matrix to store log likelihoods given grid_value
  for(cl in 1:anocl)
  {
    #For each griv value (gv) get log density (ld) of measurement at that value given clm and av_clv (and normal noise model)
    if(use_null & cl==anocl) {
      ld_gv[,cl] = dunif(vals, min=min(vals), max=max(vals), log=T) 
    } else                   {
      if(objects$flags$signal_model == "normal")
        ld_gv[,cl] = dnorm(vals, mean=clm[cl], sd = sqrt(av_clv[cl]), log=T) 
      if(objects$flags$signal_model == "t8"    )
        ld_gv[,cl] = my_dt(dat=vals, df=8, mean=clm[cl], sd=sqrt(av_clv[cl]), log=T)
      if(objects$flags$signal_model == "t"    )
        ld_gv[,cl] = my_dt(dat=vals, df=objects$flags$deg_free, mean=clm[cl], sd=sqrt(av_clv[cl]), log=T)
    }
  }
  return(ld_gv)
}

# check_clv(clv=objects$npars$clv, min_var=1E-50, hkclv=NULL)
check_clv=function(clv, min_var=1E-50, hkclv=NULL)
{
  if(min(clv) < min_var) {
    cat("In check_clv. Variances have gone below the minimum.\n");
    if(!is.null(hkclv)) cat("hkclv = ", hkclv, "\n", sep="");
    browser();
  }
}

soft_clmoment_estimate=function(objects, mom_type, rem_cases=F, new=F)
{
   #Trying to use soft calls of the data to derive new estimates of class means and variances (should possibly do both).
   #lpagd contains - For every grid val in every collection: A vector giving the posterior probability of that class.
   #soft_called_dat should contain: the posterior number of individuals in each class at each grid_value (in each collection)
  #lpagd           = make_lpagd(ob=objects, new=new) #Do I want to use the old lpdga? So far, yes - because it's called to aid MOVES
  #if(new) lpagd   = objects$ninferred$lpagd else lpagd = objects$oinferred$lpagd
   if(new)  pagd   = objects$ninferred$pagd  else  pagd = objects$oinferred$pagd
   nocl            = objects$opars$nocl; noco=objects$opars$noco;
   soft_called_dat = pagd #This is just to get the dimensions right - it will be changed
   old_clms        = make_clm(smcs=objects$opars$smc, clds=objects$opars$cld, noco=noco, nocl=nocl)
   vals            = as.numeric(rownames(objects$dat))
   use_colls       = colnames(objects$dat)
  if(rem_cases) {
    caseNames = names(which(objects$assoc$case_colls==1))
    pagd      = pagd[,,-caseNames, drop=F]
    use_colls = use_colls[-caseNames]
  }

   for(cl in 1:nocl)
     soft_called_dat[,cl,] = pagd[,cl,]*objects$dat
   dimnames(soft_called_dat)[[1]] = rownames(objects$dat)
   mom_est = objects$opars$clv #this is just to get the dimensions right - this might be a vector of class means
   if(mom_type=="mean") colnames(mom_est)=paste(rep("clm",ncol(mom_est)),1:ncol(mom_est),sep="")
   for(collName in use_colls)
   {
     coll_ind = which(use_colls==collName) # Indexing for objects which only contain info on control collections 
     for(cl in 1:nocl)
     {
       moments = calc_dat_moments(data=soft_called_dat[,cl,collName], in_clv=objects$opars$clv[collName,cl]); #Original value returned when estimation impossible.
       if( is.null(moments[[mom_type]])) {
         if(mom_type=="var" ) mom_est[collName,cl] = objects$npars$clv[collName,cl];
         if(mom_type=="mean") mom_est[collName,cl] = old_clms[collName,cl];
         problem=T 
       }
       if(!is.null(moments[[mom_type]])) {
         mom_est[collName,cl] = reverse_hack(vals=vals, cl=cl, flags=objects$flags, moments=moments, wanted_moment=mom_type)
         if((mom_type!="mean") & objects$flags$DEBUG>0.1) check_clv(clv=mom_est[collName,cl], min_var=1E-50, hkclv=NULL)
        #mom_est[collName,cl] = moments[[mom_type]]; 
         problem=F 
       }
     }
   }
   if(mom_type=="mean" & !is.null(mom_est))
     for(coll in 1:noco)
       mom_est[coll,] = sort(mom_est[coll,], decreasing=F)

   if((mom_type=="mean") & sum(!(apply(mom_est,1,diff)>=0)) >0 ) {cat("In soft_clmoment_estimate. Error, cannot have negative distances between clusters.\n"); browserdump();}  
   if((mom_type=="mean") & sum( (apply(mom_est,1,diff)==0)) >0) {
     if(objects$flags$DEBUG>1.5 & !objects$flags$use_mpar_additions) cat("In soft_clmoment_estimate. Warning, have zero distance between clusters (returning originals).\n"); 
     if(objects$flags$DEBUG>2  ) browserdump()
     mom_est = old_clms
   }  
   if((mom_type=="var" ) & sum(!(mom_est>=0) ) >0) {cat("In soft_clmoment_estimate. Error, cannot have negative variances of clusters.\n"     ); browserdump();}  
   if((mom_type!="mean") & objects$flags$DEBUG>0.1) check_clv(clv=mom_est, min_var=1E-50, hkclv=NULL)

   return_val         = list(mom_est, problem)
   names(return_val)  = c("mom_est", "problem")
   return(return_val)
}

#Produces hard calls (h_calls) for each grid value (check_calls can do this for individuals)
make_grid_calls=function(objects, direct_lpdga=NULL, new=F, use_null_freq=F)
{
 #if(!is.null(direct_lpdga)) lpagd = make_lpagd(ob=objects, direct_lpdga=direct_lpdga, new=new, use_null_freq=use_null_freq)
 #if( is.null(direct_lpdga)) {if(new) lpagd = objects$ninferred$lpagd else lpagd = objects$oinferred$lpagd}
  if(!is.null(direct_lpdga))  pagd = make_pagd( ob=objects, direct_lpdga=direct_lpdga, new=new, use_null_freq=use_null_freq)
  if( is.null(direct_lpdga)) {if(new)  pagd = objects$ninferred$pagd  else  pagd = objects$oinferred$pagd}
  return(apply(pagd, c(1,3), which.max) )
}

#Takes in a list of vectors of values. Returns a matrix cols correspond to lists, rows to 'grid points'
#Each individual in the original vectors is placed in a 'box' and the multiplicities of the boxes make up the new structure
grid_data=function(dat, start_range, grid_res, breaks=NULL, grid_density, DEBUG)
{
   if(!exists("DEBUG")) {cat("Warning - no instance of DEBUG passed (griddat)\n"); DEBUG=1}
   no_inds = sum(unlist(lapply(dat, length)))
   noco    = length(dat)
   ind_per_cohort = floor(no_inds/noco)
   #rgrd = the range of the grid being used to 'compress' the data.
   rgrd = start_range
   for(col in 1:length(dat))
   {
     rdat = range(dat[[col]])
     rgrd = c(min(rdat[1], rgrd[1]), max(rdat[2], rgrd[2]))
   }
   do_by_cohort = F; #I now do it by total no_inds as with the heirarchy can combine info accross cohorts.
   if(do_by_cohort) {
     if(ind_per_cohort<=1000                      ) min_bins = max(24, floor(no_inds/17))
     if(ind_per_cohort>1000 & ind_per_cohort<=5000) min_bins = 40
     if(ind_per_cohort>5000                       ) min_bins = 100
     if(ind_per_cohort<=1000                      ) max_bins = floor(no_inds/12)
     if(ind_per_cohort>1000 & ind_per_cohort<=5000) max_bins = 100
     if(ind_per_cohort>5000                       ) max_bins = 180
   } else {
     if(no_inds<=1000               ) min_bins = max(12, floor(no_inds/17))
     if(no_inds>1000 & no_inds<=5000) min_bins = 100
     if(no_inds>5000                ) min_bins = 135
     if(no_inds<=1000               ) max_bins = max(12, floor(no_inds/13))
     if(no_inds>1000 & no_inds<=5000) max_bins = 130
     if(no_inds>5000                ) max_bins = 200
   }
   min_bins = min_bins*grid_density
   max_bins = max_bins*grid_density
   no_bins = max(min_bins, ((rgrd[2]-rgrd[1])/grid_res - 1))
   no_bins = min(max_bins, no_bins)
   if(0) {cat("  How many bins?\n"); browser();}

   if(DEBUG==3.111 & no_bins<30) {cat("in grid_dat, not many bins.\n"); browser();}
   # When there's a smal number of extreme individuals want to 1) not lose resolution and 2) not have too many bins
   # So solve this by having large bins at the extremities of the distribution. (SO usually have more resolution than is clear from the plots)
   if( is.null(breaks))
     breaks  = (((-1):(no_bins+2))/(no_bins+1))*(rgrd[2]-rgrd[1])+rgrd[1]
   if(!is.null(breaks))
     breaks  = c(min(min(breaks),min(unlist(dat))), breaks[-c(1, length(breaks))], max(max(breaks), max(unlist(dat))))

   #values  = (breaks + ((breaks[2]-breaks[1])/2))[-c(length(breaks))] #goes wrong when breaks aren't homogeneous
   b_stt    = breaks[-c(length(breaks))]
   b_end    = breaks[-c(1)]
   values  = (b_stt+b_end)/2
  
   new_dat = matrix(-1, nrow=length(breaks)-1, ncol=length(dat))
   for(col in 1:length(dat))
      new_dat[,col] = hist(dat[[col]], breaks=breaks, plot=F)$counts
   colnames(new_dat) = names(dat);
   rownames(new_dat) = values
   return_val = list(new_dat, breaks)
   names(return_val) = c("new_dat", "grid_breaks")
   return(return_val)
}


# Creates a 1-dimensional summary of a data matrix by taking the 1st principal
# component from a PCA.
#
# Notes:
#   no_to_use   is not implemented
#   split_data  should *not* be used (keep it FALSE)
#
# Notes from Niall:
# What if PCA picks out 'different components' for different collections!?
# This will get dealt with when I model the probes.
run_PCA=function(data_array,
                 split_data = FALSE,
                 no_to_use  = 1,
                 pca_type   = c("prcomp", "svd"),
                 scale      = FALSE)
{
  # In general: if you have run pca_type="svd" (and so have the svd.all
  # variable available) and want to get an approximation of the whole data, or
  # a 'cleaned' version of the data, use:
  #
  #                  svd.all$u[, 1:no_to_use, drop=F]   %*%
  #   diag(as.matrix(svd.all$d[  1:no_to_use, drop=F])) %*%
  #                t(svd.all$v[, 1:no_to_use, drop=F])

  # Validate some of the arguments.
  pca_type = match.arg(pca_type)

  # Initialise data structure (a list) in which to place results.
  noco       = ncol(data_array)
  dat        = as.list(rep(-1, ncol(data_array)))
  names(dat) = names(data_array)

  # Different execution path depending on whether split_data is TRUE.
  if (split_data) {
    warning("Using split_data=TRUE is a *bad* idea, and also not properly implemented.")

    # Run PCA on each sample collection separately.
    for (coll in 1:noco) {
      # Run PCA and pull out 1st principal component.
      if (pca_type == "svd") {
        svd.all     = svd(scale(data_array[[coll]], center=T, scale=scale))
        dat[[coll]] = svd.all$u[,1]
        # Note: this is not actually a proper PCA, but the output will be same
        # up to a scalar multiple.
      }
      if (pca_type == "prcomp") {
        pca.all     = prcomp(data_array[[coll]], center=T, scale.=scale)
        dat[[coll]] = pca.all$x[,1]
      }
      names(dat)[coll] = names(data_array)[coll]

      # Re-orientate the PC scores to match the orientation of the raw data.
      if (cor( dat[[coll]], rowMeans(data_array[[1,coll]])) <
          cor(-dat[[coll]], rowMeans(data_array[[1,coll]])))
        dat[[coll]] = -dat[[coll]]
    }
  } else {
    # Convert data into one big matrix.
    data_matrix = data_array_to_matrix(data_array, simpleNames=TRUE)

    # Run PCA and pull out 1st principal component.
    if (pca_type == "svd") {
      svd.all = svd(scale(data_matrix, center=T, scale=scale))
      ldat    = svd.all$u[,1]
      # Note: this is not actually a proper PCA, but the output will be same up
      # to a scalar multiple.
    }
    if (pca_type == "prcomp") {
      pca.all = prcomp(data_matrix, center=T, scale.=scale)
      ldat    = pca.all$x[,1]
    }

    # Re-orientate the PC scores to match the orientation of the raw data.
    if (cor( ldat, rowMeans(data_matrix)) <
        cor(-ldat, rowMeans(data_matrix)))
      ldat = -ldat

    # Place results into the list 'dat'.
    collsizes   = sapply(data_array, nrow)
    coll_ends   = cumsum(collsizes)
    coll_starts = c(1, coll_ends[(1:(length(collsizes)-1))]+1)
    for (coll in 1:noco)
      dat[[coll]] = ldat[coll_starts[coll]:coll_ends[coll]]
  }

  # Return a list with the 1st PCs.
  return(dat)
}

calc_means=function(data_array)
{
  dat        = as.list(rep(-1, ncol(data_array)))
  names(dat) = 1:ncol(data_array)
  for(coll in 1:ncol(data_array))
  {
    dat[[coll]]      = rowMeans(data_array[1,coll][[1]])
    names(dat)[coll] = names(data_array)[coll]
  }  
  return(dat)
}

data_array_to_matrix=function(data_array, add_coll_to_names=T, coll_sep_char="£", simpleNames=F)
{
  data_matrix = matrix(NA, nrow=0, ncol=ncol(data_array[[1]]))
  for(coll in 1:length(data_array))
  {
    new_block_start = nrow(data_matrix)+1
    data_matrix     = rbind(data_matrix, data_array[[coll]])
    new_block_end   = nrow(data_matrix)
    if(add_coll_to_names) {
      if(!simpleNames)
        rownames(data_matrix)[new_block_start:new_block_end] = paste(names(data_array)[coll], rownames(data_array[[coll]]), sep=coll_sep_char)
      if( simpleNames)
        rownames(data_matrix)[new_block_start:new_block_end] = rownames(data_array[[coll]])
    }
  }
  return(data_matrix)
}

dissect_sample_names=function(sample_names, coll_sep_char="£")
{
  if(is.list(sample_names)) sample_names = unlist(sample_names)
  if(length(grep(coll_sep_char, sample_names, fixed=T))==0) {
    rv = list("coll_labels"="none", "collections"="none", "orig_names"=sample_names)
    return(rv)
  }
  split_names = strsplit(sample_names, split=coll_sep_char, fixed=T)
  coll_labels = sapply(split_names, '[[', 1)
  collections = unique(coll_labels)
  orig_names  = sapply(split_names, '[[', 2)
  names(orig_names) = coll_labels
  rv = list("coll_labels"=coll_labels, "collections"=collections, "orig_names"=orig_names)
  return(rv)
}


data_matrix_to_array=function(data_matrix, added_coll_to_names=TRUE, coll_sep_char="£")
{
  split_names = dissect_sample_names(sample_names=rownames(data_matrix), coll_sep_char="£")
  collections = split_names$collections
  orig_names  = split_names$orig_names
  data_array  = matrix(list(""), nrow=1, ncol=length(collections))
  names(data_array)    = collections
  colnames(data_array) = collections
  for(coll in collections)
  {
    collind                     = which(collections==coll)
    this_coll_inds              = which(names(orig_names)==coll)
    data_array[[1,coll]]        = data_matrix[this_coll_inds,, drop=F]    
    # Is the ORDER of the names within the collections definitely maintained throughout this?
    rownames(data_array[[1,coll]]) = orig_names[this_coll_inds]
  }
  return(data_array)
}


guess_peaks = function(height=15, dat, just_indices=F)
{
  mounds = dat>=height
  bounds=diff(mounds)
  starts = which(bounds== 1)
  ends   = which(bounds==-1)
  if(length(starts)==0)
  {
    peaks = c(1, length(dat))
    if(!just_indices) peaks = as.numeric(names(dat)[peaks])
    return(peaks);
  }
  if(min(starts) > min(ends)) {
     starts = c(1          , starts)
     names(starts)[1]           = names(dat)[1]
  }
  if(max(starts) > max(ends)) {
     ends   = c(length(dat), ends  )
     names(ends)[length(ends)]  = names(dat)[length(dat)]
  }  
  peaks = rep(-1, length(starts))
  if(length(starts)>0)
  {
    for(region in 1:length(starts))
      peaks[region] = which.max(dat[starts[region]:ends[region]])
    peaks = peaks+starts-1
  }
  if(!just_indices) peaks = as.numeric(names(dat)[peaks])
  return(peaks)
}

#This function allows the user to input the estimated mean of each class
#maxL_means is set to false by default as the whole point is that the user chooses the means
#  Could make a different version of this function where boundaries
#  were chosen, hard calls made on the basis of the boundaries an then means, vars and gnfs on those
# user_defined_fit(objects=objects, in_nocl=5, maxL_vars=T, maxL_means=F, maxL_gnf=T, no_em_like_steps = 1)
user_defined_fit=function(objects, in_nocl, maxL_vars=T, maxL_means=F, maxL_gnf=T,
                   no_em_like_steps = 1, verbose=0)
{
  cat("This function allows the user to input the boundary points of each class.\n");
  if(in_nocl!=objects$opars$nocl) cat("In user_defined_fit. This won't work because number of classes is wrong.\n");
  noco = objects$opars$noco
  this_fit = objects
  dat2 = rowMeans(objects$dat)
  grid_vals = as.numeric(names(dat2))
  plotd(data=dat2, new=T)
 #cat("Click on the plot in between each class.\n");
  cat("Click on the plot. Click where you think each class mean is.\n");
  ok=F
  while(!ok)
  {
    click_pts = locator(n=in_nocl)
    clms      = click_pts$x
    clms      = sort(clms, decreasing=F)
    abline(v = clms)
    clms = myas.matrix(invec=clms, rdim=c(1,length(clms)), dimnames=list("coll", paste("cl", 1:3, sep="")))
    clms = rev_hk2(mom_type="mean", moments=clms, nocl=in_nocl, vals=grid_vals, flags=objects$flags)
    if(verbose>=2) {cat("You chose:", round(clms, digits=3), sep=" ")}
    if(objects$flags$DEBUG>2) ok        = get_user_ok() else ok=T
    if(ok) break();
    plotd(data=objects$dat)
  }
  this_fit$npars$smc = rep(clms[1], noco)
  this_fit$npars$cld = matrix(rep(diff(clms), noco), nrow=noco, byrow=T)
  
  for(step in 1:no_em_like_steps)
  {
    #Produce and lpdga vector (ASSUMES means/variances/gnfs)
    this_fit   = update_lpdga(objects = this_fit)
   #this_fit$ninferred$lpagd = make_lpagd(ob=this_fit, direct_lpdga=NULL, direct_gnf=NULL, new=T, combined=F)
    this_fit$ninferred$pagd  = make_pagd( ob=this_fit, direct_lpdga=NULL, direct_gnf=NULL, new=T, combined=F)
    this_lpdga = this_fit$ninferred$lpdga
    #gnf:  given the lpdga vector (and existing gnf)
    if(maxL_vars ) this_fit   = maxL_variances( objects=this_fit         )
    if(maxL_gnf  ) this_fit   = combined_maxgnf(objects=this_fit, min_1=T)
    if(maxL_means) this_fit   = maxL_means(     objects=this_fit         , use_hcalls=F)
  }
  objects = this_fit
  objects$opars = objects$npars
  #Decide which aspects of objects to change (pass as flags?)
  return(objects)
}

browserdump=function()
{
  browser();
  dump.frames()
}


compare_to_sim_dat=function(stpt_states, nocls, bic_best_nocl, dat, cnv_types, data_array, stpts)
{
  if(length(nocls)>1 ) h_calls = check_calls(ob = stpt_states[[which(nocls==bic_best_nocl)]], dat=dat, cnv_types=cnv_types, data_array=data_array)
  if(length(nocls)==1 & length(stpts)==1) 
    h_calls = check_calls(ob = stpt_states[[1]], dat=dat, cnv_types=cnv_types, data_array=data_array)
  if(length(nocls)==1 & length(stpts)> 1) 
    h_calls = check_calls(ob = best_states[[1]], dat=dat, cnv_types=cnv_types, data_array=data_array)
  
  #look_at_model_states(stpt_states)
  #move_records = list(mv_names, accept)
  #names(move_records) = c("mv_names", "accept")
  #check_moves_made(move_records)
}

#  quick_process_map(stpt_states)
quick_process_map=function(stpt_states, cnv_index=NULL, cnv_name=NULL, ung_dat=NULL, verbose=0)
{
 #best_within_nocl = apply(stpt_states, 1, function(x) which.max(sapply(x, function(y) y$likelihood$o_liklihd)))
  nocls            = sapply(stpt_states[,1], function(x) x$opars$nocl)
  best_within_nocl = rep(NA, length(nocls))
  best_within_nocl[which(nocls!=1)] = apply(stpt_states[which(nocls!=1),], 1, function(x) which.max(sapply(x, function(y) y$lstore$hier_mchoice$o_liklihd)))
  best_within_nocl[which(nocls==1)] = 1
  best_indices     = cbind(1:nrow(stpt_states), best_within_nocl)
  model_evidences  = sapply(stpt_states[best_indices], calc_evidence, type="bic"); names(model_evidences) = rownames(stpt_states);
  bic_best_nocl    = nocls[which.max(model_evidences)]
  if(verbose>=1) summarise_model_choice(stpt_states[best_indices])
  return(model_evidences)
}


summarise_model_choice=function(best_states, hier_mchoice=T)
{
  cat(" Summarise_model_choice should really be updated for new model choice criterion.\n"); browser();
  if( hier_mchoice) likelihoods     = sapply(best_states, function(x) x$lstore$hier_mchoice$o_liklihd)
  if(!hier_mchoice) likelihoods     = sapply(best_states, function(x) x$lstore$simple_model$o_liklihd)
  model_evidences = sapply(best_states, calc_evidence, type="bic")
  no_data_points  = sum(best_states[1][[1]]$dat)
  nocls           = sapply(best_states, function(x) x$opars$nocl)
  no_pars         = sapply(nocls, calc_simple_no_pars)
  bic_penalties   = no_pars*log(no_data_points)
  index = 1:length(best_states)
  values = list(likelihoods, bic_penalties, nocls, model_evidences); names(values) = c("likelihoods", "bic_penalties", "nocls", "model_evidences");
  sapply(index, display_ev_summ, values=values)
  cat("bic chosen nocl = ", nocls[which.max(model_evidences)], "\n", sep="")
}
display_ev_summ=function(index, values)
{
  cat("Nocl = ", values$nocls[index], ", likelihood = ", round(values$likelihoods[index], digits=2), ", bic_penalty = ", values$bic_penalties[index], 
      ", so evidence = ", values$model_evidences[index], "\n", sep="")
}

make_model_likelihoods=function(stpts)
{
  noclis   = nrow(stpts)
  no_stpts = ncol(stpts)
  model_likelihoods      = matrix(-1E200, noclis, no_stpts)
  model_likelihoods[1,1] = stpts[[1,1]]$likelihood$o_liklihd
  for(nocli in 2:noclis)
    for(stpt_ind in 1:no_stpts)
    {
      if(is.null(stpts[[nocli,stpt_ind]]))
        model_likelihoods[nocli, stpt_ind] = stpts[[nocli,stpt_ind]]$likelihood$o_liklihd else
        model_likelihoods[nocli, stpt_ind] = NULL
    }
  return(model_likelihoods)
}

quick_fit_summary=function(fit=best_fit, cnv_name=NULL, cnv_index=NULL, write=F, text_pars_fn=get_coutput_fns(cnv_name = fn_cnv_name)$text_pars_fn, smry_line, seed, verbose=T, stpt_states)
{
  best_nocl     = fit$opars$nocl
  nocls         = as.numeric(sapply(strsplit(rownames(stpt_states), split="="), '[', 2))
  evidences     = apply(X=stpt_states, MARGIN=c(1,2), FUN=calc_evidence, separate_collections=fit$flags$use_hier_mchoice, set_point = "hier_mchoice", type="bic", new=F) 
  max_evidences = apply(evidences, MARGIN=1, max, na.rm=T)
  max_e_indices = which(evidences==max_evidences, arr.ind=T) #, na.rm=T)
  max_e_indices = rep(NA, nrow(evidences))
  for(nocl_ind in 1:length(nocls)) max_e_indices[nocl_ind] = which(evidences[nocl_ind,]==max_evidences[nocl_ind])[1]
  for(nocl_ind in 1:length(nocls))
  {
    nocl  = nocls[nocl_ind]
    if(nocl!=best_nocl) spfit = stpt_states[[nocl_ind,max_e_indices[nocl_ind]]] else spfit = fit
    smcs = round(spfit$opars$smc, digits=4)
    clds = round(spfit$opars$cld, digits=4)
    gnf_pop = round(spfit$opars$gnfp$gnf_lambda, digits=4)
    names(gnf_pop) = paste("gnfcl", 1:length(gnf_pop), sep="")
    noco  = spfit$opars$noco
    clms  = round(make_clm(smcs=smcs, clds=clds, noco=noco, nocl=nocl), digits=5)
    clvs  = round(spfit$opars$clv, digits=8)
    clms  = round(spfit$opars$hkclm, digits=8)
    clvs  = round(spfit$opars$hkclv, digits=8)
    betas = spfit$opars$betas
    names(betas) = paste("beta", (1:length(betas))-1, sep="")
    rownames(clvs) = rownames(clms)
    colnames(clvs) = paste(rep("cl=", ncol(clvs)), 1:ncol(clvs), sep="")
  
    in_warn = getOption("warn")
    options(warn=-1)
    if(write) {
      first_append = nocl_ind!=1
      write.table(paste("nocl ", nocl), file=text_pars_fn, append=first_append, quote=F, row.names=F, col.names=F)
      write.table((matrix(paste("clmean", 1:nocl, sep=""), nrow=1)), file=text_pars_fn, append=T, quote=F, row.names=F, col.names=F)
      write.table((clms), file=text_pars_fn, append=T, quote=F, row.names=T, col.names=F)
      write.table((matrix(paste("clvar", 1:nocl, sep=""), nrow=1)), file=text_pars_fn, append=T, quote=F, row.names=F, col.names=F)
      write.table((clvs), file=text_pars_fn, append=T, quote=F, row.names=T, col.names=F)
      write.table(t(as.matrix(gnf_pop)), file=text_pars_fn, append=T, quote=F, row.names=F, col.names=T)
      write.table(t(as.matrix(betas)), file=text_pars_fn, append=T, quote=F, row.names=F, col.names=T)
    }
    #cat("\n");
  }
  #cat("\n");
  write.table(format(as.matrix(smry_line)), file=text_pars_fn, append=T, quote=F, row.names=F, col.names=T)
  options(warn=in_warn)
  if(verbose>=2) {
    cat("bic best number of classes =", best_nocl, "\n");
    #cat("Quick summary of the best model spfit:\n");
    #cat("\nInferred Class means:\n")
    #print(clms)
    #cat("\nInferred Class Variances:\n")
    #print(clvs)
    #cat("\nInferred Genotype Frequencies:\n")
    #print(spfit$opars$gnfp$gnf_lambda)
  }
 #cat("  Have a look at cnv_summary file.\n"); browser();
}



#Have decided to drop all the 'cunning' quantiles stuff as a dead loss. Just looking for the range of the data now.
calc_high_low_grid_vals=function(objects, cushion_with_mincld=T)
{
   wdat      = objects$flag$wdat
   dat       = rowMeans(objects$dat)
   q1        = cumsum(dat) #These are used to find certain quantiles of the data 
   grid_vals = as.numeric(names(dat))
   no_inds   = sum(dat)
   zero_pt   = which(grid_vals > 0)[1]
   extreme_dat      = (sum(dat[1:zero_pt])<(no_inds/100 )) | (sum(dat[zero_pt:length(dat)])<(no_inds/100 ))
   very_extreme_dat = (sum(dat[1:zero_pt])<(no_inds/2000)) | (sum(dat[zero_pt:length(dat)])<(no_inds/2000))
   if(extreme_dat) {
     if(very_extreme_dat) {
       cut_off_min = 0 * no_inds
       cut_off_max = 1 * no_inds
     } else              {
     cut_off_min = min(0, objects$flags$stpt$bot_q-5e-5) * no_inds
     cut_off_max = max(1, objects$flags$stpt$top_q+5e-5) * no_inds
     }
   } else          {
     cut_off_min = min(0, objects$flags$stpt$bot_q-5e-4) * no_inds
     cut_off_max = max(1, objects$flags$stpt$top_q+5e-4) * no_inds
   }
   low_gv  = max(1                , which(q1>cut_off_min)[1]-1, na.rm=T)
   high_gv = min(length(grid_vals), which(q1>cut_off_max)[1]+1, na.rm=T)
   if(cushion_with_mincld)
   {
     low_gv  = low_gv  - get_hack_diff_mean(cl=1                 , wdat=wdat, add_cld=objects$flags$hack_add_cld)
     high_gv = high_gv + get_hack_diff_mean(cl=objects$opars$nocl, wdat=wdat, add_cld=objects$flags$hack_add_cld)
   }
   extreme_gvs        = c( low_gv ,  high_gv )
   names(extreme_gvs) = c("low_gv", "high_gv")
   if(low_gv!=1) {cat("This function is currently essentially switched off - so why is low_gv!=1?.\n"); browser()}
   return(extreme_gvs)
}


#This takes a vector of class means or distances as input and spits out a full matrix of them
#Currently these will have no names
avg_to_cohort=function(avg_clm, noco)
{
  return(matrix(rep(avg_clm, noco), nrow=noco, byrow=T))
}

get_user_ok=function()
{
  understand=F
  while(!understand)
  {
    #cat("Is that ok (type \"yes\" or \"no\")?\n")
    #input = strsplit(Rin(), "")[[1]][1]
    input = my.pause()
    cat("You entered:", input, "\n");
    if(input=="y") {ok=T; understand=T}
    if(input=="n") {ok=F; understand=T}
    if(input!="n" & input!="y") {cat("Didn't understand input. Try again pls.\n")}
  }
  return(ok)
}

 my.pause <- function() {
  x <- ""
  while ( x != "y" && x != "m" && x != "n" )
   x <- readline(prompt = "\t Are these ok? (Type y/n): ")
  return(x)
 }

#Takes in an object with one or more 'moments' (means or variances) of some subset of the data. Subtracts the minimum values (as appropriate)
# reverse_hack(flags=objects$flags, moments=objects$npars$hkclv[1,1], wanted_moment="var")
reverse_hack=function(vals=NULL, cl=NA, coll=1, flags, moments, wanted_moment="mean", min_var=NULL, wdat=flags$wdat, neg_cldok=F)
{
 #if(is.null(vals)) wdat = flags$dmax - flags$dmin;  if(!is.null(vals)) wdat = max(vals)-min(vals)
  wdat = flags$wdat
  if(is.null(min_var)) min_var = flags$min_var
  if(flags$use_mpar_additions) {
    if(wanted_moment=="mean") hdmean = get_hack_diff_mean(cl=cl, wdat=wdat, add_cld=flags$hack_add_cld)
    if(wanted_moment=="var" ) hdsd   = get_hack_diff_sd(         wdat=wdat, add_var=flags$hack_add_var)
   #this_moment= unlist(moments[wanted_moment])
    this_moment= moments[[wanted_moment]]
    if(!(length(this_moment)==1 & is.numeric(this_moment))) {cat("In reverse_hack. Problem with this_moment.\n"); browser();}
   #if(wanted_moment=="mean") moment_est = max(0, this_moment - hdmean);
    if(wanted_moment=="mean") moment_est =        this_moment - hdmean ;
    if(wanted_moment=="var" ) {
      adjusted_sd = sqrt(this_moment) - hdsd
      if(adjusted_sd<0) moment_est = min_var else  moment_est  = max(min_var, (adjusted_sd)^2);
    }
  }
  if(0) {cat("In maxL_mean_or_vars. Check that the hack_adjustment has gone smoothly.\n"); browser();}
  if(!flags$use_mpar_additions) moment_est = moments[wanted_moment];
  if(wanted_moment!="mean" & min(moment_est)<(min_var-1e-20)) {cat("In maxL_mean_or_vars. hack_adjustment has not gone smoothly.\n"); browser();}
  return(moment_est)
}

#Takes in the class means for a collection (or an averaged set) and spits out new means with the minimum_values subtracted
# class_means2 = rev_hk2(mom_type="mean", moments=class_means, nocl=nocl, vals=grid_vals, flags=objects$flags)
rev_hk2=function(mom_type="mean", moments, nocl, vals=NULL, flags, precision=1e-15, increase_sm_dsts=T, neg_cldok=F)
{
   mom2 = moments
   for(cl in 1:nocl) {
     moment   = moments[cl]; names(moment) = mom_type
     mom2[cl] = reverse_hack(vals=vals, cl=cl, flags=flags, moments=moment, wanted_moment=mom_type, neg_cldok=neg_cldok)
   }
  if(mom_type=="mean") {
    clds = apply(mom2, 1, diff)
    smc  = mom2[1]
    if(increase_sm_dsts) clds = mypmax(inmat=clds, flags$min_extra_cld)
    mom3 = cumsum(c(smc, clds))
  } else mom3=mom2
  if(length(mom2)>1) {if(flags$DEBUG>2.5 & abs((mom2[2]/mom2[1])-0.1)<precision) {cat("Why is there this _weird_ 1/10th relationship between clm1 and clm2?\n"); browser();}}
  return(mom3)
}

#Takes in a full set of smcs and clds and spits out objects of the same form but with the minimum_values subtracted
#smcs_clds = rev_hk3(smcs=smcs, clds=clds, nocl=nocl, noco=noco, mom_type="mean", vals=grid_vals, flags=objects$flags)
rev_hk3=function(smcs, clds, nocl, noco, mom_type, vals, flags)
{
   new_clm_allc = make_clm(smcs = smcs, clds = clds, nocl=nocl, noco=noco)
   for(coll in 1:noco)
     new_clm_allc[coll,] = rev_hk2(mom_type=mom_type, moments=new_clm_allc[coll,,drop=F], nocl=nocl, vals=vals, flags=flags)
   smcs_clds = make_smcs_clds(clm=new_clm_allc, nocl=nocl)
  return(smcs_clds)
}

#Takes in hkclms and spits out objects smcs and clds with the fixed_cld portion removed.
rev_hk4=function(hkclm, nocl=NULL, mom_type="mean", flags, increase_sm_dsts=T, neg_cldok=F)
{
  nocl = ncol(hkclm)
  extra_clm = hkclm
   for(coll in 1:nrow(hkclm))
     extra_clm[coll,] = rev_hk2(mom_type=mom_type, moments=hkclm[coll,,drop=F], nocl=nocl, flags=flags, increase_sm_dsts=increase_sm_dsts)
   smcs_clds = make_smcs_clds(clm=extra_clm, nocl=nocl, neg_cldok=neg_cldok)
  return(smcs_clds)
}


## eclm = t(apply(cbind(objects$opars$smc, objects$opars$cld), 1, cumsum))
# This function takes in the positions of the smallest classes, and the matrix of distances between classes and returns the matrix of class positions
make_clm=function(smcs, clds, noco, nocl)
{
  #if(is.null(noco)) {cat("In make_clm. Need to input a number of collection.\n"); browser()}
  check = (ncol(clds)==(nocl-1))
  if(length(check)!=1) {cat("Error in make_clm. Probably dropped a dimension on clds.\n"); browser();}
  if(nocl==1) {
    clm = matrix(smcs, nrow=noco)
   #rownames(clm) = makeDefaultCollnames(noco=noco)
    rownames(clm) = rownames(clds)
    colnames(clm) = "cl1"
    return(clm)
  }
  if(check) {
    if(noco>1) {
      clm = t(apply(cbind(smcs,clds), 1, cumsum)) #This only works as have conditioned on noco>1 AND nocl>1 (because t(vec) gives row vec)
      if(is.null(colnames(clds))) colnames(clds) = paste("cld" , 1:(nocl-1), sep="")
      if(is.null(rownames(clds))) rownames(clds) = makeDefaultCollnames(noco=noco)
     #colnames(clm)[-c(1)] = colnames(clds)
     #rownames(clm)        = rownames(clds)
    } else     {
      clm = cumsum(c(smcs,clds))
      clm = matrix(clm, nrow=1)
    }
  } else    {
    cat("In make_clm. Decided not to proceed as the number of columns doesn't match the number of componenets/classes.\n");
    browser();
  }
  colnames(clm) = paste("cl"  , 1:nocl)
  rownames(clm) = rownames(clds)
  return(clm)
}

make_smcs_clds=function(clm, nocl, neg_cldok=F, DEBUG=1)
{
  if(!is.matrix(clm)) {cat("In make_smcs_clds. Error, function is expecting a matrix of cluster means.\n"); if(objects$flags$DEBUG>1) browser() }
  check = ncol(clm)==(nocl)
  noco  = nrow(clm)
  if(check) {
    smcs             = clm[,1]
    if(nocl==1) clds = matrix(-1, nrow=noco, ncol=0) 
    if(nocl==2) clds = t(t(apply(clm, 1, diff)))
    if(nocl >2) clds =   t(apply(clm, 1, diff))
    rownames(clds)   = rownames(clm)
  } else    {
    cat("In make_smcs_clds. Decided not to proceed as matrix seems to be transposed.\n");
    browser();
  }
  if(length(clds)>0 & !neg_cldok) {
    if(range(clds)[1]==0) {cat("In make_smcs_clds. Error, shouldn't have cluster distances of 0.\n"); if(objects$flags$DEBUG>2){browser();}}
    if(range(clds)[1]< 0) {cat("In make_smcs_clds. Error, can't have negative cluster distances.\n");             browser(); } 
  }
  return_val = list(smcs, clds)
  names(return_val) = c("smcs", "clds")
  return(return_val)
}

set_start_points=function(to_use=c(1,4))
{
  #These are 'start points', '3clqs' is the quantiles of the data to initialise 3 class centres
  stpt1    = list("type"="clever", "cl3qs"=NULL, "genqs"= NULL, "maximise"=T, "bot_q"=NULL , "top_q"=NULL, "previous"=NULL)
  stpt2    = list("type"="user"  , "cl3qs"=NULL, "genqs"= NULL, "maximise"=T, "bot_q"=NULL , "top_q"=NULL, "previous"=NULL)

  stpt3    = list("type"="naive" , "cl3qs"=c(0.01 , 0.5 , 0.99 ), "genqs"="broad"   , "maximise"=F, "bot_q"=0.01  , "top_q"=0.99  , "previous"=NULL)
  stpt4    = list("type"="naive" , "cl3qs"=c(0.01 , 0.2 , 0.99 ), "genqs"="broad"   , "maximise"=T, "bot_q"=0.01  , "top_q"=0.99  , "previous"=NULL)
  stpt5    = list("type"="naive" , "cl3qs"=c(0.01 , 0.80, 0.99 ), "genqs"="vbroad"  , "maximise"=F, "bot_q"=0.001 , "top_q"=0.999 , "previous"=NULL)
  stpt6    = list("type"="naive" , "cl3qs"=c(0.001, 0.01, 0.999), "genqs"="vvbroad" , "maximise"=F, "bot_q"=0.0001, "top_q"=0.9999, "previous"=NULL)
  stpt7    = list("type"="naive" , "cl3qs"=c(0.03 , 0.5 , 0.9  ), "genqs"="moderate", "maximise"=T, "bot_q"=0.03  , "top_q"=0.97  , "previous"=NULL)
  stpt8    = list("type"="naive" , "cl3qs"=c(0.1  , 0.5 , 0.85 ), "genqs"="tight"   , "maximise"=F, "bot_q"=0.1   , "top_q"=0.9   , "previous"=NULL)
  
  all_stpts        = list( stpt1 ,  stpt2 ,  stpt3 ,  stpt4 ,  stpt5 ,  stpt6 ,  stpt7 ,  stpt8)
  names(all_stpts) = list("stpt1", "stpt2", "stpt3", "stpt4", "stpt5", "stpt6", "stpt7", "stpt8")

  stpts = list()
  for(i in 1:length(to_use))
      stpts[[i]] = all_stpts[[to_use[i]]]
  return(stpts)
}

make_new_start_priors=function(opriors, del_class)
{
  newcl_priors = opriors
  return(newcl_priors)
}

make_new_start_pars=function(opars, del_class, model_pdisease)
{
  newcl_pars       = opars
  newcl_pars$nocl  = opars$nocl -1
  newcl_pars$anocl = opars$anocl-1
  if( del_class==1) {
    newcl_pars$smc  = opars$smc+opars$cld[,1] #smc is a vector, cld is a matrix
    newcl_pars$cld  = opars$cld[,-c(1), drop=F]
  } else            {
    newcl_pars$smc  = opars$smc
    newcl_pars$cld  = opars$cld[,-c(del_class-1), drop=F]
  }
  newcl_pars$clv   = opars$clv[  ,-c(del_class), drop=F]
  newcl_pars$hkclv = opars$hkclv[,-c(del_class), drop=F]
  newcl_pars$hkclm = opars$hkclm[,-c(del_class), drop=F]
 #cat("Check that hkclm is compatible with smc+cld\n"); browser();
  #noco stays the same
  newcl_pars$gnfp$gnf_ws     = make_new_start_gnf(oldgnf=opars$gnfp$gnf_ws    , del_class=del_class)
  newcl_pars$gnfp$gnf_lambda = make_new_start_gnf(oldgnf=opars$gnfp$gnf_lambda, del_class=del_class)
  newcl_pars$gnfp$gnf_controls = make_control_freqs(objects=NULL, pop_freqs    =newcl_pars$gnfp$gnf_lambda  , new=F, betas=newcl_pars$betas, model_pdisease=model_pdisease)
  newcl_pars$gnfp$gnf_cases    =    make_case_freqs(objects=NULL, pop_freqs=newcl_pars$gnfp$gnf_lambda, new=F, betas=newcl_pars$betas)
  return(newcl_pars)
}
# make_new_start_gnf(oldgnf=x, del_class=2)
make_new_start_gnf=function(oldgnf, del_class)
{
  nocl = length(oldgnf)
  if( del_class==1)
    newgnf = c(oldgnf[1]+oldgnf[2], oldgnf[-c(1,2)])
  if( del_class==nocl)
    newgnf = c(oldgnf[-c(nocl-1,nocl)], oldgnf[nocl-1]+oldgnf[nocl])
  if( del_class!=1 & del_class!=nocl) {
    newgnf    = oldgnf[-c(del_class)]
    newgnf[del_class-1] = newgnf[del_class-1] + oldgnf[del_class]/2
    newgnf[del_class  ] = newgnf[del_class]   + oldgnf[del_class]/2
  }
  return(newgnf)
}

last_moves=function(model, last_iter, iter, mvbp, hmvbp, uprand)
{
    if(model=="simple" & iter == last_iter-6)     uprand = ( mvbp[3 ] +  mvbp[4 ])/2 #Cluster Means
    if(model=="simple" & iter == last_iter-5)     uprand = ( mvbp[2 ] +  mvbp[3 ])/2 #Cluster Variances
    if(model=="simple" & iter == last_iter-4)     uprand = ( mvbp[10] +  mvbp[11])/2 #Combined Allele Frequencies
    if(model=="simple" & iter == last_iter-3)     uprand = ( mvbp[3 ] +  mvbp[4 ])/2 #Cluster Means
    if(model=="simple" & iter == last_iter-2)     uprand = ( mvbp[2 ] +  mvbp[3 ])/2 #Cluster Variances
    if(model=="simple" & iter == last_iter-1)     uprand = ( mvbp[10] +  mvbp[11])/2 #Combined Allele Frequencies
    if(model=="hier_nocl_choice" & iter == last_iter-6)     uprand = ( mvbp[3 ] +  mvbp[4 ])/2 #Cluster Means
    if(model=="hier_nocl_choice" & iter == last_iter-5)     uprand = ( mvbp[2 ] +  mvbp[3 ])/2 #Cluster Variances
    if(model=="hier_nocl_choice" & iter == last_iter-4)     uprand = ( mvbp[10] +  mvbp[11])/2 #Genotype Frequencies
    if(model=="hier_nocl_choice" & iter == last_iter-3)     uprand = ( mvbp[3 ] +  mvbp[4 ])/2 #Cluster Means
    if(model=="hier_nocl_choice" & iter == last_iter-2)     uprand = ( mvbp[2 ] +  mvbp[3 ])/2 #Cluster Variances
   #if(model=="hier_nocl_choice" & iter == last_iter-2)     {debug(update_params); debug(soft_clmoment_estimate); browser();}
    if(model=="hier_nocl_choice" & iter == last_iter-1)     uprand = ( mvbp[10] +  mvbp[11])/2 #Genotype Frequencies
    if(model=="no_association" & iter == last_iter-4)   uprand = ( mvbp[3 ] +  mvbp[4 ])/2 #Cluster Means
    if(model=="no_association" & iter == last_iter-3)   uprand = ( mvbp[2 ] +  mvbp[3 ])/2 #Cluster Variances
    if(model=="no_association" & iter == last_iter-2)   uprand = (hmvbp[6 ] + hmvbp[7 ])/2 #Genotype frequencies
    if(model=="no_association" & iter == last_iter-1)   uprand = (hmvbp[6 ] + hmvbp[7 ])/2 #Genotype frequencies
    assoc = model=="full_model" | model=="full_no_hierarchy"
    if(assoc & iter == last_iter-8)       uprand = ( mvbp[3 ] +  mvbp[4 ])/2 #Cluster Means
    if(assoc & iter == last_iter-7)       uprand = ( mvbp[2 ] +  mvbp[3 ])/2 #Cluster Variances
    if(assoc & iter == last_iter-6)       uprand = (hmvbp[6 ] + hmvbp[7 ])/2 #Genotype frequencies
    if(assoc & iter == last_iter-5)       uprand = (hmvbp[3 ] + hmvbp[4 ])/2 #Betas
    if(assoc & iter == last_iter-4)       uprand = (hmvbp[6 ] + hmvbp[7 ])/2 #Genotype frequencies
    if(assoc & iter == last_iter-3)       uprand = (hmvbp[3 ] + hmvbp[4 ])/2 #Betas
    if(assoc & iter == last_iter-2)       uprand = (hmvbp[6 ] + hmvbp[7 ])/2 #Genotype frequencies
    if(assoc & iter == last_iter-1)       uprand = (hmvbp[3 ] + hmvbp[4 ])/2 #Betas
  return(uprand)
}

# Function which takes in the best model fit as decided by BIC. 
# The idea is to merge classes that (when merged) don't give rise to multi-modal density functions. (Proposed by Chris Holmes)
# This helps account for Batch effects and other 'bumps in the tails' and more generally - skewed distributions.
# Get plots by simply adding 'model_fits', get posterior class assignments by simply adding those as well. Can't get a mean/var version of merged models.
# source("cnv_caller.R"); mat = matrix(rnorm(3e4, 0, 1), nrow=10, ncol=3000); mat[,501:1000] = mat[,501:1000] + 2.3; mat[,1001:2000] = mat[,1001:2000] + 1.1; mat[,2001:3000] = mat[,2001:3000] + 0.6; rv = analyse_data(dat_matrix=mat, DEBUG=1.71, nocls=6:4); fit = rv$best_fit; plotd(fit, no_bars=30, new_plot=T)
# source("cnv_caller.R"); fit = post_bic_simple_merge(fit=fit, pars=fit$opars, mode_counter="simple_nc") 
# source("cnv_caller.R"); plotd(objects=fit, dens_vals = fit$mdens_vals, model_fits = fit$merged_fits, plot_combined=F) 
post_bic_simple_merge=function(fit, pars, mode_counter="simple_nc", dens_res=100, new=F, combined=T, DEBUG=1) #, model_fits=NULL, merges=NULL)
{
  nocl        = fit$opars$nocl
  noco        = fit$opars$noco
  fit$merged_fits  = NULL
  if(nocl==1) {fit$merged_fits  = NULL; return(fit)}
  ##Currently I combine the model fits to decide which components to merge - but I need to keep them separated when I merge them
  md_rv          = make_fit_densities(objects=fit, pars=fit$opars,  combined=combined, coll="all", new=new, dens_res = dens_res, externalDEBUG=DEBUG)
  md_model_fits  = md_rv$model_fits
  md_dens_vals   = md_rv$dens_vals
  model_fits = as.list(rep(NA, noco))
  dens_vals  = as.list(rep(NA, noco))
  for(coll in 1:noco)
  {
    rv                 = make_fit_densities(objects=fit, pars=fit$opars,  combined=F, coll=coll, new=new, dens_res = dens_res, externalDEBUG=DEBUG)
    model_fits[[coll]] = rv$model_fits
    dens_vals [[coll]] = rv$dens_vals
  }

  fit$mdens_vals = dens_vals
  psbl_merge  = rep(F  , nocl-1) #This records the q-score for the kth class and the(k+1)th class
  names(psbl_merge) = 1:length(psbl_merge)
  finished    = F
  merged_nocl = nocl
  md_merged_mfs  = md_model_fits
  merged_mfs     = model_fits
  fit$merges  = list()
  fit$relabelled_classes  = 1:nocl; names(fit$relabelled_classes) = 1:nocl
  fit$merged_nocl = nocl
  while(!finished & merged_nocl>1)
  {
    for(cl in 2:merged_nocl)
    {
      adcl = cl-1 #adcl stands for 'adjacent class' the idea is to see if these two classes, merged, give rise to a (roughly) unimodal distribution
      if(mode_counter == "simple_nc") should_merge = whether_to_merge(density1=md_merged_mfs[paste("cl", cl, sep=""),], density2=md_merged_mfs[paste("cl",adcl, sep=""),])
          #par(mfcol=c(2,2)); x = md_model_fits; plot(x[1,], type="l"); plot(x[2,], type="l"); plot(x[3,], type="l"); plot(x[1,]+x[2,]+x[3,], type="l")
      if(should_merge) {
        merged_nocl                  = merged_nocl - 1
        this_merge                   = c(adcl, cl)
        fit$merges                   = c(fit$merges, list(this_merge))
        md_merged_mfs                = merge_two_comps(comp_mat=md_merged_mfs, cind1=cl, cind2=adcl)
        fit$opars$hkclm              = matrix(rep(NA, merged_nocl*noco), nrow=noco, ncol=merged_nocl)
        fit$opars$hkclv              = matrix(rep(NA, merged_nocl*noco), nrow=noco, ncol=merged_nocl)
        fit$opars$clv                = matrix(rep(NA, merged_nocl*noco), nrow=noco, ncol=merged_nocl)
        fit$opars$cld                = matrix(rep(NA, (merged_nocl-1)*noco), nrow=noco, ncol=merged_nocl-1)
        fit$opars$smc                = rep(NA, noco)
        fit$merged_nocl              = merged_nocl
        fit$opars$nocl               = merged_nocl
        fit$relabelled_classes       = update_class_labels(fit$relabelled_classes, merge = this_merge, orig_nocl=nocl)
        for(group in 1:length(fit$opars$gnfp))
        {
          tmp = fit$opars$gnfp[[group]]; tmp[adcl] = tmp[adcl]+tmp[cl]; tmp = c(tmp[1:adcl], tmp[-(1:cl)]);
          fit$opars$gnfp[[group]] = tmp
        }
        for(coll in 1:noco)
        {
          #merged_class                 = (merged_mfs[[coll]][cl,, drop=F] + merged_mfs[[coll]][adcl,, drop=F])
          #merged_mfs[[coll]]           = merged_mfs[[coll]][-cl,, drop=F]
          #merged_mfs[[coll]][adcl,]    = merged_class
          #rownames(merged_mfs[[coll]]) = paste("cl", 1:nrow(merged_mfs[[coll]]), sep="")
          merged_mfs[[coll]]           = merge_two_comps(comp_mat=merged_mfs[[coll]], cind1=cl, cind2=adcl)
          fit$merged_fits[[coll]]      = merged_mfs[[coll]]
        }
        break()
      } else finished = T
    }
  }
  if(length(unique(fit$relabelled_classes))!=fit$merged_nocl) {cat("  WARNING! Merged number of classes doesn't agree with relabelling.\n"); browser();}
  if(length(fit$merged_fits)==0) fit$merged_fits = NULL #fit$merged_fits = "no_merges"
  return(fit)
}

merge_two_comps=function(comp_mat, cind1, cind2)
{
  merged_class       = comp_mat[ cind1,, drop=F] + comp_mat[cind2,, drop=F]
  comp_mat           = comp_mat[-cind1,, drop=F]
  comp_mat[cind2,]   = merged_class
  rownames(comp_mat) = paste("cl", 1:nrow(comp_mat), sep="")
  return(comp_mat)
} 

demo_merging=function()
{
# pdf(file="simple_merge.pdf"   ); plotd(objects=fit, new_plot=T, plot_combined=F);               plotd(objects=fit, dens_vals = fit$mdens_vals, model_fits = fit$merged_fits, plot_combined=F, new_plot=F              ); dev.off()
# pdf(file="7219_unmerged.pdf", width=20, height=15); plotd(objects=fit, new_plot=T, plot_combined=T, pcolls=names(sample_names));dev.off()
# pdf(file="7219_merged.pdf"  , width=20, height=15); plotd(objects=fit, dens_vals = fit$mdens_vals, model_fits = fit$merged_fits, plot_combined=T, new_plot=T, pcolls=names(sample_names)); dev.off()
  png("without_merges.png")
  plotd(objects=fit)
  dev.off()
  png("with_merges.png")
  source("cnv_caller.R"); fit = post_bic_simple_merge(fit=fit, pars=fit$opars, mode_counter="simple_nc");  plotd(objects=fit, dens_vals = fit$mdens_vals, model_fits = fit$merged_fits)
  dev.off()
}

whether_to_merge=function(density1, density2, second_peak_length=0) #Metrics (HWE, posterior)
{
  # bad_posterior  =     # If this is very bad should relax merge condition
  # good_posterior =     # If this is very good may not need to merge at all
  # very_low_gnf   =     # If this is very low then class may not be being used to should merge it out
  # bad_HWE        =     # If this is very bad may indicate artifact, so should relax merge condition
  merge = nc_is_unimodal(density1=density1, density2=density2, second_peak_length=second_peak_length)
  return(merge)
}

nc_is_unimodal=function(density1, density2, second_peak_length=0)
{
  totd          = density1 + density2 #the total density (ie. the sum of the two input densities)
  dtd           = diff(totd)
  first_dip     = which(dtd<0)[1]                          # Not Very robust identification of first negative slope in density
  if(is.na(first_dip))         return(TRUE)
  if(first_dip == length(dtd)) return(TRUE)
  is_unimodal   = sum(dtd[(first_dip+1):length(dtd)]>0)==second_peak_length # Not Very robust check of any later increases
  return(is_unimodal)
}

update_class_labels=function(labels, orig_nocl, merge)
{
  # labels = 1:7; names(labels)=labels; nocl=max(labels); merge=c(2,3); 
  # labels = update_class_labels(labels=labels, orig_nocl=nocl, merge=merge)
  check = sum(names(labels)==(1:orig_nocl))==orig_nocl
  if(!check) cat("May have a bug in class relabelling script.\n");
  crnt_labels = unique(labels)
  new_labels  = crnt_labels;
  new_labels[merge[2]] = new_labels[merge[1]]
  labels[which(labels==crnt_labels[merge[2]])] = crnt_labels[merge[1]]
  return(labels)
}

# source("/data/garganey/cardin/postdoc/CNVs/calling/function_lib_local.R")
merge_calls=function(calls, relabelled_classes, preamble = c("chr", "cnv_id", "pos", "nocl"), return_mat=F, ind_names=NULL)
{
  # relabelled_classes is a vector of the form c("1"=1, "2"=1, "3"=3, "4"=3, "5"=5, "6"=6), representing which class each of those original classes was merged into
  if(length(relabelled_classes)==0) return(calls)
  if(is.null(names(calls))) names(calls)[1:4] = preamble
  legend       = calls[preamble] #legend is the leading rows of the calls-line (a 4+(nocl*no_inds) vector)
  new_legend   = legend       
  nocl         = calls["nocl"]; #calls[which(preamble=="nocl")]
  calls_core   = calls[-(1:length(preamble))]
  calls_mat    = matrix(as.numeric(calls_core), ncol = as.numeric(nocl), byrow=T)
  if(!is.null(ind_names)) rownames(calls_mat) = ind_names
  new_classes  = unique(relabelled_classes)
  new_nocl     = length(new_classes)
  new_legend["nocl"] = new_nocl
  merged_calls = matrix(NA, nrow=nrow(calls_mat), ncol=new_nocl)
  for(i in 1:new_nocl)
  {
    wanted_columns   = which(relabelled_classes==new_classes[i]) #Pull out the columns in the calls matrix to be merged into this class
    merged_calls[,i] = rowSums(calls_mat[,wanted_columns, drop=F])  # Add together the posterior assignments to these classes to get the total in the merged class
  }
  if(return_mat) return(merged_calls)
  new_calls = c(new_legend, as.vector(t(merged_calls)))
  return(new_calls)
}
# relabelled_classes = c(1,1,2,2,5); nocl=length(relabelled_classes); calls_mat = make_diagnostic_calls(nocl=nocl); calls = c("chr"=2, "cnv_id"="test", "pos"=15, "nocl"=nocl, as.vector(t(calls_mat)));
# merged_calls = merge_calls(calls=calls, relabelled_classes=relabelled_classes, return_mat=T); print(merged_calls)

make_diagnostic_calls=function(nocl=5, no_inds=8)
{
  calls_mat = matrix(as.numeric(NA), nrow=no_inds, ncol=nocl)
  for(i in 1:ncol(calls_mat))
  {
    calls_mat[,i] = 1:no_inds * 1*10^(-i)
  }
  return(calls_mat)
}

calc_q_score=function(mean1, mean2, var1, var2)
{
  qscore = abs(mean1-mean2)/abs(sqrt(var1)-sqrt(var2))
  return(qscore)
}

# rv = make_fit_densities(objects=objects, combined=combined, coll=coll, new=new); model_fits = rv$model_fits; dens_vals  = rv$dens_vals  
make_fit_densities=function(objects, pars=NULL, combined=F, coll=NULL, new=F, dens_res = 1000, no_inds_vec=NULL, externalDEBUG=1)
{
  # If the collections are not being combined (controlled by 'combined') then 
  # now identify collections by name, trying to ensure that here (even behaving consistently for old code that supplies indices)
  if(!combined) {
    if(coll %in% colnames(objects$dat)) {
      collName=coll 
    } else {
      numericCollcheck = coll %in% 1:ncol(objects$dat)
      if(!numericCollcheck) {
        cat("  Warning, can't identify required collection in make_fit_densities.\n")
        if(objects$flags$DEBUG>1) browser()
      }
      collName=colnames(objects$dat)[coll]
    }
  }
  # Temporary debugging code - to understand why this code _doesn't_ break...
  if(externalDEBUG>=3) browser()
  noco      = objects$opars$noco
  nocl      = objects$opars$nocl
  if(is.null(pars) & !new) pars = objects$opars
  if(is.null(pars) &  new) pars = objects$npars
  if(is.null(no_inds_vec)) no_inds_vec = colSums(objects$dat)
  gnf_lambda = pars$gnfp$gnf_lambda; gnf_controls = pars$gnfp$gnf_controls; gnf_cases = pars$gnfp$gnf_cases; 
  grid_vals = as.numeric(rownames(objects$dat))
  min_dat   = min(min(grid_vals))
  max_dat   = max(max(grid_vals))
  dens_vals = ((0:dens_res)/dens_res)*(max_dat-min_dat)+min_dat
  model_fits = matrix(NA, nrow=nocl, ncol=length(dens_vals))
  if(is.null(objects$flags$signal_model)) objects$flags$signal_model="normal"
  if(combined) 
  {
    clm           = colMeans(pars$hkclm)  
    avg_clv       = colMeans(pars$hkclv)  
    for(cl in 1:pars$nocl)
    {
      if(objects$flags$signal_model=="normal")
        model_fits[cl,] = dnorm(dens_vals      , mean=clm[cl], sd=sqrt(avg_clv[cl])       )
      if(objects$flags$signal_model=="t8")
        model_fits[cl,] = my_dt(dens_vals, df=8, mean=clm[cl], sd=sqrt(avg_clv[cl]), log=F)
      if(objects$flags$signal_model=="t")
        model_fits[cl,] = my_dt(dens_vals, df=objects$flags$deg_free, mean=clm[cl], sd=sqrt(avg_clv[cl]), log=F)
      model_fits[cl,] = model_fits[cl,] * gnf_lambda[cl] # this looks right, as this is COMBINED collections
    }
  } else {
    clm           = make_clm(smcs=pars$smc, clds=pars$cld, noco=noco, nocl=nocl) 
    for(cl in 1:pars$nocl)
    {
      if(objects$flags$signal_model=="normal")
        model_fits[cl,] = dnorm(dens_vals,       mean=pars$hkclm[collName,cl], sd=sqrt(pars$hkclv[collName,cl])       )
      if(objects$flags$signal_model=="t8")
        model_fits[cl,] = my_dt(dens_vals, df=8, mean=pars$hkclm[collName,cl], sd=sqrt(pars$hkclv[collName,cl]), log=F)
      if(objects$flags$signal_model=="t")
        model_fits[cl,] = my_dt(dens_vals, df=objects$flags$deg_free, mean=pars$hkclm[collName,cl], sd=sqrt(pars$hkclv[collName,cl]), log=F)
      case        = objects$assoc$case_colls[collName]==1
      if(!case) coll_gfreqs = gnf_controls
      if( case) coll_gfreqs = gnf_cases
      model_fits[cl,] = model_fits[cl,] * coll_gfreqs[cl]
    }
  }
  rownames(model_fits) = paste("cl", 1:nrow(model_fits), sep="");  colnames(model_fits) = NULL
  rv = list("dens_vals" = dens_vals, "model_fits"=model_fits)
  return(rv)
}

    


pick_filename=function(filetag, add_run_label=F)
{
  fn       = paste(filetag, ".txt",sep="")
  found_fn = F
  num      = 1;
  while(!found_fn & add_run_label)
  {
    fn = paste(filetag, num, ".txt",sep="")
    if( file.exists(fn)) {num=num+1}
    if(!file.exists(fn)) {found_fn=T; break();}
  }
  return(fn)
}

#This function is designed to find out the number of CNVs 'successfully' called in the current set of calls by counting lines in call-summary files
get_no_cnvs=function(csmry_fn, max_cnv=NULL)
{
  if(is.null(csmry_fn)) {cat("  Warning - no filename passed to get_no_cnvs!\n"); browser()}
  wc_com       = paste("wc ", csmry_fn)
  wc_rv        = strsplit(system(wc_com, intern=T), split=" ")[[1]]
  no_cnvs      = wc_rv[which(sapply(wc_rv, nchar)>0)][1]
  no_cnvs      = min(as.numeric(max_cnv), as.numeric(no_cnvs))
  return(no_cnvs)
}


# This function is an R equivalent of fgrep -n as you might use it for finding the lines numbers for lines that contain a pattern in a file
getLineNum=function(pattern, file, verbose=1)
{
 #fgrepcom = paste("fgrep -n -w ", pattern, file, sep=" ")
  fgrepcom = paste("fgrep -n ", "'", pattern, "'", file, sep=" ")
  fgrepOut = system(fgrepcom, intern=T)
  if(length(fgrepOut)==0) {
    if(verbose>=1) cat("Couldn't find this CNV, sorry (maybe there are no calls - no probes on chip?)\n");
    lineNum=NULL
  } else 
    lineNum  = as.numeric(strsplit(fgrepOut, ":")[[1]][1])
  return(lineNum)
}


getAlfFromCounts=function(counts)
{
  if(length(counts)>3) {if(verbose>1) cat("  Multi-allelic not implemented.\n"); return(NA)}
  if(length(counts)==1) return(1)
  ## When only two types are present assume major class is homozygous (as otherwise badly out of HWE)
  if(length(counts)==2) 
    counts = completeGenoCounts(counts=counts)

  ## Should come through to here regardless of whether there were two or three counts originally
  if(length(counts)==3) {
    numAllele0 = sum(2*counts[1] +   counts[2])
    numAllele1 = sum(  counts[2] + 2*counts[3])
    freq       = numAllele1/(numAllele1+numAllele0)
    return(freq)
  }
  cat("  Should not be here. Unhandled exception.\n")
  stop();
}

completeGenoCounts=function(counts, verbose=1, DEBUG=1)
{
  # Reject calls made with >3 genotypes as this cannot be a two allele system
  if(length(counts)>3) {if(verbose>1) cat("  Multi-allelic not implemented.\n"); return(NA)}

  #Unfortunately this situation is somewhat ambiguous - don't know which way you're homozygous
  if(length(counts)==1) return(c(1,0,0)) 

  ## When only two types are present assume major class is homozygous (as otherwise badly out of HWE)
  if(length(counts)==2) {
    majorClass = which.max(counts)
    if(majorClass==1) counts = c(counts, 0)
    if(majorClass==2) counts = c(0, counts)
  }
  ## Should come through to here regardless of whether there were two or three counts originally
  if(length(counts)==3) {
    return(counts)
  }
  if(length(counts)==0) {cat("  Null counts object supplied.\n"); if(DEBUG>1) browser(); return(NA)}
  cat("  Should not be here. Unhandled exception.\n")
  stop();
}


simdat_names=function(easy=F)
{
  if(easy) {
    simdat_tags     = c("easy_noassoc", "easy_varbeta")
    simdat_dates    = c("2009-05-26"  , "2009-05-26"  )
  } else   {
    simdat_tags     = c("noassoc2"  , "varbeta2"  , "varbeta_smallcoll2", "varbeta_smallmgf2")
    simdat_dates    = c("2009-05-26", "2009-05-26", "2009-05-26"        , "2009-05-26"       )
  }
  return(list("simdat_tags"=simdat_tags, "simdat_dates"=simdat_dates))
}

sim_exps=function()
{
  #exps = experiments. nh = no hierarchy (but there are two workarounds: independent and combined collections)
  exp_names              = c("full_model", "nh1_no_priors", "nh2_comb_colls", "no_null", "normal_signal")
  exps                   = as.list(rep(NA, length(exp_names))); names(exps) = exp_names 
  exps$full_model[1]     = "unused_par=NA"
  exps$nh1_no_priors[1]  = "use_priors=F"
  exps$nh2_comb_colls[1] = "combine_colls=T"
  exps$no_null[1]        = "use_null=F"
  exps$normal_signal[1]  = "signal_model=\"normal\""
  return(exps)
}

# genFreqs_from_fit(fit=best_fit)
genFreqs_from_fit=function(fit)
{
  gncs = genCounts_from_fit(fit=fit)
  gnfs = gncs; 
  for(i in 1:nrow(gncs)) gnfs[i,] = gncs[i,]/sum(gncs[i,])
  return(gnfs)
}
# genCounts_from_fit(fit=best_fit)
genCounts_from_fit=function(fit)
{
  noco=fit$opars$noco
  p = fit$oinferred$pagd
  nocl = dim(p)[2]-1
  d = fit$dat  
  if(noco==3) {
    coll1 = colSums(p[,1:nocl,1, drop=F] * d[,1]);
    coll2 = colSums(p[,1:nocl,2, drop=F] * d[,2]);
    coll3 = colSums(p[,1:nocl,3, drop=F] * d[,3]); 
    gncs = matrix(c(coll1, coll2, coll3), ncol=length(coll1), byrow=T); 
    colnames(gncs) = names(coll1); rownames(gncs) = colnames(d)
  }
  if(noco==1) {
    coll1 = colSums(p[,1:nocl,1, drop=F] * d[,1]);
    gncs = matrix(c(coll1), ncol=length(coll1), byrow=T); 
    colnames(gncs) = names(coll1); rownames(gncs) = colnames(d)
  }  
  return(gncs)
}

getGlmBetasFromSimdat=function(total_sim, returnGlm=F)
{
  cnv_types = total_sim$simdat$cnv_types
  response = c(); 
  for(collName in names(cnv_types)) 
    response = c(response, rep(total_sim$sim_pars$case_colls[collName], length(cnv_types[[collName]])))
  genotypes  = unlist(cnv_types)
  gadd  = glm(response~genotypes, family=binomial())
  gnull = glm(response~1, family=binomial())
  # aic = -2 * (log-likelihood)  + 2 * #linear parameters, => logl = -1/2(aic - 2*no_pars) = no_pars - aic/2 #What is no parameters!?
  # bic = likelihood - no_pars*log(no_data_points)
  loglik_add  = 2 -  gadd$aic/2 #The additive model has a mean and an additive parameter
  loglik_null = 1 - gnull$aic/2 #The null model has a mean parameter only
  typesBF  = (loglik_add - loglik_null) - 1*log(length(unlist(cnv_types)))
  trTypesBeta1 = gadd$coefficients["genotypes"]
  if(0) {cat("  Surely there should be SOME difference between the collections ? (look at trTypesBeta)\n"); browser()}
  if(returnGlm) return(gadd)
  rv = c("typesBF"=typesBF, "trTypesBeta1"=trTypesBeta1)
  return(rv)
}

# glm = glmBetasFromFit(fit=best_fit, caseRow=3)
glmBetasFromFit=function(fit, caseRow=NULL, full=T)
{
  gncs = genCounts_from_fit(fit=fit)
  if(is.null(caseRow)) {
    caseRow = nrow(gncs)
    cat("  Currently assuming that bottom collection is case collection.\n")
  }
  controlCounts = colSums(gncs[-caseRow,])
  caseCounts    = gncs[ caseRow,]
  counts        = round(rbind(controlCounts, caseCounts), digits=0)
  rownames(counts) = c("controls", "cases")
  glm           = fitAdditive(counts=counts)
  if(full) return(glm) else return(glm$coefficients)
}

## Author - Damjan Vukcevic (as far as I know, Niall Cardin)
# Given a matrix of genotype counts, fits and returns the additive
# model.  The matrix should look like this:
#
#               AA   AB   BB
#     controls 207 1354 2318
#     cases     86  701 1155
#
fitAdditive <- function(counts)
{
    # If SNP is monomorphic in either cases or controls, cannot estimate
    # effect size.
    if (sum(counts["cases",   ] > 0) <= 1 ||
        sum(counts["controls",] > 0) <= 1  )
        return(NULL)

    # Find which genotypes are observed in the sample.
    obs.geno <- colSums(counts) != 0

    # Get values for model fitting.
    g <- (0:2)[obs.geno] # genotype
    y <- counts["cases",obs.geno]   # number of cases (per genotype)
    n <- colSums(counts)[obs.geno]  # total individuals (per genotype)

    # Fit the additive model.
    glm(y/n ~ g, weights=n, family="binomial")
}

get_sim_dat=function(cnv_index, simdat_tag, arguments)
{
  dat_fn_tag    = get_dir_names(simdat_tag=simdat_tag)$simdat_dir
  this_sim_fn   = get_input_fns(arguments=arguments, cnv_index=cnv_index)$simdat_fn
  load_dat_name = load(this_sim_fn)
  simdat        = total_sim$simdat
  return(simdat)
}

get_sim_data_array=function(cnv_index, simdat_tag, arguments)
{
  simdat        = get_sim_dat(cnv_index=cnv_index, simdat_tag=simdat_tag, arguments=arguments)
  data_array    = simdat$data_array
  return(data_array)
}


get_sim_ung_dat=function(cnv_index, simdat_tag, arguments, pca=T, verbose=F)
{
  data_array    = get_sim_data_array(cnv_index=cnv_index, simdat_tag=simdat_tag, arguments=arguments)
  no_inds_vec   = unlist(apply(data_array, 2, get_no_inds))
  ung_dat       = process_data(data_array=data_array, no_inds=sum(no_inds_vec), keep_range=F, 
                     return_ungridded=T,  grid_density=2, pca=pca, verbose=verbose)$ungridded
  return(ung_dat)
}

#  objects = makesimple_objects()
makesimple_objects=function()
{
  setwd( "/home/markov/cardin/My Documents/postdoc/CNVs/calling/")
  source("cnv_caller.R")
  options(error=recover); 
  DEBUG            = 1.71                  
  arguments        = set_arguments(write_results=F)
  extra_args       = set_up_caller(arguments)
  data_and_details = get_data(      arguments=arguments, extra_args=extra_args, cnv_index=1);
  extra_args$sim_args$case_colls = names(data_and_details$data_array)
  arguments        = data_and_details$arguments;    
  objects          = Initialise(nocl=4, stpt_ind=1, cnv_index=1, extra_args=extra_args, arguments=arguments, data_and_details=data_and_details, model="simple")
  return(objects)
}

#Currently requires a rectangular list
# wo = prep_list_4write(list=arguments) 
prep_list_4write=function(list)
{
  wo1 = sapply(1:length(list), prep_list_obj, list=list)
  wo2 = as.data.frame(wo1)
  wo3 = as.matrix(wo2)
  return(wo3)
}

prep_list_obj=function(index, list)
{
   return(c(names(list)[index], unlist(list[index])))
}

# Augments the global file-tag with the specifics of this simulation (but NOT this CNV unless added as extra) assumes .txt unless stated otherwise.
write_tag_to_fn=function(tag, real_data, seed, verbose=T, extra, signal_model, add_extension=T, filetype="txt", deg_free=NA, results_dir_tag=NULL)
{
  if(is.null(results_dir_tag)) results_dir_tag = "test_calls/"
  results_root         = get_dir_names()$output_dir       # get_dir_names()$output_dir
  if(verbose>=2) cat("Writing results to: ", paste(get_dir_names()$output_dir, results_dir_tag, sep=""), "\n");
  if(signal_model=="t") fn = paste(results_root, results_dir_tag, extra, "_", tag, "_", signal_model, deg_free, "_summary_seed=", seed, sep="")
  if(signal_model!="t") fn = paste(results_root, results_dir_tag, extra, "_", tag, "_", signal_model,           "_summary_seed=", seed, sep="")
  if(add_extension) fn = paste(fn, ".", filetype, sep="")
  return(fn)
}

make_output_dirs=function(real_data, verbose=1, calls="calls/", plots="plots/", pars="pars/", fits="fits/", stpts="stpts",
                          one_ddat="one_ddat/", results_dir_tag=NULL) 
{
  if(is.null(results_dir_tag)) results_dir_tag = "test_calls/"
  results_root         = get_dir_names()$output_dir
  if(substr(results_dir_tag, nchar(results_dir_tag), nchar(results_dir_tag))!="/") results_dir_tag = paste(results_dir_tag, "/", sep="")
  if(verbose>=2) cat("Writing results to: ", paste(get_dir_names()$output_dir, results_dir_tag, sep=""), "\n");
  main_dir     = get_coutput_dirs()$coutput_root
  calls_dir    = get_coutput_dirs()$cd
  plots_dir    = get_coutput_dirs()$plots
  pars_dir     = get_coutput_dirs()$pars 
  fits_dir     = get_coutput_dirs()$fits  
  one_ddat_dir = get_coutput_dirs()$one_ddat
  stpts_dir    = get_coutput_dirs()$stpts   
  if(!file.exists(main_dir    )) dir.create(main_dir    , showWarnings = FALSE)
  if(!file.exists(calls_dir   )) dir.create(calls_dir   , showWarnings = FALSE)
  if(!file.exists(one_ddat_dir)) dir.create(one_ddat_dir, showWarnings = FALSE)
  if(!file.exists(plots_dir   )) dir.create(plots_dir   , showWarnings = FALSE)
  if(!file.exists(pars_dir    )) dir.create(pars_dir    , showWarnings = FALSE)
  if(!file.exists(fits_dir    )) dir.create(fits_dir    , showWarnings = FALSE)
  if(!file.exists(stpts_dir   )) dir.create(stpts_dir   , showWarnings = FALSE)
  return(c("main_dir"=main_dir, "calls_dir"=calls_dir, "plots_dir"=plots_dir, "pars_dir"=pars_dir, "fits_dir"=fits_dir, "one_ddat_dir"=one_ddat_dir, "stpts_dir"=stpts_dir))
}


quant_to_grid_val=function(quantile, objects)
{
  if(quantile>1) {
    cat("In quant_to_grid_val. Input quantile >1 which makes no sense.\n")
    quantile=1;
    if(objects$flags$DEBUG>2) browser();
  }
  grid_vals  = as.numeric(rownames(objects$dat))  
  no_inds    = sum(objects$dat)
  dat2       = rowSums(objects$dat)
  grid_index = which(cumsum(dat2) > quantile*no_inds)[1]
  grid_index = max(1, grid_index)
  grid_index = min(length(grid_vals), grid_index)
  return(grid_vals[grid_index])
}


initialise_clm=function(objects, bot_q, top_q, equal=T, nocl, style=NULL)
{
     clm       = rep(-1, nocl)
     if(nocl>1)
     {
       clm[1]    = quant_to_grid_val(quantile = bot_q, objects)
       clm[nocl] = quant_to_grid_val(quantile = top_q, objects)
       spacing   = (clm[nocl] - clm[1])/(nocl-1)
       for(cl in 2:(nocl-1))
         clm[cl] = clm[1] + spacing*(cl-1)
     } else
     {
       clm[1]    = 0
     }
     if(is.null(style)) 
     {
       cat("In set_stpt1. Warning, specific stpt type not set.\n"); 
       if(objects$flags$DEBUG>2) browser();
     }
  clm = matrix(clm, nrow=1, ncol=nocl, dimnames=list(c("comb_colls"), paste(rep("cl", nocl), 1:nocl)))  
  check_clm(objects=objects, smcs=NULL, dsts=NULL, in_clm=clm, move="initialise_clm", cur=T, average=T, smc_min_val=0.055, extra_added=T)
  return(clm)
}

standardise_names=function(nms, verbose=0.5) {
  if(length(grep(".",nms[1], fixed=T))>0) {
    split    = strsplit(nms, split=".", fixed=T)
    #nms2     = t(as.matrix(data.frame(split)))# Old method, for comparison
    coll     = sapply(split, '[[', 1)
    ccc_name = sapply(split, '[[', 2)
    nms2     = cbind(coll, ccc_name)
  } else {
    if(verbose>=1) cat("Can't help you here, the names seem fine already.\n");
    rv = cbind(rep(NA, length(nms)), nms); colnames(rv) = c("coll", "ccc_name")
    return(rv)
  }
  return(nms2)
}


sim_cnv_types=function(beta0, beta1, hpriors, sim_pars, nocl, 
                       noco, gnf_lambda=NULL, gnf_controls, gnf_cases
                      )
{
  # In this model: D denotes dsiease status (reflects a 'prospective' likelihood/perspective of the study)
  # P(D|Z,B) Bin(1, p), p = exp(B0 + B1*Z)/(1+exp(B0 + B1*Z)).
  # dm_p = (disease_model) the binomial probability of someone having disease status (with the above model)
  # Z = the number of 'genotypic' copies at this locus.
  Z     = 0:(nocl-1)
  dm_p  = exp(beta0 + beta1*Z)/(1+exp(beta0 + beta1*Z))
  #dg_zb_0 = dbinom(0, size=1, prob=dm_p) #This is the probability of being a CONTROL for each copy number value
  # P(Zi | D, B) (proportional to P(D|Zi,B)*P(Zi))  
  cnv_types        = as.list(rep("", noco))
  names(cnv_types) = makeDefaultCollnames(noco=length(cnv_types))
  names(sim_pars$no_inds) = names(cnv_types)
  for(collName in names(cnv_types))
  {
    #controls
    if(!sim_pars$case_colls[collName])
    {
      no_inds   = sim_pars$no_inds[collName]
     #freqs_mat = matrix(rep(gnf_lambda  , no_inds), nrow=no_inds, byrow=T);
      freqs_mat = matrix(rep(gnf_controls, no_inds), nrow=no_inds, byrow=T);
      cnv_types[[collName]] = apply(X=freqs_mat, MARGIN=1, FUN=my_rmultinom)
    }
    #cases
    if( sim_pars$case_colls[collName])
    {
      no_inds        = sim_pars$no_inds[collName]
     #case_freqs     = (gnf_lambda * dm_p)/sum(gnf_lambda * dm_p)
     #case_freqs_mat = matrix(rep(case_freqs, no_inds), nrow=no_inds, byrow=T);
      case_freqs_mat = matrix(rep(gnf_cases, no_inds), nrow=no_inds, byrow=T);
      cnv_types[[collName]] = apply(X=case_freqs_mat, MARGIN=1, FUN=my_rmultinom)
    }
  }
  return(cnv_types)
}




##### Damjan's code for simulating case control genotypes (designed for SNPs) #####
# inverse of logit function
expit <- function(l)
    1 / (1 + exp(-l))
# randomly sample SNPs
sample.SNP <- function( maf, log.odds.ratio=0, mu=-5,
                        n.cases=2000, n.controls=2000 )
{
    n <- n.cases + n.controls
    p0 <- expit(mu)
    p1 <- expit(mu + log.odds.ratio)
    maf.cases <- p1*maf / (p0*(1-maf) + p1*maf)
    alleles.controls <- sample( 0:1, 2*n.controls, replace=TRUE, c( 1-maf, maf             ) )
    alleles.cases    <- sample( 0:1, 2*n.cases   , replace=TRUE, c( 1-maf.cases, maf.cases ) )
    # sampling genotypes
    genotypes.controls <- colSums(matrix( alleles.controls, 2 ))
    genotypes.cases    <- colSums(matrix( alleles.cases,    2 ))
    # allele counts (with a hack to make it work with zero counts)
    a <- rbind( cases   =table(c(genotypes.cases,   0:2)),
                controls=table(c(genotypes.controls,0:2)) ) - 1
    colnames(a) <- c("AA","AB","BB")
    return(a)
}

# This function takes in a value x and returns T/F with:
# If x is 0, NA, NaN, NULL or FALSE then FALSE is returned - if x is TRUE or a positive number then TRUE is returned.
testVal=function(x, fussy=FALSE)
{
  ## Check for multiple values - these will not be dealt with here.
  if(length(x)>1) {
    warning("  Trying to test object with length>1 - only using first element.\n")
    return(testVal(x[[1]]))
  }
  
  # Test for null first as no other test makes sense if x is null
  if(is.null(x)) { 
    return(FALSE)
  } 

  # Next can test for NA and NaN at once as they don't conflict
  if(is.na(x) | is.nan(x))
    return(FALSE)

  # It is unclear what to do with characters - if fussy is true then you get false and a complaint.
  # If fussy is false then characters are checked for obvious cases and true is the default.
  if(is.character(x)) {
    if(fussy) {
      cat("  Warning, tried to test the logical value of a character, returning FALSE.\n")
      return(FALSE)
    } else
    {
      if(x=="FALSE") return(FALSE)
      if(x=="TRUE" ) return(TRUE)
      return(TRUE)
    }
  }

  # Have ascertained that x is not an exceptional case, so can test in the usual way now.
  if(!x) 
    return(FALSE)

  # If fussy is false all other values are treated as true. If fussy is true then test for TRUE and positive integers
  if(!fussy)
    return(TRUE)
  if(fussy)
  {
    if(identical(x, TRUE)) return(TRUE)
    if(is.numeric(x) & x>0) return(TRUE)
    return(FALSE)
  }
}
 
# ung_dat = ungrid_dat(fit$dat);           # hist(ung_dat[[1]], n=100, col="lightgrey")
ungrid_dat=function(grid_dat)
{
   vals    = as.numeric(rownames(grid_dat))
   counts  = grid_dat
   noco    = ncol(grid_dat)
   ung_dat = as.list(rep("", noco))
  #names(ung_dat) = paste(rep("coll", noco), 1:noco, sep="")
   names(ung_dat) = colnames(grid_dat)
   for(coll in 1:noco)
   {
     ung_dat[[coll]] = rep(vals, counts[,coll])
   }
  return(ung_dat)
}

# This function is used to compare variation within and between groups.
# It takes in a named vector of measurements and a two-column matrix which gives pairs of associated measurements
# This is appropriate for many pairs of duplicates - but not for data of just two large groups
calcMAD=function(measurements, duplicateNames, pause=F)
{
  #From Chris Holmes: 
  #I suggest calculating a ratio of MADs (median absolute deviations), say
  # MAD_d / MAD_n
  # Where MAD_d is the MAD of duplicates,
  # MAD_d = median( \{ | x_{i1} – x_{i2} | \}_i )
  # For i = 1,….p duplicate pairs, {x_i1, x_i2} the i’th duplicate pair measurement, 
  # and MAD_n is the MAD across all samples (to the global median).
  
  # To make the score==1 when there's no difference between pairs of duplicates and 
  # arbitrary pairs of samples the measure is now divided by 2.
  
  globalMedian = median(    measurements)
  MADdups      = median(abs(measurements[duplicateNames[,1]] - 
                            measurements[duplicateNames[,2]] )
                       )
  # cor(measurements[duplicateNames[,1]], measurements[duplicateNames[,2]])^2
  MADall       = median(abs(measurements-globalMedian))
  MAD          = MADdups/(2*MADall)
  if(pause) browser()
  return(MAD)
}

# This function makes a matrix of assignment prior probabilities based on the genotype frequencies and 
# the null class proportion (if a null class is being used)
# aprobs = make_aprobs(gnf=NULL, use_null=use_null, null_prop=null_prop, null_freq=ob$gnfp$nullf, use_null_freq=F, noco=noco, gnf_lambda=gnf_lambda)
make_aprobs=function(gnf, use_null, null_prop, null_freq, use_null_freq, noco, gnf_lambda)
{
   if( use_null) {
    #if(!use_null_freq) null_class = rep(null_prop, noco)
    #if( use_null_freq & objects$flags$DEBUG>1) {
    #  cat("Warning. In make_aprobs. Current thinking says to use null_prop, not null_freq.\n");
    #  browser();
    #  null_class = null_freq
    #}
    #aprobs     = rbind(gnf, null_class)
    #rownames(aprobs)[nrow(aprobs)] = "NULL"
    #probs     = apply(aprobs, 2, normalise)
   #aprobs     = c(gnf_lambda, null_prop)
    aprobs     = c(normalise(gnf_lambda, sum=1-null_prop), null_prop)
    names(aprobs)[length(aprobs)] = "NULL"
    probs      = normalise(aprobs)
  } else
  {
     aprobs     = normalise(gnf_lambda)
  }
  return(aprobs)
}

#This function translates old_cnvnames (CNV_v1) <--> old_cnvnames (CNV) using the probe to cnv mapping file (by default is in the global environment)
swap_name=function(new_cnvname=NULL, old_cnvname=NULL, pass_ptcnv=NULL)
{
  if(!is.null(pass_ptcnv)) ptcnv = pass_ptcnv
  if(!is.null(new_cnvname)) return(ptcnv[which(ptcnv[,"CNV"   ]==new_cnvname),"CNV_v1"])
  if(!is.null(old_cnvname)) return(ptcnv[which(ptcnv[,"CNV_v1"]==new_cnvname),"CNV   "])
  cat("Coudln't find an appropriate type of cnv_name\n");
}

# source("function_lib_core.R"); look_in_matrix_of_lists_of_lists(list_matrix=stpt_states, first_level_name="opars", wanted_var="nocl")
getel = function(dat, name) {return(dat[[1]][[name]])}
look_in_matrix_of_lists_of_lists=function(list_matrix, first_level_name="opars", wanted_var="nocl")
{
  tmp         = apply(list_matrix, MARGIN=c(1,2), getel, name=first_level_name)
  wanted_vals = apply(tmp, MARGIN=c(1,2), getel, name=wanted_var)
  return(wanted_vals)
}

summarise_collections=function(sample_names= get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc))
{
  msqc  = read.table(get_samp_fn(), as.is=T, header=T, sep="\t")
  colls_of_interest = c("Gender", "DNAsource", "Cohort")
  smsqc = msqc[,colls_of_interest]
  colls = names(sample_names)
 #coll_summ = as.list(rep(NA, length(colls))); names(coll_summ) = colls
  coll_summ = matrix(NA, nrow=length(colls), ncol=length(colls_of_interest)-1); 
  rownames(coll_summ) = colls; colnames(coll_summ) = colls_of_interest[1:(length(colls_of_interest)-1)]
  for(coll in 1:length(colls))
  {
    this_coll_dat = subset(smsqc, smsqc[,"Cohort"]==colls[coll])
    prop_male     = round(sum(this_coll_dat[,"Gender"   ]=="M"    )/nrow(this_coll_dat), digits=2)
    prop_blood    = round(sum(this_coll_dat[,"DNAsource"]=="Blood")/nrow(this_coll_dat), digits=2)
   #coll_summ[[coll]] = c("prop_male" = prop_male, "prop_blood"=prop_blood)
    coll_summ[ coll,] = c(prop_male, prop_blood)
  }
  summ_fn = paste(get_ann_dir(), "collection_summaries.txt", sep="")
  write.table(format(coll_summ), file=summ_fn, quote=F, row.names=T, col.names=T, sep="\t")
  return(coll_summ)
}

calcAnova=function(simulateData=F)
{
  if(simulateData)
  {
    n = 100
    ndup = 20
    samid = rep(1:n, times = c(rep(2, ndup), rep(1, n - ndup)))
    samfac = as.factor(samid)
    form = as.formula(~ -1 + samfac)
    X = model.matrix(form, model.frame(form, samfac))
    sig = 0
    sigb = 1
    y = X %*% rnorm(n, sd = sig) + rnorm(n + ndup, sd = sigb)
  }
  lm1 = lm(y ~ -1 + samfac)
  summaryValues = anova(lm1)
  return(summaryValues)
}

# confidence = calc_confidence(pagd=best_fit$oinferred$pagd, grid_dat = best_fit$dat)
calc_confidence=function(pagd, grid_dat)
{
  #lpagd =  array(-1, c(grid_size, anocl, noco)) #Remember, this NO LONGER has the counts in each grid included in it
  #grid_vals = as.numeric(rownames(dat))

  confidences     = apply(pagd, MARGIN=c(1,3), max) #Should produce a grid_size*noco matrix of max_posterior_call
  mean_confidence = sum(confidences * grid_dat)/sum(grid_dat)
 #cat("  Check that this calculates the correct mean confidence (maximum posterior call)\n"); browser();
  return(mean_confidence)
}


##Profiling in R
profile_cnv_caller=function(profile_file = "11Dec_profile1.txt")
{
  Rprof(profile_file) 
  source("data_freeze1.R")
  options(warn=1)
  return(summaryRprof(profile_file))
}
# source("cnv_caller.R"); options(error=recover); prof = profile_cnv_caller(); c;

profile_QC_maker=function(max_cnv=100, excl="pearson6.0")
{
  options(error=recover); 
  options(warn=1); 
  Rprof("QCprofile_file.txt"); 
 #source("cnv_caller.R"); 
  calc_call_rates(excl=excl, max_cnv=max_cnv, dbg="_prof")
  Rprof(NULL); 
  profsum = summaryRprof("QCprofile_file.txt")
  return(profsum)
}
# source("cnv_caller.R"); options(error=recover); prof = profile_QC_maker(max_cnv=NULL);
# Rprof("QCprofile_file.txt")        #<--- Give a name to the file that the profiler will create
# calc_call_rates(arguments=10)      #<--- run some function (or source a file) that you want to be profiled
# summaryRprof("QCprofile_file.txt") #<--- Read in the file that the profiler created for you


