# setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling")
# source("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling/post_calling.R")

# get_ncl_cnvs      : INPUT = summary files giving the number of classes inferred for each CNV. OUTPUT = nothing (but passes lists of n-class CNVs to plot finding fn)
# get_specific_plots: INPUT = List of CNVs. OUTPUT = nothing (But copies the plots for these CNVs to new directories (makes those dirs if it needs to))
# join_plots        : INPUT = A directory. OUTPUT = nothing (But lists files and then joins them into chunks of 'joined' plots)
# run_join_plots    : Passes the various things that join_plots needs and runs it over many classes etc.
# mv_joined_plots   : INPUT = Locations of files to be moved. OUTPUT = nothing (But moves the joined-plots to their own directories)


# options(error=recover);  setwd("/users/cardin/CNVs/calling/caller_scripts/"); 
# source("cnv_caller.R"); setups(1); process_calls(fussy=F, concat=F, reordr=F); gc(); gc();
# project_root = "/users/cardin/CNVs/calling/"; source("run_caller.R"); process_calls()
# process_calls(fussy=F, concat=F, smrise=F, reordr=F, srt_smry=F, merge=T, mg_smrise=F, hardc=F, make_QC=F, merged_QC=F, test=F)
pcq=function( concat=F, smrise=F, reordr=F, srt_smry=F, merge=F, mg_smrise=F, hardc=F, make_QC=F, merged_QC=F, test=F,
                merge_statuses=c(F,T), ers=c(F,T), diseases=get_diseases()) 
{
  process_calls(concat=concat, smrise=smrise, reordr=reordr, srt_smry=srt_smry, merge=merge, mg_smrise=mg_smrise, hardc=hardc,
                make_QC=make_QC, merged_QC=merged_QC, test=test,
                merge_statuses=c(T,F), ers=c(F,T), diseases=get_diseases()) 
}


# library(cccpCallNJC, lib.loc="~/cardinRlibraries/"); library(cccpCallNJC, lib.loc="~/cardinRlibraries/"); setups(1); process_calls()
process_calls=function(fussy=F, this_run_name=write_tag, this_run_loc=.default.coutput_root, 
                sample_names = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), 
                collections=names(sample_names), 
                concat=T, smrise=T, reordr=T, srt_smry=T, merge=T, mg_smrise=T, hardc=T, make_QC=T, merged_QC=T, test=T,
                merge_statuses=c(T,F), ers=c(F,T), diseases=get_diseases(), exclude=F, #These are parameters for the testing
                cnvtest_ind_exl_fn = NULL, cnvtest_cnv_exl_fn = NULL, 
                males_ind_exl_fn=paste(this_run_loc, "males_exclusion_list.txt",sep=""),
                test_controls=T, extra_BC_tests=T, remake_cnvtest_samples=T, ldf=T, DEBUG=1) 
{
  if(concat)    {cat("Concatenating calls files.\n"      ); cat_calls_files(fussy=fussy, this_run_name=this_run_name, this_run_loc=this_run_loc)}
  if(smrise)    {cat("Summarising   calls files.\n"      ); make_summaries_from_joined(this_run_name=this_run_name, this_run_loc=this_run_loc)  }
  if(reordr)    {cat("Re-ordering   calls files.\n"      ); re_order_catted(this_run_name=this_run_name, this_run_loc=this_run_loc); gc();      }
  if(srt_smry)  {cat("Make  sorted call sumries.\n"      ); make_sorted_summaries(this_run_name=this_run_name, this_run_loc=this_run_loc)  }
  if(merge)     {cat("Performing Merging       .\n"      ); merge_all_calls(this_run_name=this_run_name, this_run_loc=this_run_loc, ldf=F, DEBUG=DEBUG); gc()            }
  if(merge&ldf) {cat("Performing Merging (ldf) .\n"      ); 
    ldf_calls_fns        = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$ldf_sorted_calls_fns
    ldf_smry_fnames      = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_srtd_smry_cfn
    merge_all_calls(this_run_name=this_run_name, this_run_loc=this_run_loc, ldf=T, DEBUG=DEBUG,
                    calls_fns=ldf_calls_fns, sorted_smry_fnames=ldf_smry_fnames); gc()            
  }
  if(mg_smrise) {cat("Summarising merged calls .\n"      ); summarise_merged_calls(this_run_name=this_run_name, this_run_loc=this_run_loc); gc()  }
  if(make_QC)   {
    cat("Calculating unmerged QC metrics.\n"); 
    calc_call_rates(    this_run_name=this_run_name, this_run_loc=this_run_loc, unmerged=T, merged=F); gc() #'merged' and 'unmerged' are irrelevant & legacy
    if(ldf) {
      cat("Calculating unmerged QC metrics (ldf).\n"); 
      calc_ldf_call_rates(this_run_name=this_run_name, this_run_loc=this_run_loc            , merged=F); gc()
    }
  }
  if(merged_QC) {
    cat("Calculating   merged QC metrics.\n"); 
    calc_merged_callqc(    this_run_name=this_run_name, this_run_loc=this_run_loc); gc()
    if(ldf) {
      cat("Calculating   merged QC metrics (ldf).\n"); 
      calc_ldf_merged_callqc(this_run_name=this_run_name, this_run_loc=this_run_loc); gc()
    }
  }
  if(hardc)     {
    cat("Making Hard Calls        .\n"      ); 
    make_lots_of_hcalls_matrices(    this_run_name=this_run_name, this_run_loc=this_run_loc, unmerged=T, merged=T, ldf=F, DEBUG=DEBUG); gc()
    if(ldf) {
      cat("Making Hard Calls (ldf)  .\n"      ); 
      make_lots_of_ldf_hcalls_matrices(this_run_name=this_run_name, this_run_loc=this_run_loc, unmerged=T, merged=T, DEBUG=DEBUG); gc()
    }
  }
  if(test)      {
    cat("Note - the test=T flag requires the ccc+ project specific code to be loaded.\n"); 
    cat("Running cnvtest.\n"                ); 
    if(remake_cnvtest_samples) make_cnvtest_sample_files()
    run_all_diseases(diseases = diseases, pause=F, sex_cov="BC", expanded_references=ers, exclude=exclude,
                       merge_statuses=merge_statuses, cnvtest_ind_exl_fn=cnvtest_ind_exl_fn, cnvtest_cnv_exl_fn=cnvtest_cnv_exl_fn,
                       test_controls=test_controls, extra_BC_tests=extra_BC_tests, males_ind_exl_fn=males_ind_exl_fn, ldf=F)
    if(ldf) {
      run_all_diseases(diseases = diseases, pause=F, sex_cov="BC", expanded_references=ers, exclude=exclude,
                       merge_statuses=merge_statuses, cnvtest_ind_exl_fn=cnvtest_ind_exl_fn, cnvtest_cnv_exl_fn=cnvtest_cnv_exl_fn,
                       test_controls=test_controls, extra_BC_tests=extra_BC_tests, males_ind_exl_fn=males_ind_exl_fn, ldf=T)
    }
  }
 #if(make_newplots) cat("Making Augmented CPlots  .\n"); make_augmented_plots(this_run_name=this_run_name, this_run_loc=this_run_loc)
  return(0)
}

# "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_7/callingRoot/", "allExceptX_allCNVsAllMappings.Standard"
setups=function(set=1, date=Sys.Date())
{
  if(set %in% c(1, "garTest")) {
    assign(x = "project_root"         , value = "/data/garganey/cardin/postdoc/CNVs/calling/"                 , envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = paste("test_", date, sep="")                            , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                                 , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
  }
  if(set %in% c(2, "garStandard")) {
    assign(x = "project_root"         , value = "/data/garganey/cardin/postdoc/CNVs/calling/"                 , envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = "allExceptX_GSVannotation.Standard"                           , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                                 , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
  }
  if(set %in% c(3, "clusterStandard")) {
    assign(x = "project_root"         , value = "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_8/callingRoot/", envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = "allExceptX_GSVannotation.Standard"      , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")            , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
  }
  if(set %in% c(4, "wsim", "wtcc_sim")) {
    assign(x = "project_root"         , value = "/users/cardin/CNVs/calling/", envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = "easy_noassoc_nh1_no_priors_2009-05-26"                                    , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
  }
  if(set %in% c(5)) {
    assign(x = "project_root"         , value = "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_8/callingRoot/", envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = "allExceptX_GSVannotation.Standard"                           , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                                 , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
  }
  if(set %in% c(6, "watStandard")) {
    assign(x = "project_root"         , value = "/data/wattle/project/wtccc.plus.cnv/processedDataFreeze/data_freeze_8/callingRoot/", envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = paste("allExceptX_GSVannotation.Standard", sep="")           , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
  }
}

#sample_names_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name)$sample_names_fn,
#  source("cnv_caller.R"); setups("dev"); nocls = merge_all_calls(return="nocls")
merge_all_calls=function(this_run_name=write_tag, this_run_loc=.default.coutput_root, no_preamble_cols=4, return=NULL,
        sample_names = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections=names(sample_names), 
        jd  = get_coutput_dirs(coutput_root=this_run_loc)$jd,
        mcd = get_coutput_dirs(coutput_root=this_run_loc)$merged_calls_dir,
        mpd = get_coutput_dirs(coutput_root=this_run_loc)$merged_plots_dir,
        calls_fns          = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$sorted_calls_fns,
        sorted_smry_fnames = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$sorted_smry_cfn,
        pdf=T, save_fits=T, ldf=F, DEBUG=1
       )
{
  if(!file.exists(mcd)) dir.create(mcd, showWarnings = FALSE)
  if(pdf & !file.exists(mpd)) dir.create(mpd, showWarnings = FALSE)
  if(!ldf) merged_calls_fns = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$merged_calls_fns
  if( ldf) merged_calls_fns = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$ldf_merged_calls_fns

  noco         = length(collections)
  
  preamble_con = file(calls_fns[1], open="r")
  no_cnvs      = get_no_cnvs(sorted_smry_fnames[1])
  nocls        = rep(NA, no_cnvs)
  coll_order   = match(collections, names(sample_names))
  sample_names = sample_names[coll_order]
  all_sample_names = standardise_names(nms=unlist(sample_names), verbose=F)[,"ccc_name"]; names(all_sample_names) = NULL
  no_inds_vec  = sapply(sample_names, length)
  no_inds      = sum(no_inds_vec)

  all_relabelled_classes = as.list(rep(NA, no_cnvs))
  calls_cons = as.list(rep(NA, length(calls_fns)))
  for(callsfn in 1:length(calls_fns)) calls_cons[[callsfn]] = file(calls_fns[callsfn], open="r")
  for(cnv in 1:no_cnvs) {
    if(cnv%%10  ==0) cat(".");
    if(cnv%%500 ==0) cat("On CNV ", cnv, "\n");
    this_cnv_info   = scan(preamble_con, skip=0, nlines=1, what=character(0), quiet=T)
    nocl            = as.numeric(this_cnv_info[4]); 
    cnv_name        = this_cnv_info[2]
    nocls[cnv]      = nocl
    if(!ldf) {
      inf_smry        = myload(get_coutput_fns(this_run_name=this_run_name, cnv_name=cnv_name)$fit_fn)         
    } else {
      inf_smry        = myload(get_coutput_fns(this_run_name=this_run_name, cnv_name=cnv_name)$ldf_fit_fn)         
    }
    inf_args        = read.table(get_coutput_fns(this_run_name=this_run_name, cnv_name=cnv_name)$args_input_fn, as.is=T, header=F, fill=T)
    fit             = make_objects_from_cfitoutput(inf_smry=inf_smry, inf_args=inf_args)
   #fit             = c(inf_smry, inf_args=inf_args); fit$flags$cnv=cnv;
    merged_fit      = post_bic_simple_merge(fit=fit, pars=fit$opars, mode_counter="simple_nc", DEBUG=DEBUG) 
    if(save_fits) {
      if(!ldf) {
        mfd            = get_coutput_dirs(coutput_root=this_run_loc)$merged_fits_dir
        merged_plot_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$merged_plots_fn;        
        merged_fit_fn  = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$merged_fits_fn
      }
      if( ldf) 
      {
        mfd            = get_coutput_dirs(coutput_root=this_run_loc)$ldf_merged_fits_dir
        merged_plot_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$ldf_merged_plots_fn;        
        merged_fit_fn  = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$ldf_merged_fits_fn
      }
      if(!file.exists(mfd)) dir.create(mfd, showWarnings = FALSE)
      save(merged_fit, file=merged_fit_fn)
    }
    if(pdf) {
      pdf(file=merged_plot_fn, width=15.5, height=10)
      plotd(objects=merged_fit, dens_vals = merged_fit$mdens_vals, model_fits = merged_fit$merged_fits, cnv_index=cnv)
      dev.off()
      #scp -qr cardin@login1-cluster1.well.ox.ac.uk:/users/cardin/CNVs/calling/caller_output/ppc_allp_23Mar/merged_plots .
    }
   #if(cnv_name %in% c("CNVR158.1", "CNVR806.2", "CNVR2838.1")) browser();
   #plotd(objects=fit, dens_vals = fit$mdens_vals, model_fits = fit$merged_fits, plot_combined=F) 
    for(coll in 1:length(collections))
    {
      calls         = scan(calls_cons[[coll]], skip=0, nlines=1, what=character(0), quiet=T )
      na_info_check = sum(is.na(calls[1:4])==is.na(this_cnv_info[1:4]))==4; if(!na_info_check) {cat("  Error! ambiguity about CNV-calls details.\n"); browser();}
      info_check    = sum(calls[1:4]==this_cnv_info[1:4], na.rm=T)==sum(!is.na(calls[1:4])); if(!info_check) {cat("  Error! ambiguity about CNV-calls details.\n"); browser();}
      calls_mat     = matrix(as.numeric(calls[-(1:no_preamble_cols)]), nrow=no_inds_vec[coll], byrow=T)
      merged_calls  = merge_calls(calls=calls, relabelled_classes=merged_fit$relabelled_classes, return_mat=F);
      all_relabelled_classes[[cnv]] = merged_fit$relabelled_classes
      ## NJC: CHange this line to the following one:    append = !(cnv==1 && coll==1)
      append = !(cnv==1)
      write.table(t(merged_calls), file=merged_calls_fns[coll], quote=F, row.names=F, col.names=F, append=append)
    }
  }
  cat("Done.\n")
  if(!ldf) which_classes_merged_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$which_classes_merged_fn
  if( ldf) which_classes_merged_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$ldf_which_classes_merged_fn
  save(all_relabelled_classes, file=which_classes_merged_fn)
  for(con in 1:length(calls_cons)) close(calls_cons[[con]])
  close(preamble_con)
  # awk '{print $1,$2,$3,$4}' mergedcalls_58C.txt > first_merge_summaries.txt
  if(!is.null(return)) return(get(return))
}

# source("cnv_caller.R"); cat_calls_files()
# source("cnv_caller.R"); cat_calls_files(mapping="orig_PCA", fussy=T)
cat_calls_files=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, fussy=T, 
                         sample_names  = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
                         joined_dir    = get_coutput_dirs(coutput_root = this_run_loc)$jd, collections = names(sample_names),
                         calls_dir     = get_coutput_dirs(coutput_root=this_run_loc)$cd,
                         ldf_calls_dir = get_coutput_dirs(coutput_root=this_run_loc)$ldf_calls_dir,
                         joined_calls_fns     = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$joined_calls_fns,
                         ldf_joined_calls_fns = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_joined_calls_fns,
                         do_ldf               = file.exists(ldf_calls_dir)
                         )
{
  if(!file.exists(joined_dir)) dir.create(joined_dir, showWarnings = FALSE)
  no_colls         = length(collections)
  cat("On Collection: ");
  for(coll in collections)
  {
    cat(coll, ", ", sep="");
    collind        = which(collections==coll)
   #wd = getwd()
   #setwd(calls_dir)
    if( fussy) {
      cat_com = paste("cat ", get_calls_fns(this_run_name=this_run_name), " > ", joined_calls_fns[collind], sep="", collapse=" ")
    }
    if(!fussy) {
#      modified by RDP 31/07/09
      cat_com     = paste("cat *", coll, ".txt > ",     joined_calls_fns[collind], sep="", collapse=" ")
      cat_com_ldf = paste("cat *", coll, ".txt > ", ldf_joined_calls_fns[collind], sep="", collapse=" ")
#      cat_com     = paste("cat ", calls_dir,                   "*", coll, ".txt > ",     joined_calls_fns[collind], sep="", collapse=" ")
#      cat_com_ldf = paste("cat ", ldf_calls_dir,               "*", coll, ".txt > ", ldf_joined_calls_fns[collind], sep="", collapse=" ")
    }
#      added by RDP 31/07/09
    orig_dir <- setwd(calls_dir)
#      added by RDP 31/07/09
    system(cat_com)
    setwd(orig_dir)
    if(do_ldf) {
#      added by RDP 31/07/09
      orig_dir <- setwd(ldf_calls_dir)
      system(cat_com_ldf)
#      added by RDP 31/07/09
      setwd(orig_dir)
    } else
      cat("  Couldn't find ldf calls.\n");
   #setwd(wd)  
  }  
}

# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); make_summaries_from_joined()
make_summaries_from_joined=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
      sample_names    = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
      joined_dir       = get_coutput_dirs(coutput_root = this_run_loc)$jd,   collections = names(sample_names),
      joined_calls_fns = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$joined_calls_fns,
      smry_fns         = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$summary_calls_fns,
      ldf_joined_calls_fns = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_joined_calls_fns,
      ldf_smry_calls_fns   = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_smry_calls_fns,
      ldf_calls_dir = get_coutput_dirs(coutput_root=this_run_loc)$ldf_calls_dir,
      do_ldf               = file.exists(ldf_calls_dir)
      )
{
  for(coll in 1:length(smry_fns)) {
    awkcom      = paste("awk '{print $1,$2,$3,$4}' ",     joined_calls_fns[coll], " > ",           smry_fns[coll], sep="");
    ldf_awkcom  = paste("awk '{print $1,$2,$3,$4}' ", ldf_joined_calls_fns[coll], " > ", ldf_smry_calls_fns[coll], sep="");
   #wd = getwd()
   #setwd(joined_dir)
    system(awkcom)
    if(do_ldf)
      system(ldf_awkcom) else
      cat("  Couldn't find ldf calls.\n");
   #setwd(wd)  
    cat(".")
  }
  cat("\n")
}
make_sorted_summaries=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
        sample_names     = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections = names(sample_names),
        joined_dir       = get_coutput_dirs(coutput_root = this_run_loc)$jd,   
        sorted_calls_fns = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$sorted_calls_fns,
        ldf_sorted_calls_fns = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_sorted_calls_fns,
        ldf_srtd_smry_cfn    = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_srtd_smry_cfn
        )
{
  make_summaries_from_joined( joined_dir     = joined_dir,
                            joined_calls_fns = sorted_calls_fns,
                            smry_fns         = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA)$sorted_smry_cfn,
                            ldf_joined_calls_fns = ldf_sorted_calls_fns,
                            ldf_smry_calls_fns   = ldf_srtd_smry_cfn
                          )
}
summarise_merged_calls=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
        sample_names     = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections = names(sample_names),
        merged_calls_dir = get_coutput_dirs(coutput_root = this_run_loc)$merged_calls_dir,
        merged_calls_fns = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$merged_calls_fns,
        ldf_merged_calls_fns = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$ldf_merged_calls_fns,
        ldf_merged_smry_cfn  = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$ldf_merged_smry_cfn
        )
{
  make_summaries_from_joined( joined_dir       = merged_calls_dir,
                              joined_calls_fns = merged_calls_fns,
                              smry_fns         = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA)$merged_smry_cfn,
                              ldf_joined_calls_fns = ldf_merged_calls_fns,
                              ldf_smry_calls_fns   = ldf_merged_smry_cfn,
                            )
  ######## These lines shouldn't need to be passed to (above) function as the defaults will be correct.
  #ldf_calls_dir        = get_coutput_dirs(coutput_root=this_run_loc)$ldf_calls_dir,
  #do_ldf               = file.exists(ldf_calls_dir)
}

# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); re_order_catted()
re_order_catted=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
        sample_names    = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
        joined_dir = get_coutput_dirs(coutput_root = this_run_loc)$jd, collections = names(sample_names),
        joined_calls_fns = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$joined_calls_fns,
        smry_fns         = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$summary_calls_fns,
        sorted_calls_fns = get_coutput_fns(coutput_root = this_run_loc, this_run_name=this_run_name, cnv_name=NA, collections=collections)$sorted_calls_fns,
        ldf_smry_calls_fns   = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_smry_calls_fns,
        ldf_joined_calls_fns = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_joined_calls_fns,
        ldf_sorted_calls_fns = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA, collections=collections)$ldf_sorted_calls_fns,
        ldf_calls_dir = get_coutput_dirs(coutput_root=this_run_loc)$ldf_calls_dir, DEBUG=1,
        do_ldf           = file.exists(ldf_calls_dir)
)
{
  cols    = c("chr", "cnv", "start", "nocl")
  cat("On Collection: ");
  for(coll in collections)
  {
    cat(coll, ", ", sep="");
    collind   = which(collections==coll)

    smry_info     = read.table(          smry_fns[collind], header=F)
    colnames(smry_info    ) = cols
    pos        = smry_info[    ,"start"]
    if(sum(is.na(    pos))==length(    pos))     pos = as.numeric(    smry_info[,"cnv"])
    chrs      =     smry_info[,"chr"  ]
    new_order     = order(    chrs,     pos, decreasing=F)
    jc        = readLines(joined_calls_fns[collind])
    sc        =     jc[new_order]
    write.list_to_file(x=    sc, filename=    sorted_calls_fns[collind])
    if(do_ldf) {
      ldf_smry_info = read.table(ldf_smry_calls_fns[collind], header=F)
      colnames(ldf_smry_info) = cols
      ldf_pos    = ldf_smry_info[,"start"]
      if(sum(is.na(ldf_pos))==length(ldf_pos)) 
        ldf_pos = as.numeric(ldf_smry_info[,"cnv"])
      ldf_chrs  = ldf_smry_info[,"chr"  ]
      ldf_new_order = order(ldf_chrs, ldf_pos, decreasing=F)
      ldf_jc    = readLines(ldf_joined_calls_fns[collind])
      ldf_sc    = ldf_jc[ldf_new_order]
      write.list_to_file(x=ldf_sc, filename=ldf_sorted_calls_fns[collind])
    }
  }
  cat(".    Done: ", "\n", sep="")
}
# Helper function for check_right_no_samples
round_calls=function(cnv_line) { return(c(cnv_line[1:4], round(as.numeric(cnv_line[-(1:4)]), digits=3))) }


# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); store_sample_names();
store_sample_names=function(this_run_loc = .default.coutput_root, this_run_name=write_tag)
{
    data_and_details = look_at_a_cnv(cnv_name="Affy6_1.1", mapping="y_GMM", return_dad=T)
    dat   = data_and_details$data_array
    collsizes = sapply(dat, nrow)
    names = sapply(dat, rownames)
    cnv_test_dir = "/data/garganey/cardin/postdoc/CNVs/calling/testing/cnvtest/cnv_files/"
    collsizesfn = paste(cnv_test_dir, "coll_sizes.txt", sep="")
    write.table(t(as.matrix(collsizes)), file=collsizesfn, quote=F, row.names=F, col.names=T)
    save(names, file=paste(cnv_test_dir, "sample_names.RData", sep=""))
    browser();
}

# source("cnv_caller.R"); make_lots_of_hcalls_matrices(thresholds = c(0.8, 0.9, 0.95, 0.975, 0.98, 0.99), sets = list(NULL, "snplessp"))
make_lots_of_hcalls_matrices=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, ldf=F, DEBUG=1, 
                                      thresholds = c(0.8, 0.9, 0.95, 0.975, 0.98, 0.99), unmerged=T, merged=T)
{
    ## Shouldn't be used for ldf calls unless the standard filenames for the calls etc. are ldf calls (in which case whoudl work with ldf=FALSE?)
    make_matrices_of_hard_calls(this_run_loc = this_run_loc, this_run_name=this_run_name, call_threshes=thresholds, ldf=F, DEBUG=DEBUG); 
}

# source("cnv_caller.R"); make_lots_of_ldf_hcalls_matrices(thresholds = c(0.8, 0.9, 0.95, 0.975, 0.98, 0.99), sets = list(NULL, "snplessp"))
make_lots_of_ldf_hcalls_matrices=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, DEBUG=1, 
                        sample_names    = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections=names(sample_names), 
                        thresholds = c(0.8, 0.9, 0.95, 0.975, 0.98, 0.99), unmerged=T, merged=T)
{
    make_matrices_of_hard_calls(this_run_loc = this_run_loc, this_run_name=this_run_name, call_threshes=thresholds,
          joined_dir    = get_coutput_dirs(coutput_root=this_run_loc)$jd,
          mergedc_dir   = get_coutput_dirs(coutput_root=this_run_loc)$merged_calls_dir,
          calls_fns     = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_sorted_calls_fns, 
          mergedc_fns   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_merged_calls_fns, 
          csmry_fns     = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_srtd_smry_cfn,
          hcalls_dir    = get_coutput_dirs(coutput_root=this_run_loc)$hard_calls_dir, ldf=T, DEBUG=DEBUG        
          ); 
}

# source("cnv_caller.R"); make_matrices_of_hard_calls(call_threshes=0.95001);
make_matrices_of_hard_calls=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
          sample_names    = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections=names(sample_names), 
          call_threshes = c(0.95), no_preamble_cols = 4, unmerged=T, merged=T, #dfr=get_dfr() ,
          joined_dir    = get_coutput_dirs(coutput_root=this_run_loc)$jd,
          mergedc_dir   = get_coutput_dirs(coutput_root=this_run_loc)$merged_calls_dir,
          calls_fns     = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$sorted_calls_fns, 
          mergedc_fns   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$merged_calls_fns, 
          csmry_fns     = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$sorted_smry_cfn,
          hcalls_dir    = get_coutput_dirs(coutput_root=this_run_loc)$hard_calls_dir, ldf=F, DEBUG=1
          )
{
  hcalls_names = rep(NA, length(call_threshes)); merged_hc_fns = rep(NA, length(call_threshes)); 
  for(thresh in 1:length(call_threshes)) 
  {
    if(!ldf) {
      hcalls_names[ thresh] = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, call_thresh=call_threshes[thresh], cnv_name=NULL)$hard_calls_fn
      merged_hc_fns[thresh] = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, call_thresh=call_threshes[thresh], cnv_name=NULL)$merged_hcalls_fn
    } else {
      hcalls_names[ thresh] = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, call_thresh=call_threshes[thresh], cnv_name=NULL)$ldf_hard_calls_fn
      merged_hc_fns[thresh] = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, call_thresh=call_threshes[thresh], cnv_name=NULL)$ldf_merged_hcalls_fn
    }
  }  
  noco         = length(collections)
  calls_cons   = as.list(rep(NA, length(calls_fns)))
  mergc_cons   = as.list(rep(NA, length(calls_fns)))
  for(callsfn  in 1:length(calls_fns  )) calls_cons[[callsfn]]  = file(calls_fns[   callsfn], open="r")
  for(mergcsfn in 1:length(mergedc_fns)) mergc_cons[[mergcsfn]] = file(mergedc_fns[mergcsfn], open="r")
  unmpreamble_con = file(calls_fns[1], open="r")
    mpreamble_con = file(mergedc_fns[1] , open="r")
  no_cnvs      = get_no_cnvs(csmry_fn=csmry_fns[1])
  coll_order   = match(collections, names(sample_names))
  sample_names = sample_names[coll_order]
  no_inds_vec  = sapply(sample_names, length); 
  no_inds      = sum(no_inds_vec)
  all_sample_names = standardise_names(nms=unlist(sample_names))[,"ccc_name"]; names(all_sample_names) = NULL
  colnames = c("chr", "cnv_name", "pos", "nocl", all_sample_names)
  if(!file.exists(hcalls_dir)) dir.create(hcalls_dir, showWarnings = FALSE)
  for(thresh in 1:length(call_threshes)) 
  {
    if(unmerged) write.table(t(as.matrix(colnames)), file=hcalls_names[ thresh], quote=F, row.names=F, col.names=F, append=F)
    if(  merged) write.table(t(as.matrix(colnames)), file=merged_hc_fns[thresh], quote=F, row.names=F, col.names=F, append=F)
  }
  unm_nocls = rep(NA, no_cnvs); m_nocls = rep(NA, no_cnvs); 
  line = 0
  for(cnv in 1:no_cnvs)
  {
    if(cnv%%10  ==0) cat(".");
    if(cnv%%500 ==0) cat("On CNV ", cnv, "\n");
    if(unmerged) unmerged_preamble = scan(unmpreamble_con, skip=0, nlines=1, what=character(0), quiet=T)
    if(  merged)   merged_preamble = scan(  mpreamble_con, skip=0, nlines=1, what=character(0), quiet=T)
    pos             = as.numeric(unmerged_preamble[3]); chr        = as.numeric(unmerged_preamble[1])
    cnv_name        = unmerged_preamble[2]
    
    if(unmerged) {
      unm_nocl = as.numeric(unmerged_preamble[4])
      unm_nocls[cnv]        = unm_nocl; 
      names(unm_nocls)[cnv] = cnv_name;
    }
    if(  merged) {
      m_nocl = as.numeric(merged_preamble[4])
      m_nocls[cnv]        = m_nocl;
      names(m_nocls)[cnv] = cnv_name;
    }
    hcalls = as.list(rep(NA, length(call_threshes))); merged_hcalls = as.list(rep(NA, length(call_threshes))); 
    for(thresh in 1:length(call_threshes))
    {
      hcalls[[thresh]]        = matrix(NA, nrow=1, ncol=4+no_inds)
      merged_hcalls[[thresh]] = matrix(NA, nrow=1, ncol=4+no_inds)
      colnames(hcalls[[thresh]])        = c("chr", "cnv_name", "pos", "nocl", all_sample_names)
      colnames(merged_hcalls[[thresh]]) = c("chr", "cnv_name", "pos", "nocl", all_sample_names)
      hcalls[[thresh]][1,1:4]           = c("chr"=chr, "cnv_name"=cnv_name, "pos"=pos, "nocl"=unm_nocl)
      merged_hcalls[[thresh]][1,1:4]    = c("chr"=chr, "cnv_name"=cnv_name, "pos"=pos, "nocl"=m_nocl)    
    }
    for(coll in 1:length(collections))
    {  
      if(unmerged) {
        calls               = scan(calls_cons[[coll]], skip=0, nlines=1, what=character(0), quiet=T ); line=line+1
        calls_mat           = matrix(as.numeric(calls[-(1:no_preamble_cols)]), nrow=no_inds_vec[coll], byrow=T)
        rownames(calls_mat) = sample_names[[coll]]
      }
      if(  merged) {
        merged_calls               = scan(mergc_cons[[coll]], skip=0, nlines=1, what=character(0), quiet=T )
        merged_calls_mat           = matrix(as.numeric(merged_calls[-(1:no_preamble_cols)]), nrow=no_inds_vec[coll], byrow=T)
        rownames(merged_calls_mat) = sample_names[[coll]]
      }
      for(thresh in 1:length(call_threshes))
      {
        if(unmerged) {
          hcalls[[thresh]][1,sample_names[[coll]]] = make_hcalls(calls_mat=calls_mat, nocl=unm_nocl, call_thresh=call_threshes[thresh], DEBUG=DEBUG)
        }
        if(  merged) {
          merged_hcalls[[thresh]][1,sample_names[[coll]]] = make_hcalls(calls_mat=merged_calls_mat, nocl=m_nocl, call_thresh=call_threshes[thresh], DEBUG=DEBUG)
        }
      }
    }
    for(thresh in 1:length(call_threshes))
    {
      if(unmerged) write.table(hcalls[[thresh]]       , file=hcalls_names[ thresh], quote=F, row.names=F, col.names=F, append=T) # append=(cnv!=1))
      if(  merged) write.table(merged_hcalls[[thresh]], file=merged_hc_fns[thresh], quote=F, row.names=F, col.names=F, append=T)
    }
  }
  cat("Done.\n")
  if(unmerged) {
    for(callsfn in 1:length(calls_fns  )) close(calls_cons[[callsfn]])
    close(unmpreamble_con)
  }
  if(  merged) {
    for(mergcfn in 1:length(mergedc_fns)) close(mergc_cons[[mergcfn]])
    close(mpreamble_con)
  }
  return(0)
}

make_hcalls=function(calls_mat, nocl=NULL, call_thresh=0.95001, inc_null_class=T, DEBUG=1)
{
 #if(is.null(nocl)) nocl = ncol(calls_mat)-as.integer()
  ## Check to see whether the exceeding the call threshold at least guarantees that you're the most-likely type (including null)
  if(call_thresh < (1/(ncol(calls_mat)+1)) & DEBUG>=1) {
    cat("  Warning, call_threshold ought to be at least 1/numTypes (including NULL).\n")
    if(DEBUG>1) browser()
  }
  call_thresh = max(call_thresh, (1/ncol(calls_mat))+1e-5)
  if(is.null(rownames(calls_mat))) rownames(calls_mat) = paste("ind", 1:nrow(calls_mat), sep="")
  high_vals  = which(calls_mat>call_thresh, arr.ind=T)
  hcalls_vec = rep(NA, nrow(calls_mat))
  names(hcalls_vec) = rownames(calls_mat)
  hcalls_vec[rownames(high_vals)] = high_vals[,2]
  return(hcalls_vec)
}

# source("post_calling.R"); lk=likelihood_from_fits(cnv_identifier="CNV")
# likelihood_from_fits(dfr = dfr, cnv_name="Affy6_14_1")
likelihood_from_fits=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                              signal_model=NULL, precision=1e-4, use_null=T, null_prop=1e-3, cnv_name="Affy6_14_1", deg_free=NULL, 
                              DEBUG=1, cnv_identifier="CNV", ldf=T) #, merged=F, merge_list=NULL)
{
  rv        = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name, verbose=1)
  if(!ldf)  {
    names_ud  = myload(rv$dat_with_smpl_fn); 
    ud        = myload(rv$data_fn)
    fit       = myload(rv$fit_fn )
  } else  {
    names_ud  = myload(rv$ldf_dat_with_smpl_fn); 
    for(coll in names(names_ud)) names(names_ud[[coll]]) = dissect_sample_names(names(names_ud[[coll]]))$orig_names
    ud        = myload(rv$ldf_data_fn)
    fit       = myload(rv$ldf_fit_fn )
  }
  signal_model = fit$signal_model
  deg_free     = fit$deg_free
  # Likelihoods are independent of merging!!
  #if(merged) {
  #  if(length(merge_list)<1) {
  #    cat("  Warning! Are supposed to be using merged calls but haven't been passed list of merges to use.\n"); browser();
  #    cat("  Finding list automatically, but this is inefficient.\n");
  #    merge_list_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$which_classes_merged_fn
  #    merge_list_nm = load(merge_list_fn)     
  #    merge_list    = get(merge_list_nm); rm(merge_list_nm)
  #  }
  #}

  collections = names(ud)
  coll_sizes  = sapply(ud, length)
  noco        = length(collections)
  nocl        = fit[["bestf_pars"]]$nocl
  if(is.null(use_null)) {
    use_null    = fit$bestf_pars$use_null
    null_prop   = fit$bestf_pars$null_prop; if(!use_null) null_prop=NULL
  }
  pop_freqs   = fit$bestf_pars$pgnf
  class_props = c(pop_freqs, null_prop)
  check_freq  = abs(sum(class_props)-1)<precision
  likelihoods = as.list(rep(NA, noco)); names(likelihoods) = collections
  rud         = range(ud)
  dat_min     = rud[1]
  dat_max     = rud[2]

  #Need to check that all collections referred to come in the same order!!
  for(coll in 1:noco)
  {
    likelihoods[[coll]] = rep(NA, coll_sizes[coll]);
    tmp = rep(NA, nocl)
    class_means = fit$bestf_pars$full_clm[coll,]
    class_vars  = fit$bestf_pars$full_clv[coll,]

    #This is the point where the likelihoods themselves are calculated - doesn't use merged calls (but it's equivalent)
    if(signal_model=="normal")
      tmp = mapply(dnorm, mean=class_means, sd=sqrt(class_vars), MoreArgs=list("x"=ud[[coll]]  , "log"=T        ))
    #if(signal_model=="t8")
    #  tmp = mapply(my_dt, mean=class_means, sd=sqrt(class_vars), MoreArgs=list("dat"=ud[[coll]], "log"=T, "df"=8))
    if(length(grep("t.", signal_model))>0 | "t"==signal_model)
      tmp = mapply(my_dt, mean=class_means, sd=sqrt(class_vars), MoreArgs=list("dat"=ud[[coll]], "log"=T, "df"=deg_free))
      
    if(use_null) tmp = cbind(tmp, dunif(x=ud[[coll]], min=dat_min, max=dat_max, log=T))

    rep_props       = matrix(class_props, nrow=nrow(tmp), ncol=length(class_props), byrow=T)
    pd1             = exp(tmp) * rep_props
    likelihoods[[coll]] = rowSums(pd1); names(likelihoods[[coll]]) = names(names_ud[[coll]])
  }
  if(DEBUG>1) {if(is.na(range(likelihoods))[1]) {cat("  Warning, have NA likelihoods.\n"); browser();}}
  return(likelihoods)
}

# source("cnv_caller.R"); good_cnvs = make_good_cnvs(extra_dir="ppc_df6/", good_thresh=16500, metric="posteriors")$good_cnvs
make_good_cnvs=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                        myQC_dir   = get_coutput_dirs(coutput_root=this_run_loc)$QC_dir,
                        cnv_threshs = c("fair_thresh"=16500, "med_thresh"=17100, "good_thresh"=17525), metric="posteriors", cnv_stats=NULL,
                        extra_dir=NULL, no_classes = c(3), cnv_identifier="CNV", cl2_fair_thresh=16500, cl2_med_thresh=17100, cl2_good_thresh=17525)
{
  if(metric %in% c("likelihoods", "posteriors",  "callrates1",  "callrates2",  "no_null")) {
    nocls_fn     = paste(myQC_dir, extra_dir, "number_classes.txt"     , sep="")
    cnv_stat_fn  = paste(myQC_dir, extra_dir, "by_cnv_QC_metrics.RData", sep="")
    if(is.null(cnv_stats))  qcn = load(cnv_stat_fn)
    nocls        = scan(nocls_fn, skip=1, nlines=1, what=numeric(0), quiet=T); names(nocls) = rownames(cnv_stats)

    qcvals       = cnv_stats[,metric]
    qcv_3cl      = qcvals[names(which(nocls==3))]
    good_thresh  = cnv_threshs["good_thresh"];  med_thresh  = cnv_threshs[ "med_thresh"]; fair_thresh  = cnv_threshs["fair_thresh"]; 
    good_cnvs    = rownames(cnv_stats)[which(qcvals >= good_thresh                        )]
     med_cnvs    = rownames(cnv_stats)[which(qcvals >  med_thresh  & qcvals < good_thresh )]
    fair_cnvs    = rownames(cnv_stats)[which(qcvals >  fair_thresh & qcvals <  med_thresh )]
    rt_nocl_cnvs = names(nocls)[which(nocls%in%no_classes)]
    gdrv_cnvs    = intersect(rt_nocl_cnvs, good_cnvs)# Good 'return value' CNVs, these are filtered for having the wanted number of classes
    gdrv_cnvs    = good_cnvs[match(gdrv_cnvs, good_cnvs)] #reordering cnv lists to retain original order
    mdrv_cnvs    = intersect(rt_nocl_cnvs,  med_cnvs)
    mdrv_cnvs    =  med_cnvs[match(mdrv_cnvs,  med_cnvs)] 
    frrv_cnvs    = intersect(rt_nocl_cnvs, fair_cnvs)
    frrv_cnvs    = good_cnvs[match(frrv_cnvs, fair_cnvs)] 
  }
  if(metric %in% c("cnvtest_info")) {
    diseases = get_diseases()
    cat("Maybe using cnvtest metrics won't be so useful.\n")
  }
  rv = list("good_cnvs"=gdrv_cnvs, "med_cnvs"= mdrv_cnvs, "fair_cnvs"=frrv_cnvs)
  return(rv)
}


calc_merged_callqc=function(this_run_loc       = .default.coutput_root, this_run_name=write_tag,
      sample_names = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections=names(sample_names), 
      merged_calls_fns   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$merged_calls_fns, 
      merged_summary_fn  = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$merged_smry_cfn,
      merged_calls_dir   = get_coutput_dirs(coutput_root=this_run_loc)$merged_calls_dir, merged = T, unmerged=!merged,
      merged_call_QC_dir = get_coutput_dirs(coutput_root=this_run_loc)$merged_call_QC_dir,
      write_files=T, summarise_inds=F, use_vpqc=F, which_verdicts="master.list.csv",
      verdict_col="verdict.damjan", standard = "c",
      merged_QCs_fn      = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$merged_qc_stats_fn,
      merged_cnv_QC_fn   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$merged_cnv_qcs_fn
      )
                            
{
  calc_call_rates(this_run_loc = this_run_loc, this_run_name=this_run_name, merged=T, unmerged=F,
                  calls_fns    = merged_calls_fns,
                  csmry_fns    = merged_summary_fn,
                  joined_dir   = merged_calls_dir,
                  myQC_dir     = merged_call_QC_dir,
                  all_QCs_fn   = merged_QCs_fn,
                  by_cnv_QC_fn = merged_cnv_QC_fn,
                  write_files=T, summarise_inds=F, use_vpqc=F, which_verdicts=which_verdicts, verdict_col=verdict_col, standard = standard)
}

calc_ldf_call_rates=function(this_run_loc = this_run_loc, this_run_name=this_run_name, merged=F,
      sample_names = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections=names(sample_names)
      )
{
  calc_call_rates(this_run_loc = this_run_loc, this_run_name=this_run_name, merged = merged, ldf=T, 
       calls_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_sorted_calls_fns,
#       Next line changed by RDP 03/09/2009, after call and email with Niall
#       csmry_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_merged_smry_cfn,
       csmry_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_srtd_smry_cfn,
       all_QCs_fn   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$ldf_qc_stats_fn,
       by_cnv_QC_fn = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$ldf_cnv_qcstats_fn,
       )  
}

calc_ldf_merged_callqc=function(merged=T, this_run_loc = this_run_loc, this_run_name=this_run_name,
      merged_call_QC_dir = get_coutput_dirs(coutput_root=this_run_loc)$merged_call_QC_dir,
      sample_names = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc), collections=names(sample_names)
      )
{
  calc_call_rates(merged = merged, ldf=T,
       calls_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_merged_calls_fns, 
       csmry_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$ldf_merged_smry_cfn,
       all_QCs_fn   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$ldf_merged_qc_stats_fn,
       by_cnv_QC_fn = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$ldf_merged_cnv_qcs_fn,
       myQC_dir     = merged_call_QC_dir
       )  
}

#  source("cnv_caller.R"); options(error=recover); calc_call_rates(good_cnvs = make_good_cnvs(no_classes = 3, extra_dir="ppc_df6/")$good_cnvs, dbg="_df6")
# This function generates a large number of QC scores for a call-set. It can also generate QC for merged calls but that is done by using different
# input directories and filenames (so that the calls, summaries and output files correspond to the call-sets required)
calc_call_rates=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, collections  = names(sample_names),
     calls_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$sorted_calls_fns, 
     csmry_fns    = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL, collections=collections)$summary_calls_fns,
     sample_names = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
     joined_dir   = get_coutput_dirs(coutput_root=this_run_loc)$jd, merged = F, unmerged=!merged,
     myQC_dir     = get_coutput_dirs(coutput_root=this_run_loc)$QC_dir,
     all_QCs_fn   = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$qc_stats_fn,
     by_cnv_QC_fn = get_coutput_fns( coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NULL)$cnv_qcstats_fn,
     no_cnvs=NULL, good_cnvs=c(), no_preamble_cols = 4, call_thresh1 = 0.95, call_thresh2 = 0.90, 
     write_files=T, write_all=F, make_plots=F, max_cnv=NULL, dbg=NULL, summarise_inds=F, use_vpqc=F,
     which_verdicts="master.list.csv", verdict_col="verdict.damjan", standard = "c", DEBUG=1, ldf=F)
{
  noco         = length(collections)
  preamble_con = file(calls_fns[1], open="r")
  if(is.null(no_cnvs))
    no_cnvs    = get_no_cnvs(csmry_fns[1], max_cnv=max_cnv)
  sample_names = get_sample_names(coutput_root=this_run_loc, this_run_name=this_run_name)
  coll_order   = match(collections, names(sample_names))
  sample_names = sample_names[coll_order]
  all_sample_names = standardise_names(nms=unlist(sample_names), verbose=F)[,"ccc_name"]; names(all_sample_names) = NULL
  no_inds_vec  = sapply(sample_names, length)
  no_inds      = sum(no_inds_vec)
  if(length(good_cnvs)) good_cnvs = get_curated_good_cnvs(which_verdicts=which_verdicts, verdict_col=v, standard=standard) 

  if(merged) {
    merge_list_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$which_classes_merged_fn
    merge_list    = myload(merge_list_fn)         
  }
  msqc     = as.matrix(read.table(file=get_msqc_fn(), as.is=T, header=T, colClasses="character", sep="\t"))
  dlrqs    = quantile(as.numeric(msqc[,"Metric_DLRSpread"]), prob=c(0.001, 0.999))
  #dlrqs    = quantile(vdas$Metric_DLRSpread, prob=c(0.001, 0.999))
  high_dlr = msqc[which(as.numeric(msqc[,"Metric_DLRSpread"])>dlrqs["99.9%"]),, drop=F]
  if(!file.exists(myQC_dir)) dir.create(myQC_dir, showWarnings = FALSE)
  if(use_vpqc) #vpqc = Vincet lagnol's QC, won't always have this.
  {
    vpqc_fn = paste(myQC_dir, "vincent_dispersion_all_samples.RData", sep="") #This is my filename for Vincent's QC
    if(!file.exists(vpqc_fn)) {
      cat("  Warning! Couldn't find Vincent's QC file, ignoring this data.\n");
      use_vpqc=F
    } else {
      nm = load(vpqc_fn) #the name of the loaded object is often: vincent.dispersion.all.samples
      if(sum("vincent.dispersion.all.samples" %in% nm)>=1) vdas = vincent.dispersion.all.samples else {
        cat("  Warning, looks like Vincent may have changed the name of his QC data-frame. trying to cope automatically.\n");
        vdas = get(nm)      
      }
      strange  = vdas[which(vdas$strange),]
    }
  }

  #no_calls stores the number of calls above a certain threshold
  no_calls1       = as.list(rep(NA, noco)) ; names(no_calls1 )      = names(sample_names)
  for(coll in 1:noco) {no_calls1[[coll]]        = rep(0 , no_inds_vec[coll]); names(       no_calls1[[coll]]) = sample_names[[coll]]}
  no_calls2 = no_calls1; no_calls_poly = no_calls1; no_calls_3cl = no_calls1; no_calls_mono = no_calls1;
  no_calls_poly2 = no_calls1; no_calls_3cl2 = no_calls1; no_calls_mono2 = no_calls1;
  #total_posterior stores the the total of argmax(P(class(individual) | model fit)), to get a 'confidence' for each individual
  total_posterior = no_calls1; total_posterior_poly = no_calls1; total_posterior_mono = no_calls1; total_posterior_3cl = no_calls1
  likelihoods = no_calls1; likelihoods_poly = no_calls1; likelihoods_mono = no_calls1; likelihoods_3cl = no_calls1
  likelihoods_gd = no_calls1; no_calls_gd = no_calls1;   no_calls_gd2 = no_calls1;   total_posterior_gd = no_calls1; no_called_null_gd = no_calls1; 
  acnv_stat_names = c("likelihoods", "posteriors", "callrates1", "callrates2", "no_null", "nocl")
  acnv_stats   = (rep(NA, length(acnv_stat_names))); names(acnv_stats)=acnv_stat_names
  cnv_stats    = matrix(0, ncol=length(acnv_stat_names), nrow=no_cnvs); colnames(cnv_stats) = acnv_stat_names
  rownames(cnv_stats) = 1:no_cnvs
  #no_minor_class stores the number of times an individual was placed in the minor class at a 2-class CNV.
  no_minor_class = no_calls1; 
  no_called_null = no_calls1; no_called_null_mono = no_calls1; no_called_null_poly = no_calls1; no_called_null_3cl = no_calls1;

  if(summarise_inds) { 
    inds_to_summarise        = c(as.character(high_dlr$WTCCC_name[3 ]), as.character(high_dlr$WTCCC_name[7 ]),
                               sapply(sample_names, '[[', 2))
    if(use_vpqc) inds_to_summarise = c(inds_to_summarise, as.character(strange$WTCCC_name[2  ]), as.character(strange$WTCCC_name[4 ]), 
                               as.character(strange$WTCCC_name[6]), as.character(strange$WTCCC_name[8]))

    names(inds_to_summarise) = c(as.character(high_dlr$Cohort[3 ]), as.character(high_dlr$Cohort[7 ]),
                               names(sapply(sample_names, '[[', 2)))
    if(use_vpqc) names(inds_to_summarise) = c(names(inds_to_summarise), as.character(strange$Cohort[2  ]), as.character(strange$Cohort[4 ]), 
                               as.character(strange$Cohort[6]), as.character(strange$Cohort[8]))
  } else {
    inds_to_summarise        = c(sapply(sample_names, '[[', 2))
    names(inds_to_summarise) = c(names(sapply(sample_names, '[[', 2)))
  }
  no_inds_to_summarise = length(inds_to_summarise)
  ind_details = list("cccname"=NA, "coll"=NA, "likelihoods"=c(), "callrates1"=c(), "callrates2"=c(), "cnv_names"=c())
  selection_ind_details = vector(mode="list", length=no_inds_to_summarise);
  for(i in 1:no_inds_to_summarise) {
    selection_ind_details[[i]]         = ind_details
    selection_ind_details[[i]]$cccname = inds_to_summarise[i]
    selection_ind_details[[i]]$coll    = names(inds_to_summarise[i])
    selection_ind_details[[i]]$dlr     = msqc[,"Metric_DLRSpread"][which(msqc[,"WTCCC_name"]==selection_ind_details[[i]]$cccname)]
  }

  nocls      = rep(NA, no_cnvs)
  scan_time  = 0
  calls_cons = as.list(rep(NA, length(calls_fns)))
  for(callsfn in 1:length(calls_fns)) calls_cons[[callsfn]] = file(calls_fns[callsfn], open="r")
  for(cnv in 1:no_cnvs) {
    if(cnv%%10  ==0) cat(".");
    if(cnv%%500 ==0) cat("On CNV ", cnv, "\n");
    this_cnv_info   = scan(preamble_con, skip=0, nlines=1, what=character(0), quiet=T)
    nocl            = as.numeric(this_cnv_info[4]); cnv_name   = this_cnv_info[2]
    nocls[cnv]      = nocl; names(nocls)[cnv] = cnv_name;
    # Likelihoods are independent of merging!!
    cnv_likelihoods = likelihood_from_fits(this_run_loc = this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name, ldf=ldf)
    coll_order      = match(collections, names(cnv_likelihoods))
    cnv_likelihoods = cnv_likelihoods[coll_order]
    for(i in 1:no_inds_to_summarise) {
      coll = selection_ind_details[[i]]$coll
      name = selection_ind_details[[i]]$cccname
      selection_ind_details[[i]]$likelihoods = c(selection_ind_details[[i]]$likelihood, cnv_likelihoods[[coll]][[name]])
      selection_ind_details[[i]]$cnv_names  = c(selection_ind_details[[i]]$cnv_names , cnv_name)
    }

    rownames(cnv_stats)[cnv]     = cnv_name
    cnv_stats[cnv,"nocl"]        = nocl
    cnv_stats[cnv,"likelihoods"] = sum(unlist(cnv_likelihoods)); 
    for(coll in 1:length(collections))
    {
      ptm1  = proc.time();
      calls = scan(calls_cons[[coll]], skip=0, nlines=1, what=character(0), quiet=T )
      ptm2  = proc.time(); scan_time = scan_time + (ptm2-ptm1)
      calls_mat  = matrix(as.numeric(calls[-(1:no_preamble_cols)]), nrow=no_inds_vec[coll], byrow=T)
      rownames(calls_mat) = sample_names[[coll]]
      check_nocl = ncol(calls_mat)==nocl; if(!check_nocl) {cat(  "Warning! annotiation of number of classes doesn't fit calls!.\n"); if(DEBUG>1) browser()}
      if(nocl==2) in_minor_class  = get_in_minor_class(calls_mat, nocl, call_thresh = 0.5, no_inds = no_inds_vec[coll])
      called_thresh1  = get_callable_inds(calls_mat, nocl, call_thresh = call_thresh1, no_inds = no_inds_vec[coll])
      called_thresh2  = get_callable_inds(calls_mat, nocl, call_thresh = call_thresh2, no_inds = no_inds_vec[coll])
      max_posterior   = get_max_posterior(calls_mat, nocl, no_inds = no_inds_vec[coll])
      called_null     = get_called_null(calls_mat, nocl, bound=0.5, no_inds = no_inds_vec[coll])
      for(i in which(sapply(selection_ind_details, '[[', "coll")==collections[coll])) {
        selection_ind_details[[i]]$callrates1 = c(selection_ind_details[[i]]$callrates1, called_thresh1[[selection_ind_details[[i]]$cccname]])
        selection_ind_details[[i]]$callrates2 = c(selection_ind_details[[i]]$callrates2, called_thresh2[[selection_ind_details[[i]]$cccname]])
      }

      # nullcheck (2class): lc = (length(calls)-4)/2; c1 = as.numeric(calls[-(1:4)][2*(1:lc)-1]); c2 = as.numeric(calls[-(1:4)][2*(1:lc)-0]); cs = pmax(c1,c2); range(cs)

      cnv_stats[cnv,"posteriors"] = cnv_stats[cnv,"posteriors"] + sum((max_posterior )) #+ sum(unlist(max_posterior ))
      cnv_stats[cnv,"no_null"   ] = cnv_stats[cnv,"no_null"   ] + sum((called_null   )) # Unlist shoudln't be needed here should it?
      cnv_stats[cnv,"callrates1"] = cnv_stats[cnv,"callrates1"] + sum((called_thresh1))
      cnv_stats[cnv,"callrates2"] = cnv_stats[cnv,"callrates2"] + sum((called_thresh2))
 
      no_calls1[[coll]]        =  no_calls1[[coll]] + called_thresh1
      no_calls2[[coll]]        =  no_calls2[[coll]] + called_thresh2
      total_posterior[[ coll]] = total_posterior[[coll]]  + max_posterior
      likelihoods[[     coll]] = likelihoods[[    coll]]  + cnv_likelihoods[[coll]]
      no_called_null[[coll]]   = no_called_null[[coll]]       + called_null
      if(nocl==1) {
        no_calls_mono[[ coll]]       =  no_calls_mono[[ coll]] + called_thresh1
        no_calls_mono2[[coll]]       =  no_calls_mono2[[coll]] + called_thresh2
        total_posterior_mono[[coll]] = total_posterior_mono[[coll]] + max_posterior
        likelihoods_mono[[    coll]] = likelihoods_mono[[    coll]] + cnv_likelihoods[[coll]]
        no_called_null_mono[[coll]]  = no_called_null_mono[[coll]]  + called_null
      }
      if(nocl==2) {
        no_minor_class[[coll]]       = no_minor_class[[coll]]       + in_minor_class
      }
      if(nocl==3) {
        no_calls_3cl[[  coll]]       =  no_calls_3cl[[  coll]] + called_thresh1
        no_calls_3cl2[[ coll]]       =  no_calls_3cl2[[ coll]] + called_thresh2
        total_posterior_3cl[[ coll]] = total_posterior_3cl[[ coll]] + max_posterior
        likelihoods_3cl[[     coll]] = likelihoods_3cl[[    coll]] + cnv_likelihoods[[coll]]
        no_called_null_3cl[[ coll]]  = no_called_null_3cl[[ coll]]  + called_null
      }
      if(nocl >1) {
        no_calls_poly[[ coll]]       =  no_calls_poly[[ coll]] + called_thresh1
        no_calls_poly2[[coll]]       =  no_calls_poly2[[coll]] + called_thresh2
        total_posterior_poly[[coll]] = total_posterior_poly[[coll]] + max_posterior
        likelihoods_poly[[    coll]] = likelihoods_poly[[    coll]] + cnv_likelihoods[[coll]]
        no_called_null_poly[[coll]]  = no_called_null_poly[[coll]]  + called_null
      }
      if(cnv_name %in% good_cnvs & nocl==3)
      {
        no_calls_gd[[  coll]]       =  no_calls_gd[[  coll]] + called_thresh1
        no_calls_gd2[[ coll]]       =  no_calls_gd2[[ coll]] + called_thresh2
        total_posterior_gd[[ coll]] = total_posterior_gd[[ coll]] + max_posterior
        likelihoods_gd[[     coll]] = likelihoods_gd[[    coll]] + cnv_likelihoods[[coll]]
        no_called_null_gd[[ coll]]  = no_called_null_gd[[ coll]]  + called_null
      }
    }
  }  
  cat("Done.\n")
  if(sum(is.na(nocls))>0) { cat("Problem with identifying number of classes for at least one CNV.\n"); browser();}
  no_poly = sum(nocls>1, na.rm=T); no_2cl = sum(nocls==2, na.rm=T); no_mono = sum(nocls==1, na.rm=T); no_3cl = sum(nocls==3, na.rm=T)
 #png(file="Distributions of call rate and confidence for individuals in data freeze 3.png", width = 1200, height=1000)
  if(write_files)
  {
    extra = paste(dbg, "/", sep="")
    if(!file.exists(myQC_dir)) dir.create(myQC_dir, showWarnings = FALSE)
    no_calls1_fn = paste(myQC_dir,  "proportion_calls_above_0.95.txt", sep="") 
    no_calls2_fn = paste(myQC_dir,  "proportion_calls_above_0.90.txt", sep="") 
    no_calls_poly_fn  = paste(myQC_dir,  "proportion_calls_in_polyCNVs_above_0.95.txt", sep="") 
    no_calls_poly_fn2 = paste(myQC_dir,  "proportion_calls_in_polyCNVs_above_0.90.txt", sep="") 
    no_calls_mono_fn  = paste(myQC_dir,  "proportion_calls_in_monoCNVs_above_0.95.txt", sep="") 
    no_calls_mono_fn2 = paste(myQC_dir,  "proportion_calls_in_monoCNVs_above_0.90.txt", sep="") 
    no_calls_3cl_fn  = paste(myQC_dir,  "proportion_calls_in_3clsCNVs_above_0.95.txt", sep="") 
    no_calls_3cl_fn2 = paste(myQC_dir,  "proportion_calls_in_3clsCNVs_above_0.90.txt", sep="") 
    total_posterior_fn      = paste(myQC_dir,  "total_posterior_in_allCNVs.txt", sep="") 
    total_posterior_poly_fn = paste(myQC_dir,  "total_posterior_in_polyCNVs.txt", sep="") 
    total_posterior_mono_fn = paste(myQC_dir,  "total_posterior_in_monoCNVs.txt", sep="") 
    total_posterior_3cl_fn  = paste(myQC_dir,  "total_posterior_in_3clsCNVs.txt", sep="") 
    likelihoods_fn      = paste(myQC_dir,  "likelihoods_in_allCNVs.txt", sep="") 
    likelihoods_poly_fn = paste(myQC_dir,  "likelihoods_in_polyCNVs.txt", sep="") 
    likelihoods_mono_fn = paste(myQC_dir,  "likelihoods_in_monoCNVs.txt", sep="") 
    likelihoods_3cl_fn  = paste(myQC_dir,  "likelihoods_in_3clsCNVs.txt", sep="") 
    no_minor_class_fn = paste(myQC_dir,  "number_in_minor_class_at_2class_CNVs.txt", sep="") 
    no_called_null_fn = paste(myQC_dir,  "Number_of_times_individual_likely_null.txt", sep="") 
    no_called_null_poly_fn = paste(myQC_dir,  "Number_of_times_individual_likely_null_poly.txt", sep="") 
    no_called_null_mono_fn = paste(myQC_dir,  "Number_of_times_individual_likely_null_mono.txt", sep="") 
    no_called_null_3cl_fn  = paste(myQC_dir,  "Number_of_times_individual_likely_null_3cls.txt", sep="") 

    nocls_fn          = paste(myQC_dir,  "number_classes.txt", sep="") 
    selection_of_inds_full_QC_fn = paste(myQC_dir,  "full_stats_at_some_inds.RData", sep="")  

    all_QCs = list("calls1" = no_calls1, "calls2" = no_calls2, "callspoly" = no_calls_poly, "callspoly2" = no_calls_poly2, "callsmono" = no_calls_mono, "callsmono2" = no_calls_mono2, 
                   "calls3cl" = no_calls_3cl, "calls3cl2" = no_calls_3cl2, "total_posterior" = total_posterior, "total_posterior_poly" = total_posterior_poly, "nocls"=nocls, 
                   "total_posterior_mono" = total_posterior_mono, "total_posterior_3cl" = total_posterior_3cl, "no_minor_class" = no_minor_class, "no_called_null"=no_called_null, 
                    "likelihoods" = likelihoods, "likelihoods_poly" = likelihoods_poly, "likelihoods_mono" = likelihoods_mono, "likelihoods_3cl" = likelihoods_3cl, "bycnv_metrics"=cnv_stats,
                    "likelihoods_gd" = likelihoods_gd,  "no_calls_gd"=no_calls_gd, "no_calls_gd2"=no_calls_gd2, "total_posterior_gd"=total_posterior_gd, "no_called_null_gd"=no_called_null_gd,
                    "selection_ind_details"=selection_ind_details, "cnv_stats"=cnv_stats)
    if(write_all) {
      write.table(matrix(nocls, nrow=1), nocls_fn, quote=T, row.names=F, col.names=T)
      write.list_to_file(no_calls1, filename=no_calls1_fn); write.list_to_file(no_calls2, filename=no_calls2_fn)
      write.list_to_file(no_calls_poly , filename=no_calls_poly_fn ); write.list_to_file(no_calls_poly2, filename=no_calls_poly_fn2);
      write.list_to_file(no_calls_mono , filename=no_calls_mono_fn ); write.list_to_file(no_calls_mono2, filename=no_calls_mono_fn2);
      write.list_to_file(no_calls_3cl  , filename=no_calls_3cl_fn  ); write.list_to_file(no_calls_3cl2 , filename=no_calls_3cl_fn2 );
      write.list_to_file(no_minor_class, filename=no_minor_class_fn); 
      write.list_to_file(no_called_null, filename=no_called_null_fn); 
      write.list_to_file(no_called_null_poly, filename=no_called_null_poly_fn); 
      write.list_to_file(no_called_null_mono, filename=no_called_null_mono_fn); 
      write.list_to_file(no_called_null_3cl , filename=no_called_null_3cl_fn); 
      write.list_to_file(total_posterior      , filename=total_posterior_fn      );
      write.list_to_file(total_posterior_poly , filename=total_posterior_poly_fn );
      write.list_to_file(total_posterior_mono , filename=total_posterior_mono_fn );
      write.list_to_file(total_posterior_3cl  , filename=total_posterior_3cl_fn  );
      write.list_to_file(likelihoods      , filename=likelihoods_fn      );
      write.list_to_file(likelihoods_poly , filename=likelihoods_poly_fn );
      write.list_to_file(likelihoods_mono , filename=likelihoods_mono_fn );
      write.list_to_file(likelihoods_3cl  , filename=likelihoods_3cl_fn  );
      save(selection_ind_details, file=selection_of_inds_full_QC_fn);
    }
   #tmp = sapply(all_QCs, write.list_to_file, filename=all_QCs_fn2, append=T);
    save(all_QCs  , file=all_QCs_fn);
    save(cnv_stats, file=by_cnv_QC_fn);
  }
  if(make_plots) {
    xlab95 = "Call Rate with 0.95 call threshold";   xlab90 = "Call Rate with 0.90 call threshold"; 
    png(file=paste(myQC_dir,  "Distributions_of_call_rate_and_confidence.png", sep=""), width = 1600, height=1300)
    par(mfcol=c(3,3))
    hist(unlist(no_calls1)/no_cnvs           , n=100, col="grey", main="Call rates - All CNVs", xlab = xlab95)
    if(no_poly>0) hist(unlist(no_calls_poly)/no_poly       , n=100, col="grey", main="Call rates - Polymorphic CNVs", xlab = xlab95) else plot(1:10)
    if(no_3cl >0) hist(unlist(no_calls_3cl)/no_3cl         , n=100, col="grey", main="Call rates - 3class CNVs", xlab = xlab95) else plot(1:10)
   #hist(unlist(no_calls2)/no_cnvs           , n=100, col="grey", main="Call rates - All CNVs", xlab = xlab90)
   #hist(unlist(no_calls_poly2)/no_poly      , n=100, col="grey", main="Call rates - Polymorphic CNVs", xlab = xlab90)
   #hist(unlist(no_calls_3cl2)/no_3cl        , n=100 , col="grey", main="Call rates - 3class CNVs", xlab = xlab90)
    hist(unlist(likelihoods)/no_cnvs     , n=100, col="grey", main="likelihoods - All CNVs", xlab = "likelihood")
    if(no_poly>0) hist(unlist(likelihoods_poly)/no_poly, n=100, col="grey", main="likelihoods - Polymorphic CNVs", xlab = "likelihood") else plot(1:10)
    if(no_3cl>0) hist(unlist(likelihoods_3cl)/no_3cl  , n=100, col="grey", main="likelihoods - 3class CNVs", xlab = "likelihood")  else plot(1:10)
    hist(unlist(total_posterior)/no_cnvs     , n=100, col="grey", main="Confidences - All CNVs", xlab = "likelihood")
    if(no_poly>0) hist(unlist(total_posterior_poly)/no_poly, n=100, col="grey", main="Confidences - Polymorphic CNVs", xlab = "Average Maximum Posterior Call") else plot(1:10)
    if(no_3cl>0) hist(unlist(total_posterior_3cl)/no_3cl  , n=100, col="grey", main="Confidences - 3class CNVs", xlab = "Average Maximum Posterior Call") else plot(1:10)
    dev.off()
    if(no_2cl>0) {
      png(file=paste(myQC_dir,  "Proportion of time in minor class at 2class CNVs.png", sep=""), width = 1200, height=1000)
      par(mfcol=c(1,1))
      hist(unlist(no_minor_class)/no_2cl, n=100, col="grey", main="Contribution to Bumps in Tails", xlab = "Proportion of time in minor allele")
      dev.off()
    }
    if(no_mono>0 & no_2cl>0 & no_poly>0 & no_3cl >0) {
      png(file=paste(myQC_dir,  "Proportion of time sample called null.png", sep=""), width = 1200, height=1000)
      par(mfcol=c(2,2))
      hist(unlist(no_called_null)/no_cnvs, n=100, col="grey", main="Proportion of Null Calls", xlab = "Proportion of time >0.5 in Null")
      hist(unlist(no_called_null_poly)/no_poly, n=100, col="grey", main="Proportion of Null Calls - Polymorphic", xlab = "Proportion of time >0.5 in Null")
      hist(unlist(no_called_null_mono)/no_mono, n=100, col="grey", main="Proportion of Null Calls - Monomorphic", xlab = "Proportion of time >0.5 in Null")
      hist(unlist(no_called_null_3cl )/no_3cl , n=100, col="grey", main="Proportion of Null Calls - 3class"     , xlab = "Proportion of time >0.5 in Null")
      dev.off()
    }
  }
 #browser();
  for(callsfn in 1:length(calls_fns)) close(calls_cons[[callsfn]])
  close(preamble_con)
}

process_postcalling_qc=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                                myQC_dir=get_coutput_dirs(coutput_root=this_run_loc)$QC_dir, qc_dir = paste(get_coutput_dirs(coutput_root=this_run_loc)$QC_dir,  sep=""))
{
  qcname     = load(paste(qc_dir, "all_QC_metrics.RData", sep=""))
  lik        = all_QCs$likelihoods    ; likbad    = sort(unlist(lik   ), decreasing=F)
  lik3cl     = all_QCs$likelihoods_3cl; likbad3cl = sort(unlist(lik3cl), decreasing=F)
  save(lik   , file = paste(qc_dir, "likelihoods1.RData"        , sep=""))
  save(lik3cl, file = paste(qc_dir, "likelihoods_3cl_only.RData", sep=""))
  write.table(likbad3cl[1:515], file=paste(qc_dir, "first_bad_samples_list.txt", sep=""), quote=F, col.names=F)
  plot(unlist(lik), unlist(lik3cl))
}

get_callable_inds=function(calls_mat, nocl, call_thresh = call_thresh, no_inds)
{
 #if(ignore_monomorphic & nocl==1) return(rep(NA, no_inds))
 #inds_callable = apply(calls_mat, 1, max)>call_thresh
  high_vals     = which(calls_mat>call_thresh, arr.ind=T)[,1]
  inds_callable = 1:nrow(calls_mat) %in% high_vals 
  names(inds_callable) = rownames(calls_mat)
  return(inds_callable)
}
get_max_posterior=function(calls_mat, nocl, no_inds, no_preamble_cols = 4)
{
 #if(ignore_monomorphic & nocl==1) return(rep(NA, no_inds))
 #max_posterior = apply(calls_mat, 1, max)
  if(nocl==1) max_posterior = calls_mat[,1]
  if(nocl==2) max_posterior = pmax(calls_mat[,1], calls_mat[,2])
  if(nocl==3) max_posterior = pmax(calls_mat[,1], calls_mat[,2], calls_mat[,3])
  if(nocl==4) max_posterior = pmax(calls_mat[,1], calls_mat[,2], calls_mat[,3], calls_mat[,4])
  if(nocl >4) max_posterior = apply(calls_mat, 1, max)
 #names(max_posterior) = rownames(calls_mat) #redundant, names are already kept
  return(max_posterior)
}
get_in_minor_class=function(calls_mat, nocl, call_thresh = 0.5, no_inds, slow=F)
{
  check            = nocl==2; if(!check) {cat("  Warning. This function was written only for 2-class CNVs.\n"); browser();}
  high_vals        = which(calls_mat>call_thresh, arr.ind=T)[,1]
  inds_callable    = 1:nrow(calls_mat) %in% high_vals 
  max_posterior    = get_max_posterior(calls_mat=calls_mat, nocl=nocl, no_inds = no_inds)
  if(!slow) hcalls = 1+(calls_mat[,2]>calls_mat[,1])
  if( slow) hcalls = apply(calls_mat, 1, which.max)
  counts           = c(sum(hcalls[inds_callable]==1), sum(hcalls[inds_callable]==2))
  minor_gntp       = which.min(counts)
  in_minor_class   = (hcalls==minor_gntp & inds_callable)
 #names(in_minor_class) = rownames(calls_mat)  #redundant, names are already kept
  return(in_minor_class)
}
get_called_null=function(calls_mat, nocl, bound=0.5, no_inds)
{
  non_null   = rowSums(calls_mat)
  null_calls = non_null<bound
  return(null_calls)
}

# sample_names = get_sample_names()
get_sample_names=function(coutput_root = .default.coutput_root, this_run_name=write_tag, 
                          sn_fn = get_coutput_fns(coutput_root=coutput_root, this_run_name=this_run_name, cnv_name=NA)$sample_names_fn,
                          verbose=0.5)
{
   if(verbose>=1) cat("Reading in sample Names...")
   lines           = readLines(sn_fn)  
   if(verbose>=1) cat("  Parsing Sample Names...")
   split_lines     = sapply(lines, strsplit, split=" ") #Loads in the object: names
   sample_names    = as.list(rep(NA, length(lines)))
    
   for(coll in 1:length(lines))
   {
     sample_names[[coll]] = split_lines[[coll]][-c(1)]
     names(sample_names)[coll] = split_lines[[coll]][1]
   }
   if(verbose>=1) cat("Done.\n")
  return(sample_names)
}

#From commands given to me by Damjan
# setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling")
# source("cnv_caller.R"); run_join_plots(tags1="all", tags2="cl_plots_df4", cls=1:5)
run_join_plots=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                        joined_dir = get_coutput_dirs(coutput_root = this_run_loc)$jd,
                        plots_dir  = get_coutput_dirs(coutput_root = this_run_loc)$plots_dir, 
                        tags1="all", tags2="cl_plots_df4", cls=1:5)
{
  dir_tags = paste(tags1, cls, tags2, sep="")
  for(cl in cls) {
    jplots_dir=get_coutput_dirs(coutput_root = this_run_loc)$jplots_dir
  join_plots(dir_tag = dir_tags[cl], jplots_dir=jplots_dir, plots_dir=plots_dir);
  }
}

# source("cnv_caller.R"); mv_joined_plots(cls=1:5)
mv_joined_plots=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                        joined_dir = get_coutput_dirs(coutput_root = this_run_loc)$jd,
                        plots_dir = get_coutput_dirs(coutput_root = this_run_loc)$plots_dir, 
                        tags1="all", tags2="cl_plots_df4", cls=1:5)
{
  for(cl in cls)
  {
    dir_tag = paste("all", cl, "cl_plots/", sep="")
    subset_dir_name=paste(get_coutput_dirs(coutput_root = this_run_loc)$coutput_root, dir_tag, sep="")
    joined_plots_dir = plots_dir = get_coutput_dirs(coutput_root = this_run_loc)$jplots_dir
    if(!file.exists(joined_plots_dir)) dir.create(joined_plots_dir, showWarnings = FALSE)
      mvcom = paste("mv ", subset_dir_name, "*joined*.pdf ", joined_plots_dir, sep="")
    system(mvcom)
  }
}


# join_plots(dir_tag = "all1cl_plots_df4"); 
join_plots=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                    joined_dir = get_coutput_dirs(coutput_root = this_run_loc)$jd,
                    plots_dir  = get_coutput_dirs(coutput_root = this_run_loc)$plots_dir, 
                    jplots_dir = get_coutput_dirs(coutput_root = this_run_loc)$jplots_dir,
                    dir_tag    = "plots_of_interest/")
{
  fn_store_fn = paste(jplots_dir, "filenames.txt", sep="")
  make_list_com = paste("ls ", jplots_dir, "*.pdf > ", fn_store_fn, sep="")# Damjans original line:  ls > file.list
  system(make_list_com)
  get_no_files_com = paste("wc -l ", fn_store_fn, sep="")
  no_files   = as.numeric(strsplit(system(get_no_files_com, intern=T), split=" ")[[1]][1])
  chunk_size = 300
  no_chunks  = ceiling(no_files/chunk_size)
  for(chunk in 1:no_chunks) {
    #sed -n   '1,100p' file.list > file.list1
    #sed -n '101,200p' file.list > file.list2
    begin  = ((chunk-1)*chunk_size)+1
    end    = ((chunk-0)*chunk_size)+0
    chunk_fn = paste(jplots_dir, "fns_tojoin_", chunk, ".txt", sep="")
    sedcom = paste("sed -n \'", begin, ",", end, "p\' ", fn_store_fn, " > ", chunk_fn, sep="")
    system(sedcom)
  }
  # etc...

  # Fix this to make it the proper syntax for pdfjoin.
  for(chunk in 1:no_chunks) {
    #pdfjoin -o joinedimages1.pdf `cat file.list1`
    #pdfjoin -o joinedimages2.pdf `cat file.list2`
    chunk_fn = paste(jplots_dir, "fns_tojoin_", chunk, ".txt", sep="")
   # pdfjoin --outfile joined_inserts.pdf *inserts_101*.pdf
    pdfjoincom = paste("pdfjoin --outfile ", "joinedimages", chunk, ".pdf `cat ", chunk_fn, "`", sep="")
   #pdfjoincom = paste("pdfjoin `cat ", chunk_fn, "`", sep="")
    wd = getwd(); setwd(jplots_dir)
    system(pdfjoincom)
    setwd(wd)
  }
  # nice mv *joined*.pdf ../joined_2cl_plots/ &
  # nice scp -r all1cl_plots/ cardin@wattle.well.ox.ac.uk:/data/wattle/project/wtccc.plus.cnv/cardin/ 
  # nice scp -r all2cl_plots/ cardin@wattle.well.ox.ac.uk:/data/wattle/project/wtccc.plus.cnv/cardin/ 
  # nice scp -r joined_2cl_plots/ cardin@wattle.well.ox.ac.uk:/data/wattle/project/wtccc.plus.cnv/cardin/ 
  # ssh wattle.well.ox.ac.uk
  # cd /data/wattle/project/wtccc.plus.cnv/cardin/
  # 
}


# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); look_at_skew(anew=F, new_cutoffs=F);
look_at_skew=function(machine="garganey", DEBUG=1.7, anew=F, new_cutoffs=F, write_old=F,
                      results_dir=get_coutput_fns()$coutput_root)
{
  pr_mapping_file_orig    = paste(get_dir_names()$ptcnv_dir, "probe_to_CNV_mapping_original.txt", sep="")
  probe_mapping_orig      = read.table(pr_mapping_file_orig, header=T)
  sann_fn                 = paste(get_dir_names()$sang_ann_dir, "MASTER_sample_QC.txt", sep="")
  sann                    = read.table(sann_fn, header=T, sep="\t")

  skew_cnv_list_fn = paste(results_dir, "jm_skew_cnvs.txt", sep="") 
  image_fns        = read.table(skew_cnv_list_fn, as.is=T)
  cnv_names        = apply(image_fns, MARGIN=1, getcnvname_image)
  cnv_indices      = which(probe_mapping_orig[,"CNV"] %in% cnv_names)
  

 #BC               = matrix(NA, nrow=0, ncol=1224); #This needse to be set properly
  BC               = NULL
  if(anew) {
    for(cnv in cnv_indices)
    {  
      arguments        = set_arguments(cnvs=cnv, write_tag="NA", read_tag="NA")
      extra_args       = set_up_caller(arguments)
      data_and_details = get_data(arguments=arguments, extra_args=extra_args, cnv_index=cnv, DEBUG=DEBUG);
      BC_dat           = data_and_details$ung_dat[["BC"]]
      BC               = rbind(BC, BC_dat)
    }
    rownames(BC)     = probe_mapping_orig[cnv_indices,"CNV"]
   #browser();
    write.table(    BC, file=paste(results_dir, "BC_data_at_skew_CNVS.txt", sep=""), quote=F, col.names=T, row.names=T)
  } else {
    BC = as.matrix(read.table(file=paste(results_dir, "BC_data_at_skew_CNVS.txt", sep=""), as.is=T, header=T))
   #rownames(BC)     = probe_mapping_orig[cnv_indices,"CNV"]

  }
  if(new_cutoffs) {
    cut_offs = c()
    for(cnv in 1:nrow(BC))
    {
      hist(BC[cnv,], n=50, col="lightgrey")
      cut_offs = c(cut_offs, locator(n=1)$x)
    }
    write.table(cut_offs, file=paste(results_dir,  "cut_offs", sep=""), quote=F, col.names=F, row.names=F)
  } else {
    cut_offs = as.vector(unlist(read.table(file=paste(results_dir,  "cut_offs", sep=""), as.is=T, header=F)))
  }
  BC_inds                 = match(colnames(BC), sann[,"WTCCC_name"]) #So these are in the order of the columns
  check_ind_order1        = sum(sann[BC_inds,"WTCCC_name"] == colnames(BC))==length(colnames(BC))
  BC_sann                 = sann[BC_inds,]
  check_ind_order2        = sum(    BC_sann[,"WTCCC_name"] == colnames(BC))==length(colnames(BC))
  if(!(check_ind_order1 & check_ind_order2)) {cat("Error, indivduals' details no in the same order as data matrix.\n"); browser();}
  batches                 = unique(BC_sann[,"Batch"])

  BC_bin   = BC; for(cnv in 1:nrow(BC)) BC_bin[cnv,] = BC[cnv,] > cut_offs[cnv]
  image_fn = paste(results_dir, "Binary_data_in_original_order.png", sep="")
  if(write_old) png(file = image_fn, width=1000, height=800)
  image(BC_bin, xlab="CNVs", ylab="Individuals", main="Individuals in a long tail (white).png")
  if(write_old) dev.off()
 #plot(as.numeric(BC_sann[,"Batch"]), BC_bin[1,])
  glm = glm(BC_bin[1,] ~ as.factor(BC_sann[,"Batch"]), family="binomial")
  bad_batches_byglm = as.list(rep(NA, nrow(BC)))
  names(bad_batches_byglm) = rownames(BC)
  bad_batches_glm_fn = paste(results_dir, "bad_batches_by_glm_per_cnv", sep="") 
  if(write_old) write.list_to_file(bad_batches_byglm, filename=bad_batches_glm_fn)
  for(cnv in 1:nrow(BC)) {
    glm = glm(BC_bin[cnv,] ~ as.factor(BC_sann[,"Batch"]), family="binomial"); 
    tmp = (summary(glm)$coefficients)
    batches = sort(unique(BC_sann[,"Batch"]))
    low_pvals = tmp[,"Pr(>|z|)"] < 0.0001
    bad_batches_byglm[[cnv]] = batches[low_pvals]
    #print(summary(glm)); browser();
    # For a few of the CNVs which show a batch effect can you make a plot with the following 2 subplots.
    # (a) the histogram of the intensities in the BC cohort i.e. the plot that shows the bump.
    # (b) a plot that shows the intensities of each batch in the cohort i.e have the x-axis as batch and the y-axis as intensity.
    #     You should get a series of vertical "lines" of points, one for each cohort, and the ones that you have identified as significant should be highlighted.
    hist_fn = paste(results_dir, "Data_by_batch2_in_BC_at_", rownames(BC)[cnv], ".png", sep="")
    if(1) png(file = hist_fn, width=1200, height=800)
    par(mfcol=c(2,1))
    hist(BC[cnv,], n=50, col="lightgrey", xlab = "Linearly Scaled probe Means", main=paste("Histogram for ", rownames(BC)[cnv], sep=""))
    colour = rep("black", length(BC_sann[,"Batch"])); 
    glm_bad_batches  = c(911, 1881,  901, 1891,  861,  871,  581,  591)
    glm_vbad_batches = c(901, 911, 1881, 1891)
    colour[which(BC_sann[,"Batch"] %in% glm_bad_batches )] = "green"
    colour[which(BC_sann[,"Batch"] %in% glm_vbad_batches)] = "red"
    map = 1:length(batches); names(map) = batches
    equal_spaced_batches = map[as.character(BC_sann[,"Batch"])]
   #plot(BC_sann[,"Batch"], BC[cnv,], xlab = "Batch", ylab = "1-d Intensity Summary for individual",  main=paste("Intensity by Batch for ", rownames(BC)[cnv], sep=""), col=colour)
    plot(BC[cnv,], equal_spaced_batches, ylab = "Batch", xlab = "1-d Intensity Summary for individual",  main=paste("Intensity by Batch for ", rownames(BC)[cnv], sep=""), col=colour)
    if(1) dev.off()
  }
 #glm = glm(BC_bin[1,] ~ BC_sann[,"Batch"], family="binomial")
  plot(1:ncol(BC_bin), colMeans(BC_bin))
  hist_fn = paste(results_dir, "Proportion_calls_in_long_tail.png", sep="")
  if(write_old) png(file = hist_fn, width=1000, height=800)
  hist(colMeans(BC_bin), col="lightgrey", n=15, xlab = "Proportion of calls in a long tail", main="Proportion of calls each individual has in a long tail"); #(27*(0.2)^26*0.8) + (0.2)^27 << 1/1224
  if(write_old) dev.off()
  dodgy_inds    = which(colMeans(BC_bin)>0.7)
  dodgy_batches = BC_sann[dodgy_inds,"Batch"]
  bad_inds_per_batch = rep(NA, length(batches))
  for(batch in 1:length(batches)) bad_inds_per_batch[batch] = sum(dodgy_batches==batches[batch])
  batches_fn = paste(results_dir, "Proportion_Individuals_in_tails-Batch.png", sep="")
  if(write_old) png(file = batches_fn, width=1000, height=800)
  plot(batches, bad_inds_per_batch, xlab = "Batch Index", main="Proportion of individuals in a tail - by Batch", ylab = "Proportion in Tail")
  if(write_old) dev.off()
  #Other analyses: Sort individuals by various rows (eg. DATE, BATCH (sorted by date). then redo image plot, or plot mean tail-ness against date/batch etc.)
  browser();
}

# parse_date(date = "11-13-2008", american=T)
parse_date=function(date, american=T)
{
  split = strsplit(date, split="-")
  if(american) month = as.numeric(split[[1]][1]) else month = as.numeric(split[[1]][2])
  if(american) day   = as.numeric(split[[1]][2]) else month = as.numeric(split[[1]][1])
  year               = as.numeric(split[[1]][3])
  if(year!=2008) cat("Warning - only dates in 2008 are currently reliable to an exact number of days (though they are stricly increasing in date).\n");
  months =      c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "July", "Aug", "Sep", "Oct", "Nov", "Dec")
  daysinmonth = c( 31  ,   28 ,  31  ,   30 ,  31  ,   30 ,  31   ,  31  ,   30 ,  31  ,   30 ,   31 )
  cumul_days  = c(0, cumsum(daysinmonth))
  day = cumul_days[month] + day + ((year-2008)*365)
  return(day)
}

browsePlots=function(machine="wattle", run="standard")
{
  require(cccpCallNJC); 
  if(machine=="wattle") setups("watStandard") else setups(2)
  cnvs = floor(runif(1000, 1, 1e4))
  for(cnv in cnvs)
  {
    makeCplotFromCNVname(cnvName=NULL, cnv_index, merged=T, ldf=T)
  }

}
# library(cccpCallNJC); makeCplotFromCNVname(cnvName=cnvName, merged=T, ldf=T, breaks=150)
# library(cccpCallNJC); makeCplotFromCNVname(cnvName=cnvName, merged=T, ldf=T)
makeCplotFromCNVname=function(cnvName="CNVR1.1", cnv_index=NULL, all_cl=T, indiv_cl=T, cex.main=2.1,
                            sampleNames    = get_sample_names(), collections=NULL, no_bars=50, pcolls=names(sampleNames),
                            noco=length(sampleNames), plot_fn=get_coutput_fns(cnv_name=cnvName)$plot_fn, merged=T, ldf=T, main=NULL,
                            ptcnv=NULL,   breaks=NULL, plot_combined=T, new_plot=T, clean=F, lwd=1.5, combineOnlySupplied=FALSE,
                            ylab="", cex.lab=1.3
                            )
{  
  if(is.null(cnvName)) {
    is(is.null(ptcnv))
      ptcnv = read.table(file=get_pt2cnv_fn(), as.is=T, header=T, sep="\t")
    cnvName = get_cnv_name_from_index(cnv_index=cnv_index, ptcnv=ptcnv) #Use the probe to CNV mapping file.
  }

  ## At this point different filenames will be generated depending on the value of 'ldf'
  ## This is how the function gives the appropriate plot.
  fit_sum_fn   = intelligentGetFnames(merge=merged, ldf=ldf, sampleNames  = sampleNames,
                                   collections  = names(sampleNames), cnvName=cnvName)$fit_sum_fn  
  one_ddat_fn  = intelligentGetFnames(merge=merged, ldf=ldf, sampleNames=NULL,
                                   collections=NULL, cnvName=cnvName)$data_fn

  ungDat       = myload(one_ddat_fn) # get_one_ddat()
  if(!merged) {
    inf_args     = read.table(get_coutput_fns(cnv_name=cnvName)$args_input_fn, as.is=T, header=F, fill=T)
    inf_smry     = myload(fit_sum_fn) # get_inf_smry()
    fit          = make_objects_from_cfitoutput(inf_smry=inf_smry, inf_args=inf_args)
    dens_vals = NULL; model_fits=NULL
  }
  if( merged) {
    fit        = myload(fit_sum_fn)                 
    dens_vals  = fit$mdens_vals
    model_fits = fit$merged_fits
  }
  if(length(breaks)==1) {
    no_bars = breaks
    breaks  = NULL     
  } else {
    no_bars = NULL
  }

  look_at_calls(objects=fit, new=F, new_plot=new_plot, plot_fn=plot_fn, png=F, 
                ung_dat=ungDat, no_bars=no_bars, all_cl=all_cl, 
                indiv_cl=indiv_cl, pcolls=pcolls, breaks=breaks, in_main=main, 
                dens_vals=dens_vals, model_fits=model_fits, cex.main=cex.main,
                plot_combined=plot_combined, clean=clean, lwd=lwd,
                combineOnlySupplied=combineOnlySupplied, ylab=ylab,
                cex.lab=cex.lab
                )
}

get_cnv_name_from_index=function(cnv_index, ptcnv=NULL)
{
  if(is.null(ptcnv))
    ptcnv     = read.table(file=get_pt2cnv_fn(), as.is=T, header=T, sep="\t")
  cnvName   = ptcnv[cnv_index,"CNV"]
  return(cnvName)
}

make_objects_from_cfitoutput=function(inf_smry, inf_args=NULL, no_assoc=T, use_null_freq=F)
{
  nocl             = inf_smry$bestf_pars$nocl
  collections      = colnames(inf_smry$gdat)
  reduced_fit      = inf_smry$bestf_pars
  cnv_name         = inf_smry$cnv_name
  noco             = nrow(reduced_fit$full_clm)
  #Need to augment this object to be able to plot 
  signal_model = inf_smry$signal_model
  deg_free     = inf_smry$deg_free
  usedNullClass    = as.logical(inf_args[which(inf_args[,1]=="use_null_class"),2])
  ## Legacy code to deal with runs which didn't supply this:
  if(is.null(signal_model)) {
    signal_model = "t"
    deg_free     = 8
  }
  if(no_assoc) gnfp       = list("gnf_lambda" = reduced_fit$pgnf, "gnf_controls" = reduced_fit$pgnf, "gnf_cases" = reduced_fit$pgnf)
  if(no_assoc) case_colls = rep(0, length(collections)); names(case_colls) = collections;
  flags   = list("use_hier_mchoice" = T, "use_null_class"=inf_smry$use_null, "use_mpar_additions"=T, "hack_add_gnf_lambda" = 0, "signal_model"=signal_model,
                 "deg_free" = deg_free, "null_prop"=0.003, "DEBUG"=1.7)
  if(!is.null(inf_args)) {
    flags   = list("DEBUG"               = as.numeric(inf_args[which(inf_args[,1]=="DEBUG"),2]), 
                   "combine_colls"       = as.logical(inf_args[which(inf_args[,1]=="combine_colls"),2]),
                   "use_hier_mchoice"    = as.logical(inf_args[which(inf_args[,1]=="use_hier_mchoice"),2]), 
                   "use_null_class"      = as.logical(inf_args[which(inf_args[,1]=="use_null_class"),2]),
                   "use_mpar_additions"  = as.logical(inf_args[which(inf_args[,1]=="use_mpar_additions"),2]), 
                   "hack_add_gnf_lambda" = as.numeric(inf_args[which(inf_args[,1]=="hack_add_gnf_lambda"),2]),
                   "signal_model"        = signal_model, 
                   "deg_free"            = deg_free, 
                   "null_prop"           = as.numeric(inf_args[which(inf_args[,1]=="null_prop"),2]),
                   "cnv_name"            = cnv_name)
  }

  assoc   = list("case_colls" = case_colls)
  pars    = list("nocl" = nocl, "noco"=noco, hkclm = reduced_fit$full_clm, hkclv = reduced_fit$full_clv, smc = reduced_fit$smc, cld = reduced_fit$ecld, 
                 "clv"  = reduced_fit$eclv, "gnfp" = gnfp, "betas" = reduced_fit$betas, "null_prop" = flags$null_prop, "grid_breaks"=as.numeric(rownames(inf_smry$gdat)))
  objects = list("dat" = inf_smry$gdat, "opars" = pars, "npars"=pars, "assoc" = assoc, "flags" = flags)

  objects$ninferred$lpdga = array(-1,  c(nrow(objects$dat), nocl+flags$use_null_class, noco)) #Remember, this NO LONGER has the counts in each grid included in it
  # Create names of classes:
  if(usedNullClass) {
    classNames = c(colnames(objects$opars$hkclm), "NULL")
  } else {
    classNames = c(colnames(objects$opars$hkclm))  
  }
  dimnames(objects$ninferred$lpdga)=list(rownames(objects$dat), 
                                         classNames, 
                                         rownames(objects$opars$hkclm))
  
  objects                 = update_lpdga(objects) ##Updates objects$ninferred
  objects$ninferred$pagd  = make_pagd(ob=objects, direct_lpdga=objects$ninferred$lpdga, new=F, use_null_freq=use_null_freq)
  objects$oinferred       = objects$ninferred
  return(objects)
}

specific_fit_summary=function(fit)
{
  pars_smry = list("nocl" = fit$opars$nocl, "full_clm"=fit$opars$hkclm, "full_clv"=fit$opars$hkclv, "smc"=fit$opars$smc, 
                   "ecld"=fit$opars$cld, "eclv"=fit$opars$clv, "pgnf" = fit$opars$gnf$gnf_lambda, "betas"=fit$opars$betas)
  return(pars_smry)
}

# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); x = use_old_model_fit(mapping="orig_mean");
use_old_model_fit=function(mapping="orig",
                           joined_calls_dir = get_coutput_dirs(coutput_root=this_run_loc)$jd, 
                           pars_dir         = get_coutput_dirs(coutput_root=this_run_loc)$pars_dir, 
                           calls_tag1  = "16Jan_", pr_summary = "PCA", cnv_identifier = "CNV", 
                           calls_tag2  = "_gc50_t8_summary_seed=1",
                           cnv_listfn  = NULL)
{
  cat("  Warning, are you using the right CNV identifier?\n")
  pr_mapping_file_orig    = get_pt2cnv_fn( mapping=mapping)
  probe_mapping_orig      = read.table(pr_mapping_file_orig, header=T)

  if(mapping=="all")   {
    types       = c("orig_mean", "orig_PCA", "y_GMM_mean")
  } else {
    types       = paste(mapping, "_", pr_summary, sep="")
  }
  for(type in 1:length(types))
  {
   #mf_fns = paste(calls_dir, "core_pars_smry_", calls_tag1, types[type], calls_tag2, "*", sep="")
    wd = getwd()
    setwd(pars_dir)
    mf_fns = paste("core_pars_smry_", calls_tag1, types[type], calls_tag2, "*", sep="")
    fnlist_fn = paste("corepars_", types[type], "_filenames.txt", sep="")
    make_fnlist_com = paste("ls ", mf_fns, " > ", fnlist_fn, sep="")
    system(make_fnlist_com)
    fnlist = (read.table(fnlist_fn, as.is=T))
    this_fn = fnlist[1,1]
    core_pars = parse_core_pars(fn= this_fn, calls_dir=pars_dir)
    cnv_name  = getcnvname_corepars(this_fn)
    cnv_index = which(probe_mapping_orig[,cnv_identifier]==cnv_name) # have been using CNV_v1 !! as identifier, so may need to use this
    cat("  Now need to read in the data using using get_data, don't remove Sanger Control and call with these parameters.\n")
    cat("  Individuals will be named in data_array, and summarised in ung_dat. But grid_data will lose the names of course.\n");
    cat("  Want to get a general sense of concordance in the duplicates\n");
    browser();
    setwd(wd)
  }

}

getcnvname_corepars=function(fn="core_pars_smry_16Jan_orig_mean_gc50_t8_summary_seed=1A101_1_seed=1.txt")
{
  split1 = strsplit(fn    , "summary_seed=1")[[1]][2]
  split2 = strsplit(split1, "_seed=1.txt")[[1]][1]
  return(split2)
}
getcnvname_image=function(fn)
{
  split1 = strsplit(fn    , "summary_seed=1_")[[1]][2]
  split2 = strsplit(split1, ".pdf")[[1]][1]
  return(split2)
}

parse_core_pars=function(fn, noco = 10, calls_dir)
{
   #mfraw  = readLines(parscon)
   #remove_blanks = function(x) return(x[-which(x=="")]); nocl_line = strsplit(mfraw[[1]], split=" ")[[1]]; nocl_line = remove_blanks(nocl_line); nocl = as.numeric(nocl_line[2])
   wd = getwd()
   setwd(calls_dir)
   nocl   = read.table(fn, skip=0, nrow=1, as.is=T)[1,2]
   means  = read.table(fn, skip=2, nrow=noco, as.is=T)
   rownames_means = paste(means[,1], means[,2], sep="")
   means  = cbind(means[,-(1:2)])
   rownames(means) = rownames_means
   colnames(means) = (read.table(fn, skip=1, nrow=1, as.is=T))

  vars  = read.table(fn, skip=2+noco+1, nrow=noco, as.is=T)
  rownames_vars = paste(vars[,1],vars[,2], sep="")
  vars  = cbind(vars[,-(1:2)])
  rownames(vars) = rownames_vars
  colnames(vars) = (read.table(fn, skip=2+noco, nrow=1, as.is=T))

  gnf_names = read.table(fn, skip=(2*noco+3)  , nrow=1, as.is=T)
  gnfs      = read.table(fn, skip=(2*noco+3)+1, nrow=1, as.is=T)
  names(gnfs) = gnf_names

  betas_names = read.table(fn, skip=(2*noco+5)  , nrow=1, as.is=T)
  betas       = read.table(fn, skip=(2*noco+5)+1, nrow=1, as.is=T)
  names(betas) = betas_names

  setwd(wd)
  core_pars = list("nocl"=nocl, "means"=means, "vars"=vars, "gnfs"=gnfs, "betas"=betas)
  return(core_pars)
}


# Might one day have to do the concordance analysis on the fly - there will be too much data to read it all into memory
# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); concs=look_at_duplicates();
look_at_duplicates=function(anew=F, ann_dir = get_dir_names()$sang_ann_dir, call_thresh=0.95, make_png=T)
{
 #collections      = c("58C", "NBS", "T2D", "RA", "CD", "BD", "CAD", "HT", "BC", "T1D")
  collections      = c("NBS")
  jcalls_dir        = get_coutput_dirs(coutput_root=this_run_loc, er=expanded_reference)$jd
  #sample_names_fn = "./misc/sample_names_Duplicates1_normal_summary_seed=1.txt"
  sample_files_dir = "/data/garganey/cardin/postdoc/CNVs/calling/testing/cnvtest/cnv_files/"
  sn_fn            = get_sample_names_fn(coutput_root=.default.coutput_root)
  msQC_full_fn = get_msqc_fn()
  msQC         = read.table(msQC_full_fn, as.is=T, header=T, sep="\t")
  msQC_NBS     = msQC[which(msQC[,"Cohort"]=="NBS"),]
  no_all_NBS_inds  = nrow(msQC_NBS); #841, but I exclude some, and only get left with 816)
  cnvs             = 1:4178; #1:100
  
   cat("Reading in sample Names...")
   lines           = readLines(sn_fn)  
   cat("  Parsing Sample Names...")
   split_lines     = sapply(lines, strsplit, split=" ") #Loads in the object: names
   sample_names    = as.list(rep(NA, length(lines)))
    
   for(coll in 1:length(lines))
   {
     sample_names[[coll]] = split_lines[[coll]][-c(1)]
     names(sample_names)[coll] = split_lines[[coll]][1]
   }
   cat("Done.\n")
   msQC_NBS_calls_order = msQC_NBS[match(msQC_NBS[,"WTCCC_name"], sample_names$NBS),]
   no_inds = length(sample_names$NBS)


  if(anew) {
    cat("Reading in data...\n On cnv:")
    calls = as.list(rep(NA, length(cnvs))) #No longer do this as it was impossible to hold them all in memory.
    connections = as.list(rep(NA, length(collections)))
    calls_fns   = paste(jcalls_dir, "sortedcalls_orig_mean_", collections, ".txt", sep="")
    # connections = sapply(calls_fns, open)   #connections = sapply(calls_fns, file)
  for(coll in 1:length(collections)) connections[[coll]] = file(description = calls_fns[coll], open="r");
    for(cnv in cnvs)
    {
      cat(cnv, " ", sep="")
      calls[[cnv]] = as.list(rep(NA, length(collections)))
      for(coll in 1:length(collections))  
      {
       #calls[[cnv]][[coll]] = read.table(calls_fn, as.is=T, header=F, skip=cnv-1, nrow=1)
       #calls[[coll]] = read.table(connections[[coll]], as.is=T, header=F, skip=0, nrow=1)  
        calls[[cnv]][[coll]] = read.table(connections[[coll]], as.is=T, header=F, skip=0, nrow=1)
  
       #Can't put in the individual names if nocl>1 !
       #colnames(calls[[cnv]][[coll]]) = c("chr", "cnvid", "pos", "nocl", sample_names[[which(names(sample_names)==collections[coll])]])
      }  
    }
    sapply(connections, close)
    save(calls, file=paste(jcalls_dir, "all_NBS_calls_.RData"))
    cat(" Done.\n")
  } else {
    cat("Loading calls...")
    callsname = load(file=paste(jcalls_dir, "all_NBS_calls_.RData"))
    cat("Done.\n")
  }
  nocls     = sapply(calls, function(x) x[[1]][,4] )
  cnv_names = sapply(calls, function(x) x[[1]][,2] )
  

  duplicate_names   = get_dups_from_msQC()
  duplicate_indices = dup_inds_from_names(duplicate_names=duplicate_names, msQC_NBS_calls_order=msQC_NBS_calls_order)
  # dn2 = msQC[,"WTCCC_name"][duplicate_indices] #Loses the matrix structure. How to retain it?


  simplerv1 = calc_concordance(cnv_dat=calls[[1]], pairs=duplicate_indices, collind=1, call_thresh=call_thresh, no_inds=no_inds)
  simplerv2 = calc_concordance(cnv_dat=calls[[2]], pairs=duplicate_indices, collind=1, call_thresh=call_thresh, no_inds=no_inds)
  sconcs = sapply(calls[1:80], calc_concordance, pairs=duplicate_indices, collind=1, call_thresh=call_thresh, no_inds=no_inds)
  cat("\n");

  conc_and_missing = sapply(calls, calc_concordance, pairs=duplicate_indices, collind=1, call_thresh=call_thresh, no_inds=no_inds)
  colnames(conc_and_missing) = cnv_names
  save(conc_and_missing, file=paste(jcalls_dir, "conc_and_missing.RData", sep=""))# load(paste(jcalls_dir, "conc_and_missing.RData", sep=""))
  poly_cm         = conc_and_missing[,nocls>1]
  cat("\n");
  concs = conc_and_missing[1,]
  which_comparable = conc_and_missing[1,]>0
  can_compare      = conc_and_missing[,which(which_comparable)]
  conc_nocleq2     = conc_and_missing[,which(which_comparable & nocls==2)]
  conc_nocleq3     = conc_and_missing[,which(which_comparable & nocls==3)]
  conc_noclgte3    = conc_and_missing[,which(which_comparable & nocls>=3)]
  conc_low_missing = conc_and_missing[,which(which_comparable & (unlist(conc_and_missing[4,]))/816<0.1) ]
  conc_vlow_missing= conc_and_missing[,which(which_comparable & (unlist(conc_and_missing[4,]))/816<0.01)]

  total_agrees     = sum(unlist(can_compare[1,]))
  total_disagrees  = sum(unlist(can_compare[2,]))
  overall_concordance = total_agrees/(total_agrees+total_disagrees)
  nocl_2_agrees     = sum(unlist(conc_nocleq2[1,]))
  nocl_2_disagrees  = sum(unlist(conc_nocleq2[2,]))
  nocl_2_concordance = nocl_2_agrees/(nocl_2_agrees+nocl_2_disagrees)
  nocl_3_agrees     = sum(unlist(conc_nocleq3[1,]))
  nocl_3_disagrees  = sum(unlist(conc_nocleq3[2,]))
  nocl_3_concordance = nocl_3_agrees/(nocl_3_agrees+nocl_3_disagrees)

  lowmiss_agrees     = sum(unlist(conc_low_missing[1,]))
  lowmiss_disagrees  = sum(unlist(conc_low_missing[2,]))
  lowmiss_concordance = lowmiss_agrees/(lowmiss_agrees+lowmiss_disagrees)
  vlowmiss_agrees     = sum(unlist(conc_vlow_missing[1,]))
  vlowmiss_disagrees  = sum(unlist(conc_vlow_missing[2,]))
  vlowmiss_concordance = vlowmiss_agrees/(vlowmiss_agrees+vlowmiss_disagrees)


  if(make_png) png(file=paste(jcalls_dir, "histogram_of_concordances_allpoly.png", sep=""), width=1200, height=800)
  hist(unlist(can_compare["concordance"  ,]), n=100, col="lightgrey", xlab="Concordance", main="Histogram of Concordances across CNVs called as polymorphic")
  if(make_png) dev.off()
  if(make_png) png(file=paste(jcalls_dir, "histogram_of_concordances_3+classes.png", sep=""), width=1200, height=800)
  hist(unlist(conc_noclgte3["concordance",]), n=100, col="lightgrey", xlab="Concordance", main="Histogram of Concordances across CNVs woth 3+ classes")
  if(make_png) dev.off()
  
  browser();
  all_missing1    = which(poly_cm[2,]==94);  all_missing2 = which(poly_cm[1,]==-1); check = sum(all_missing1==all_missing2)==length(all_missing1)
  missing_cut_off = 0.2
  many_missing1   = which(poly_cm[2,]>(94*missing_cut_off))
  if(length(all_missing1)>0) some_hcalls_cm = poly_cm[,-all_missing1] else some_hcalls_cm = poly_cm

 #concs   = conc_and_missing$concordance
 #missing = conc_and_missing$missing
  #print(concs[,can_compare])
  mean_concs_all = mean(concs, na.rm=T); mean_concs_2plus = mean(concs[which(nocls>=2)], na.rm=T); mean_concs_3plus = mean(concs[which(nocls>=3)], na.rm=T); 
  perfect_concs_all = sum(concs>(1-1E-5), na.rm=T); perfect_concs_2plus = sum(concs[which(nocls>=2)]>(1-1E-5), na.rm=T); perfect_concs_3plus = sum(concs[which(nocls>=3)]>(1-1E-5), na.rm=T); 
  gt95_concs_all = sum(concs>0.95, na.rm=T); gt95_concs_2plus = sum(concs[which(nocls>=2)]>0.95, na.rm=T); gt95_concs_3plus = sum(concs[which(nocls>=3)]>0.95, na.rm=T); 
  cat("Total no called as polymorphic = ", sum(nocls>=2), ", and total number called as having at least classes = ", sum(nocls>=3), "\n")
  cat("Number of 2+classes >0.95 conc = ", gt95_concs_2plus, ", and number of 3+classes >0.95 conc = ", gt95_concs_3plus, "\n");
  cat("Average concordance in polymorphic CNVs= ", mean_concs_2plus, "and number perfect = ", perfect_concs_2plus, "\n");
  cat("Average concordance in 3+ classes  CNVs= ", mean_concs_3plus, "and number perfect = ", perfect_concs_3plus, "\n");
  return(concs)
}


#Calculates concordances and no_missing. If only one class returns -2,-2. If all data is missing returns conc/no_(dis)agree=-1. 
calc_concordance=function(this_run_loc = .default.coutput_root, this_run_name=write_tag, 
                          cnv_dat, pairs, collind=1, call_thresh=0.95, no_inds=816)
{
  cat(".")
  nocl         = cnv_dat[[collind]][1,4]
  if(nocl>1)
  {
    dup_indices1 = pairs[,1]
    dup_indices2 = pairs[,2]
    c_and_m1   = dup_hcalls(indices = dup_indices1, nocl=nocl, dat=cnv_dat[[collind]], call_thresh=call_thresh, no_inds=no_inds)
    c_and_m2   = dup_hcalls(indices = dup_indices2, nocl=nocl, dat=cnv_dat[[collind]], call_thresh=call_thresh, no_inds=no_inds)
    cnv_calls1 = c_and_m1$hcalls
    cnv_calls2 = c_and_m2$hcalls
    no_missing = c_and_m1$no_missing; check = (no_missing == c_and_m2$no_missing); if(!check) {cat("  Problem with no_missing calc.\n"); browser();}
    no_dups_missing = sum(cnv_calls1==-3 | cnv_calls2 ==-3)
   #get_missingness = dup_hcalls(indices = , nocl=nocl, dat=cnv_dat[[collind]], call_thresh=call_thresh) This will be very slow!!
   #no_NAs       = sum(is.na(cnv_calls1+cnv_calls2))
    if(no_dups_missing == nrow(pairs)) {
     #if(no_missing < 600) {cat("  Surely there should be some duplicates both called?\n"); browser()}
      no_agree     = -1
      no_disagree  = -1
      concordance  = -1
    } else {
      no_agree     = sum((cnv_calls1!=-3 & cnv_calls2!=-3) & (cnv_calls1==cnv_calls2))
      no_disagree  = sum((cnv_calls1!=-3 & cnv_calls2!=-3) & (cnv_calls1!=cnv_calls2))
      concordance  = no_agree/(nrow(pairs) - no_dups_missing)
    }
    rv = list("no_agree"= no_agree, "no_disagree"=no_disagree, "concordance"=round(concordance, digits=4), "no_missing" = no_missing)
  } else {
    rv = list("no_agree"= -2, "no_disgaree"=-2, "concordance"=-2, "no_missing" = -2)
    return(rv)
  }
  return(rv)
}

single_call=function(x, dat2, call_thresh) {
  hc = dat2[1,x]>call_thresh; 
  if(sum(hc)==0) return(-3) else return(which(hc))
}

dup_hcalls=function(indices, nocl, dat, call_thresh=0.95, preamble_cols = 1:4, no_inds=816)
{
  no_dups = length(indices)
  if((no_inds%%1 != 0) | (no_dups%%1 != 0)) {cat(" Error - have miscalculated number of individuals.\n"); browser()}
  dup_cols                         = matrix(NA, nrow=no_dups, ncol=nocl)
  all_ind_cols = matrix(NA, nrow=no_inds, ncol=nocl)
  for(cl in 1:nocl) dup_cols[,cl]      = indices     * nocl - nocl + cl
  for(cl in 1:nocl) all_ind_cols[,cl]  = (1:no_inds) * nocl - nocl + cl
  if(nocl==3) browser();

  hcalls = rep(NA, no_dups)
  dat2   = dat[1,-preamble_cols]>call_thresh
  missing_dat_inds = apply(all_ind_cols, 1, function(x, dat2) {sum(!dat2[1,x])==length(dat2[1,x])}, dat2=dat2 )
  no_missing = length(which(missing_dat_inds))
 #not_miss   = which(!missing_dat_inds)
 #not_miss_dups = intersect(not_miss, indices)
 #if(length(not_miss_dups)>0) hcalls_dups = apply(all_ind_cols[not_miss_dups,], 1, function(x, dat2, call_thresh) {which(dat2[1,x]>call_thresh)}, dat2=dat2, call_thresh=call_thresh)
  hcalls_dups = apply(dup_cols, 1, single_call, dat2=dat2, call_thresh=call_thresh)

  if(0) {
    for(ind in 1:no_dups)
    {
      if(max(dat[1,dup_cols[ind,]])>=call_thresh) {
        hcalls[ind] = which.max(dat[1,max(preamble_cols) + dup_cols[ind,]])
      } else {
        hcalls[ind] = NA
      }
     #print(dat[1,indices[ind,]])
    }
  }
  rv = list("hcalls"=hcalls_dups, "no_missing"=no_missing)
  return(rv)
}

dup_inds_from_names=function(duplicate_names, msQC_NBS_calls_order)
{
  first_run  = match(duplicate_names[,"wtcccN1"], msQC_NBS_calls_order[,"WTCCC_name"])
  second_run = match(duplicate_names[,"wtcccN2"], msQC_NBS_calls_order[,"WTCCC_name"])
  dup_indices = cbind(first_run, second_run)
  return(dup_indices)
}

# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); get_dups_from_msQC();
get_dups_from_msQC=function(ann_dir    = get_dir_names()$sang_ann_dir, msQCfn = "MASTER_sample_QC.txt")
{
  msQC_full_fn = paste(ann_dir, msQCfn, sep="")
  msQC         = read.table(msQC_full_fn, as.is=T, header=T, sep="\t")
  nml_name     = "WTCCC_name"
  nml_names    = msQC[,nml_name]
  NBS_inds     = which(msQC[,"Cohort"]=="NBS")
  NBS_nmln     = nml_names[NBS_inds]
  NBS_ext_name = msQC[NBS_inds,"External_name"]

  NBS_EN_woFs  = sapply(NBS_ext_name, strip_Fs)     # The NBS individuals' external names with the -F and _F tags removed.
  number_that_match = sum(duplicated(NBS_EN_woFs))  # The number of individuals who's stripped names appear exactly twice (94!!)
  ENof_dups    = msQC[NBS_inds,"External_name"][duplicated(NBS_EN_woFs)] #The 'External_name's of these duplicated individuals
  dup_checks   = sapply(sapply(ENof_dups, strip_Fs), check_duplicated, stripped_all_Enames = sapply(msQC[,"External_name"], strip_Fs))
  WTCCCn_dups  = t(sapply(sapply(ENof_dups, strip_Fs), getwtccc_name   , stripped_all_Enames = sapply(msQC[,"External_name"], strip_Fs), 
                        allWTCCC_names=msQC[,"WTCCC_name"], full_all_Enames = msQC[,"External_name"]))
 #write.table(WTCCCn_dups, file="wtccc_NBS_dup_names.txt", quote=T, row.names=F, col.names=T)
  return(WTCCCn_dups)  
}

# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); get_alldups_from_msQC();
get_alldups_from_msQC=function(ann_dir = get_dir_names()$sang_ann_dir, msQCfn = "MASTER_sample_QC.txt")
{
  msQC_full_fn = paste(ann_dir, msQCfn, sep="")
  msQC         = read.table(msQC_full_fn, as.is=T, header=T, sep="\t")
  wtccc_name   = "WTCCC_name"
  wtccc_names  = msQC[,wtccc_name]
  ext_name     = msQC[,"External_name"]

  EN_woFs      = sapply(ext_name, strip_Fs)     # All individuals' external names with the -F and _F tags removed.
  number_that_match = sum(duplicated(EN_woFs))  # The number of individuals who's stripped names appear exactly twice (94!!)
  ENof_dups    = msQC[,"External_name"][duplicated(EN_woFs)] #The 'External_name's of these duplicated individuals
  dup_checks   = sapply(sapply(ENof_dups, strip_Fs), check_duplicated, stripped_all_Enames = sapply(msQC[,"External_name"], strip_Fs))
  WTCCCn_dups  = t(sapply(sapply(ENof_dups, strip_Fs), getwtccc_name   , stripped_all_Enames = sapply(msQC[,"External_name"], strip_Fs), 
                        allWTCCC_names=msQC[,"WTCCC_name"], full_all_Enames = msQC[,"External_name"]))
 #write.table(WTCCCn_dups, file="wtccc_NBS_dup_names.txt", quote=T, row.names=F, col.names=T)
  return(WTCCCn_dups)  
}


getwtccc_name=function(stripped_ENof_dup, stripped_all_Enames, allWTCCC_names, full_all_Enames)
{
  no_matches    = sum(stripped_all_Enames==stripped_ENof_dup)
  if(no_matches!=2) {cat("Problem with name: ", stripped_ENof_dup, "\n"); browser();}
  name_types    = c("ExtN1", "ExtN2", "wtcccN1", "wtcccN2")
  all_names_dup = matrix(NA, nrow=2, ncol=length(name_types))
  dup_indices   = which(stripped_all_Enames==stripped_ENof_dup)
  if(length(dup_indices)!=2) {cat("Problem with name: ", stripped_ENof_dup, "\n"); browser();}
  return_names  = c(full_all_Enames[dup_indices[1]], full_all_Enames[dup_indices[2]], allWTCCC_names[dup_indices[1]], allWTCCC_names[dup_indices[2]])
  names(return_names) = name_types
  return(return_names)
}

check_duplicated=function(stripped_ENof_dup, stripped_all_Enames)
{
  no_matches = sum(stripped_all_Enames==stripped_ENof_dup)
  if(no_matches==2) {
    return(TRUE) 
  } else { 
    cat("Problem with name: ", stripped_ENof_dup, "\n");
    browser();
    return(FALSE)
  }
}

strip_Fs=function(string)
{
  len = nchar(string)
  if(check_for_F(string)) string = substr(string, 1, len-2)
  return(string)
}


#Note - this is the NEW sample conversion file. It is no longer tabule.
# options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); parse_ms_conversion();
parse_ms_conversion=function(ann_dir = get_dir_names()$sang_ann_dir, 
                             mscfn = "df3_MASTER_sample_conversion.txt",     no_lines=6335    ,
                         old_mscfn =     "MASTER_sample_conversion.txt", old_no_lines=498    )
{
  old_msc = read.table(paste(ann_dir, old_mscfn, sep=""), as.is=T, header=T)

  msc            = as.list(rep(NA, no_lines))
  msc_core_colls = matrix(NA, nrow = no_lines, ncol = ncol(old_msc))
  msc_core_colls = data.frame(msc_core_colls)
  full_msc_fn    = paste(ann_dir, mscfn, sep="")
  header         = read.table(full_msc_fn, as.is=T, header=F, nrow=1)
  colnames(msc_core_colls) = header[1:16]
  cat("On line: ")
  for(line in 1:no_lines)
  {
    if(line%%200==0) {cat(line, ", ", sep="")}
    msc[[line]]           = read.table(full_msc_fn, as.is=T, header=F, skip = line, nrow=1)
    msc_core_colls[line,] = msc[[line]][1,1:ncol(old_msc)]
  }
  cat("\n");
  msc_colls = msc_core_colls[,"Cohort"]
  msc_reps  = msc_core_colls[,"Replicate"]
  NBS_inds  = which(msc_colls=="NBS")
  rep_inds  = which(msc_reps==TRUE)
  NBS_rep_inds1  = intersect(rep_inds, NBS_inds)
  msc_core_colls[NBS_rep_inds1[1],]
  browser();
  return(msc)
}

check_for_F=function(string)
{
  len = nchar(string)
  dash_or_underscore_F = substr(string,len-1,len)=="-F" | substr(string,len-1,len)=="_F"
 #browser();
  return(dash_or_underscore_F)
}
check_for_dashF=function(string)
{
  len = nchar(string)
  return(substr(string,len-1,len)=="-F")
}
check_for_underscoreF=function(string)
{
  len = nchar(string)
  return(substr(string,len-1,len)=="_F")
}

get_dups_from_kathys_new_file=function(write=F)
{
  wd = getwd()
  setwd("/data/garganey/cardin/postdoc/CNVs/ccc+_main/from others/")
  sa = read.table("stirrups_Replicates_in_WTCCC_CNV.csv", as.is=T, header=T, sep=",")
  ms = read.table("../MASTER_sample_QC.txt", as.is=T, header=T, sep="\t")
  dupinds = which(!is.na(sa[,"WTCCC_name_Resupply"]))
  dups = sa[dupinds,]
  sdups = dups[,c(1,2,3,7,8)]
  browser()
  setwd(wd)
  dups_fn = paste(get_dir_names()$ox_inputs_dir, "duplicates_from_kathys_file.txt", sep="")
  if(write) write.table(sdups, file=dups_fn, quote=F, col.names=T, row.names=F)
  return(dups)
}

#options(error=recover);  setwd("/net/markov/export/postdocs/cardin/My Documents/postdoc/CNVs/calling"); source("cnv_caller.R"); 
metrics_vs_DLRS=function()
{
  ann_dir      = get_dir_names()$sang_ann_dir;
  msQCfn       = "MASTER_sample_QC.txt"
  msQC_full_fn = paste(ann_dir, msQCfn, sep="")
  msQC         = read.table(msQC_full_fn, as.is=T, header=T, sep="\t")
  qcm_dir      = "/data/garganey/cardin/postdoc/CNVs/calling/QC/"
  qcn          = load(paste(qcm_dir, "all_QC_metrics.RData", sep=""))
  #names(all_QCs)
  calls_3cl_all_inds = unlist(all_QCs$calls3cl)
  msQC_inds    = match(msQC[,"WTCCC_name"], names(calls_3cl_all_inds))

}

# closeAllConnections(); source("cnv_caller.R"); setups(5); debug(make_verdict_plots); make_verdict_plots()
# closeAllConnections(); source("cnv_caller.R"); setups(5); make_verdict_plots()
make_verdict_plots=function(this_run_name=write_tag, this_run_loc=.default.coutput_root)
{
  vpd = get_coutput_dirs(coutput_root=this_run_loc)$verdicts_plots_dir
  if(!file.exists(vpd)) dir.create(vpd, showWarnings = FALSE)
  masterListFname           = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$masterListFname
  merged_smry_fnames  = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA)$merged_smry_cfn
  
  cat("  Reading in master CNV list..."); master_list = myload(masterListFname); cat("Done\n");
  no_cnvs      = get_no_cnvs(merged_smry_fnames[1])
  preamble_con = file(merged_smry_fnames, open="r")

  for(cnv in 1:no_cnvs) {
    if(cnv%%10  ==0) cat(".");
    if(cnv%%500 ==0) cat("On CNV ", cnv, "\n");
    this_cnv_info    = scan(preamble_con, skip=0, nlines=1, what=character(0), quiet=T)
    nocl             = as.numeric(this_cnv_info[4]); 
    cnv_name         = this_cnv_info[2]
    mffn             = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$merged_fits_fn
    merged_fit       = myload(mffn)
    verdicts_plot_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$verdicts_plots_fn;
    pdf(file=verdicts_plot_fn, width=15.5, height=10)
    pcolls = c("NBS", "BC", "CD", "CAD", "T2D", "RA", "HT", "BD", "58C", "T1D")
    plotd(objects=merged_fit, dens_vals = merged_fit$mdens_vals, model_fits = merged_fit$merged_fits, master_list=master_list, 
          pcolls=pcolls)
    dev.off()
   #browser()
  }
  cat("Done.\n")
  close(preamble_con)
}

if(0) {
 masterListFname  = get_coutput_fns()$masterListFname
 ml         = myload(masterListFname)
 cnv_names = c("CNVR7499.1", "CNVR534.1", "CNVR2527.1")
 cnv_name = cnv_names[3]
 ml[which(ml[,"CNV"]==cnv_name),c("bestLocalAffy500kTagR2", "bestLocalAffy500kTagRSID")]
 ml[which(ml[,"CNV"]==cnv_name),c("bestLocalHapmapTagR2", "bestLocalHapmapTagRSID")]
 ml[which(ml[,"CNV"]==cnv_name),c("bestLocalAffy6TagR2", "bestGlobalAffy6TagRSID")]

 ml[which(ml[,"CNV"]==cnv_name),c("bestLocalAffy500kTagR2", "bestLocalAffy500kTagRSID",
                                  "bestLocalHapmapTagR2", "bestLocalHapmapTagRSID",
                                  "bestLocalAffy6TagR2", "bestGlobalAffy6TagRSID")]

}

# source("cnv_caller.R"); setups(5); make_verdicts_plot_data()
make_verdicts_plot_data=function(this_run_name=write_tag, this_run_loc=.default.coutput_root)
{
  mfd = get_coutput_dirs(coutput_root=this_run_loc)$merged_fits_dir 
  if(!file.exists(mfd)) dir.create(mfd, showWarnings = FALSE)
  merged_smry_fnames  = get_coutput_fns(coutput_root=this_run_loc, cnv_name=NA)$merged_smry_cfn
  
  preamble_con = file(merged_smry_fnames, open="r")
  no_cnvs      = get_no_cnvs(merged_smry_fnames[1])
  for(cnv in 1:no_cnvs) {
    if(cnv%%10  ==0) cat(".");
    if(cnv%%500 ==0) cat("On CNV ", cnv, "\n");
    this_cnv_info   = scan(preamble_con, skip=0, nlines=1, what=character(0), quiet=T)
    nocl            = as.numeric(this_cnv_info[4]); 
    cnv_name        = this_cnv_info[2]
    inf_smry        = myload(get_coutput_fns(this_run_name=this_run_name, cnv_name=cnv_name)$fit_fn)
    inf_args        = read.table(get_coutput_fns(this_run_name=this_run_name, cnv_name=cnv_name)$args_input_fn, as.is=T, header=F, fill=T)
    fit             = make_objects_from_cfitoutput(inf_smry, inf_args=inf_args); fit$flags$cnv=cnv;
    merged_fit      = post_bic_simple_merge(fit=fit, pars=fit$opars, mode_counter="simple_nc") 
    save(merged_fit, file=get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$merged_fits_fn)
  }
  cat("Done.\n")
  close(preamble_con)
}

# source("cnv_caller.R"); make_manyp_verdicts_plot_data(which_pipeline=1) #Don't do 12!! That's standard
make_manyp_verdicts_plot_data=function(which_pipeline="all")
{
  pipeline_names = get_pipelines(which=which_pipeline)
  
  for(pipeline in pipeline_names)
  {
    assign(x = "project_root"         , value = "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_7/callingRoot/", envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = pipeline                                                      , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                                 , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
    make_verdicts_plot_data()
  }
}

make_a_verdicts_plot=function(this_run_name=write_tag, this_run_loc=.default.coutput_root, cnv_name, master_list=NULL, merged_fit=NULL, pdf=F, 
                              masterListFname        = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$masterListFname,
                              verdicts_plot_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$verdicts_plots_fn,
                              mffn             = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=cnv_name)$merged_fits_fn)
{
  if(is.null(master_list)) {
    cat("  Reading in master CNV list...")    
    master_list    = myload(masterListFname);           
  }
  if(is.null(merged_fit)) {
    merged_fit = myload(mffn)
  }
  if(pdf) pdf(file=verdicts_plot_fn, width=15.5, height=10)
  plotd(objects=merged_fit, dens_vals = merged_fit$mdens_vals, model_fits = merged_fit$merged_fits, master_list=master_list)
  if(pdf) dev.off()
}

get_pipelines=function(which = "all")
{
  pipelines = c("allExceptX_allCNVsAllMappings.n1_mean_allProbes", "allExceptX_allCNVsAllMappings.n1_mean_noSNPs", 
                     "allExceptX_allCNVsAllMappings.n1_pca_allProbes" , "allExceptX_allCNVsAllMappings.n1_pca_noSNPs",
                     "allExceptX_allCNVsAllMappings.n4_mean_allProbes", "allExceptX_allCNVsAllMappings.n4_mean_noSNPs", 
                     "allExceptX_allCNVsAllMappings.n4_pca_allProbes" , "allExceptX_allCNVsAllMappings.n4_pca_noSNPs",
                     "allExceptX_allCNVsAllMappings.n6_mean_allProbes", "allExceptX_allCNVsAllMappings.n6_mean_noSNPs", 
                     "allExceptX_allCNVsAllMappings.n6_pca_noSNPs"    , "allExceptX_allCNVsAllMappings.Standard",  
                     "allExceptX_allCNVsAllMappings.n6_mean_allProbes", "allExceptX_allCNVsAllMappings.n6_mean_noSNPs", 
                     "allExceptX_allCNVsAllMappings.n6_pca_noSNPs")
  if(which=="all") return(pipelines)
  return(pipelines[which])
}

# closeAllConnections(); source("cnv_caller.R"); options(warn=2); setups(5); calc_lots_of_HWEs()
calc_lots_of_HWEs=function()
{
  pipeline_names = get_pipelines(which="all")
  for(pipeline in pipeline_names)
  {
    assign(x = "project_root"         , value = "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_7/callingRoot/", envir = .GlobalEnv); 
    assign(x = "write_tag"            , value = pipeline                                                      , envir = .GlobalEnv); 
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                                 , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 

    HWEs_and_MAFs_dir = "/users/cardin/CNVs/calling/caller_output/HWEs_and_MAFs/"
    HWEs_tag = paste(HWEs_and_MAFs_dir, "", pipeline, sep="")
    MAFs_tag = paste(HWEs_and_MAFs_dir, "", pipeline, sep="")
    calc_HWE_and_MAF_data(this_run_name=pipeline, stop=T, callsets=c("merged", "unmerged"), HWEs_tag=HWEs_tag, MAFs_tag=MAFs_tag)
  }
}
# closeAllConnections(); source("cnv_caller.R"); options(warn=2); setups(3); calc_HWE_and_MAF_data(this_run_name="allExceptX_allCNVsAllMappings.Standard", callsets=c("merged", "unmerged"))

# closeAllConnections(); source("cnv_caller.R"); options(warn=2); setups(5); find_related(filetype = "rda", hcalls=hcalls, legend=legend) 
# closeAllConnections(); source("cnv_caller.R"); options(warn=2); setups(5); find_related(filetype = "rda") 
find_related=function(this_run_name=write_tag, this_run_loc=.default.coutput_root, filetype = "rda", 
        hcalls_fn          = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA, call_thresh=0.95, hcalls_filetype=filetype)$hard_calls_fn,
        merged_hcalls_fn   = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA, call_thresh=0.95, hcalls_filetype=filetype)$merged_hcalls_fn,
        merged_smry_cfn    = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$merged_smry_cfn,
        merged_qc_stats_fn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$merged_qc_stats_fn,
        hc23cl = NULL, legend23cl = NULL, hcalls=NULL, legend=NULL
      )
{
  qc        = myload(merged_qc_stats_fn)
  no_inds1  = length(unlist(qc$total_posterior_gd));
  post      = qc$cnv_stats[,"posteriors"]/no_inds1
  if(is.null(hc23cl) | is.null(legend23cl)) {
    cat("  Reading in hcalls...")
    if(filetype=="rda")  { hcalls = myload(merged_hcalls_fn) } else
    { 
      if(filetype=="text.gz") hcalls_con = gzfile(merged_hcalls_fn, open="r")
      if(filetype=="txt"    ) hcalls_con =   file(merged_hcalls_fn, open="r")
      hcalls = read.table(hcalls_con, as.is=T, header=T)
      close(hcalls_con)
    }
    cat(" Done\n");
    legend1   = read.table(merged_smry_cfn, as.is=T, header=F)
    legend    = hcalls[,1:4]
    hcalls    = hcalls[,-(1:4)]

    nocl_theory = legend[,4]; names(nocl_theory)=legend[,2]
    check_cnv_order = sum(names(post)==names(nocl_theory))==length(post)

    high_post          = which(post>0.975)
    two_or_three_class = which(nocl_theory %in% c(2,3))
    gd_cnvs            = sort(intersect(high_post, two_or_three_class), decreasing=F)
    hc23cl     = hcalls[gd_cnvs,]
    legend23cl = legend[gd_cnvs,]
    rm(hcalls); gc(); gc();
  }
  no_inds2  = ncol(hcalls)
  check     = no_inds1==no_inds2; if(!check) {cat("  Warning! Disagreement about the number of individuals.\n"); browser()}
  
  ind_names = colnames(hcalls)
  rel_scores = get_relatedness_matrix(hcalls = hc23cl)
  cat("Done.\n");
  save(rel_scores, file=paste(this_run_loc, "relatedness.rda", sep=""))
  browser()
}
# closeAllConnections(); library(cccpCallNJC);  options(warn=2); setups(2); find_heterozygosity(filetype = "rda") 
find_heterozygosity=function(this_run_name=write_tag, this_run_loc=.default.coutput_root, filetype = "rda", 
       merge = T, ldf=T, goodCNVPosteriorThreshold=0.975,
       sampleNames  = get_sample_names(),
       collections  = names(sampleNames),
       merged_hcalls_fn   = intelligentGetFnames(merge=merge, ldf=ldf, 
                                   callThresh=0.95, fileType=filetype, sampleNames=sampleNames)$hCallsFnames,
       merged_smry_cfn    = intelligentGetFnames(merge=merge, ldf=ldf, sampleNames=sampleNames)$csmry_fns,
       merged_qc_stats_fn = intelligentGetFnames(merge=merge, ldf=ldf, sampleNames=sampleNames)$QCfname,
       hc3cl = NULL, legend3cl = NULL, hcalls=NULL, legend=NULL
      )
{
  qc        = myload(merged_qc_stats_fn)
  no_inds1  = length(unlist(qc$total_posterior_gd));
  post      = qc$cnv_stats[,"posteriors"]/no_inds1
  if(is.null(hc3cl) | is.null(legend3cl)) {
    cat("  Reading in hcalls...")
    if(filetype=="rda")  { hcalls = myload(merged_hcalls_fn) } else
    { 
      if(filetype=="txt.gz") hcalls_con = gzfile(merged_hcalls_fn, open="rt")
      if(filetype=="txt"   ) hcalls_con =   file(merged_hcalls_fn, open="rt")
      hcalls = read.table(hcalls_con, as.is=T, header=T)
      close(hcalls_con)
    }
    cat(" Done\n");
    legend1   = read.table(merged_smry_cfn, as.is=T, header=F)
    legend    = hcalls[,1:4]
    hcalls    = hcalls[,-(1:4)]
    gc(verbose=F)

    nocl_theory = legend[,4]; names(nocl_theory)=legend[,2]
    check_cnv_order = sum(names(post)==names(nocl_theory))==length(post)

    high_post          = which(post>goodCNVPosteriorThreshold)
    three_class        = which(nocl_theory %in% c(3))
    gd_3clcnvs         = sort(intersect(high_post,        three_class), decreasing=F)
    hc3cl     = hcalls[gd_3clcnvs,]
    legend3cl = legend[gd_3clcnvs,]
    rm(hcalls); gc(); gc();
  }
  ind_names = colnames(hc3cl)
  no_inds2  = ncol(hc3cl)
  check     = no_inds1==no_inds2; if(!check) {cat("  Warning! Disagreement about the number of individuals.\n"); browser()}

  heteroz = rep(NA, length=no_inds1)
  names(heteroz) = ind_names
  cat("Calculating relatedness and heterozygosity:")
  for(ind1 in 1:no_inds1)
  {
    heteroz[ind1] = get_heterozygosity(calls1=hc3cl[,ind_names[ind1]]); 
    if(ind1==2) cat("Done individual 1.\n"); if(ind1%%200==0) cat("."); if(ind1%%2000==0) cat("On Individual1=", ind1, "\n")
  }
  cat("Done.\n");
  save(heteroz, file=getStatFnames(ldf=ldf, merge=merge, this_run_loc=this_run_loc)$heterozygosityFname)
}

# file=getStatFnames(ldf=ldf, merge=merge)$byCollectionHWEfname
getStatFnames=function(this_run_loc = .default.coutput_root, write_tag=NULL,
                                ldf=T, merge=T)
{
  if(ldf  ) ldfExtra   = "ldf"    else ldfExtra   = "nonLdf" 
  if(merge) mergeExtra = "Merged" else mergeExtra = "nonMerged" 
  if(!is.null(write_tag)) write_tag = paste(write_tag, "_", sep="")
  heterozygosityFname  = paste(this_run_loc, write_tag, ldfExtra, mergeExtra, "Heterozygosity.rda" , sep="")
  HWEfname             = paste(this_run_loc, write_tag, ldfExtra, mergeExtra, "HWE.txt"            , sep="")
  MAFfname             = paste(this_run_loc, write_tag, ldfExtra, mergeExtra, "MAF.txt"            , sep="")
  byCollectionHWEfname = paste(this_run_loc, write_tag, ldfExtra, mergeExtra, "HWEbyCollection.txt", sep="")
  byCollectionMAFfname = paste(this_run_loc, write_tag, ldfExtra, mergeExtra, "MAFbyCollection.txt", sep="")
  rv = list("heterozygosityFname" =heterozygosityFname, 
            "HWEfname"            =HWEfname,
            "MAFfname"            =MAFfname,
            "byCollectionHWEfname"=byCollectionHWEfname,
            "byCollectionMAFfname"=byCollectionMAFfname)            
  return(rv)
}                            

get_relatedness_matrix=function(hcalls)
{
  no_inds = ncol(hcalls)  
  hcallsb = hcalls
  scores = matrix(NA, nrow=no_inds, ncol=no_inds)
  for(ind in 1:(no_inds-1))
  {
    if(ind%%10==0) cat(ind, ", ")
    hcallsb      = cbind(hcallsb[,-1], rep(NA, nrow(hcallsb)))
    tmp          = abs(hcalls-hcallsb)
    no_not_NAs   = colSums(!is.na(tmp))
    scores[,ind] = colSums(tmp, na.rm=T)/(2*no_not_NAs)
  }
  cat(" Done\n");
  return(scores)
}

get_relatedness=function(calls1, calls2)
{
  no_not_NAs = sum(!is.na(calls1+calls2))
  score      = sum(abs(calls1-calls2), na.rm=T)/(2*no_not_NAs)
  return(score)
}
get_heterozygosity=function(calls1)
{
  heteroz = sum(calls1==1, na.rm=T)/length(calls1)
  return(heteroz)
}

## A linux only function to quickly pull out the calls for a single CNV. This is unlikely to be very efficient if you'll want more than 10 CNVs in total (use fgrep -f for that)
## The function (by default will return the names of the individuals and the CNV, though if you're getting lots of CNVs that's not so efficient)
## The function splits the response into a list. The names, 4 details of the CNV and then the data. Ids will be attached to the latter two if getNames=TRUE
## By default it'll also check whether a CNV is polymorphic or not for you (though this shouldn't get in your way)
getSingleCNVhardCalls=function(call_thresh=0.8, hcalls_filetype="txt", getNames=TRUE, cnvName=NULL, getCNV=TRUE, checkPoly=TRUE)
{
  if(is.null(cnvName) & getCNV) {cat("  Warning, can't get you the data at a NULL CNV! returning at most names.\n"); getCNV=FALSE}
  merged_hcalls_fn = get_coutput_fns(call_thresh=call_thresh, hcalls_filetype=hcalls_filetype)$merged_hcalls_fn
  if(getNames) {
    getNamesCom      = paste("head -n ", "1", " ", merged_hcalls_fn, sep="")
    indNames1        = system(getNamesCom, intern=T)
    indNames2        = strsplit(paste(indNames1, sep="", collapse=""), " ")[[1]]
    indNames         = indNames2[-(1:4)]
    preambleHeaders  = indNames2[  1:4 ]
  } else {indNames=NULL; preambleHeaders=NULL}

  if(getCNV)
  {
    smryFn           = get_coutput_fns(call_thresh=0.8, hcalls_filetype="txt")$merged_smry_cfn
    numLines         = get_no_cnvs(smryFn)
    lineNum          = getLineNum(pattern=cnvName, file=smryFn)
    if(is.null(lineNum)) {cat("Couldln't find this CNV! Sorry.\n"); return(NULL)}
    
    headTailCom = paste("head -n ", lineNum+1, " ", merged_hcalls_fn, " | tail -n 1 ", sep="")
    tailHeadCom = paste("tail -n ", (numLines-lineNum)+1, " ", merged_hcalls_fn, " | head -n 1 ", sep="")
    if(lineNum<=numLines/2) hcalls1   = system(headTailCom, inter=T) else hcalls1   = system(tailHeadCom, inter=T) 
   #hcalls1   = system(headTailCom, inter=T)
    hcalls2  = paste(hcalls1, sep="", collapse="")
    hcalls3  = strsplit(hcalls2, " ")[[1]]
    preamble = hcalls3[1:4]               ;
    CNVdata  = as.numeric(hcalls3[-(1:4)]);
    if(getNames) {
      names(preamble) = preambleHeaders
      names(CNVdata ) = indNames
    }
    checkRightLine = preamble["cnv_name"]==cnvName
    if(!length(checkRightLine)==1) {cat("  Warning!! Haven't parsed cnv data correctly in getSingleCNVhardCalls.\n"); browser()} #Perhaps you've called the function incorrectly?
    if(!checkRightLine) {cat("  Warning!! May not have pulled out the right line.\n"); browser()}
  } else {CNVdata=NULL; preamble=NULL}
  if(checkPoly) if(length(setdiff(unique(CNVdata), NA))>1) poly=T else poly=F else poly=NULL
  rv = list("indNames"= indNames, "preamble"=preamble, "CNVdata"=CNVdata, "poly"=poly)
  return(rv)
}

# closeAllConnections(); library(cccpCallNJC); options(warn=2); setups(3); calc_HWE_and_MAF_data()
# closeAllConnections(); options(warn=2); calc_HWE_and_MAF_data(DEBUG=2, write=F, stop=T)
calc_HWE_and_MAF_data=function(this_run_name=write_tag, this_run_loc=.default.coutput_root, 
                               no_preamble_cols=4, 
                               sample_names=get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
                               collections =names(sample_names),
                               stop=T, MAFs_tag=NULL, HWEs_tag=NULL, write=T, 
                               exclusions_fn=NULL,
                               ldfs=c(T,F), merges=c(T,F),
                               DEBUG=1)
{
  if(!is.null(exclusions_fn)) {
    exclusions <- as.character(read.delim(exclusions_fn, header=FALSE)[[1]])
  }
  for(ldf in ldfs)
  {
    for(merge in merges)
    {
      cat(" Calculating HWEs and MAFs for: ", "ldf=", ldf, " and merge=", merge, " calls.\n", sep="")
      # Create filenames according to ldf/merge status
      calls_fns   = intelligentGetFnames(merge=merge, ldf=ldf, sampleNames=sample_names, collections=collections)$calls_fns
      smry_fnames = intelligentGetFnames(merge=merge, ldf=ldf, sampleNames=sample_names, collections=collections)$csmry_fns

      preamble_con     = file(smry_fnames, open="r")
      no_cnvs          = get_no_cnvs(smry_fnames[1])
      noco             = length(collections)
      sample_names     = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc)
      coll_order       = match(collections, names(sample_names))
      sample_names     = sample_names[coll_order]
      all_sample_names = standardise_names(nms=unlist(sample_names), verbose=F)[,"ccc_name"]; names(all_sample_names) = NULL
      no_inds_vec      = sapply(sample_names, length)
      MAFs             = rep(NA, no_cnvs); 
      HWEs             = rep(NA, no_cnvs)

      calls_cons = as.list(rep(NA, length(calls_fns)))
      for(callsfn in 1:length(calls_fns)) calls_cons[[callsfn]] = file(calls_fns[callsfn], open="r")
      skip      = 0
      coll_MAFs = matrix(NA, ncol=noco, nrow=no_cnvs); 
      colnames(coll_MAFs)      = collections
      rownames(coll_MAFs) = paste("tmp", 1:nrow(coll_MAFs))
      for(cnv in 1:no_cnvs) {
        if(cnv%% 40  ==0) cat(".");
        if(cnv%%2000 ==0) cat("On CNV ", cnv, "\n");
        this_cnv_info   = scan(preamble_con, skip=0, nlines=1, what=character(0), quiet=T)
        nocl            = as.numeric(this_cnv_info[4]); 
        cnv_name        = this_cnv_info[2]
        rownames(coll_MAFs)[cnv] = cnv_name
        if(nocl>1) {
          calls_mat       = matrix(NA, nrow=0, ncol=nocl, byrow=T)
          controls_mat    = matrix(NA, nrow=0, ncol=nocl, byrow=T)
          calls_mats      = as.list(rep(NA, noco))
          for(coll in 1:noco)
          {
            calls          = scan(calls_cons[[coll]], skip=skip, nlines=1, what=character(0), quiet=T ) #This increments when nocl==1 as no need to read in calls.
            na_info_check  = sum(is.na(calls[1:4])==is.na(this_cnv_info[1:4]))==4; if(!na_info_check) {cat("  Error! ambiguity about CNV-calls details.\n"); browser();}
            info_check     = sum(calls[1:4]==this_cnv_info[1:4], na.rm=T)==sum(!is.na(calls[1:4])); if(!info_check) {cat("  Error! ambiguity about CNV-calls details.\n"); browser();}
           #calls_mat      = matrix(as.numeric(calls[-(1:no_preamble_cols)]), nrow=no_inds_vec[coll], byrow=T)
            calls_mats[[coll]] = matrix(as.numeric(calls[-(1:no_preamble_cols)]), ncol=nocl, byrow=T)
            rownames(calls_mats[[coll]]) = sample_names[[coll]]
            if(!is.null(exclusions_fn)) {
              samplesToUse <- setdiff(row.names(calls_mats[[coll]]), exclusions)
              calls_mats[[coll]] <- calls_mats[[coll]][samplesToUse,]
            }
            calls_mat      = rbind(calls_mat, calls_mats[[coll]])
            if(collections[coll] %in% c("58C", "NBS")) 
              controls_mat = rbind(controls_mat, calls_mats[[coll]])
            coll_MAFs[cnv, coll] = calc.maf(cnv.calls=calls_mats[[coll]]); 
          }
          MAFs[cnv]     = calc.maf(           cnv.calls=calls_mat   ); names(MAFs)[cnv] = cnv_name
          HWEs[cnv]     = calc.hwe.pval.exact(cnv.calls=controls_mat); names(HWEs)[cnv] = cnv_name
          if(is.na(HWEs[cnv]) | is.na(MAFs[cnv])) {
            if(DEBUG>=1) cat("  Warning, NAs in HWEs&MAFs funtion.\n")
            if(DEBUG> 1) cat("  HWE = ", HWEs[cnv], " and MAF = ", MAFs[cnv], ".\n", sep="")
            if(DEBUG> 1) browser()
          }
          if(!is.na(MAFs[cnv])) if(stop == T & MAFs[cnv]==0) {
            cat(" Warning - 0 MAF yet nocl>1!\n"); browser()
          }
          skip = 0
        } else {
          skip = skip + 1
         #for(coll in 1:noco)
         #  calls         = scan(calls_cons[[coll]], skip=0, nlines=1, what=character(0), quiet=T ) #This is only done to move through the file!
          MAFs[cnv]     = 0; names(MAFs)[cnv] = cnv_name
          HWEs[cnv]     = 1; names(HWEs)[cnv] = cnv_name
        }
      }
      # Create filenames according to ldf/merge status
      MAFsFname       = getStatFnames(ldf=ldf, merge=merge, write_tag=write_tag)$MAFfname
      HWEsFname       = getStatFnames(ldf=ldf, merge=merge, write_tag=write_tag)$HWEfname
      byCollMAFsFname = getStatFnames(ldf=ldf, merge=merge, write_tag=write_tag)$byCollectionMAFfname
     #byCollHWEsFname = getStatFnames(ldf=ldf, merge=merge, write_tag=write_tag)$byCollectionHWEfname

      if(write) {
        write.table(signif(MAFs     , digits=3), file=MAFsFname      , col.names=F, quote=F)
        write.table(signif(coll_MAFs, digits=3), file=byCollMAFsFname, col.names=T, quote=F)
        write.table(signif(HWEs     , digits=3), file=HWEsFname      , col.names=F, quote=F)
      }
      cat("Done.\n")
      for(callsfn in 1:length(calls_fns)) close(calls_cons[[callsfn]])
      close(preamble_con)
    }
  }
}

# This function is designed to take in hard-calls and if there's a very low frequency class merge it.
# Not currently used in program (isn't really appropriate for proper analyses, just helpful when you want it)
lowGnfMerge=function(preamble=NULL, calls=NULL, hcallsDetails=NULL, mergeThresh=0.01, pause=F)
{
  # There are two ways of passing the data, either pass some calls and a description vector (preamble) or giving a list with those as elements
  if(!is.null(hcallsDetails) & is.null(preamble) & is.null(calls))
  {
    preamble = hcallsDetails$preamble
    calls    = hcallsDetails$CNVdata
  }
  
  if(!is.null(preamble) & !is.null(calls))
  {
    # Find the genotype frequencies in the hard-calls
    gnfs = normalise(table(calls))

    #Identify those classes whos frequency drops below the threshold
    smallClasses = which(gnfs<mergeThresh)
    #Currently this isn't fully general, will fail with two adjacent small classes:
    if(1%in% diff(smallClasses)) {
      cat("  Can't deal with adjacent tiny classes yet.\n"); browser()
    }
    # Merge those classes (preferentially 'left') and relabel
    freqClasses = calls
    for(cl in smallClasses)
    {
      thisClInds  = which(freqClasses==cl)
      if(cl==1) {
        freqClasses[thisClInds] = cl+1
      } else    {
        freqClasses[thisClInds] = cl-1
      }
    }
    # Want to rename the possible classes in the form {1,...,n} (in case additivity is important or to compare to other calls)
    remainingLabels  = sort(unique(freqClasses), decreasing=F)
    mapLabels        = 1:length(remainingLabels); 
    names(mapLabels) = remainingLabels
    freqClasses      = mapLabels[as.character(freqClasses)]
   #freqClasses      = mapLabels[(freqClasses)]
    names(freqClasses) = names(calls)    
    if(pause) browser()
    return(freqClasses)
  }
  cat("  Shouldn't be here, unahndled exception.\n"); browser();
}


# Function to get the central x% of an empirical distribution (list of numbers)
# The function is overly conservative - it excludes at least as many individuals as the input suggests at BOTH ENDS
getCentralRegion=function(numbers, propToKeep, returnRegion=FALSE)
{
  cutOffs        = quantile(numbers, prob=c((1-propToKeep)/2, (1+propToKeep)/2))
  if(returnRegion) return(cutOffs)
  centralNumbers = numbers[numbers>cutOffs[1] & numbers<cutOffs[2]]
  return(centralNumbers)
}

# findHetCutoffs(heterozygosity=het, PropExcludeUnderNull=1/2000)
findHetCutoffs=function(heterozygosity, zCutOff=NULL, PropExcludeUnderNull=1/2000)
{
  # Can convert from probability of lying farther than some value to that value using:
  # qnorm(p=c(0.001/2, 0.33/2, mean=0, sd=1) # etc.
  centreOfDistribution = median(heterozygosity)
  measureOfVariation   = sd(getCentralRegion(numbers=heterozygosity, propToKeep=0.99))
  zCutoffs = qnorm(p=c(PropExcludeUnderNull/2, 1-(PropExcludeUnderNull/2)), mean=centreOfDistribution, sd=measureOfVariation)
  # Plots to help diagnose the cutoffs being drawn
  if(0){
    png(file=paste(this_run_loc, fn_extra, "Finding Heterozygosity Cutoffs.png", sep=""), width=1000, height=800); 
    hist(het, n=75, col="lightgrey", xlab="Heterozygosity", main="Median, 3 robust SDs based on central 0.99 and cutoffs based on 1/2000 under the Null"); 
    abline(v=centreOfDistribution, col="red"); 
    arrows(centreOfDistribution-3*measureOfVariation,600, centreOfDistribution+3*measureOfVariation, 600, col="red", code=3)
    abline(v=zCutoffs, col="green")
    dev.off()
  }
  return(zCutoffs)
}

# closeAllConnections(); options(warn=2); setups(3); debug(make_cnvtest_sample_files); make_cnvtest_sample_files()# closeAllConnections(); source("cnv_caller.R"); options(warn=2); setups(3); make_cnvtest_sample_files(write=T)
# intelligentGetQCfname(merge=T, ldf=T); intelligentGetFnames(merge=T, ldf=T, sampleNames  = get_sample_names())
# closeAllConnections(); library(cccpCallNJC); options(warn=2); setups(2); 
# makeExclusionsForTesting(use_stringent = T, write = T, pause=T, dispersionFname=paste(get_dir_names()$ox_inputs_dir, "plagnol_all_cohorts_dispersion.tab", sep=""))
# source("~/My Documents/postdoc/CNVs/calling/caller_core/cnvCall/R/post_calling_core.R")
makeExclusionsForTesting=function(this_run_name=write_tag, this_run_loc=.default.coutput_root,
                  ldf=T, merge=T,
                  qcfn = intelligentGetQCfname(merge=merge, ldf=ldf),
                  lowHet_cutoff = NULL,  highHet_cutoff = NULL, pos_cutoff = 0.967,  
                  crp_cutoff = 0.84, dispersion_cutoff=1.3,
                  lik_cutoff = 25, use_stringent = F,   
                  stringent_lowHet_cutoff = NULL, stringent_highHet_cutoff = NULL,  
                  stringent_pos_cutoff = 0.97, stringent_crp_cutoff = 0.79, 
                  stringent_lik_cutoff = 33, stringent_dispersion_cutoff = 1.2, 
                  dispersionFname = NULL,
                  het_fn = getStatFnames(ldf=ldf, merge=merge)$heterozygosityFname,
                  het    = myload(het_fn), hetCutoffRoundDigits=3,                
                  write  = T, pause=!write)
{
  #quantile(heteroz, c(0, 0.01, 0.1, 0.3, 0.5, 0.7, 0.9, 0.99, 0.999, 1))  #getwd()  #sdir = "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_7/callingRoot/caller_output/allExceptX_allCNVsAllMappings.Standard/"
  if(use_stringent) {
    lowHet_cutoff  = stringent_lowHet_cutoff
    highHet_cutoff = stringent_highHet_cutoff
    pos_cutoff = stringent_pos_cutoff
    crp_cutoff = stringent_crp_cutoff
    lik_cutoff = stringent_lik_cutoff
    dispersion_cutoff = stringent_dispersion_cutoff
  }
  qc = myload(qcfn)
  if(is.null(lowHet_cutoff)) {
    if(use_stringent)
      PropExcludeUnderNull = 1/100 else
      PropExcludeUnderNull = 1/2000
    het_cutoffs = round(findHetCutoffs(heterozygosity=het, PropExcludeUnderNull=PropExcludeUnderNull), digits=hetCutoffRoundDigits)
    lowHet_cutoff  = het_cutoffs[1]
    highHet_cutoff = het_cutoffs[2]
  }
  pos = qc$total_posterior_poly
  lik = qc$likelihoods_poly
  crp = qc$callspoly
  cat("  Breakdown of inferred numbers of classes\n"); print(table(qc$nocl))
  no_poly = sum(qc$nocls>1, na.rm=T)
  cat("  Number of polymorphic CNVs =", no_poly, "\n");
  # npos stands for 'normalised' average_maximum_posterior on calls It's normalised by number of (poly) CNVs
  npos = sapply(pos, '/', no_poly) 
  nlik = sapply(lik, '/', no_poly) 
  ncrp = sapply(crp, '/', no_poly) 
  # u = unlisted, n = normalised (to number of poly CNVs), pos=posterior, crp = call-rates-poly, like = likelihood (which is actually posterior on params not calls?)
  unpos = unlist(npos); names(unpos) = standardise_names(nms=names(unpos))[,"ccc_name"]
  uncrp = unlist(ncrp); names(uncrp) = standardise_names(nms=names(uncrp))[,"ccc_name"]
  unlik = unlist(nlik); names(unlik) = standardise_names(nms=names(unlik))[,"ccc_name"]
 #for(i in 1:20) cat(length(intersect(names(x1)[1:(10*i)], names(x2)[1:(10*i)])), ", ")

  het_exclusion = names(het  )[which(!inInterval(lowerBound=lowHet_cutoff, upperBound=highHet_cutoff, numbers=het))]
  pos_exclusion = names(unpos)[which(unpos<pos_cutoff)]
  crp_exclusion = names(uncrp)[which(uncrp<crp_cutoff)]
  lik_exclusion = names(unlik)[which(unlik<lik_cutoff)]

  excl_pos_het = union(pos_exclusion, het_exclusion)
  excl_crp_het = union(crp_exclusion, het_exclusion)
  excl_all     = unique(c(pos_exclusion, het_exclusion))
  always_bad   = intersect(pos_exclusion, het_exclusion)
  
  if(use_stringent) fn_extra = "stringent_" else fn_extra = "nonStringent_"
  if(write) {
    pdf(file=paste(this_run_loc, fn_extra, "heterozygosity1.pdf", sep=""), width=10, height=8); 
    hist(het, n=50, col="lightgrey", main="Histogram of heterozygosity metric", xlab="Heterozygosity"); 
    abline(col="green", v=c(lowHet_cutoff, highHet_cutoff))
    dev.off()
    pdf(file=paste(this_run_loc, fn_extra, "posterior_hist1.pdf", sep=""), width=10, height=8); 
    hist(unlist(npos), n=50, col="lightgrey", main="Histogram of posterior metric", xlab="Posterior"); 
    abline(col="green", v=pos_cutoff)
    dev.off()
    #pdf(file=paste(this_run_loc, fn_extra, "callrates_hist1.pdf", sep=""), width=10, height=8); 
    #hist(unlist(ncrp), n=50, col="lightgrey", main="Call-Rates at 0.95 threshold"); 
    #abline(col="green", v=crp_cutoff)
    #dev.off()
    #pdf(file=paste(this_run_loc, fn_extra, "likelihood_hist1.pdf", sep=""), width=10, height=8); 
    #hist(unlist(nlik), n=50, col="lightgrey", main="Likelihood"); 
    #abline(col="green", v=lik_cutoff)
    #dev.off()
    poshet_fn = paste(this_run_loc, fn_extra, "exclusion_posterior=", pos_cutoff, "_heterozygosity=", 
                      round(lowHet_cutoff, digits=hetCutoffRoundDigits), "-", round(highHet_cutoff, digits=hetCutoffRoundDigits), ".txt", sep="")
    #crphet_fn = paste(this_run_loc, fn_extra, "exclusion_callrate=" , crp_cutoff, "_heterozygosity=", 
    #                  round(lowHet_cutoff, digits=2), "-", round(highHet_cutoff, digits=2), ".txt", sep="")
    allm_fn   = paste(this_run_loc, fn_extra, "exclusion_posterior=", pos_cutoff, 
                         "_heterozygosity=", 
                         round(lowHet_cutoff, digits=hetCutoffRoundDigits), "-", round(highHet_cutoff, digits=hetCutoffRoundDigits), ".txt", sep="")
    #write.table(excl_pos_het, file=poshet_fn, row.names=F, col.names=F, quote=F, append=F)
    #write.table(excl_crp_het, file=crphet_fn, row.names=F, col.names=F, quote=F, append=F)
    #write.table(excl_all    , file=allm_fn  , row.names=F, col.names=F, quote=F, append=F)
  }
  
  if(!is.null(dispersionFname))
  {
    vpStats = read.table(dispersionFname, as.is=T, header=T, sep="\t")
    dispersion = unlist(vpStats[,"z"])
    names(dispersion) = vpStats[,"WTCCC_name"]

    pdf(file=paste(this_run_loc, fn_extra, "dispersion1.pdf", sep=""), width=10, height=8); 
    hist(dispersion, n=50, col="lightgrey", main="Histogram of dispersion metric", xlab="Dispersion"); 
    abline(col="green", v=dispersion_cutoff)
    dev.off()
    
    disExclusion      = names(dispersion)[which(dispersion>dispersion_cutoff)]

    # This is the exclusion list that we end up using in the ccc+ experiment:
    extendedExclusion = unique(c(pos_exclusion, het_exclusion, disExclusion))
    extendedExclusionFname = paste(this_run_loc, fn_extra, "exclusion_posterior=", pos_cutoff,
                           "_heterozygosity=", round(lowHet_cutoff, digits=hetCutoffRoundDigits), "-", 
                           round(highHet_cutoff, digits=hetCutoffRoundDigits),
                           "_dispersion=", dispersion_cutoff, ".txt", sep="")
    write.table(extendedExclusion, file=extendedExclusionFname, row.names=F, col.names=F, quote=F, append=F)

    allPos  = unlist(npos)
    names(allPos) = dissect_sample_names(sample_names=names(allPos), coll_sep_char=".")$orig_names
    overlapNames  = intersect(names(dispersion), names(allPos))
    col=rep("black", length(overlapNames))
    names(col) = overlapNames
    posOrDispBad = allPos[overlapNames]<pos_cutoff | dispersion[overlapNames]>dispersion_cutoff
    hetBad       = het_exclusion
    col[hetBad] = "red"
    pdf(file=paste(this_run_loc, fn_extra, "dispersionVsPosterior.pdf", sep=""), width=10, height=8); 
    plot(allPos[overlapNames], dispersion[overlapNames], xlab="Posterior", ylab="Dispersion", 
         main="posterior vs. dispersion (coloured by heterozygosity)", pch="+", col=col)
    abline(v=pos_cutoff, col="red")
    abline(h=dispersion_cutoff, col="red")
    dev.off()
    cat("Excluding based on all metrics (including dispersion) removes a further: ", length(extendedExclusion), "\n");

    col=rep("black", length(overlapNames))
    names(col) = overlapNames
    dispBad = dispersion[overlapNames]>dispersion_cutoff
    col[dispBad] = "red"
    pdf(file=paste(this_run_loc, fn_extra, "heterozygosityVsPosterior.pdf", sep=""), width=10, height=8); 
    plot(allPos[overlapNames], het[overlapNames], xlab="Posterior", ylab="Heterozygosity", 
          main="posterior vs. hetrozygosity (coloured by dispersion)", pch="+", col=col)
    abline(v=pos_cutoff, col="red")
    abline(h=het_cutoffs, col="red")
    dev.off()
    if(1)
    {
      metrics = cbind(allPos[overlapNames], dispersion[overlapNames])
      colnames(metrics) = c("posterior", "dispersion")
      write.table(metrics, file=paste(this_run_loc, "posteriorAndDispersion.txt", sep=""), quote=F, col.names=T, row.names=T)
    }
  } else dipersion=NULL



  cat("Excluding based on all metrics (not including dispersion) removes a further: ", length(excl_all), "\n");
  if(0) { # Code that can be used to investigate the properties of the excluded individuals - should just work with the above having completed
    msqc           = as.matrix(read.table(file=get_msqc_fn(), as.is=T, header=T, colClasses="character", sep="\t"))
    msqc_excl_rows = match(excl_all, msqc[,"WTCCC_name"])
    excl_colls     = msqc[msqc_excl_rows,"Cohort"]
    excl_batches   = msqc[msqc_excl_rows,"Batch"]
    print(table(excl_colls))
    tmp  = hist(table(excl_batches), breaks = (1:30)-0.5, plot=F)
    tmp2 = x$counts; names(tmp2) = 1:length(tmp2)
    print(tmp2[1:20])
   #print(rbind(1:20, x$counts[1:20]))
  }
  if(pause) browser();
  # cd /home/markov/cardin/My Documents/postdoc/CNVs/calling/  # cp *1.pdf "/users/rpearson/projects/wtccc.plus.cnv/processedDataFreeze/data_freeze_7/callingRoot/caller_output/allExceptX_allCNVsAllMappings.Standard/"
  # scp login1-cluster1.well.ox.ac.uk:/users/cardin/CNVs/calling/caller_scripts/*.pdf .
}

# Function to check whether a (vector of) numbers lies within an interval 
inInterval=function(lowerBound, upperBound, numbers)
{
  goodNums = numbers > lowerBound & numbers < upperBound
  return(goodNums)
}

makeListOfInds=function(listBadCAD=T, numBadCAD=10, numFromEachCollection=2,
                        sampleNames  = get_sample_names(),
                        collections  = names(sampleNames))
{
  selectionIndividuals = c()
  for(coll in collections)
  {
    thisCollSample       = 10*(1:numFromEachCollection)
    thisCollInds         = sampleNames[[coll]][thisCollSample]
    names(thisCollInds)  = rep(coll, length(thisCollInds))
    selectionIndividuals = c(selectionIndividuals, thisCollInds)
  }

  if(listBadCAD) {
    # load the file with the bad CAD individuals in it
    badCADdir = get_dir_names()$ox
    badCAD    = unlist(read.table(paste(badCADdir, "plagnol_CAD_odd_samples.txt", sep=""), as.is=T, header=F))
    
    # Select a subset of these to get stats for
    badCADindices   = ceiling((1:numBadCAD)*length(badCAD)/numBadCAD)
    badCADselection = badCAD[badCADindices]
    names(badCADselection) = rep("badCAD", length(badCADselection))

    # Augment the list of sample names with those from the CAD collection 
    selectionIndividuals = c(selectionIndividuals, badCADselection)
  }
  return(selectionIndividuals)
}

# Takes in two matrices of CNVs and matches them based on the number of classes (from "nocl_merged") and MAF (from "MAF")
# The function can either insist on a different CNV for every match (rsample=FALSE) or it can allow duplicate matches (resample=TRUE)
# The function returns a list - for each source CNV a match is given 
# (with "missing" if a match couldn't be found) and the details of the unmatchable CNVs
matchCNVsOnProperties=function(sourceCNVdat, matchCNVdat,
                               MAFwindow=0.01,
                               DEBUG=2,
                               resample=TRUE,
                               pause=FALSE
                              )
{
  remainingMatchCNVdat = matchCNVdat
  matchingCNVs         = c()
  unmatchableCNVs      = c()
  for(cnv in 1:nrow(sourceCNVdat))
  {
    sourceCNV = as.character(sourceCNVdat[cnv, "CNV"])
    nocl    = sourceCNVdat[cnv, "nocl_merged"]
    MAF     = sourceCNVdat[cnv, "MAF"        ]
    CNVname = as.character(sourceCNVdat[cnv, "CNV"])
    matchMAF           = abs(remainingMatchCNVdat[,"MAF"] - MAF)<0.01
    matchNumClasses    = remainingMatchCNVdat[,"nocl_merged"]==nocl
    matchingCNVbool    = matchMAF & matchNumClasses
    if(length(matchingCNVbool)==0) {
      cat("  Warning, can't find any matching CNVs.\n")
      if(DEBUG>1) browser()
    }
    names(matchingCNVbool) = remainingMatchCNVdat[,"CNV"]
    matchingCNVindices = names(which(matchingCNVbool))
    if(pause) browser()
    if(length(matchingCNVindices) == 0) {
      matchingCNVs = c(matchingCNVs, "missing")
      unmatchableCNVs = c(unmatchableCNVs, CNVname)
      names(unmatchableCNVs)[length(unmatchableCNVs)] = paste(nocl, MAF, sep="_")
      if(DEBUG>1) {
        cat("  Warning, couldn't find a match for this CNV.\n")
        browser()
      }
    } else {
      matchingCNV  = sample(matchingCNVindices, size=1)
      matchingCNVs = c(matchingCNVs, matchingCNV)
      temp         = which(rownames(remainingMatchCNVdat)==matchingCNV)
      if(length(temp)==0) {
        cat("  Warning, couldn't find the CNV name corresponding to matched up CNV.\n")
        browser()
      } else {
        # This line ensures that unique CNVs are chosen as matches when this is possible (or marked as missing)
        if(!resample) 
          remainingMatchCNVdat = remainingMatchCNVdat[-temp,]
        if(sum(dim(remainingMatchCNVdat)==0)>0) {
          cat("  Warning, have no CNVs left to use for matching (probably a bug).\n")
          if(DEBUG>1) browser()
        }
      }
    }
    names(matchingCNVs)[length(matchingCNVs)] = CNVname
  }
  rv = list("matchingCNVs"=matchingCNVs, "unmatchableCNVs"=unmatchableCNVs)
  return(rv)
}

# This function takes in a master list, 
# and a vector of CNV names with a corresponding names attribute of matching CNVs
# It then tests all the Bayes Factors corresponding to the ccc+ diseases for 
# a systematic difference between the two matched groups of CNVs.
# Two tests are performed, a wilcox test and a permutation test.
testBFsForDifferences=function(masterList, 
                               CNVmatchList,
                               pause=FALSE,
                               cccPlusDiseases = c("T1D", "T2D", "CD", "CAD", "BC", "BD", "HT", "RA", "control"),
                               ers = c("er=FALSE"=FALSE, "er=TRUE"=TRUE),
                               exact=FALSE,
                               verbose=1,
                               doPermTest=TRUE)
{
  require(exactRankTests)
  cantMatch         = which(CNVmatchList=="missing")
  if(length(cantMatch)>0)
    CNVmatchList      = CNVmatchList[-cantMatch]
  wilcoxPvalues     = matrix(NA, nrow=length(cccPlusDiseases), ncol=2)
  dimnames(wilcoxPvalues) = list(cccPlusDiseases, names(ers))
  wilcoxTestStats   = wilcoxPvalues
  permPvalues       = wilcoxPvalues
  permTestStats     = wilcoxPvalues
  for(disease in cccPlusDiseases)
  {
    if(0 & disease=="control") browser()
    for(expandedReference in ers)
    {
      BFcolname = paste("BF_", disease, sep="")
      if(disease=="control") 
        BFcolname = paste("BF_", "NBS", sep="")      
      if(expandedReference) {
        if(disease!="control") {
          BFcolname = paste(BFcolname, "_expanded", sep="") 
        } else {
          next()
        }
      }
      allSourceBFs   = masterList[names(CNVmatchList), BFcolname]
      allMatchBFs    = masterList[      CNVmatchList , BFcolname]
      names(allSourceBFs) = masterList[names(CNVmatchList), "CNV"]
      names(allMatchBFs)  = masterList[      CNVmatchList, "CNV"]
      ## Sometimes there are NAs in the Bayes Factors (some of the testing hasn't happened?) These should be removed:
      naBFs       = is.na(allSourceBFs) | is.na(allMatchBFs) 
      sourceBFs   = allSourceBFs[!naBFs]
      matchBFs    = allMatchBFs[ !naBFs]
      ties    = (sum(duplicated(sourceBFs))>0 | sum(duplicated(matchBFs))>0 | sum(sapply(matchBFs, '%in%', sourceBFs))>0)
      matches = which(sapply(matchBFs, '%in%', sourceBFs))
      
      if(exact) {
        wilcoxTestResult  = wilcox.exact(x=sourceBFs, y=matchBFs, alternative="two.sided", paired=FALSE)
      } else    {
        wilcoxTestResult  = wilcox.test( x=sourceBFs, y=matchBFs, alternative="two.sided", paired=FALSE)
      }
      wilcoxPvalues[  disease, expandedReference+1] = wilcoxTestResult$p.value
      wilcoxTestStats[disease, expandedReference+1] = wilcoxTestResult$statistic
      if(doPermTest) {
        # Currently the permutation test is done using some kind of normal approxiximation - is this valid?
        permTestResult    = perm.test(   x=sourceBFs, y=matchBFs, alternative="two.sided", paired=FALSE)
        permPvalues[    disease, expandedReference+1] =   permTestResult$p.value
        permTestStats  [disease, expandedReference+1] =   permTestResult$statistic
      }
      if(pause) browser()
    }
  }
  rv = list("wilcoxPvalues"  = wilcoxPvalues, 
            "permPvalues"    = permPvalues  ,
            "wilcoxTestStats"= wilcoxTestStats,
            "permTestStats"  = permTestStats)
  return(rv)
}

summariseCalls=function(merge=T, ldf=T,
                        returnSummary = FALSE,
                        verbose = 1-returnSummary
                       )
{
  summaryCallsFname = intelligentGetFnames(merge=merge, ldf=ldf, 
                                           sampleNames  = get_sample_names())$csmry_fns
  summaryCalls = read.table(summaryCallsFname, as.is=T, header=FALSE)
  colnames(summaryCalls) = c("chr", "CNVname", "position", "numClasses")
  if(verbose>=1) {
    cat("The number of classes inferred was:")
    print(table(summaryCalls[,"numClasses"]))
  }
  if(returnSummary)
    return(summaryCalls)
}
#summariseCalls()

if(0) {
  #"quiteEasyBadProbesSimpleStudyFourClass_2009-11-20", "mediumSignalBadProbesSimpleStudyTwoClass_2009-11-26"
  # detach(package:cccpCallNJC); 
  library(cccpCallNJC); 
  read_tag="quiteEasyBadProbesSimpleStudyThreeClass_2009-11-20"
  write_tag=paste(read_tag, "_results",sep=""); #_resultsMean
 #lookAtSimDat(readTag=read_tag, merge=TRUE, wrongPause=TRUE)
  lookAtSimDat(readTag=read_tag, merge=TRUE, tooManyPause=TRUE)
}
lookAtSimDat=function(readTag="simpleStudyThreeClass_2009-11-09", 
                      cnv="all", seed=1,
                      merge=T, ldf=T,
                      allPause = FALSE,
                      wrongPause = FALSE,
                      tooManyPause = FALSE,
                      machine = "teal"
                     )
{
  ## Check that the files can be automatically found:
  if(!exists("project_root")) {
    cat("  Need a project root to find files (choosing a default!)\n")
    if(machine=="teal")
      projectRoot = "/data/teal/cardin/calling/" else
      projectRoot = "/data/garganey/cardin/postdoc/CNVs/calling/" 
    assign(x="project_root", value=projectRoot, envir=.GlobalEnv)
   #browser()
  }
  ## Read in simulated data summary of parameters used
  summaryFile     = paste(project_root, "simdat/", readTag, "/simpars/", "sim_pars_", readTag, "_seed=", seed, ".txt", sep="")
  colNamesSummary = read.table(summaryFile, as.is=TRUE, header=FALSE, skip=0, nrow=1)
  simSummary      = read.table(summaryFile, as.is=TRUE, header=FALSE, skip=1)
  simNumClasses   = simSummary[,35] # The final column gives the number of classes, hard to tell from names though.
  
  if(exists("write_tag")) {
    ## Read in summary of inference (re: numClasses etc)
    assign(x = "results_dir_tag"      , value = paste(write_tag, "/", sep="")                                 , envir = .GlobalEnv); 
    assign(x = ".default.coutput_root", value = paste(project_root, "caller_output/", results_dir_tag, sep=""), envir = .GlobalEnv); 
    summaryCallsFname = intelligentGetFnames(merge=merge, ldf=ldf, 
                                             sampleNames  = get_sample_names())$csmry_fns
    summaryCalls  = read.table(summaryCallsFname, as.is=T, header=FALSE)
    colnames(summaryCalls) = c("chr", "CNVname", "position", "numClasses")
    infNumClasses = summaryCalls[,"numClasses"]
    wrongNumClassesBool = infNumClasses!=simNumClasses
    gotWrongNumClasses  = summaryCalls[wrongNumClassesBool, "CNVname"]
  } else 
    gotWrongNumClasses  = NULL
  if(cnv=="all") 
    cnvs = 1:nrow(simSummary) else
    cnvs = cnv
  # This is an object to store the types from all the simulated CNVs
  allCNVtypes  = as.list(rep(NA, length(cnvs)))
  # This is an object to store the data from CNVs where the inference went wrong.
  typesAtWrong = as.list(rep(NA, length(gotWrongNumClasses)))
  names(typesAtWrong) = gotWrongNumClasses
  cat("Reading in simulated data sets"); if(wrongPause | allPause| tooManyPause) cat("\n")
  for(cnv in cnvs) {
    if((cnv%%50)==0) cat(".")
    simdatFname = paste(project_root, "simdat/", readTag, "/", readTag, "_seed=", seed, "_sim=", cnv, ".RData", sep="")
    allSimDat      = myload(simdatFname)
    trueNumClasses = allSimDat$sim_pars$numGenotypes
    CNVtypes       = allSimDat$simdat$cnv_types
    if(cnv %in% names(typesAtWrong))
      typesAtWrong[[cnv]] = CNVtypes
    allCNVtypes[[cnv]] = CNVtypes

    ## Read in some measure of how bad the data is at this CNV. Perhaps a Q-score from the true types?

    ## Get the frequencies for each type as these may harm numClasses inference.    
    types          = table(unlist(CNVtypes))
    check          = identical(names(types), as.character(1:max(names(types))))
    if(!check)
      cat("  Warning, not all potential types present.\n")
    freqs          = types/sum(types)    
    if(allPause | (wrongPause & wrongNumClassesBool[cnv])
                | (tooManyPause & infNumClasses[cnv]>trueNumClasses)) {
      cat("Percentages at", cnv, "=", round(freqs, digits=3)*100, "\n", sep=" ")
      browser()
    }
  }
  cat("Done.\n")
  allTypes        = as.character(sort(unique(unlist(allCNVtypes))))
  allFreqs        = sapply(allCNVtypes, getFreqsFromAllTypes, names=allTypes)
  if(is.matrix(allFreqs))
    freqsAtWrong    = allFreqs[,wrongNumClassesBool] else {
    freqsAtWrong    = sapply(typesAtWrong, getFreqsFromAllTypes)
    freqsAtWrong    = freqsAtWrong[which(sapply(freqsAtWrong, length)>0)]
    freqsAtWrong    = (sapply(freqsAtWrong, augmentVec, names=as.character(1:trueNumClasses[1]))) #Won't work if numClasses varies
  }    
  minFreqsAtWrong   = apply(freqsAtWrong, 2, min)
  names(minFreqsAtWrong) = gotWrongNumClasses
  minFreqsAtAll     = apply(allFreqs    , 2, min)
  meanMinFreqsWrong = mean(minFreqsAtWrong)
  cat("The mean frequency at those mis-called was:", meanMinFreqsWrong, "\n")
  browser()
  rv = list("allFreqs"=allFreqs, "allCNVtypes"=allCNVtypes)
  return(rv)
}

augmentVec=function(vec, names)
{
  if(length(vec)==length(names)) 
    return(vec)
  newVec = rep(0, length(names))
  names(newVec) = names
  newVec[names(vec)] = vec
  return(newVec)  
}

getFreqsFromAllTypes=function(CNVtypes, returnCounts=FALSE, 
                              names=NULL)
{
  #cat(".")
  counts = table(unlist(CNVtypes)) 
  if(!returnCounts)
    rv = counts/sum(counts) else
    rv = counts
  if(!is.null(names))
    rv = augmentVec(rv, names=names)
  return(rv)
}

# intelligentGetQCfname(merge=T, ldf=T); intelligentGetFnames(merge=T, ldf=T, sampleNames  = get_sample_names())
intelligentGetFnames=function(merge=T, ldf=T, cnvName=NULL, callThresh=0.8, fileType="rda",
                                   sampleNames  = get_sample_names(),
                                   collections  = names(sampleNames))
{
  if(!ldf) {
    data_fn = get_coutput_fns(cnv_name = cnvName)$data_fn
    if(!merge) {
      fit_sum_fn   = get_coutput_fns(cnv_name = cnvName)$fit_fn
      calls_fns    = get_coutput_fns(collections=collections)$sorted_calls_fns 
      hCallsFnames = get_coutput_fns(call_thresh=callThresh, hcalls_filetype=fileType)$hard_calls_fn
      csmry_fns    = get_coutput_fns(collections=collections)$sorted_smry_cfn
      joined_dir   = get_coutput_dirs()$jd
    } else  {
      fit_sum_fn   = get_coutput_fns(cnv_name = cnvName)$merged_fits_fn
      calls_fns    = get_coutput_fns(collections=collections)$merged_calls_fns
      hCallsFnames = get_coutput_fns(call_thresh=callThresh, hcalls_filetype=fileType)$merged_hcalls_fn
      csmry_fns    = get_coutput_fns(collections=collections)$merged_smry_cfn
      joined_dir   = get_coutput_dirs()$merged_calls_dir
    }
  } else {
    data_fn = get_coutput_fns(cnv_name = cnvName)$ldf_data_fn
    if(!merge) {
      fit_sum_fn   = get_coutput_fns(cnv_name = cnvName)$ldf_fit_fn
      calls_fns    = get_coutput_fns(collections=collections)$ldf_sorted_calls_fns
      hCallsFnames = get_coutput_fns(call_thresh=callThresh, hcalls_filetype=fileType)$ldf_hard_calls_fn
      csmry_fns    = get_coutput_fns(collections=collections)$ldf_srtd_smry_cfn
      joined_dir   = get_coutput_dirs()$jd
    } else  {
      fit_sum_fn   = get_coutput_fns(cnv_name = cnvName)$ldf_merged_fits_fn
      calls_fns    = get_coutput_fns(collections=collections)$ldf_merged_calls_fns
      hCallsFnames = get_coutput_fns(call_thresh=callThresh, hcalls_filetype=fileType)$ldf_merged_hcalls_fn
      csmry_fns    = get_coutput_fns(collections=collections)$ldf_merged_smry_cfn
      joined_dir   = get_coutput_dirs()$merged_calls_dir
    }
  }
  QCfname = intelligentGetQCfname(merge=merge, ldf=ldf)
  rv = list("calls_fns"=calls_fns, "csmry_fns"=csmry_fns, "joined_dir"=joined_dir,
            "fit_sum_fn"=fit_sum_fn, "data_fn"=data_fn, "hCallsFnames"=hCallsFnames,
            "QCfname"=QCfname)
  return(rv)
}
intelligentGetQCfname=function(merge=T, ldf=T, createDir=T)
{
  if(!ldf) {
    if(!merge) {
      qc_stats_fn  = get_coutput_fns()$qc_stats_fn      
      dir          = get_coutput_dirs()$QC_dir
    } else       {
      qc_stats_fn  = get_coutput_fns()$merged_qc_stats_fn
      dir          = get_coutput_dirs()$merged_call_QC_dir
    }
  } else {
    if(!merge) {
      qc_stats_fn  = get_coutput_fns()$ldf_qc_stats_fn       
      dir          = get_coutput_dirs()$QC_dir
    } else       {
      qc_stats_fn  = get_coutput_fns()$ldf_merged_qc_stats_fn
      dir          = get_coutput_dirs()$merged_call_QC_dir
    }
  }
  if(createDir & !file.exists(dir)) dir.create(dir)
  return(qc_stats_fn)
}

makeQCstats=function(
    merge        = T, 
    ldf          = T,
    calls_fns    = NULL, csmry_fns=NULL, joined_dir=NULL,
    sampleNames  = get_sample_names(),
    collections  = names(sampleNames),
    no_preamble_cols = 4, call_thresh1 = 0.95, call_thresh2 = 0.90, 
    maxCNV=NULL , namedCNVs=NULL, 
    fullStatInds = NULL, #This should be a list of individuals for whom we want to record stats at all CNVs, not just the means
    statTypes=c("posterior", "likelihood"),
    DEBUG=1,
    all_QCs_fn   = intelligentGetQCfname(merge=merge, ldf=ldf, createDir=T)
    )
{
  qc = getQCstatSummaries(
     merge        = merge, ldf = ldf,
     calls_fns    = calls_fns, csmry_fns=csmry_fns, joined_dir=joined_dir,
     sampleNames  = sampleNames, collections  = collections,
     no_preamble_cols = no_preamble_cols, 
     call_thresh1 = call_thresh1, call_thresh2 = call_thresh2, 
     maxCNV=maxCNV , namedCNVs=namedCNVs, 
     statTypes=statTypes,
     fullStatInds = fullStatInds, #This should be a list of individuals for whom we want to record stats at all CNVs, not just the means
     DEBUG=DEBUG)

  save(qc, all_QCs_fn)   
}

# Meant to be a neater, cut down version of 'calc_call_rates' More comments!
# Ideally would use duplicate concordance as well
# It is assumed that the exclusion list will have a column called WTCCC_name which contains ONLY individuals to be excluded
# source("../caller_core/cnvCall/R/post_calling_core.R"); getQCstatSummaries(sampleExclusionListFname = paste(get_dir_names()$ox_inputs_dir, "pearsonPreTestingExclusions.txt", sep=""))
getQCstatSummaries=function(
     merge        = T, 
     ldf          = T,
     calls_fns    = NULL, csmry_fns=NULL, joined_dir=NULL,
     sampleNames  = get_sample_names(),
     collections  = names(sampleNames),
     no_preamble_cols = 4, call_thresh1 = 0.95, call_thresh2 = 0.90, 
     maxCNV=NULL , namedCNVs=NULL, 
     fullStatInds = NULL, #This should be a list of individuals for whom we want to record stats at all CNVs, not just the means
     statTypes=c("posterior", "likelihood"),
     sampleExclusionListFname=NULL, 
     DEBUG=1)
{
  # if calls-filenames haven't been passed find them automatically based on whether merged and ldf calls are wanted.
  if(is.null(calls_fns)) {
    calls_fns    = intelligentGetFnames(merge=merge, ldf=ldf)$calls_fns
    csmry_fns    = intelligentGetFnames(merge=merge, ldf=ldf)$csmry_fns
    joined_dir   = intelligentGetFnames(merge=merge, ldf=ldf)$joined_dir
  }
  if(!is.null(sampleExclusionListFname))
  {
    sampleExclusionList = as.matrix(read.table(sampleExclusionListFname, as.is=T, header=T))
  } else
    sampleExclusionList = NULL
  allSampleNames      = dissect_sample_names(sample_names=unlist(sampleNames), coll_sep_char=".")$orig_names
  sampleInclusionList = setdiff(allSampleNames, sampleExclusionList)
  includeByCollection = sapply(sampleNames, setdiff, sampleExclusionList)
  # Set up some basic variables required for the function, these all concern sample identification:
  noco         = length(collections)
  coll_order   = match(collections, names(sampleNames))
  sampleNames  = sampleNames[coll_order]
  all_sampleNames = standardise_names(nms=unlist(sampleNames), verbose=F)[,"ccc_name"]; 
  names(all_sampleNames) = NULL
  numInds_vec  = sapply(sampleNames, length)
  numInds      = sum(numInds_vec)
  
  #Give various objects proper collection names:
  names(calls_fns) = names(sapply(collections, grep, calls_fns))
  # This doesn't need to be named as there's just one file - not collection specific:
 #names(csmry_fns) = names(sapply(collections, grep, csmry_fns))

  # Get cnv details (number of CNVs, names etc.): Read in preamble file
  allCNVsPreamble = read.table(csmry_fns, as.is=T, header=F)
  allCNVnames     = allCNVsPreamble[,2]
  numCNVs         = length(allCNVnames)
  if(is.null(maxCNV)) maxCNV=numCNVs
  
  # In case only a subset of CNVs is required, can be run much quicker using that:
  if(!is.null(namedCNVs)) 
  {
    cnvIndices = which(allCNVnames %in% namedCNVs)
    names(cnvIndices) = namedCNVs
  } else {
    cnvIndices = 1:maxCNV
    names(cnvIndices) = allCNVnames
  }
  checkNames = sum(names(cnvIndices) == allCNVnames[cnvIndices]) == length(cnvIndices)
  if(!checkNames) {
    namesDisagree = which(names(cnvIndices) != allCNVnames[cnvIndices])
    cat("  Ambiguity in CNV naming.\n"); 
    browser()
  } 
  numCNVs    = length(cnvIndices)

  # Make objects to record stats at each CNV
  collPosteriors  = paste(collections, "_", statTypes[1], sep="")
  collLikelihoods = paste(collections, "_", statTypes[2], sep="")
  cnvStatNames   = c(statTypes, collPosteriors, collLikelihoods, "numClasses")
  cnvStats = matrix(0, nrow=numCNVs, ncol=length(cnvStatNames))
  rownames(cnvStats) = allCNVnames[cnvIndices]
  colnames(cnvStats) = cnvStatNames
  
  # Make object to record the posteriors (smoothed versoin of call-rates) for each individual
  totalPosterior        = as.list(rep(0, noco)) ; 
  names(totalPosterior) = names(sampleNames)
  totalPosteriorPoly    = totalPosterior
  # Also record the likelihood - this detects people are are generally in the tails, null etc.
  likelihoods           = totalPosterior
  likelihoodsPoly       = totalPosterior
  
  # Make object to record the  full statistics for some individuals, to look at the distributions.
  fullStatsDat = as.list(rep(0, length(fullStatInds)))
  names(fullStatsDat) = fullStatInds
  for(ind in fullStatInds) {
    fullStatsDat[[ind]] = matrix(0, nrow=numCNVs, ncol=length(statTypes))
    rownames(fullStatsDat[[ind]]) = allCNVnames[cnvIndices]
  }

  # Open the files with the calls in
  callsCons = as.list(rep(NA, length(calls_fns)))
  names(callsCons) = names(calls_fns)
  for(coll in collections) 
    callsCons[[coll]] = file(calls_fns[coll], open="r")

  nocls      = rep(NA, numCNVs)
  # Loop over the CNVs calculating the required stats at each CNV
  for(cnv in cnvIndices) {
    theseIndicesCNVindex = which(cnvIndices==cnv)    
    if(theseIndicesCNVindex%%10  ==0) cat(".");
    if(theseIndicesCNVindex%%500 ==0) cat("On CNV ", theseIndicesCNVindex, "\n");

    # Read in the preamble data - to find out how many columns there are before the calls, etc.
    allCNVsPreamble    
    nocl              = allCNVsPreamble[cnv, 4]
    CNVname           = allCNVsPreamble[cnv, 2]
    nocls[cnv]        = nocl; 
    names(nocls)[cnv] = CNVname;

    # Calculate the CNV likelihoods for all collections (these get collated within the by-colection loop)
    cnvLikelihoods = likelihood_from_fits(cnv_name=CNVname, ldf=ldf)

    # Record all values of posterior so that they can be summarised
    allPosteriors  = c() #rep(NA, numInds)
    allLikelihoods = c() #rep(NA, numInds)
    # Read in the main calls data - these are stored in a separate file for each collection
    # Also calculate some of the required statistics in this loop.
    for(coll in collections)
    {
      # Read in and parse the calls
      # Need to skip to the right line. If reading in cnvIndex B after cnvIndex A need to skip: B-A-1 lines.
      if(theseIndicesCNVindex>1) 
        skip       = (cnv-cnvIndices[theseIndicesCNVindex-1])-1 else
        skip       = cnv-1  #If the first CNV is cnv_index 67, then sould skip 66 lines to read the right data.
      calls      = scan(callsCons[[coll]], skip=skip, nlines=1, what=character(0), quiet=T )
      calls_mat  = matrix(as.numeric(calls[-(1:no_preamble_cols)]), nrow=numInds_vec[coll], byrow=T)
      rownames(calls_mat) = sampleNames[[coll]]

      # Just to check that the preamble files are in the same order as the main data
      check_nocl = ncol(calls_mat)==nocl; if(!check_nocl) {
        cat(  "Warning! annotation of number of classes doesn't fit calls!.\n"); if(DEBUG>=1) browser()
      }

      # Generate 'posterior' metric values.
      maxPosterior   = get_max_posterior(calls_mat, nocl, no_inds=numInds_vec[coll])
      totalPosterior[[coll]] = totalPosterior[[coll]]  + maxPosterior
      likelihoods[[   coll]] = likelihoods[[   coll]]  + cnvLikelihoods[[coll]]
      if(nocl >1) {
        totalPosteriorPoly[[coll]] = totalPosteriorPoly[[coll]] + maxPosterior
        likelihoodsPoly[[   coll]] = likelihoodsPoly[[   coll]] + cnvLikelihoods[[coll]]
      }

      # Store the values for individuals across collections to get mean values for cnvStats      
      allPosteriors  = c(allPosteriors , maxPosterior)
      allLikelihoods = c(allLikelihoods, cnvLikelihoods[[coll]])
      # Add cy-collection posterior/likelihood summaries to cnvStats object:
      thisCollPosName     = paste(coll, "_posterior" , sep="")
      thisCollLikName     = paste(coll, "_likelihood", sep="")
      cnvStats[CNVname, thisCollPosName] = mean(maxPosterior[includeByCollection[[coll]]])
      cnvStats[CNVname, thisCollLikName] = mean(cnvLikelihoods[[coll]][includeByCollection[[coll]]])
      
      # Should generate duplicate concordance here (if there are duplicates - pass null otherwise)
      
      # Generate full statistics for some individuals, to look at the distributions.
      for(ind in intersect(fullStatInds, sampleNames[[coll]]))
      {
        fullStatsDat[[ind]][CNVname,] = c(maxPosterior[ind], cnvLikelihoods[[coll]][ind])
      }     
    }
    cnvStats[CNVname,"numClasses"] = nocl
    cnvStats[CNVname,"posterior" ] = mean(allPosteriors[sampleInclusionList])
    cnvStats[CNVname,"likelihood"] = mean(allLikelihoods[sampleInclusionList])
#    browser()
  } 
  cat("Done.\n")
  numPoly = sum(nocls>1, na.rm=T);
  meanPosteriors      = sapply(totalPosterior    , '/', numCNVs) 
  meanPosteriorsPoly  = sapply(totalPosteriorPoly, '/', numPoly) 
  meanLikelihoods     = sapply(likelihoods       , '/', numCNVs) 
  meanLikelihoodsPoly = sapply(likelihoodsPoly   , '/', numPoly) 
  rv = list("totalPosterior" = totalPosterior, 
            "totalPosteriorPoly" = totalPosteriorPoly, 
            "meanPosteriors"=meanPosteriors,
            "meanPosteriorsPoly"=meanPosteriorsPoly,
            "totalLikelihood" = likelihoods, 
            "totalLikelihoodPoly" = likelihoodsPoly, 
            "meanLikelihoods"=meanLikelihoods,
            "meanLikelihoodsPoly"=meanLikelihoodsPoly,
            "numCNVs"=numCNVs,
            "nocls"=nocls,
            "fullStatsDat"=fullStatsDat,
            "cnvStats"=cnvStats)
  for(callsfn in 1:length(calls_fns)) close(callsCons[[callsfn]])
  return(rv)
}


# closeAllConnections(); source("cnv_caller.R"); options(warn=2); setups(3); compare_coll_bfs(write=T) 
compare_coll_bfs=function(this_run_name=write_tag, this_run_loc=.default.coutput_root,
                  sample_names    = get_sample_names(this_run_name=this_run_name, coutput_root=this_run_loc),
                  qcfn = get_coutput_fns(coutput_root=this_run_loc, this_run_name=this_run_name, cnv_name=NA)$merged_qc_stats_fn,
                  collections = names(sample_names), diseases = get_diseases(), use_merged=T, expanded_references=c(F,T),
                  write=T)
{
  for(merged in use_merged) {
    for(er in expanded_references)
    {
      cnvtest_outputs = as.list(rep(NA, length(diseases)))
      bfs             = as.list(rep(NA, length(diseases)))
      for(dis in 1:length(diseases))
      {   
         disease = diseases[dis]
         f = get_cnvtest_filenames(merged=use_merged, this_run_name=this_run_name, this_run_loc=this_run_loc, 
                             collections=collections, er=er, disease=disease)
         #cnvtest_outdir=f$cnvtest_outdir, cnvtest_outfn=f$cnvtest_outfn
         cnvtest_outputs[[dis]] = read.table(f$cnvtest_outfn, as.is=T, header=T, sep=" ")
         bf_col = paste(disease, "_phenotype_bayesian_add_score", sep="")
         bfs[[dis]] = cnvtest_outputs[[dis]][,bf_col]
      }
      if(write) {
      pdf(file=paste(this_run_loc, "Basic_Bayes_Factor_Density_Plot_exp_ref=", er, ".pdf", sep=""), width=12, height=10)
        plot(density(bfs[[1]]), xlim=c(-2, 20), ylim=c(0,2.6), col=1)
        for(dis in 2:length(diseases)) lines(density(bfs[[dis]]), col=dis)
        legend("topleft",
               diseases,
               title="BF colours",
               pch=15,  # squares
               col=1:length(diseases))
        dev.off()
    }
    
    damjans_inspection_dir = "/users/vukcevic/wtccc.plus.cnv/inspection.pipeline/"
   #ds_hitlist_fn = paste(damjans_inspection_dir, "cnv_hit_list.txt", sep="")
    ds_hitlist_fn = paste(damjans_inspection_dir, "cnv_hit_list.csv", sep="")
    ds_hitlist    = read.table(ds_hitlist_fn, as.is=T, header=T, sep=",")  
    bc_rows       = which(ds_hitlist[,"collection"]=="BC")
    bc_hits       = ds_hitlist[bc_rows,"CNV"]
    
    bc_covariate_fn = paste(f$cnvtest_outdir, "testing_allExceptX_allCNVsAllMappings.Standard_BC_expanded_reference=", er, "_sex_covariate.txt"  , sep="")
    bc_nomales_fn   = paste(f$cnvtest_outdir, "testing_allExceptX_allCNVsAllMappings.Standard_BC_expanded_reference=", er, "_excluding_males.txt", sep="")

    bc_nomales      = read.table(bc_nomales_fn  , as.is=T, header=T, sep=" ")
    bc_covariate    = read.table(bc_covariate_fn, as.is=T, header=T, sep=" ")
    bc_standard     = cnvtest_outputs[[bc_index]]
    if(merged) merged_part = "merged_" else  merged_part = NULL
    noexcl_test_dir = paste(this_run_loc, "oldTestingResults/orig_", merged_part, "testing_expanded_reference=", er, "/", sep="")
    bc_noexcl_fn    = paste(noexcl_test_dir, "testing_allExceptX_allCNVsAllMappings.Standard_BC_expanded_reference=", er, ".txt"                , sep="")
   #bc_noexclnm_fn  = paste(noexcl_test_dir, "testing_allExceptX_allCNVsAllMappings.Standard_BC_expanded_reference=", er, "_excluding_males.txt", sep="")
   #bc_noexclcov_fn = paste(noexcl_test_dir, "testing_allExceptX_allCNVsAllMappings.Standard_BC_expanded_reference=", er, "_sex_covariate.txt", sep="")
    bc_noexcl       = read.table(bc_noexcl_fn, as.is=T, header=T, sep=" ")

    nomales_bcbf_col   = paste("BC", "_phenotype_bayesian_add_score"    , sep="")
    standard_bcbf_col  = paste("BC", "_phenotype_bayesian_add_score"    , sep="")
    covariate_bcbf_col = paste("BC", "_phenotype_bayesian_add_sex_score", sep="")
    noexcl_bcbf_col    = paste("BC", "_phenotype_bayesian_add_score"    , sep="")

    bcbfs_standard  = bc_standard[ , standard_bcbf_col]; names(bcbfs_standard)  = bc_standard[ ,"id2"]
    bcbfs_nomales   = bc_nomales[  ,  nomales_bcbf_col]; names(bcbfs_nomales)   = bc_nomales[  ,"id2"]
    bcbfs_covariate = bc_covariate[,covariate_bcbf_col]; names(bcbfs_covariate) = bc_covariate[,"id2"]
    bcbfs_noexcl    = bc_noexcl[   ,   noexcl_bcbf_col]; names(bcbfs_noexcl   ) = bc_noexcl[   ,"id2"]
    # which(colnames(bc_standard)==paste("BC", "_phenotype_bayesian_add_score", sep=""))

    bc_index        = which(diseases=="BC")
    bcbfs           = rbind(bcbfs_noexcl, bcbfs_standard, bcbfs_covariate, bcbfs_nomales)
    bc_hits_bymethod = bcbfs[,bc_hits]
    cat("Breast Cancer Hits for the three testing types (expanded reference = ", er, "):\n", sep="")
    print(bc_hits_bymethod)
    if(write) write.table(bc_hits_bymethod, file = paste(this_run_loc, "bc_hits_bymethod_expref=", er, ".txt", sep=""), quote=F, row.names=T, col.names=T)
    if(write) {
      pdf(file=paste(this_run_loc, "BC_Bayes_Factor_Density_Plot_exp_ref=", er, ".pdf", sep=""), width=12, height=10)
      plot(density(bcbfs[1,]), xlim=c(-2, 20), ylim=c(0,2.6), col=1)
      for(test_type in 2:nrow(bcbfs)) lines(density(bcbfs[[test_type]]), col=test_type)
      legend("topleft",
             rownames(bcbfs),
             title="BF colours",
             pch=15,  # squares
             col=1:nrow(bcbfs))
      dev.off()
    }
    browser()
    }  
  }
}



